//@ui5-bundle sap/ui/table/library-preload.js
/*!
 * OpenUI5
 * (c) Copyright 2009-2019 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('sap/ui/table/AnalyticalColumn',['./Column','./library','sap/ui/core/Element','sap/ui/model/type/Boolean','sap/ui/model/type/DateTime','sap/ui/model/type/Float','sap/ui/model/type/Integer','sap/ui/model/type/Time','./TableUtils','./AnalyticalColumnMenu'],function(C,l,E,B,D,F,I,T,a,A){"use strict";
function i(c){return a.isA(c,"sap.ui.table.AnalyticalTable");}
var b=C.extend("sap.ui.table.AnalyticalColumn",{metadata:{library:"sap.ui.table",properties:{leadingProperty:{type:"string",group:"Misc",defaultValue:null},summed:{type:"boolean",group:"Misc",defaultValue:false},inResult:{type:"boolean",group:"Misc",defaultValue:false},showIfGrouped:{type:"boolean",group:"Appearance",defaultValue:false},groupHeaderFormatter:{type:"any",group:"Behavior",defaultValue:null}}}});
b.prototype.init=function(){C.prototype.init.apply(this,arguments);};
b._DEFAULT_FILTERTYPES={"Time":new T({UTC:true}),"DateTime":new D({UTC:true}),"Float":new F(),"Integer":new I(),"Boolean":new B()};
b.prototype._createMenu=function(){return new A(this.getId()+"-menu");};
b.prototype.setGrouped=function(g,s){var p=this.getParent();if(i(p)){if(g){p._addGroupedColumn(this.getId());}else{p._removeGroupedColumn(this.getId());}}var r=this.setProperty("grouped",g,s);this._updateColumns();return r;};
b.prototype.setSummed=function(s){var r=this.setProperty("summed",s,true);this._updateTableAnalyticalInfo();return r;};
b.prototype.setVisible=function(v){C.prototype.setVisible.call(this,v);this._updateColumns();return this;};
b.prototype.getLabel=function(){var L=this.getAggregation("label");if(!L){if(!this._oBindingLabel){var p=this.getParent();if(i(p)){var o=p.getBinding("rows");if(o){this._oBindingLabel=l.TableHelper.createLabel();this.addDependent(this._oBindingLabel);a.Binding.metadataLoaded(p).then(function(){this._oBindingLabel.setText(o.getPropertyLabel(this.getLeadingProperty()));}.bind(this));}}}L=this._oBindingLabel;}return L;};
b.prototype.getFilterProperty=function(){var p=this.getProperty("filterProperty");if(!p){var P=this.getParent();if(i(P)){var o=P.getBinding("rows");var L=this.getLeadingProperty();if(o&&o.getFilterablePropertyNames().indexOf(L)>-1){p=L;}}}return p;};
b.prototype.getSortProperty=function(){var p=this.getProperty("sortProperty");if(!p){var P=this.getParent();if(i(P)){var o=P.getBinding("rows");var L=this.getLeadingProperty();if(o&&o.getSortablePropertyNames().indexOf(L)>-1){p=L;}}}return p;};
b.prototype.getFilterType=function(){var f=this.getProperty("filterType");if(!f){var p=this.getParent();if(i(p)){var o=p.getBinding("rows");var L=this.getLeadingProperty(),P=o&&o.getProperty(L);if(P){switch(P.type){case"Edm.Time":f=b._DEFAULT_FILTERTYPES["Time"];break;case"Edm.DateTime":case"Edm.DateTimeOffset":f=b._DEFAULT_FILTERTYPES["DateTime"];break;case"Edm.Single":case"Edm.Double":case"Edm.Decimal":f=b._DEFAULT_FILTERTYPES["Float"];break;case"Edm.SByte":case"Edm.Int16":case"Edm.Int32":case"Edm.Int64":f=b._DEFAULT_FILTERTYPES["Integer"];break;case"Edm.Boolean":f=b._DEFAULT_FILTERTYPES["Boolean"];break;}}}}return f;};
b.prototype._updateColumns=function(s,f){var p=this.getParent();if(i(p)){p._updateColumns(s,f);}};
b.prototype._updateTableAnalyticalInfo=function(s){var p=this.getParent();if(p&&i(p)&&!p._bSuspendUpdateAnalyticalInfo){p.updateAnalyticalInfo(s);}};
b.prototype._updateTableColumnDetails=function(){var p=this.getParent();if(p&&i(p)&&!p._bSuspendUpdateAnalyticalInfo){p._updateTableColumnDetails();}};
b.prototype.shouldRender=function(){if(!this.getVisible()||!this.getTemplate()){return false;}return(!this.getGrouped()||this._bLastGroupAndGrouped||this.getShowIfGrouped())&&(!this._bDependendGrouped||this._bLastGroupAndGrouped);};
b.prototype.getTooltip_AsString=function(){var t=E.prototype.getTooltip_AsString.apply(this);var p=this.getParent();if(!t&&i(p)){var o=p.getBinding("rows");if(o&&this.getLeadingProperty()){t=o.getPropertyQuickInfo(this.getLeadingProperty());}}return t;};
b.prototype._menuHasItems=function(){var m=function(){var t=this.getParent();var o=t.getBinding("rows");var r=o&&o.getAnalyticalQueryResult();return(t&&r&&r.findMeasureByPropertyName(this.getLeadingProperty()));}.bind(this);return C.prototype._menuHasItems.apply(this)||m();};
b.prototype.isFilterableByMenu=function(){var f=this.getFilterProperty();if(!f||!this.getShowFilterMenuEntry()){return false;}var p=this.getParent();if(i(p)){var o=p.getBinding("rows");if(o){if(o.getFilterablePropertyNames().indexOf(f)>-1&&o.getProperty(f)){return true;}}}return false;};
b.prototype.isGroupable=function(){var p=this.getParent();if(i(p)){var o=p.getBinding("rows");if(o){var r=o.getAnalyticalQueryResult();if(r&&r.findDimensionByPropertyName(this.getLeadingProperty())&&o.getSortablePropertyNames().indexOf(this.getLeadingProperty())>-1&&o.getFilterablePropertyNames().indexOf(this.getLeadingProperty())>-1){return true;}}}return false;};
b.ofCell=C.ofCell;return b;});
sap.ui.predefine('sap/ui/table/AnalyticalColumnMenu',['./ColumnMenu',"sap/ui/unified/MenuRenderer",'./library',"sap/ui/thirdparty/jquery"],function(C,M,l,q){"use strict";var G=l.GroupEventType;
var A=C.extend("sap.ui.table.AnalyticalColumnMenu",{
metadata:{library:"sap.ui.table"},
renderer:"sap.ui.unified.MenuRenderer"
});
A.prototype._addMenuItems=function(){C.prototype._addMenuItems.apply(this);if(this._oColumn){this._addSumMenuItem();}};
A.prototype._addGroupMenuItem=function(){var c=this._oColumn,t=this._oTable;if(c.isGroupable()){this._oGroupIcon=this._createMenuItem("group","TBL_GROUP",c.getGrouped()?"accept":null,function(e){var m=e.getSource();var g=c.getGrouped();var s=g?G.group:G.ungroup;c.setGrouped(!g);t.fireGroup({column:c,groupedColumns:t._aGroupedColumns,type:s});m.setIcon(!g?"sap-icon://accept":null);});this.addItem(this._oGroupIcon);}};
A.prototype._addSumMenuItem=function(){var c=this._oColumn,t=this._oTable,b=t.getBinding("rows"),r=b&&b.getAnalyticalQueryResult();if(t&&r&&r.findMeasureByPropertyName(c.getLeadingProperty())){this._oSumItem=this._createMenuItem("total","TBL_TOTAL",c.getSummed()?"accept":null,q.proxy(function(e){var m=e.getSource(),s=c.getSummed();c.setSummed(!s);m.setIcon(!s?"sap-icon://accept":null);},this));this.addItem(this._oSumItem);}};
A.prototype.open=function(){C.prototype.open.apply(this,arguments);var c=this._oColumn;this._oSumItem&&this._oSumItem.setIcon(c.getSummed()?"sap-icon://accept":null);this._oGroupIcon&&this._oGroupIcon.setIcon(c.getGrouped()?"sap-icon://accept":null);};
return A;});
sap.ui.predefine('sap/ui/table/AnalyticalColumnMenuRenderer',['sap/ui/table/AnalyticalColumnMenu'],function(M){"use strict";return M.getMetadata().getRenderer();},true);
sap.ui.predefine('sap/ui/table/AnalyticalTable',['./AnalyticalColumn','./Table','./TreeTable',"./TableRenderer",'./library','sap/ui/model/analytics/ODataModelAdapter','sap/ui/model/SelectionModel','sap/ui/model/Sorter','sap/ui/unified/Menu','sap/ui/unified/MenuItem','./TableUtils',"./plugins/BindingSelectionPlugin","sap/base/Log","sap/base/assert","sap/ui/thirdparty/jquery","sap/base/util/UriParameters"],function(A,T,a,b,c,O,S,d,M,e,f,B,L,g,q,U){"use strict";var G=c.GroupEventType,h=c.SortOrder,k=c.TreeAutoExpandMode;
var m=T.extend("sap.ui.table.AnalyticalTable",{
metadata:{library:"sap.ui.table",properties:{sumOnTop:{type:"boolean",group:"Appearance",defaultValue:false,deprecated:true},numberOfExpandedLevels:{type:"int",group:"Misc",defaultValue:0,deprecated:true},autoExpandMode:{type:"string",group:"Misc",defaultValue:"Bundled",deprecated:true},columnVisibilityMenuSorter:{type:"any",group:"Appearance",defaultValue:null},collapseRecursive:{type:"boolean",defaultValue:true},dirty:{type:"boolean",group:"Appearance",defaultValue:null,deprecated:true}},designtime:"sap/ui/table/designtime/AnalyticalTable.designtime"},
renderer:"sap.ui.table.TableRenderer"
});
m.prototype._getFixedBottomRowContexts=function(){var o=this.getBinding("rows");if(o){return[o.getGrandTotalNode()];}};
m.prototype._getContexts=a.prototype._getContexts;
m.prototype.init=function(){T.prototype.init.apply(this,arguments);this.addStyleClass("sapUiAnalyticalTable");this.setShowColumnVisibilityMenu(true);this.setEnableColumnFreeze(true);this.setEnableCellFilter(true);this._aGroupedColumns=[];this._bSuspendUpdateAnalyticalInfo=false;f.Grouping.setGroupMode(this);};
m.prototype.exit=function(){this._cleanupGroupHeaderMenu();T.prototype.exit.apply(this,arguments);};
m.prototype._adaptLocalization=function(r,l){return T.prototype._adaptLocalization.apply(this,arguments).then(function(){if(l){this._cleanupGroupHeaderMenu();}}.bind(this));};
m.prototype.setFixedRowCount=function(){L.error("The property fixedRowCount is not supported by control sap.ui.table.AnalyticalTable!");return this;};
m.prototype.setFixedBottomRowCount=function(){L.error("The property fixedBottomRowCount is managed by control sap.ui.table.AnalyticalTable!");return this;};
m.prototype.setDirty=function(D){L.error("The property dirty of control sap.ui.table.AnalyticalTable is deprecated. Please use showOverlay instead.");this.setProperty("dirty",D,true);this.setShowOverlay(this.getDirty());return this;};
m.prototype.setEnableGrouping=function(){L.error("The property enableGrouping is not supported by the sap.ui.table.AnalyticalTable control");return this;};
m.prototype.setGroupBy=function(){L.warning("The groupBy association is not supported by the sap.ui.table.AnalyticalTable control");return this;};
m.prototype.getModel=function(n){var o=T.prototype.getModel.apply(this,arguments);var r=this.getBindingInfo("rows");if(o&&r&&r.model==n){O.apply(o);}return o;};
m.prototype._onBindingChange=function(E){T.prototype._onBindingChange.apply(this,arguments);var r=typeof(E)==="object"?E.getParameter("reason"):E;if(r!=="sort"){this._invalidateColumnMenus();}};
m.prototype._bindAggregation=function(n,o){if(n==="rows"){this.setProperty("firstVisibleRow",0,true);this._applyAnalyticalBindingInfo(o);this._updateTotalRow(true);this._applyODataModelAnalyticalAdapter(o.model);}T.prototype._bindAggregation.call(this,n,o);if(n==="rows"){f.Binding.metadataLoaded(this).then(function(){this._updateColumns(true);}.bind(this));}};
m.prototype._applyAnalyticalBindingInfo=function(o){var C=this.getColumns();for(var i=0,l=C.length;i<l;i++){if(C[i].getSorted()){o.sorter=o.sorter||[];o.sorter.push(new d(C[i].getSortProperty()||C[i].getLeadingProperty(),C[i].getSortOrder()===h.Descending));}}o.parameters=o.parameters||{};o.parameters.analyticalInfo=this._getColumnInformation();if(!o.parameters.hasOwnProperty("sumOnTop")){o.parameters.sumOnTop=this.getSumOnTop();}if(!o.parameters.hasOwnProperty("numberOfExpandedLevels")){o.parameters.numberOfExpandedLevels=this.getNumberOfExpandedLevels();}if(o.parameters.numberOfExpandedLevels>this._aGroupedColumns.length){o.parameters.numberOfExpandedLevels=0;}if(!o.parameters.hasOwnProperty("autoExpandMode")){var E=this.getAutoExpandMode();if(E!=k.Bundled&&E!=k.Sequential){E=k.Bundled;}o.parameters.autoExpandMode=E;}};
m.prototype._applyODataModelAnalyticalAdapter=function(o){if(o){O.apply(o);}};
m.prototype._getColumnInformation=function(){var C=[],t=this.getColumns();for(var i=0;i<this._aGroupedColumns.length;i++){var o=sap.ui.getCore().byId(this._aGroupedColumns[i]);if(!o){continue;}C.push({name:o.getLeadingProperty(),visible:o.getVisible(),grouped:o.getGrouped(),total:o.getSummed(),sorted:o.getSorted(),sortOrder:o.getSortOrder(),inResult:o.getInResult(),formatter:o.getGroupHeaderFormatter()});}for(var i=0;i<t.length;i++){var o=t[i];if(this._aGroupedColumns.indexOf(o.getId())>-1){continue;}if(!o instanceof A){L.error("You have to use AnalyticalColumns for the Analytical table");}C.push({name:o.getLeadingProperty(),visible:o.getVisible(),grouped:o.getGrouped(),total:o.getSummed(),sorted:o.getSorted(),sortOrder:o.getSortOrder(),inResult:o.getInResult(),formatter:o.getGroupHeaderFormatter()});}return C;};
m.prototype._updateTableContent=function(){var o=this.getBinding("rows");var r=this._getRowCounts();var R=this.getRows();var i;if(!o){for(i=0;i<R.length;i++){f.Grouping.cleanupTableRowForGrouping(this,R[i]);}return;}var l=this.getBindingInfo("rows");var t=this._getTotalRowCount()>r.count;for(i=0;i<R.length;i++){var I=i>(r.count-r.fixedBottom-1)&&t;var n=R[i];var p=n.getIndex();var C;if(I&&o.bProvideGrandTotals){C=o.getGrandTotalContextInfo();}else{C=this.getContextInfoByIndex(p);}var s=C?C.level:0;if(!C||!C.context){f.Grouping.cleanupTableRowForGrouping(this,n);continue;}if(o.nodeHasChildren&&o.nodeHasChildren(C)){f.Grouping.updateTableRowForGrouping(this,n,true,C.nodeState.expanded,C.nodeState.expanded&&!l.parameters.sumOnTop,false,s,o.getGroupName(C.context,C.level));}else{f.Grouping.updateTableRowForGrouping(this,n,false,false,false,C.nodeState.sum,s,C.nodeState.sum&&C.level>0?o.getGroupName(C.context,C.level):null);}var u=n.getCells();var v=u.length;for(var j=0;j<v;j++){var w=A.ofCell(u[j]);var $=q(u[j].$().closest("td"));if(o.isMeasure(w.getLeadingProperty())){$.addClass("sapUiTableMeasureCell");$.toggleClass("sapUiTableCellHidden",C.nodeState.sum&&!w.getSummed());}else{$.removeClass("sapUiTableMeasureCell");}}}};
m.prototype.oncontextmenu=function(E){if(q(E.target).closest('tr').hasClass('sapUiTableGroupHeader')||q(E.target).closest('.sapUiTableGroupHeader > .sapUiTableRowSelectionCell').length>0){this._iGroupedLevel=q(E.target).closest('[data-sap-ui-level]').data('sap-ui-level');var o=this._getGroupHeaderMenu();o.openAsContextMenu(E,f.getCell(this,E.target)||E.target);E.preventDefault();E.stopPropagation();}};
m.prototype._getGroupHeaderMenu=function(){var t=this;function j(){var i=t._iGroupedLevel-1;if(t._aGroupedColumns[i]){var l=t.getColumns().filter(function(C){return t._aGroupedColumns[i]===C.getId();})[0];return{column:l,index:i};}else{return undefined;}}if(!this._oGroupHeaderMenu){this._oGroupHeaderMenu=new M();this._oGroupHeaderMenuVisibilityItem=new e({text:f.getResourceText("TBL_SHOW_COLUMN"),select:function(){var o=j();if(o){var C=o.column,s=C.getShowIfGrouped();C.setShowIfGrouped(!s);t.fireGroup({column:C,groupedColumns:C.getParent()._aGroupedColumns,type:(!s?G.showGroupedColumn:G.hideGroupedColumn)});}}});this._oGroupHeaderMenu.addItem(this._oGroupHeaderMenuVisibilityItem);this._oGroupHeaderMenu.addItem(new e({text:f.getResourceText("TBL_UNGROUP"),select:function(){var o=j();if(o&&o.column){var u=o.column;u.setGrouped(false);t.fireGroup({column:u,groupedColumns:t._aGroupedColumns,type:G.ungroup});}}}));this._oGroupHeaderMenu.addItem(new e({text:f.getResourceText("TBL_UNGROUP_ALL"),select:function(){var l=t.getColumns();t.suspendUpdateAnalyticalInfo();for(var i=0;i<l.length;i++){l[i].setGrouped(false);}t.resumeUpdateAnalyticalInfo();t.fireGroup({column:undefined,groupedColumns:[],type:G.ungroupAll});}}));this._oGroupHeaderMoveUpItem=new e({text:f.getResourceText("TBL_MOVE_UP"),select:function(){var o=j();if(o){var C=o.column;var i=t._aGroupedColumns.indexOf(C.getId());if(i>0){t._aGroupedColumns[i]=t._aGroupedColumns.splice(i-1,1,t._aGroupedColumns[i])[0];t.updateAnalyticalInfo();t.fireGroup({column:C,groupedColumns:C.getParent()._aGroupedColumns,type:G.moveUp});}}},icon:"sap-icon://arrow-top"});this._oGroupHeaderMenu.addItem(this._oGroupHeaderMoveUpItem);this._oGroupHeaderMoveDownItem=new e({text:f.getResourceText("TBL_MOVE_DOWN"),select:function(){var o=j();if(o){var C=o.column;var i=t._aGroupedColumns.indexOf(C.getId());if(i<t._aGroupedColumns.length){t._aGroupedColumns[i]=t._aGroupedColumns.splice(i+1,1,t._aGroupedColumns[i])[0];t.updateAnalyticalInfo();t.fireGroup({column:C,groupedColumns:C.getParent()._aGroupedColumns,type:G.moveDown});}}},icon:"sap-icon://arrow-bottom"});this._oGroupHeaderMenu.addItem(this._oGroupHeaderMoveDownItem);this._oGroupHeaderMenu.addItem(new e({text:f.getResourceText("TBL_SORT_ASC"),select:function(){var o=j();if(o){var C=o.column;C.sort(false);}},icon:"sap-icon://up"}));this._oGroupHeaderMenu.addItem(new e({text:f.getResourceText("TBL_SORT_DESC"),select:function(){var o=j();if(o){var C=o.column;C.sort(true);}},icon:"sap-icon://down"}));this._oGroupHeaderMenu.addItem(new e({text:f.getResourceText("TBL_COLLAPSE_LEVEL"),select:function(){t.getBinding("rows").collapseToLevel(t._iGroupedLevel-1);t.setFirstVisibleRow(0);t._getSelectionPlugin().clearSelection();}}));this._oGroupHeaderMenu.addItem(new e({text:f.getResourceText("TBL_COLLAPSE_ALL"),select:function(){t.getBinding("rows").collapseToLevel(0);t.setFirstVisibleRow(0);t._getSelectionPlugin().clearSelection();}}));this._oGroupHeaderMenu.addItem(new e({text:f.getResourceText("TBL_EXPAND_LEVEL"),select:function(){t.getBinding("rows").expandToLevel(t._iGroupedLevel);t.setFirstVisibleRow(0);t._getSelectionPlugin().clearSelection();}}));this._oGroupHeaderMenu.addItem(new e({text:f.getResourceText("TBL_EXPAND_ALL"),select:function(){t.expandAll();}}));}var o=j();if(o){var C=o.column;if(C.getShowIfGrouped()){this._oGroupHeaderMenuVisibilityItem.setText(f.getResourceText("TBL_HIDE_COLUMN"));}else{this._oGroupHeaderMenuVisibilityItem.setText(f.getResourceText("TBL_SHOW_COLUMN"));}this._oGroupHeaderMoveUpItem.setEnabled(o.index>0);this._oGroupHeaderMoveDownItem.setEnabled(o.index<this._aGroupedColumns.length-1);}else{this._oGroupHeaderMoveUpItem.setEnabled(true);this._oGroupHeaderMoveDownItem.setEnabled(true);}return this._oGroupHeaderMenu;};
m.prototype._cleanupGroupHeaderMenu=function(){if(this._oGroupHeaderMenu){this._oGroupHeaderMenu.destroy();this._oGroupHeaderMenu=null;this._oGroupHeaderMenuVisibilityItem=null;this._oGroupHeaderMoveUpItem=null;this._oGroupHeaderMoveDownItem=null;}};
m.prototype.getContextByIndex=function(i){var o=this.getBinding("rows");return i>=0&&o?o.getContextByIndex(i):null;};
m.prototype.getContextInfoByIndex=function(i){var o=this.getBinding("rows");return i>=0&&o?o.getNodeByIndex(i):null;};
m.prototype.suspendUpdateAnalyticalInfo=function(){this._bSuspendUpdateAnalyticalInfo=true;};
m.prototype.resumeUpdateAnalyticalInfo=function(s,F){this._bSuspendUpdateAnalyticalInfo=false;this._updateColumns(s,F);};
m.prototype.addColumn=function(C,s){var o=this._getColumn(C);if(o.getGrouped()){this._addGroupedColumn(o.getId());}T.prototype.addColumn.call(this,o,s);this._updateColumns(s);return this;};
m.prototype.insertColumn=function(C,i,s){var o=this._getColumn(C);if(o.getGrouped()){this._addGroupedColumn(o.getId());}T.prototype.insertColumn.call(this,o,i,s);this._updateColumns(s);return this;};
m.prototype.removeColumn=function(C,s){var r=T.prototype.removeColumn.apply(this,arguments);if(!this._bReorderInProcess){this._aGroupedColumns=q.grep(this._aGroupedColumns,function(v){if(C.getId){return v!=C.getId();}else{return v==C;}});}this.updateAnalyticalInfo(s);return r;};
m.prototype.removeAllColumns=function(s){this._aGroupedColumns=[];var r=T.prototype.removeAllColumns.apply(this,arguments);this._updateColumns(s);return r;};
m.prototype._getColumn=function(C){if(typeof C==="string"){var o=new A({leadingProperty:C,template:C,managed:true});return o;}else if(C instanceof A){return C;}else{throw new Error("Wrong column type. You need to define a string (property) or pass an AnalyticalColumnObject");}};
m.prototype._updateColumns=function(s,F){if(!this._bSuspendUpdateAnalyticalInfo){this._updateTableColumnDetails();this.updateAnalyticalInfo(s,F);if(this.bOutput){this.invalidate();}}};
m.prototype.updateAnalyticalInfo=function(s,F){if(this._bSuspendUpdateAnalyticalInfo){return;}var o=this.getBinding("rows");if(o){var C=this._getColumnInformation();var n=o.getNumberOfExpandedLevels()||0;if(n>this._aGroupedColumns.length){o.setNumberOfExpandedLevels(0);}o.updateAnalyticalInfo(C,F);this._updateTotalRow(s);if(!s){this._getRowContexts();}}};
m.prototype.refreshRows=function(){T.prototype.refreshRows.apply(this,arguments);this._updateTotalRow();};
m.prototype._updateTotalRow=function(s){var o=this.getBinding("rows");var n=0;var r=this.getRowMode();if(o&&(o.providesGrandTotal()&&o.hasTotaledMeasures())){n=1;}if(r){r.setProperty("fixedBottomRowCount",n,s);}else{this.setProperty("fixedBottomRowCount",n,s);}};
m.prototype._updateTableColumnDetails=function(){if(this._bSuspendUpdateAnalyticalInfo){return;}var l=this.getBinding("rows"),r=l&&l.getAnalyticalQueryResult();if(r){var C=this.getColumns(),n=[],u=[],D=[],p={},t,v;for(var i=0;i<C.length;i++){t=C[i];t._isLastGroupableLeft=false;t._bLastGroupAndGrouped=false;t._bDependendGrouped=false;if(!t.getVisible()){continue;}var w=t.getLeadingProperty();v=r.findDimensionByPropertyName(w);if(v){var x=v.getName();if(!p[x]){p[x]={dimension:v,columns:[t]};}else{p[x].columns.push(t);}if(t.getGrouped()&&n.indexOf(x)==-1){n.push(x);}if(D.indexOf(x)==-1){D.push(x);}}}u=q.grep(D,function(s){return n.indexOf(n,s)==-1;});if(n.length>0){q.each(n,function(i,s){q.each(p[s].columns,function(j,o){if(!o.getGrouped()){o._bDependendGrouped=true;}});});if(n.length==D.length){v=r.findDimensionByPropertyName(sap.ui.getCore().byId(this._aGroupedColumns[this._aGroupedColumns.length-1]).getLeadingProperty());var y=p[v.getName()].columns;q.each(y,function(i,o){o._bLastGroupAndGrouped=true;});}}if(u.length==1){q.each(p[u[0]].columns,function(j,o){o._isLastGroupableLeft=true;});}}};
m.prototype._getFirstMeasureColumnIndex=function(){var o=this.getBinding("rows"),r=o&&o.getAnalyticalQueryResult(),C=this._getVisibleColumns();if(!r){return-1;}for(var i=0;i<C.length;i++){var j=C[i],l=j.getLeadingProperty();if(r.findMeasureByName(l)||r.findMeasureByPropertyName(l)){return i;}}};
m.prototype.getTotalSize=function(){var o=this.getBinding("rows");if(o){return o.getTotalSize();}return 0;};
m.prototype._onPersoApplied=function(){T.prototype._onPersoApplied.apply(this,arguments);this._aGroupedColumns=[];var C=this.getColumns();for(var i=0,l=C.length;i<l;i++){if(C[i].getGrouped()){this._addGroupedColumn(C[i].getId());}}this._updateColumns();};
m.prototype._addGroupedColumn=function(C){if(this._aGroupedColumns.indexOf(C)===-1){this._aGroupedColumns.push(C);}};
m.prototype._removeGroupedColumn=function(C){var i=this._aGroupedColumns.indexOf(C);if(i>=0){this._aGroupedColumns.splice(i,1);}};
m.prototype.getGroupedColumns=function(){return this._aGroupedColumns;};
m.prototype.setCollapseRecursive=function(C){var o=this.getBinding("rows");if(o){g(o.setCollapseRecursive,"Collapse Recursive is not supported by the used binding");if(o.setCollapseRecursive){o.setCollapseRecursive(C);}}this.setProperty("collapseRecursive",!!C,true);return this;};
m.prototype.expand=a.prototype.expand;m.prototype.collapse=a.prototype.collapse;
m.prototype.expandAll=function(){var o=this.getBinding("rows");if(o){o.expandToLevel(this._aGroupedColumns.length);this.setFirstVisibleRow(0);this._getSelectionPlugin().clearSelection();}return this;};
m.prototype.collapseAll=a.prototype.collapseAll;m.prototype.isExpanded=a.prototype.isExpanded;
m.prototype.getAnalyticalInfoOfRow=function(r){if(!f.isA(r,"sap.ui.table.Row")||r.getParent()!==this){return null;}var o=this.getBindingInfo("rows");var j=this.getBinding("rows");if(!o||!j){return null;}var C=r.getBindingContext(o.model);if(!C){return null;}var I=C===j.getGrandTotalContext();var l=null;var n=-1;if(I){l=j.getGrandTotalContextInfo();n=0;}else{l=this.getContextInfoByIndex(r.getIndex());if(l){n=l.level;}}var p=l&&j.nodeHasChildren&&j.nodeHasChildren(l);var s=!p&&!I&&l&&l.nodeState&&l.nodeState.sum;var t=[];if(s||p){var u=this.getGroupedColumns();if(u.length>0&&n>0&&n<=u.length){for(var i=0;i<n;i++){t.push(u[i]);}}}return{grandTotal:I,group:p,groupTotal:s,level:n,context:C,groupedColumns:t};};
m.prototype.setRowMode=function(r){T.prototype.setRowMode.apply(this,arguments);this._getRowMode().disableFixedRows();};
m.prototype._initLegacyRowMode=function(r){T.prototype._initLegacyRowMode.apply(this,arguments);this._getRowMode().disableFixedRows();};
m.prototype._createLegacySelectionPlugin=function(){return new B(this);};
return m;});
sap.ui.predefine('sap/ui/table/AnalyticalTableRenderer',['sap/ui/table/AnalyticalTable'],function(T){"use strict";return T.getMetadata().getRenderer();},true);
sap.ui.predefine('sap/ui/table/Column',['sap/ui/core/Element','sap/ui/core/library','sap/ui/core/Popup','sap/ui/model/Filter','sap/ui/model/FilterOperator','sap/ui/model/FilterType','sap/ui/model/Sorter','sap/ui/model/Type','sap/ui/model/type/String','./TableUtils','./library','./ColumnMenu','sap/base/util/ObjectPath',"sap/base/util/JSTokenizer","sap/base/Log","sap/ui/thirdparty/jquery"],function(E,c,P,F,a,b,S,T,d,f,g,C,O,J,L,q){"use strict";var H=c.HorizontalAlign,h=g.SortOrder,V=c.ValueState;var j={Standard:"Standard",Creation:"Creation"};var k=new window.WeakMap();
var m=E.extend("sap.ui.table.Column",{metadata:{library:"sap.ui.table",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},minWidth:{type:"int",group:"Dimension",defaultValue:0},flexible:{type:"boolean",group:"Behavior",defaultValue:true,deprecated:true},resizable:{type:"boolean",group:"Behavior",defaultValue:true},hAlign:{type:"sap.ui.core.HorizontalAlign",group:"Appearance",defaultValue:H.Begin},sorted:{type:"boolean",group:"Appearance",defaultValue:false},sortOrder:{type:"sap.ui.table.SortOrder",group:"Appearance",defaultValue:h.Ascending},sortProperty:{type:"string",group:"Behavior",defaultValue:null},filtered:{type:"boolean",group:"Appearance",defaultValue:false},filterProperty:{type:"string",group:"Behavior",defaultValue:null},filterValue:{type:"string",group:"Behavior",defaultValue:null},filterOperator:{type:"string",group:"Behavior",defaultValue:null},defaultFilterOperator:{type:"string",group:"Behavior",defaultValue:null},filterType:{type:"any",group:"Misc",defaultValue:null},grouped:{type:"boolean",group:"Appearance",defaultValue:false},visible:{type:"boolean",group:"Appearance",defaultValue:true},name:{type:"string",group:"Appearance",defaultValue:null},showFilterMenuEntry:{type:"boolean",group:"Appearance",defaultValue:true},showSortMenuEntry:{type:"boolean",group:"Appearance",defaultValue:true},headerSpan:{type:"any",group:"Behavior",defaultValue:1},autoResizable:{type:"boolean",group:"Behavior",defaultValue:false}},defaultAggregation:"label",aggregations:{label:{type:"sap.ui.core.Control",altTypes:["string"],multiple:false},multiLabels:{type:"sap.ui.core.Control",multiple:true,singularName:"multiLabel"},template:{type:"sap.ui.core.Control",altTypes:["string"],multiple:false},creationTemplate:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},menu:{type:"sap.ui.unified.Menu",multiple:false}},events:{columnMenuOpen:{allowPreventDefault:true,parameters:{menu:{type:"sap.ui.unified.Menu"}}}}}});
m._DEFAULT_FILTER_TYPE=new d();
m.prototype.init=function(){this.mSkipPropagation={template:true,creationTemplate:true};this._oSorter=null;this._initTemplateClonePool();};
m.prototype._initTemplateClonePool=function(){this._mTemplateClones=Object.keys(j).reduce(function(t,s){t[s]=[];return t;},{});};
m.prototype.exit=function(){this._destroyTemplateClones();C._destroyColumnVisibilityMenuItem(this.oParent);};
m.prototype.setParent=function(p,A,s){C._destroyColumnVisibilityMenuItem(this.oParent);var r=E.prototype.setParent.apply(this,arguments);var M=this.getAggregation("menu");if(M&&typeof M._updateReferences==="function"){M._updateReferences(this);}return r;};
m.prototype.invalidate=function(o){if(o!==this.getTemplate()&&o!==this.getCreationTemplate()&&!f.isA(o,"sap.ui.table.ColumnMenu")){E.prototype.invalidate.apply(this,arguments);}};
m.prototype.setLabel=function(l){var o=l;if(typeof(l)==="string"){o=g.TableHelper.createLabel({text:l});}this.setAggregation("label",o);return this;};
m.prototype.setTemplate=function(t){var o=t;var e=this._getTable();var i=this.getTemplate();if(typeof t==="string"){o=g.TableHelper.createTextView().bindProperty("text",t);}this.setAggregation("template",o,true);if(this.getVisible()){this.invalidate();}this._destroyTemplateClones("Standard");if(e&&this.getVisible()){if(o){e.invalidateRowsAggregation();}if(!i||!o){var l=e.getCreationRow();if(l){l._update();}}}return this;};
m.prototype.destroyTemplate=function(){this.destroyAggregation("template");this._destroyTemplateClones("Standard");var t=this._getTable();var o=t?t.getCreationRow():null;if(o){o._update();}return this;};
m.prototype.setCreationTemplate=function(o){var t=this._getTable();this.setAggregation("creationTemplate",o,true);this._destroyTemplateClones("Creation");if(o&&t&&this.getVisible()){var e=t.getCreationRow();if(e){e._update();}}return this;};
m.prototype.getCreationTemplate=function(){return this.getAggregation("creationTemplate");};
m.prototype.destroyCreationTemplate=function(){this.destroyAggregation("creationTemplate",true);this._destroyTemplateClones("Creation");return this;};
m.prototype.getMenu=function(){var M=this.getAggregation("menu");if(!M){M=this._createMenu();this.setMenu(M);}return M;};
m.prototype.invalidateMenu=function(){var M=this.getAggregation("menu");if(this._bMenuIsColumnMenu){M._invalidate();}};
m.prototype._menuHasItems=function(){var M=this.getAggregation("menu");var t=this.getParent();var e=function(){return(this.isSortableByMenu()||this.isFilterableByMenu()||this.isGroupable()||(t&&t.getEnableColumnFreeze())||(t&&t.getShowColumnVisibilityMenu()));}.bind(this);return!!((M&&M.getItems().length>0)||e());};
m.prototype.isFilterableByMenu=function(){return!!(this.getFilterProperty()&&this.getShowFilterMenuEntry());};
m.prototype.isSortableByMenu=function(){return!!(this.getSortProperty()&&this.getShowSortMenuEntry());};
m.prototype.isGroupable=function(){var t=this.getParent();return!!(t&&t.getEnableGrouping&&t.getEnableGrouping()&&this.getSortProperty());};
m.prototype.setMenu=function(M){this.setAggregation("menu",M,true);this._bMenuIsColumnMenu=f.isA(M,"sap.ui.table.ColumnMenu");return this;};
m.prototype._createMenu=function(){if(!this._defaultMenu){this._defaultMenu=new C(this.getId()+"-menu",{ariaLabelledBy:this});}return this._defaultMenu;};
m.prototype.setSortProperty=function(v){this.setProperty("sortProperty",v);this.invalidateMenu();return this;};
m.prototype.setSorted=function(e){this.setProperty("sorted",e,true);this._updateIcons();return this;};
m.prototype.setSortOrder=function(t){this.setProperty("sortOrder",t,true);this._updateIcons();return this;};
m.prototype.setFilterProperty=function(v){this.invalidateMenu();return this.setProperty("filterProperty",v);};
m.prototype.setFiltered=function(e){this.setProperty("filtered",e,true);this._updateIcons();return this;};
m.prototype.setFilterValue=function(v){this.setProperty("filterValue",v,true);var M=this.getMenu();if(this._bMenuIsColumnMenu){M._setFilterValue(v);}return this;};
m.prototype.setFilterOperator=function(v){return this.setProperty("filterOperator",v,true);};
m.prototype._openMenu=function(D,w){var M=this.getMenu();var e=this.fireColumnMenuOpen({menu:M});if(e){var i=P.Dock;var o=D;if(!D){D=this.getDomRef();o=this.getFocusDomRef();}M.open(!!w,o,i.BeginTop,i.BeginBottom,D);}};
m.prototype.toggleSort=function(){this.sort(this.getSorted()&&this.getSortOrder()===h.Ascending);};
m.prototype.sort=function(D,A){var t=this.getParent();if(t){t.pushSortedColumn(this,A);var N=D?h.Descending:h.Ascending;var e=t.fireSort({column:this,sortOrder:N,columnAdded:A});if(e){var s=t.getSortedColumns();var o=t.getColumns();for(var i=0,l=o.length;i<l;i++){if(s.indexOf(o[i])<0){o[i].setProperty("sorted",false,true);o[i].setProperty("sortOrder",h.Ascending,true);o[i]._updateIcons(true);delete o[i]._oSorter;}}this.setProperty("sorted",true,true);this.setProperty("sortOrder",N,true);this._oSorter=new S(this.getSortProperty(),this.getSortOrder()===h.Descending);var p=[];for(var i=0,l=s.length;i<l;i++){s[i]._updateIcons(true);p.push(s[i]._oSorter);}t._resetColumnHeaderHeights();t._updateRowHeights(t._collectRowHeights(true),true);var B=t.getBinding("rows");if(B){if(this._updateTableAnalyticalInfo){this._updateTableAnalyticalInfo(true);}B.sort(p);}else{L.warning("Sorting not performed because no binding present",this);}}}return this;};
m.prototype._updateIcons=function(s){var t=this.getParent(),e=this.getSorted(),i=this.getFiltered();if(!t||!t.getDomRef()){return;}this.$().parents(".sapUiTableCHT").find('td[data-sap-ui-colindex="'+this.getIndex()+'"]:not([colspan]):not(.sapUiTableHidden):first').toggleClass("sapUiTableColFiltered",i).toggleClass("sapUiTableColSorted",e).toggleClass("sapUiTableColSortedD",e&&this.getSortOrder()===h.Descending);t._getAccExtension().updateAriaStateOfColumn(this);if(!s){t._resetColumnHeaderHeights();t._updateRowHeights(t._collectRowHeights(true),true);}};
m.prototype._renderSortIcon=function(){this._updateIcons();};
m.prototype._getFilter=function(){var o,p=this.getFilterProperty(),v=this.getFilterValue(),s=this.getFilterOperator(),e,i,t=this.getFilterType()||m._DEFAULT_FILTER_TYPE,I=t instanceof d,B;if(v){if(!s){B=v.match(/(.*)\s*\.\.\s*(.*)/);if(v.indexOf("=")==0){s=a.EQ;e=v.substr(1);}else if(v.indexOf("!=")==0){s=a.NE;e=v.substr(2);}else if(v.indexOf("<=")==0){s=a.LE;e=v.substr(2);}else if(v.indexOf("<")==0){s=a.LT;e=v.substr(1);}else if(v.indexOf(">=")==0){s=a.GE;e=v.substr(2);}else if(v.indexOf(">")==0){s=a.GT;e=v.substr(1);}else if(B){if(B[1]&&B[2]){s=a.BT;e=B[1];i=B[2];}else if(B[1]&&!B[2]){s=a.GE;e=B[1];}else{s=a.LE;e=B[2];}}else if(I&&v.indexOf("*")==0&&v.lastIndexOf("*")==v.length-1){s=a.Contains;e=v.substr(1,v.length-2);}else if(I&&v.indexOf("*")==0){s=a.EndsWith;e=v.substr(1);}else if(I&&v.lastIndexOf("*")==v.length-1){s=a.StartsWith;e=v.substr(0,v.length-1);}else{if(this.getDefaultFilterOperator()){s=this.getDefaultFilterOperator();}else{if(I){s=a.Contains;}else{s=a.EQ;}}e=v.substr(0);}if(!i){o=new F(p,s,this._parseFilterValue(e));}else{o=new F(p,s,this._parseFilterValue(e),this._parseFilterValue(i));}}else{o=new F(p,s,this._parseFilterValue(v));}}return o;};
m.prototype.filter=function(v){var t=this.getParent();if(t&&t.isBound("rows")){var o=t.fireFilter({column:this,value:v});if(o){this.setProperty("filtered",!!v,true);this.setProperty("filterValue",v,true);var M=this.getMenu();if(this._bMenuIsColumnMenu){M._setFilterValue(v);}var p=[];var r=t.getColumns();for(var i=0,l=r.length;i<l;i++){var s=r[i],u;M=s.getMenu();try{u=s._getFilter();if(s._bMenuIsColumnMenu){M._setFilterState(V.None);}}catch(e){if(s._bMenuIsColumnMenu){M._setFilterState(V.Error);}continue;}if(u){p.push(u);}}t.getBinding("rows").filter(p,b.Control);this._updateIcons();}}return this;};
m.prototype._parseFilterValue=function(v){var o=this.getFilterType();if(o){if(q.isFunction(o)){v=o(v);}else{v=o.parseValue(v,"string");}}return v;};
m.prototype.shouldRender=function(){return this.getVisible()&&!this.getGrouped()&&this.getTemplate()!=null;};
m.prototype.setProperty=function(N,v){var t=this._getTable();var e=t&&N==="visible"&&this.getProperty(N)!=v;var r=E.prototype.setProperty.apply(this,arguments);if(e){t.invalidateRowsAggregation();var o=t.getCreationRow();if(o){o._update();}}return r;};
m.prototype.setFilterType=function(t){var o=t;if(typeof(t)==="string"){try{var e=J.parseJS(t);if(typeof(e.type)==="string"){var i=O.get(e.type);o=i&&new i(e.formatOptions,e.constraints);}}catch(l){var i=O.get(t);o=i&&new i();}if(!(o instanceof T)){L.error("The filter type is not an instance of sap.ui.model.Type! Ignoring the filter type!");o=undefined;}}this.setProperty("filterType",o,true);return this;};
m.prototype.getIndex=function(){var t=this.getParent();if(t){return t.indexOfColumn(this);}else{return-1;}};
m.prototype._getFreeTemplateClone=function(t){var e=this._mTemplateClones[t];var o=null;if(!e){return null;}for(var i=0;i<e.length;i++){if(!e[i]||e[i].bIsDestroyed){e.splice(i,1);i--;}else if(!o&&!e[i].getParent()){o=e[i];}}return o;};
m.prototype.getTemplateClone=function(i,p){if(typeof i!=="number"||this.getTemplate()==null){return null;}var t=p==null?"Standard":p;var o=this._getFreeTemplateClone(t);if(!o&&j.hasOwnProperty(t)){var G=this["get"+(t==="Standard"?"":t)+"Template"];var e=G.call(this);if(e){o=e.clone();this._mTemplateClones[t].push(o);}}if(o){k.set(o,this);var l=this.getParent();if(l){l._getAccExtension().addColumnHeaderLabel(this,o);}}return o;};
function n(e){for(var i=0;i<e.length;i++){if(e[i]!=null&&!e[i].bIsDestroyed){e[i].destroy();}}}
m.prototype._destroyTemplateClones=function(t){if(t==null){for(var s in j){n(this._mTemplateClones[s]);}this._initTemplateClonePool();}else{n(this._mTemplateClones[t]);this._mTemplateClones[t]=[];}};
m.prototype._closeMenu=function(){var M=this.getAggregation("menu");if(M){M.close();}};
m.prototype.setVisible=function(v){this.setProperty("visible",v);C._updateVisibilityIcon(this.getParent(),this.getIndex(),v);return this;};
m.prototype._getTable=function(){var p=this.getParent();return f.isA(p,"sap.ui.table.Table")?p:null;};
m.ofCell=function(o){return k.get(o)||null;};
return m;});
sap.ui.predefine('sap/ui/table/ColumnMenu',['./library','sap/ui/unified/Menu','sap/ui/unified/MenuItem','sap/ui/unified/MenuTextFieldItem',"sap/ui/unified/MenuRenderer",'sap/ui/Device','./TableUtils',"sap/base/assert","sap/ui/thirdparty/jquery"],function(a,M,b,c,d,D,T,e,q){"use strict";
var C=M.extend("sap.ui.table.ColumnMenu",{
metadata:{library:"sap.ui.table"},
renderer:"sap.ui.unified.MenuRenderer"
});
C.prototype.init=function(){if(M.prototype.init){M.prototype.init.apply(this,arguments);}this.addStyleClass("sapUiTableColumnMenu");this._bInvalidated=true;this._iPopupClosedTimeoutId=null;this._oColumn=null;this._oTable=null;this._attachPopupClosed();};
C.prototype.exit=function(){if(M.prototype.exit){M.prototype.exit.apply(this,arguments);}window.clearTimeout(this._iPopupClosedTimeoutId);this._oColumn=this._oTable=null;};
C.prototype.onThemeChanged=function(){if(this.getDomRef()){this._invalidate();}};
C.prototype.setParent=function(p){this._invalidate();this._updateReferences(p);return M.prototype.setParent.apply(this,arguments);};
C.prototype._updateReferences=function(p){this._oColumn=p;if(this._oColumn){e(T.isA(this._oColumn,"sap.ui.table.Column"),"ColumnMenu.setParent: parent must be a subclass of sap.ui.table.Column");this._oTable=this._oColumn.getParent();if(this._oTable){e(T.isA(this._oTable,"sap.ui.table.Table"),"ColumnMenu.setParent: parent of parent must be subclass of sap.ui.table.Table");}}};
C._destroyColumnVisibilityMenuItem=function(t){if(!t||!t._oColumnVisibilityMenuItem){return;}t._oColumnVisibilityMenuItem.destroy();t._oColumnVisibilityMenuItem=null;};
C.prototype._removeColumnVisibilityFromAggregation=function(){if(!this.oParent||!this.oParent._oColumnVisibilityMenuItem){return;}this.removeAggregation("items",this.oParent._oColumnVisibilityMenuItem,true);};
C.prototype._invalidate=function(){this._bInvalidated=true;};
C.prototype._attachPopupClosed=function(){var t=this;if(!D.support.touch){this.getPopup().attachClosed(function(){t._iPopupClosedTimeoutId=window.setTimeout(function(){if(t._oColumn){if(t._lastFocusedDomRef){t._lastFocusedDomRef.focus();}else{t._oColumn.focus();}}},0);});}};
C.prototype.open=function(){if(this._bInvalidated){this._bInvalidated=false;this._removeColumnVisibilityFromAggregation();this.destroyItems();this._addMenuItems();}else if(this._oColumn){this._addColumnVisibilityMenuItem();}if(this.getItems().length>0){this._lastFocusedDomRef=arguments[4];M.prototype.open.apply(this,arguments);}};
C.prototype._addMenuItems=function(){if(this._oColumn){this._addSortMenuItem(false);this._addSortMenuItem(true);this._addFilterMenuItem();this._addGroupMenuItem();this._addFreezeMenuItem();this._addColumnVisibilityMenuItem();}};
C.prototype._addSortMenuItem=function(f){var o=this._oColumn;if(o.isSortableByMenu()){var s=f?"desc":"asc";var i=f?"sort-descending":"sort-ascending";this.addItem(this._createMenuItem(s,"TBL_SORT_"+s.toUpperCase(),i,function(E){o.sort(f,E.getParameter("ctrlKey")===true);}));}};
C.prototype._addFilterMenuItem=function(){var o=this._oColumn;if(o.isFilterableByMenu()){var t=o.getParent();var f=t&&t.getEnableCustomFilter();if(f){this.addItem(this._createMenuItem("filter","TBL_FILTER_ITEM","filter",function(){t.fireCustomFilter({column:o});}));}else{this.addItem(this._createMenuTextFieldItem("filter","TBL_FILTER","filter",o.getFilterValue(),function(){o.filter(this.getValue());}));}}};
C.prototype._addGroupMenuItem=function(){var o=this._oColumn;if(o.isGroupable()){var t=this._oTable;this.addItem(this._createMenuItem("group","TBL_GROUP",null,function(){t.setGroupBy(o);}));}};
C.prototype._addFreezeMenuItem=function(){var o=this._oColumn;var t=this._oTable;var f=t&&t.getEnableColumnFreeze();if(f){var i=o.getIndex();var I=i+T.Column.getHeaderSpan(o)==t.getComputedFixedColumnCount();this.addItem(this._createMenuItem("freeze",I?"TBL_UNFREEZE":"TBL_FREEZE",null,function(){var E=t.fireColumnFreeze({column:o});if(E){if(I){t.setFixedColumnCount(0);}else{t.setFixedColumnCount(i+1);}}}));}};
C.prototype._addColumnVisibilityMenuItem=function(){var t=this._oTable;if(t&&t.getShowColumnVisibilityMenu()){if(t._oColumnVisibilityMenuItem&&!t._oColumnVisibilityMenuItem.bIsDestroyed){this.addItem(t._oColumnVisibilityMenuItem);return;}t._oColumnVisibilityMenuItem=this._createMenuItem("column-visibilty","TBL_COLUMNS");var o=new M(t._oColumnVisibilityMenuItem.getId()+"-menu");t._oColumnVisibilityMenuItem.setSubmenu(o);var f=t.getColumns();if(t.getColumnVisibilityMenuSorter&&typeof t.getColumnVisibilityMenuSorter==="function"){var s=t.getColumnVisibilityMenuSorter();if(typeof s==="function"){f=f.sort(s);}}var B=t.getBinding();var A=T.isA(B,"sap.ui.model.analytics.AnalyticalBinding");var v=t._getVisibleColumns();for(var i=0,l=f.length;i<l;i++){var g=f[i];if(A&&g.isA("sap.ui.table.AnalyticalColumn")){var Q=B.getAnalyticalQueryResult();var E=Q.getEntityType();var m=B.getModel().getProperty("/#"+E.getTypeDescription().name+"/"+g.getLeadingProperty()+"/sap:visible");if(m&&(m.value==="false"||m.value===false)){continue;}}var h=this._createColumnVisibilityMenuItem(o.getId()+"-item-"+i,g);o.addItem(h);if(v.length==1&&v[0]===g){h.setEnabled(false);}}this.addItem(t._oColumnVisibilityMenuItem);}};
C.prototype._createColumnVisibilityMenuItem=function(i,o){var t=this._oTable;function g(l){return l&&l.getText&&l.getText();}var s=o.getName()||g(o.getLabel());if(!s){o.getMultiLabels().forEach(function(l,f){if(T.Column.getHeaderSpan(o,f)===1){s=g(l)||s;}});}return new b(i,{text:s,icon:o.getVisible()?"sap-icon://accept":null,ariaLabelledBy:[t.getId()+(o.getVisible()?"-ariahidecolmenu":"-ariashowcolmenu")],select:q.proxy(function(E){var v=!o.getVisible();if(v||T.getVisibleColumnCount(this._oTable)>1){var t=o.getParent();var f=true;if(T.isA(t,"sap.ui.table.Table")){f=t.fireColumnVisibility({column:o,newVisible:v});}if(f){o.setVisible(v);}}},this)});};
C.prototype._createMenuItem=function(i,t,I,h){return new b(this.getId()+"-"+i,{text:T.getResourceText(t),icon:I?"sap-icon://"+I:null,select:h||function(){}});};
C.prototype._createMenuTextFieldItem=function(i,t,I,v,h){h=h||function(){};return new c(this.getId()+"-"+i,{label:T.getResourceText(t),icon:I?"sap-icon://"+I:null,value:v,select:h||function(){}});};
C.prototype._setFilterValue=function(v){var o=this.getParent();var t=(o?o.getParent():undefined);var f=sap.ui.getCore().byId(this.getId()+"-filter");if(f&&(t&&!t.getEnableCustomFilter())){f.setValue(v);}return this;};
C.prototype._setFilterState=function(f){var o=this.getParent();var t=(o?o.getParent():undefined);var F=sap.ui.getCore().byId(this.getId()+"-filter");if(F&&(t&&!t.getEnableCustomFilter())){F.setValueState(f);}return this;};
C._updateVisibilityIcon=function(t,I,v){if(!t||!t._oColumnVisibilityMenuItem){return;}var s=v?"sap-icon://accept":"";var S=t._oColumnVisibilityMenuItem.getSubmenu();if(!S){return;}var f=S.getItems();var o;for(var i=0;i<f.length;i++){if(f[i].getId().endsWith("-item-"+I)){o=f[i];break;}}if(!o){return;}o.setProperty("icon",s);};
return C;});
sap.ui.predefine('sap/ui/table/ColumnMenuRenderer',['sap/ui/table/ColumnMenu'],function(M){"use strict";return M.getMetadata().getRenderer();},true);
sap.ui.predefine('sap/ui/table/CreationRow',["./CreationRowRenderer","./Column","./TableUtils","sap/ui/core/Control","sap/m/library","sap/m/OverflowToolbar","sap/m/ToolbarSpacer","sap/m/Button"],function(R,C,T,a,M,O,b,B){"use strict";
var c=a.extend("sap.ui.table.CreationRow",{metadata:{library:"sap.ui.table",properties:{applyEnabled:{type:"boolean",group:"Behavior",defaultValue:true}},aggregations:{cells:{type:"sap.ui.core.Control",multiple:true,singularName:"cell"},toolbar:{type:"sap.ui.core.Toolbar",multiple:false}},events:{apply:{allowPreventDefault:true}}}});
c.prototype.exit=function(){if(this._oDefaultToolbar){this._oDefaultToolbar.destroy();this._oDefaultToolbar=null;}};
c.prototype.setApplyEnabled=function(e){this.setProperty("applyEnabled",e,true);this._updateDefaultToolbar();return this;};
c.prototype.setParent=function(p){a.prototype.setParent.apply(this,arguments);this._update();return this;};
c.prototype.resetFocus=function(){var i=this._getFirstInteractiveElement();if(i){i.focus();T.selectElementText(i);return true;}return false;};
c.prototype.getFocusDomRef=function(){var i=this._getFirstInteractiveElement();if(i){return i;}return a.prototype.getFocusDomRef.apply(this,arguments);};
c.prototype._fireApply=function(){var f=false;if(this.fireApply()){f=this.resetFocus();}return f;};
c.prototype.onsapentermodifiers=function(e){if(this.getApplyEnabled()&&(e.metaKey||e.ctrlKey)){var f=document.activeElement;f.blur();e.setMarked();window.setTimeout(function(){if(!this._fireApply()){f.focus();}}.bind(this),0);}};
function d(o){return new O(o.getId()+"-tb",{content:[new b(),new B(o.getId()+"-applyBtn",{text:T.getResourceText("TBL_CREATIONROW_APPLY"),enabled:o.getApplyEnabled(),press:function(){o._fireApply();}})],style:M.ToolbarStyle.Clear,ariaLabelledBy:[o.getId()+"-label"]});}
c.prototype._getToolbar=function(){var t=this.getToolbar();if(!t){if(!this._oDefaultToolbar){this._oDefaultToolbar=d(this);}t=this._oDefaultToolbar;if(t.data("sap-ui-invalid")){this._updateDefaultToolbar();}}return t;};
c.prototype._updateDefaultToolbar=function(){if(this.getToolbar()){if(this._oDefaultToolbar){this._oDefaultToolbar.data("sap-ui-invalid",true);}return;}if(!this._oDefaultToolbar){return;}var A=this._oDefaultToolbar.getContent()[1];A.setEnabled(this.getApplyEnabled());this._oDefaultToolbar.data("sap-ui-invalid",null);};
c.prototype._getFirstInteractiveElement=function(){var e=this.getCells();for(var i=0;i<e.length;i++){var o=e[i].getDomRef();var $=T.getCell(this._getTable(),o,true);var I=T.getInteractiveElements($);if(I){return I[0];}}return null;};
c.prototype._getCell=function(i){var e=this.getCells();var o=e.filter(function(o){return C.ofCell(o).getIndex()===i;})[0];if(!o){return null;}return o;};
c.prototype._getCellDomRef=function(i){var o=this._getCell(i);var e=o?o.getDomRef():null;var $=T.getCell(this._getTable(),e,true);if(!$){return null;}return $;};
c.prototype._focusCell=function(i){var o=this._getCellDomRef(i);var I=T.getInteractiveElements(o);if(I){I[0].focus();T.selectElementText(I[0]);return true;}return false;};
c.prototype._takeOverKeyboardHandling=function(e){var t=this._getTable();var o=t?t.getDomRef():null;if(!o||!o.contains(document.activeElement)){return false;}var f=T.getCell(this._getTable(),document.activeElement);var g=T.getCellInfo(f);var F=false;if(g.columnIndex!=null&&g.columnIndex>=0){F=this._focusCell(g.columnIndex);}else{F=this.resetFocus();}if(F&&e){e.preventDefault();}return F;};
c.prototype._update=function(){var t=this._getTable();if(!t){this.removeAllCells();return;}var e=t.getColumns();this.removeAllCells();for(var i=0,l=e.length;i<l;i++){if(e[i].getVisible()){this.addCell(e[i].getTemplateClone(i,"Creation"));}}};
c.prototype._getTable=function(){var p=this.getParent();return T.isA(p,"sap.ui.table.Table")?p:null;};
return c;});
sap.ui.predefine('sap/ui/table/CreationRowRenderer',["./TableRenderer","./TableUtils","sap/ui/core/Renderer"],function(T,a,R){"use strict";var C={apiVersion:2};
C.render=function(r,c){var t=c._getTable();if(!t){return;}r.openStart("div",c);r.attr("data-sap-ui-fastnavgroup","true");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"CREATIONROW",{creationRow:c});r.class("sapUiTableCreationRow");r.openEnd();this.renderBeginSection(r);this.renderMiddleSection(r,c,t);this.renderEndSection(r,t);t._getAccRenderExtension().writeAccCreationRowText(r,t,c);r.close("div");};
C.renderBeginSection=function(r){r.openStart("div");r.class("sapUiTableCreationRowBeginSection");r.class("sapUiTableRowHdrScr");r.openEnd();r.close("div");};
C.renderMiddleSection=function(r,c,t){r.openStart("div");r.class("sapUiTableCreationRowMiddleSection");r.openEnd();this.renderForm(r,c,t);this.renderToolbar(r,c);r.close("div");};
C.renderEndSection=function(r,t){r.openStart("div");r.class("sapUiTableCreationRowEndSection");if(a.hasRowActions(t)){r.class("sapUiTableCell");r.class("sapUiTableRowActionHeaderCell");}else{r.class("sapUiTableVSbBg");}r.openEnd();r.close("div");};
C.renderForm=function(r,c,t){if(c.getCells().length===0){return;}r.openStart("div");r.class("sapUiTableCreationRowForm");r.openEnd();if(t.getComputedFixedColumnCount()>0){this.renderRowFormTable(r,t,true);}r.openStart("div");r.class("sapUiTableCtrlScr");r.openEnd();this.renderRowFormTable(r,t,false);r.close("div");r.close("div");};
C.renderRowFormTable=function(r,t,f){var s=f?0:t.getComputedFixedColumnCount();var e=f?t.getComputedFixedColumnCount():t.getColumns().length;var c=t.getCreationRow();r.openStart("table");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"CREATIONROW_TABLE");r.class("sapUiTableCtrl");r.style(f?"width":"min-width",t._getColumnsWidth(s,e)+"px");r.openEnd();r.openStart("thead").openEnd();r.openStart("tr");r.class("sapUiTableCtrlCol");r.openEnd();var b=t.getColumns();var d=new Array(e);var i;var o;var g=!f&&e>s;var h;for(i=s;i<e;i++){o=b[i];h={shouldRender:!!(o&&o.shouldRender())};if(h.shouldRender){var w=o.getWidth();if(a.isVariableWidth(w)){g=false;if(f){o._iFixWidth=o._iFixWidth||160;w=o._iFixWidth+"px";}}else if(f){delete o._iFixWidth;}h.width=w;}d[i]=h;}for(i=s;i<e;i++){o=b[i];h=d[i];if(h.shouldRender){r.openStart("th");r.style("width",h.width);r.attr("data-sap-ui-headcolindex",i);r.attr("data-sap-ui-colid",o.getId());r.openEnd();r.close("th");}}if(g){r.openStart("th").openEnd().close("th");}r.close("tr");r.close("thead");r.openStart("tbody").openEnd();r.openStart("tr");r.class("sapUiTableTr");r.openEnd();var j=c.getCells();var v=t._getVisibleColumns();for(i=s;i<e;i++){o=b[i];h=d[i];if(h.shouldRender){r.openStart("td");r.attr("data-sap-ui-colid",o.getId());var k=c._getCell(i);var n=v.length;var I=n>0&&v[0]===o;var l=n>0&&v[n-1]===o;var L=b[t.getFixedColumnCount()-1];var m=f&L===o;var H=R.getTextAlign(o.getHAlign(),k&&k.getTextDirection&&k.getTextDirection());r.style("text-align",H);r.class("sapUiTableCell");r.class("sapUiTablePseudoCell");if(I){r.class("sapUiTableCellFirst");}if(m){r.class("sapUiTableCellLastFixed");}if(l){r.class("sapUiTableCellLast");}r.openEnd();if(k){r.openStart("div");r.class("sapUiTableCellInner");r.openEnd();T.renderTableCellControl(r,t,k,I);r.close("div");}r.close("td");}}if(!f&&g&&j.length>0){r.openStart("td").class("sapUiTableCellDummy").openEnd().close("td");}r.close("tr");r.close("tbody");r.close("table");};
C.renderToolbar=function(r,c){r.renderControl(c._getToolbar());};
return C;},true);
sap.ui.predefine('sap/ui/table/Row',['sap/ui/core/Element','sap/ui/model/Context','./TableUtils',"sap/ui/thirdparty/jquery"],function(E,C,T,q){"use strict";
var R=E.extend("sap.ui.table.Row",{metadata:{library:"sap.ui.table",defaultAggregation:"cells",aggregations:{cells:{type:"sap.ui.core.Control",multiple:true,singularName:"cell"},_rowAction:{type:"sap.ui.table.RowAction",multiple:false,visibility:"hidden"},_settings:{type:"sap.ui.table.RowSettings",multiple:false,visibility:"hidden"}}}});
R.prototype.init=function(){this.initDomRefs();};
R.prototype.exit=function(){this.initDomRefs();};
R.prototype.getFocusInfo=function(){var t=this.getParent();return t?t.getFocusInfo():E.prototype.getFocusInfo.apply(this,arguments);};
R.prototype.applyFocusInfo=function(f){var t=this.getParent();if(t){t.applyFocusInfo(f);}else{E.prototype.applyFocusInfo.apply(this,arguments);}return this;};
R.prototype.addStyleClass=function(s){this.getDomRefs(true).row.addClass(s);};
R.prototype.removeStyleClass=function(s){this.getDomRefs(true).row.removeClass(s);};
R.prototype.initDomRefs=function(){this._mDomRefs={};};
R.prototype.getIndex=function(){var t=this.getParent();if(!t){return-1;}var r=t.indexOfRow(this);var m=t._getRowCounts();if(m.fixedTop>0&&r<m.fixedTop){return r;}if(m.fixedBottom>0&&r>=m.count-m.fixedBottom){var i=t._getTotalRowCount();if(i>=m.count){return i-(m.count-r);}else{return r;}}return t._getFirstRenderedRowIndex()+r;};
R.prototype.getDomRefs=function(j,c){j=j===true;c=c===true;var k=j?"jQuery":"dom";var d=this._mDomRefs;if(!d[k]){var t=this.getParent();var g=function(i){var e=document.getElementById(i);if(e){return j?q(e):e;}return null;};var G=function(e){if(e){return j?e.parent():e.parentNode;}return null;};d[k]={};if(t){var r=t.indexOfRow(this);d[k].rowSelector=g(t.getId()+"-rowsel"+r);d[k].rowAction=g(t.getId()+"-rowact"+r);}d[k].rowHeaderPart=G(d[k].rowSelector);d[k].rowFixedPart=g(this.getId()+"-fixed");d[k].rowScrollPart=g(this.getId());d[k].rowActionPart=G(d[k].rowAction);d[k].rowSelectorText=g(this.getId()+"-rowselecttext");if(j){d[k].row=q().add(d[k].rowHeaderPart).add(d[k].rowFixedPart).add(d[k].rowScrollPart).add(d[k].rowActionPart);}}var K=d[k];if(c){return Object.keys(K).map(function(k){return K[k];}).filter(Boolean);}return K;};
R.prototype._updateSelection=function(t,m){var i=t._getSelectionPlugin().isIndexSelected(this.getIndex());var d=this.getDomRefs(true);if(!d.rowScrollPart){return;}var s="rowSelect";if(i){s="rowDeselect";}if(d.rowSelector){if(!this._bHidden&&t._getShowStandardTooltips()&&T.isRowSelectorSelectionAllowed(t)){d.rowSelector.attr("title",m.mouse[s]);}else{d.rowSelector.removeAttr("title");}}if(d.rowSelectorText){var a="";if(!this._bHidden&&!T.Grouping.isInSumRow(d.rowSelector)&&!T.Grouping.isInGroupingRow(d.rowSelector)){a=m.keyboard[s];}d.rowSelectorText.text(a);}var r=d.rowScrollPart.add(d.rowFixedPart);if(!this._bHidden&&t._getShowStandardTooltips()&&T.isRowSelectionAllowed(t)){r.attr("title",m.mouse[s]);}else{r.removeAttr("title");}this._setSelected(i);t._getAccExtension().updateAriaStateOfRow(this,d,i);};
R.prototype.setRowBindingContext=function(c,m,b){var n;if(c&&!(c instanceof C)){n=c;c=c.context;}var $=this.getDomRefs(true).row;this._bHidden=!c;$.toggleClass("sapUiTableRowHidden",this._bHidden);this._collectRenderingInformation(c,n,b);this.setBindingContext(c,m);};
R.prototype.setBindingContext=function(c,m){var r=E.prototype.setBindingContext.call(this,c||null,m);this._updateTableCells(c);return r;};
R.prototype._updateTableCells=function(c){var t=this.getParent();if(!t){return;}var a=this.getCells(),A=this.getIndex(),h=!!t._updateTableCell,o,$,H;for(var i=0;i<a.length;i++){o=a[i];H=!!o._updateTableCell;$=H||h?o.$().closest("td"):null;if(H){o._updateTableCell(o,c,$,A);}if(h){t._updateTableCell(o,c,$,A);}}};
R.prototype._collectRenderingInformation=function(c,n,b){this._oNodeState=undefined;this._iLevel=0;this._bIsExpanded=false;this._bHasChildren=false;if(n){this._oNodeState=n.nodeState;this._iLevel=n.level;if(b){if(b.getLevel){this._bIsExpanded=b.isExpanded(this.getIndex());}else if(b.findNode){this._bIsExpanded=this&&this._oNodeState?this._oNodeState.expanded:false;}if(b.nodeHasChildren){if(this._oNodeState){this._bHasChildren=b.nodeHasChildren(n);}}else if(b.hasChildren){this._bHasChildren=b.hasChildren(c);}}}};
R.prototype.destroy=function(){this.removeAllCells();return E.prototype.destroy.apply(this,arguments);};
R.prototype.invalidate=function(){return this;};
R.prototype.getDragGhost=function(){var t=this.getParent();var o=t.getDomRef();var r=this.getDomRefs();var g;var G;var a;var s=t._getSelectionPlugin().getSelectedCount();function b(e){e.removeAttribute("id");e.removeAttribute("data-sap-ui");e.removeAttribute("data-sap-ui-related");var f=e.children.length;for(var i=0;i<f;i++){b(e.children[i]);}}function c(o,e){var f=o.cloneNode();var h=o.querySelector("thead").cloneNode(true);var i=o.querySelector("tbody").cloneNode();var j=e.cloneNode(true);i.appendChild(j);f.appendChild(h);f.appendChild(i);return f;}g=o.cloneNode();g.classList.add("sapUiTableRowGhost");g.classList.remove("sapUiTableVScr");g.classList.remove("sapUiTableHScr");g.style.width=o.getBoundingClientRect().width+"px";if(r.rowSelector){G=t.getDomRef("sapUiTableRowHdrScr").cloneNode();a=r.rowSelector.cloneNode(true);G.appendChild(a);g.appendChild(G);}if(r.rowFixedPart){G=t.getDomRef("sapUiTableCtrlScrFixed").cloneNode();a=c(t.getDomRef("table-fixed"),r.rowFixedPart);G.appendChild(a);g.appendChild(G);}if(r.rowScrollPart){var S=t.getDomRef("sapUiTableCtrlScr");G=S.cloneNode();a=c(t.getDomRef("table"),r.rowScrollPart);G.appendChild(t.getDomRef("tableCtrlCnt").cloneNode());G.firstChild.appendChild(a);g.appendChild(G);}if(r.rowAction){G=t.getDomRef("sapUiTableRowActionScr").cloneNode();a=r.rowAction.cloneNode(true);G.appendChild(a);g.appendChild(G);}if(s>1){G=document.createElement("div");G.classList.add("sapUiTableRowGhostCount");var d=document.createElement("div");d.textContent=s;G.appendChild(d);g.appendChild(G);}b(g);return g;};
R.prototype._setSelected=function(s){var t=this.getParent();if(s){this.addStyleClass("sapUiTableRowSel");}else{this.removeStyleClass("sapUiTableRowSel");}if(t){T.dynamicCall(t._getSyncExtension,function(S){S.syncRowSelection(t.indexOfRow(this),s);},this);}};
R.prototype._setHovered=function(h){var t=this.getParent();if(h){this.addStyleClass("sapUiTableRowHvr");}else{this.removeStyleClass("sapUiTableRowHvr");}if(t){T.dynamicCall(t._getSyncExtension,function(s){s.syncRowHover(t.indexOfRow(this),h);},this);}};
R.prototype.getRowAction=function(){return this.getAggregation("_rowAction");};
return R;});
sap.ui.predefine('sap/ui/table/RowAction',['sap/ui/core/Control',"sap/ui/table/TableUtils",'./library','sap/ui/core/Icon','sap/ui/unified/Menu','sap/ui/core/Popup',"./RowActionRenderer","sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery"],function(C,T,l,I,M,P,R,K,q){"use strict";
var a=C.extend("sap.ui.table.RowAction",{metadata:{library:"sap.ui.table",properties:{visible:{type:"boolean",group:"Misc",defaultValue:true}},defaultAggregation:"items",aggregations:{items:{type:"sap.ui.table.RowActionItem",multiple:true},_icons:{type:"sap.ui.core.Icon",multiple:true,visibility:"hidden"},_menu:{type:"sap.ui.unified.Menu",multiple:false,visibility:"hidden"}},events:{}}});
a.prototype.init=function(){var s=function(v){this.setAggregation("tooltip",v,true);this.setSrc(this.getSrc());return this;};var o=function(e){this._bKeyboard=e.which===K.SPACE||e.which===K.ENTER;I.prototype.onkeyup.apply(this,arguments);};var t=this;var i=new I(this.getId()+"-icon0",{decorative:false,press:function(e){t._handlePress(e,true);}});i.addStyleClass("sapUiTableActionIcon");i.setTooltip=s;i.onkeyup=o;this.addAggregation("_icons",i);i=new I(this.getId()+"-icon1",{decorative:false,press:function(e){t._handlePress(e,false);}});i.addStyleClass("sapUiTableActionIcon");i.setTooltip=s;i.onkeyup=o;this.addAggregation("_icons",i);this._iLen=0;this._iCount=2;this._aActions=["",""];this._iLastCloseTime=0;};
a.prototype.onAfterRendering=function(){this._updateIcons();};
a.prototype.setVisible=function(v){this.setProperty("visible",v,true);this.$().toggleClass("sapUiTableActionHidden",!v);return this;};
a.prototype.setTooltip=function(t){this.setAggregation("tooltip",t,true);var s=this.getTooltip_AsString();if(!s){this.$().removeAttr("title");}else{this.$().attr("title",s);}return this;};
a.prototype.insertItem=function(i,b){this.insertAggregation("items",i,b,true);this._updateIcons(true);return this;};
a.prototype.addItem=function(i){this.addAggregation("items",i,true);this._updateIcons(true);return this;};
a.prototype.removeItem=function(i){var r=this.removeAggregation("items",i,true);this._updateIcons(true);return r;};
a.prototype.removeAllItems=function(){var r=this.removeAllAggregation("items",true);this._updateIcons(true);return r;};
a.prototype.destroyItems=function(){this.destroyAggregation("items",true);this._updateIcons(true);return this;};
a.prototype.getAccessibilityInfo=function(){var p=this.$().parent();var A=this.getVisible()&&this._iLen>0&&this._iCount>0&&!p.hasClass("sapUiTableRowHidden")&&!p.hasClass("sapUiTableGroupHeader")&&!p.hasClass("sapUiAnalyticalTableSum");var t;if(A){t=T.getResourceText(this._iLen==1?"TBL_ROW_ACTION_SINGLE_ACTION":"TBL_ROW_ACTION_MULTIPLE_ACTION",[this._iLen]);}else{t=T.getResourceText("TBL_ROW_ACTION_NO_ACTION");}return{focusable:A,enabled:A,description:t};};
a.prototype._getVisibleItems=function(f){if(!this._aVisibleItems||f){this._aVisibleItems=[];this._iLen=0;var b=this.getItems();for(var i=0;i<b.length;i++){if(b[i].getVisible()){this._aVisibleItems.push(b[i]);this._iLen++;}}}return this._aVisibleItems;};
a.prototype._getRow=function(){return this.getParent();};
a.prototype._getCount=function(){return this._iCount;};
a.prototype._setCount=function(c){if(c<0){this._iCount=0;}else if(c>=0){this._iCount=Math.min(c,2);}this._updateIcons();};
a.prototype._setFixedLayout=function(f){this._bFixedLayout=!!f;this._updateIcons();};
a.prototype._setIconLabel=function(L){var b=this.getAggregation("_icons");for(var i=0;i<b.length;i++){b[i].removeAllAriaLabelledBy();if(L){b[i].addAriaLabelledBy(L);}}};
a.prototype._handlePress=function(e,f){var b=f?0:1;var o=this.getAggregation("_icons")[b];var A=this._aActions[b];var k=o._bKeyboard;o._bKeyboard=false;if(A=="action"){this._getVisibleItems()[b]._doFirePress();}else if(A=="action_fixed"){this._getVisibleItems()[0]._doFirePress();}else if(A=="menu"){var m=this.getAggregation("_menu");if(!m){m=new M();this.setAggregation("_menu",m,true);m.getPopup().attachClosed(function(){this._iLastCloseTime=Date.now();},this);}m.removeAllItems();if(Date.now()-this._iLastCloseTime<500){return;}var c=this.getItems();for(var i=f?0:1;i<c.length;i++){m.addItem(c[i]._getMenuItem());}m.open(!!k,o,P.Dock.EndTop,P.Dock.EndBottom,o);}};
a.prototype._updateIcons=function(f){var i=this._getVisibleItems(f);var b=this.getAggregation("_icons");var $=this.$().children();function s(c){b[0].$()[c==0?"attr":"removeAttr"]("aria-haspopup",c==0?"true":undefined);b[1].$()[c==1?"attr":"removeAttr"]("aria-haspopup",c==1?"true":undefined);}if(this._bFixedLayout&&this._iLen==1&&this._iCount==2){var A=this.getItems();if(A.length>1&&i[0]===A[1]){i[0]._syncIcon(b[1]);q($.get(0)).toggleClass("sapUiTableActionHidden",true);q($.get(1)).toggleClass("sapUiTableActionHidden",false);s(-1);this._aActions=["","action_fixed"];return;}}if(this._iLen==0||this._iCount==0){$.toggleClass("sapUiTableActionHidden",true);s(-1);this._aActions=["",""];}else if(this._iLen==1&&this._iCount>0){i[0]._syncIcon(b[0]);q($.get(0)).toggleClass("sapUiTableActionHidden",false);q($.get(1)).toggleClass("sapUiTableActionHidden",true);s(-1);this._aActions=["action",""];}else if(this._iLen==2&&this._iCount==2){i[0]._syncIcon(b[0]);i[1]._syncIcon(b[1]);$.toggleClass("sapUiTableActionHidden",false);s(-1);this._aActions=["action","action"];}else if(this._iLen>2&&this._iCount==2){i[0]._syncIcon(b[0]);b[1].setSrc("sap-icon://overflow");b[1].setTooltip(T.getResourceText("TBL_ROW_ACTION_MORE"));$.toggleClass("sapUiTableActionHidden",false);s(1);this._aActions=["action","menu"];}else{b[0].setSrc("sap-icon://overflow");b[0].setTooltip(T.getResourceText("TBL_ROW_ACTION_MORE"));q($.get(0)).toggleClass("sapUiTableActionHidden",false);q($.get(1)).toggleClass("sapUiTableActionHidden",true);s(0);this._aActions=["menu",""];}};
return a;});
sap.ui.predefine('sap/ui/table/RowActionItem',['sap/ui/core/Element','./library','sap/ui/unified/MenuItem',"sap/ui/table/TableUtils","sap/ui/core/IconPool"],function(E,l,M,T,I){"use strict";var R=l.RowActionType;
var a=E.extend("sap.ui.table.RowActionItem",{metadata:{library:"sap.ui.table",properties:{icon:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},visible:{type:"boolean",group:"Misc",defaultValue:true},text:{type:"string",group:"Misc",defaultValue:""},type:{type:"sap.ui.table.RowActionType",group:"Behavior",defaultValue:R.Custom}},events:{press:{item:{type:"sap.ui.table.RowActionItem"},row:{type:"sap.ui.table.Row"}}}}});
a.prototype.exit=function(){if(this._menuItem){this._menuItem.destroy();this._menuItem=null;}};
a.prototype.setIcon=function(i){this.setProperty("icon",i,true);this._updateRowAction();return this;};
a.prototype.setText=function(t){this.setProperty("text",t,true);this._updateRowAction();return this;};
a.prototype.setType=function(t){this.setProperty("type",t,true);this._updateRowAction();return this;};
a.prototype.setVisible=function(v){this.setProperty("visible",v,true);this._updateRowAction(true);return this;};
a.prototype.setTooltip=function(t){this.setAggregation("tooltip",t,true);this._updateRowAction();return this;};
a.prototype._doFirePress=function(){var p=this.getParent();this.firePress({item:this,row:p&&p._getRow?p._getRow():null});};
a.prototype._getMenuItem=function(){if(!this._menuItem){var t=this;this._menuItem=new M({select:function(e){t._doFirePress();}});}this._menuItem.setIcon(this._getIcon());this._menuItem.setVisible(this.getVisible());this._menuItem.setText(this._getText(false));return this._menuItem;};
a.prototype._getIcon=function(){var i=this.getIcon();if(i){return i;}if(this.getType()==R.Navigation){return I.getIconURI(T.ThemeParameters.navigationIcon);}if(this.getType()==R.Delete){return I.getIconURI(T.ThemeParameters.deleteIcon);}return null;};
a.prototype._getText=function(p){var t=p?(this.getTooltip_AsString()||this.getText()):(this.getText()||this.getTooltip_AsString());if(t){return t;}if(this.getType()==R.Navigation){return T.getResourceText("TBL_ROW_ACTION_NAVIGATE");}if(this.getType()==R.Delete){return T.getResourceText("TBL_ROW_ACTION_DELETE");}return null;};
a.prototype._syncIcon=function(i){i.setSrc(this._getIcon());i.setTooltip(this._getText(true));};
a.prototype._updateRowAction=function(f){var p=this.getParent();if(p&&p._updateIcons){p._updateIcons(f);}};
return a;});
sap.ui.predefine('sap/ui/table/RowActionRenderer',['sap/ui/table/Row'],function(R){"use strict";var a={apiVersion:2};
a.render=function(r,A){r.openStart("div",A);r.class("sapUiTableAction");if(!(A.getParent()instanceof R)){r.style("display","none");}if(!A.getVisible()){r.class("sapUiTableActionHidden");}var t=A.getTooltip_AsString();if(t){r.attr("title",t);}r.openEnd();var i=A.getAggregation("_icons");r.renderControl(i[0]);r.renderControl(i[1]);r.close("div");};
return a;},true);
sap.ui.predefine('sap/ui/table/RowSettings',['sap/ui/core/Element','./TableUtils','sap/ui/base/DataType','./library','sap/ui/core/library'],function(E,T,D,l,c){"use strict";var M=c.MessageType;var I=c.IndicationColor;
var R=E.extend("sap.ui.table.RowSettings",{metadata:{library:"sap.ui.table",properties:{highlight:{type:"string",group:"Appearance",defaultValue:"None"},highlightText:{type:"string",group:"Misc",defaultValue:""},navigated:{type:"boolean",group:"Appearance",defaultValue:false}}}});
R.prototype.validateProperty=function(p,v){if(p!="highlight"||v==null){return E.prototype.validateProperty.apply(this,arguments);}if(!D.getType("sap.ui.core.MessageType").isValid(v)&&!D.getType("sap.ui.core.IndicationColor").isValid(v)){throw new Error("\""+v+"\" is of type "+typeof v+", expected is a value of the enums sap.ui.core.MessageType or sap.ui.core.IndicationColor"+" for property \""+p+"\" of "+this);}return v;};
R.prototype.setHighlight=function(h){var r;var H;this.setProperty("highlight",h,true);r=this._getRow();if(!r){return this;}H=r.getDomRef("highlight");if(!H){return this;}for(var m in M){H.classList.remove("sapUiTableRowHighlight"+m);}for(var i in I){H.classList.remove("sapUiTableRowHighlight"+i);}H.classList.add(this._getHighlightCSSClassName());var t=r.getParent();var a=t?t._getAccExtension():null;if(a){a.updateAriaStateOfRowHighlight(this);}return this;};
R.prototype.setNavigated=function(n){var r;var N;this.setProperty("navigated",n,true);r=this._getRow();if(!r){return this;}N=r.getDomRef("navIndicator");if(!N){return this;}if(n){N.classList.add("sapUiTableRowNavigated");}else{N.classList.remove("sapUiTableRowNavigated");}return this;};
R.prototype.setHighlightText=function(h){var r=this._getRow();var t=r?r.getParent():null;var a=t?t._getAccExtension():null;this.setProperty("highlightText",h,true);if(a){a.updateAriaStateOfRowHighlight(this);}return this;};
R.prototype._getHighlightCSSClassName=function(){var h=this.getHighlight();if(h==null){h=M.None;}return"sapUiTableRowHighlight"+h;};
R.prototype._getHighlightText=function(){var h=this.getHighlight();if(h===M.None){return"";}var H=this.getHighlightText();if(h in M&&H===""){H=T.getResourceText("TBL_ROW_STATE_"+h.toUpperCase());}return H;};
R.prototype._getRow=function(){var r=this.getParent();if(T.isA(r,"sap.ui.table.Row")){return r;}else{return null;}};
return R;});
sap.ui.predefine('sap/ui/table/Table',['sap/ui/Device','sap/ui/core/Control','sap/ui/core/Element','sap/ui/core/IconPool','sap/ui/core/util/PasteHelper','sap/ui/model/ChangeReason','sap/ui/model/Filter','sap/ui/model/Sorter','sap/ui/model/BindingMode','./Column','./Row','./library','./TableUtils','./TableExtension','./TableAccExtension','./TableKeyboardExtension','./TablePointerExtension','./TableScrollExtension','./TableDragAndDropExtension',"./TableRenderer","./rowmodes/FixedRowMode","./rowmodes/InteractiveRowMode","./rowmodes/AutoRowMode","./plugins/SelectionModelPlugin","sap/ui/thirdparty/jquery","sap/base/Log"],function(D,C,E,I,P,a,F,S,B,b,R,c,T,d,e,f,g,h,j,k,m,n,A,o,q,L){"use strict";var G=c.GroupEventType,N=c.NavigationMode,p=c.SelectionMode,r=c.SelectionBehavior,s=c.SortOrder,V=c.VisibleRowCountMode;
var t=C.extend("sap.ui.table.Table",{metadata:{library:"sap.ui.table",dnd:true,properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'auto'},rowHeight:{type:"int",group:"Appearance",defaultValue:null},columnHeaderHeight:{type:"int",group:"Appearance",defaultValue:null},columnHeaderVisible:{type:"boolean",group:"Appearance",defaultValue:true},visibleRowCount:{type:"int",group:"Appearance",defaultValue:10},firstVisibleRow:{type:"int",group:"Appearance",defaultValue:0},selectionMode:{type:"sap.ui.table.SelectionMode",group:"Behavior",defaultValue:p.MultiToggle},selectionBehavior:{type:"sap.ui.table.SelectionBehavior",group:"Behavior",defaultValue:r.RowSelector},selectedIndex:{type:"int",group:"Appearance",defaultValue:-1},editable:{type:"boolean",group:"Behavior",defaultValue:true},navigationMode:{type:"sap.ui.table.NavigationMode",group:"Behavior",defaultValue:N.Scrollbar,deprecated:true},threshold:{type:"int",group:"Appearance",defaultValue:100},enableColumnReordering:{type:"boolean",group:"Behavior",defaultValue:true},enableGrouping:{type:"boolean",group:"Behavior",defaultValue:false},showColumnVisibilityMenu:{type:"boolean",group:"Appearance",defaultValue:false},showNoData:{type:"boolean",group:"Appearance",defaultValue:true},visibleRowCountMode:{type:"sap.ui.table.VisibleRowCountMode",group:"Appearance",defaultValue:V.Fixed},minAutoRowCount:{type:"int",group:"Appearance",defaultValue:5},fixedColumnCount:{type:"int",group:"Appearance",defaultValue:0},fixedRowCount:{type:"int",group:"Appearance",defaultValue:0},fixedBottomRowCount:{type:"int",group:"Appearance",defaultValue:0},enableColumnFreeze:{type:"boolean",group:"Behavior",defaultValue:false},enableCellFilter:{type:"boolean",group:"Behavior",defaultValue:false},showOverlay:{type:"boolean",group:"Appearance",defaultValue:false},enableSelectAll:{type:"boolean",group:"Behavior",defaultValue:true},enableCustomFilter:{type:"boolean",group:"Behavior",defaultValue:false},enableBusyIndicator:{type:"boolean",group:"Behavior",defaultValue:false},rowActionCount:{type:"int",group:"Appearance",defaultValue:0},alternateRowColors:{type:"boolean",group:"Appearance",defaultValue:false}},defaultAggregation:"columns",aggregations:{title:{type:"sap.ui.core.Control",altTypes:["string"],multiple:false},footer:{type:"sap.ui.core.Control",altTypes:["string"],multiple:false},toolbar:{type:"sap.ui.core.Toolbar",multiple:false,deprecated:true},extension:{type:"sap.ui.core.Control",multiple:true,singularName:"extension"},columns:{type:"sap.ui.table.Column",multiple:true,singularName:"column",bindable:"bindable",dnd:{layout:"Horizontal"}},rows:{type:"sap.ui.table.Row",multiple:true,singularName:"row",bindable:"bindable",selector:"#{id}-tableCCnt",dnd:true},rowMode:{type:"sap.ui.core.Element",multiple:false,visibility:"hidden"},creationRow:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"},noData:{type:"sap.ui.core.Control",altTypes:["string"],multiple:false},rowActionTemplate:{type:"sap.ui.table.RowAction",multiple:false},rowSettingsTemplate:{type:"sap.ui.table.RowSettings",multiple:false},contextMenu:{type:"sap.ui.core.IContextMenu",multiple:false},plugins:{type:"sap.ui.table.plugins.SelectionPlugin",multiple:true,singularName:"plugin"}},associations:{groupBy:{type:"sap.ui.table.Column",multiple:false},ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{rowSelectionChange:{parameters:{rowIndex:{type:"int"},rowContext:{type:"object"},rowIndices:{type:"int[]"},selectAll:{type:"boolean"},userInteraction:{type:"boolean"}}},columnSelect:{allowPreventDefault:true,parameters:{column:{type:"sap.ui.table.Column"}}},columnResize:{allowPreventDefault:true,parameters:{column:{type:"sap.ui.table.Column"},width:{type:"sap.ui.core.CSSSize"}}},columnMove:{allowPreventDefault:true,parameters:{column:{type:"sap.ui.table.Column"},newPos:{type:"int"}}},sort:{allowPreventDefault:true,parameters:{column:{type:"sap.ui.table.Column"},sortOrder:{type:"sap.ui.table.SortOrder"},columnAdded:{type:"boolean"}}},filter:{allowPreventDefault:true,parameters:{column:{type:"sap.ui.table.Column"},value:{type:"string"}}},group:{allowPreventDefault:true,parameters:{column:{type:"sap.ui.table.Column"}}},columnVisibility:{allowPreventDefault:true,parameters:{column:{type:"sap.ui.table.Column"},newVisible:{type:"boolean"}}},cellClick:{allowPreventDefault:true,parameters:{cellControl:{type:"sap.ui.core.Control"},cellDomRef:{type:"Object"},rowIndex:{type:"int"},columnIndex:{type:"int"},columnId:{type:"string"},rowBindingContext:{type:"sap.ui.model.Context"}}},cellContextmenu:{allowPreventDefault:true,parameters:{cellControl:{type:"sap.ui.core.Control"},cellDomRef:{type:"Object"},rowIndex:{type:"int"},columnIndex:{type:"int"},columnId:{type:"string"},rowBindingContext:{type:"sap.ui.model.Context"}},deprecated:true},beforeOpenContextMenu:{allowPreventDefault:true,parameters:{rowIndex:{type:"int"},columnIndex:{type:"int"},contextMenu:{type:"sap.ui.core.IContextMenu"}}},columnFreeze:{allowPreventDefault:true,parameters:{column:{type:"sap.ui.table.Column"}}},customFilter:{column:{type:"sap.ui.table.Column"},value:{type:"string"}},firstVisibleRowChanged:{firstVisibleRow:{type:"int"}},busyStateChanged:{busy:{type:"boolean"}},paste:{allowPreventDefault:true,parameters:{data:{type:"string[][]"}}}},designtime:"sap/ui/table/designtime/Table.designtime"}});
I.insertFontFaceStyle();
t.prototype.init=function(){this.mSkipPropagation={rowActionTemplate:true,rowSettingsTemplate:true};this._attachExtensions();this._bRtlMode=sap.ui.getCore().getConfiguration().getRTL();this._bIsFlexItem=false;this._bBindingReady=false;this._bContextsAvailable=false;this._aRowClones=[];this._bRowAggregationInvalid=true;this._mTimeouts={};this._mAnimationFrames={};this._bHideStandardTooltips=false;this._aRowHeights=[];this._iRenderedFirstVisibleRow=0;this._aSortedColumns=[];this._aTableHeaders=[];this._bAllowColumnHeaderTextSelection=false;this._iPendingRequests=0;this._bPendingRequest=false;this._iBindingLength=null;this._bFirstRendering=true;this._nDevicePixelRatio=window.devicePixelRatio;if(sap.ui.getCore().isThemeApplied()){T.readThemeParameters();}this._bInvalid=true;};
t.prototype.applySettings=function(l,x){if(l){var y=["rowMode","plugins"];var _={};for(var i=0;i<y.length;i++){var z=y[i];if(z in l){_[z]=l[z];delete l[z];}}C.prototype.applySettings.call(this,_,x);}this._initLegacyRowMode();this._initLegacySelectionPlugin();C.prototype.applySettings.call(this,l,x);};
t.prototype._attachExtensions=function(){if(this._bExtensionsInitialized){return;}d.enrich(this,g);d.enrich(this,h);d.enrich(this,f);d.enrich(this,e);d.enrich(this,j);this._bExtensionsInitialized=true;};
t.prototype.exit=function(){this.invalidateRowsAggregation();this._detachExtensions();this._destroyLegacyRowMode();this._destroyLegacySelectionPlugin();if(this._dataReceivedHandlerId){clearTimeout(this._dataReceivedHandlerId);delete this._dataReceivedHandlerId;}this._cleanUpTimers();this._detachEvents();delete this._aTableHeaders;};
t.prototype._detachExtensions=function(){d.cleanup(this);};
t.prototype.onpaste=function(i){if(i.isMarked()||/^(input|textarea)$/i.test(i.target.tagName)||!this.getDomRef("sapUiTableCnt").contains(i.target)){return;}var l=P.getPastedDataAs2DArray(i.originalEvent);if(l.length===0||l[0].length===0){return;}this.firePaste({data:l});};
t.prototype.onThemeChanged=function(){T.readThemeParameters();if(this.getDomRef()){this.invalidate();}};
t.prototype.onlocalizationChanged=function(i){var l=i.changes||{};var x=l.hasOwnProperty("rtl");var y=l.hasOwnProperty("language");this._adaptLocalization(x,y).then(function(){this.invalidate();}.bind(this));};
t.prototype._adaptLocalization=function(i,l){if(!i&&!l){return Promise.reject();}var x=Promise.resolve();if(i){this._bRtlMode=sap.ui.getCore().getConfiguration().getRTL();}if(l){x=T.getResourceBundle({async:true,reload:true});}return x.then(function(){if(l){T.Menu.cleanupDataCellContextMenu(this);this._invalidateColumnMenus();}}.bind(this));};
t.prototype._collectRowHeights=function(H){var l=this.getDomRef();if(!l){return[];}var x=this._getBaseRowHeight();var y=H?".sapUiTableColHdrTr":".sapUiTableTr";var z=l.querySelectorAll(".sapUiTableCtrlFixed > tbody > tr"+y);var J=l.querySelectorAll(".sapUiTableCtrlScroll > tbody > tr"+y);var K=this.getRows().length;var M=[];var O=D.browser.chrome&&window.devicePixelRatio!=1;if(H){if(this.getColumnHeaderHeight()>0){x=this.getColumnHeaderHeight();}else if(this.getRowMode()){x=this._getDefaultRowHeight();}}for(var i=0;i<K;i++){var Q=z[i]?z[i].getBoundingClientRect().height:0;var U=J[i]?J[i].getBoundingClientRect().height:0;var W=Math.max(Q,U);if(O){var X=x-W;if(X>0&&X<1){M.push(Math.max(W,x-1));continue;}}M.push(Math.max(W,x));}if(M.length>0&&!H){T.dynamicCall(this._getSyncExtension,function(Y){var Z=Y.syncRowHeights(M.slice());if(Z&&Z.length===M.length){M=Z.slice();}});}return M;};
t.prototype._resetRowHeights=function(){var l=this._getBaseRowHeight();var x="";if(l){x=l+"px";}var y=this.getDomRef("tableCCnt");if(y){var z=y.querySelectorAll(".sapUiTableTr");for(var i=0;i<z.length;i++){z[i].style.height=x;}}};
t.prototype._resetColumnHeaderHeights=function(){var l=this.getDomRef();if(l){var x=l.querySelectorAll(".sapUiTableColHdrTr");for(var i=0;i<x.length;i++){x[i].style.height=null;}}};
t.prototype._collectTableSizes=function(){var l={tableCtrlScrollWidth:0,tableRowHdrScrWidth:0,tableCtrlScrWidth:0,tableHSbScrollLeft:0,tableCtrlFixedWidth:0,tableCntHeight:0,tableCntWidth:0};var x=this.getDomRef();if(!x){return l;}var y=x.querySelector(".sapUiTableCnt");if(y){l.tableCntHeight=y.clientHeight;l.tableCntWidth=y.clientWidth;}var z=x.querySelector(".sapUiTableCtrlScroll:not(.sapUiTableCHT)");if(z){l.tableCtrlScrollWidth=z.clientWidth;}var H=x.querySelector(".sapUiTableRowHdrScr");if(H){l.tableRowHdrScrWidth=H.clientWidth;}var J=x.querySelector(".sapUiTableCtrlScr:not(.sapUiTableCHA)");if(J){l.tableCtrlScrWidth=J.clientWidth;}var K=this._getScrollExtension().getHorizontalScrollbar();if(K){l.tableHSbScrollLeft=K.scrollLeft;}var M=x.querySelector(".sapUiTableCtrlScrFixed:not(.sapUiTableCHA) > .sapUiTableCtrlFixed");if(M){l.tableCtrlFixedWidth=M.clientWidth;}var O=this.getFixedColumnCount();var Q=0;if(O){var U=this.getColumns();var W=x.querySelectorAll(".sapUiTableCtrlFirstCol:not(.sapUiTableCHTHR) > th");for(var i=0;i<W.length;i++){var X=parseInt(W[i].getAttribute("data-sap-ui-headcolindex"));if(!isNaN(X)&&(X<O)){var Y=U[X];var Z;if(Y._iFixWidth!=null){Z=Y._iFixWidth;}else{Z=W[i].getBoundingClientRect().width;}Q+=Z;}}}if(Q>0){var $=this._getScrollExtension();var _=l.tableRowHdrScrWidth;var a1=$.getVerticalScrollbar();if(a1&&!$.isVerticalScrollbarExternal()){_+=a1.offsetWidth;}if(T.hasRowActions(this)){var b1=this.getDomRef("sapUiTableRowActionScr");if(b1){_+=b1.offsetWidth;}}_+=T.Column.getMinColumnWidth();var c1=l.tableCntWidth-_;var d1=c1>Q;var e1=!d1;if(this._bIgnoreFixedColumnCount!==e1){this._bIgnoreFixedColumnCount=e1;if(this.getEnableColumnFreeze()){this._invalidateColumnMenus();}this.invalidate();}}return l;};
t.prototype._updateRowHeights=function(i,H){var l=this.getDomRef();if(!l){return;}function x(O,Q){var U=i[Q];if(U){O.style.height=U+"px";}}var y=H?".sapUiTableColHdrTr":".sapUiTableTr";var z=H?[]:l.querySelectorAll(".sapUiTableRowSelectionCell");var J=H?[]:l.querySelectorAll(".sapUiTableRowActionCell");var K=l.querySelectorAll(".sapUiTableCtrlFixed > tbody > tr"+y);var M=l.querySelectorAll(".sapUiTableCtrlScroll > tbody > tr"+y);Array.prototype.forEach.call(z,x);Array.prototype.forEach.call(J,x);Array.prototype.forEach.call(K,x);Array.prototype.forEach.call(M,x);};
t.prototype.onBeforeRendering=function(i){this._bInvalid=true;this._detachEvents();if(i&&i.isMarked("renderRows")){return;}this._cleanUpTimers();this.getBinding("rows");this._aTableHeaders=[];};
t.prototype.onAfterRendering=function(i){var l=i&&i.isMarked("renderRows");this._bInvalid=false;this._attachEvents();this._initRowDomRefs();if(!this._bAllowColumnHeaderTextSelection&&!l){this._disableTextSelection(this.$().find(".sapUiTableColHdrCnt"));}this.getDomRef().classList.remove("sapUiTableRActFlexible");if(!l){this._aTableHeaders=this.$().find(".sapUiTableColHdrCnt th");}this._updateTableSizes(T.RowsUpdateReason.Render,true);T.registerResizeHandler(this,"Table",this._onTableResize.bind(this));this._bFirstRendering=false;};
t.prototype.invalidate=function(){this._bInvalid=true;T.Column.invalidateColumnUtils(this);return C.prototype.invalidate.call(this);};
t.prototype._initRowDomRefs=function(){var l=this.getRows();for(var i=0;i<l.length;i++){l[i].initDomRefs();}};
t.prototype._updateTableSizes=function(l,x){x=x===true;var y=this.getDomRef();if(this._bInvalid||!y||!sap.ui.getCore().isThemeApplied()||y.offsetWidth===0){return;}if(!x){this._resetRowHeights();this._resetColumnHeaderHeights();}this._aRowHeights=this._collectRowHeights(false);var z=this._collectRowHeights(true);if(T.isVariableRowHeightEnabled(this)&&!T.isNoDataVisible(this)){this._getScrollExtension().updateInnerVerticalScrollPosition();}function H(a1){var b1=a1.getDomRef();var c1=T.Column.getMinColumnWidth();var d1=[];var e1=a1.getColumnHeaderVisible();function f1(i1,j1){if(i1<=j1){return Math.max(i1,j1-5,c1)+"px";}return-1;}function g1(j1){var k1=Math.max(j1._minWidth||0,c1,j1.getMinWidth());var l1=j1.getWidth();var m1;var n1;var o1;if(T.isVariableWidth(l1)&&!T.isFixedColumn(a1,j1.getIndex())){m1=b1.querySelectorAll('th[data-sap-ui-colid="'+j1.getId()+'"]');n1=m1[e1?0:1];o1=n1?n1.offsetWidth:null;if(o1!==null){if(o1<=k1){return{headers:m1,newWidth:f1(o1,k1)};}else if(n1&&n1.style.width!=l1){d1.push({col:j1,header:n1,minWidth:k1,headers:m1});return{headers:m1,newWidth:l1};}d1.push({col:j1,header:n1,minWidth:k1,headers:m1});}}return null;}function h1(j1){if(j1){Array.prototype.forEach.call(j1.headers,function(k1){k1.style.width=j1.newWidth;});}}a1._getVisibleColumns().map(g1).forEach(h1);if(d1.length){var i1;for(var i=0;i<d1.length;i++){i1=d1[i].header&&d1[i].header.offsetWidth;d1[i].newWidth=f1(i1,d1[i].minWidth);if(parseInt(d1[i].newWidth)>=0){h1(d1[i]);}}}}H(this);var J=this._collectTableSizes();this._updateRowHeights(this._aRowHeights,false);this._updateRowHeights(z,true);T.dynamicCall(this._getSyncExtension,function(i){i.syncLayout({top:this.getDomRef("sapUiTableCnt").offsetTop,headerHeight:this.getDomRef().querySelector(".sapUiTableColHdrCnt").getBoundingClientRect().height,contentHeight:this.getDomRef("tableCCnt").getBoundingClientRect().height});},this);var K=this._getScrollExtension();K.updateHorizontalScrollbar(J);K.updateVerticalScrollbarPosition();K.updateVerticalScrollbarVisibility();var $=this.$();if(T.hasRowActions(this)){var M=$.hasClass("sapUiTableRActFlexible");var O=this.getDomRef("dummycolhdr");if(O){var Q=this.getDomRef("header");var U=Q.clientWidth;var W=this.getColumns().reduce(function(W,i){if(i.getDomRef()&&i.getIndex()>=this.getComputedFixedColumnCount()){return W+T.convertCSSSizeToPixel(i.getWidth());}return W;}.bind(this),0);var X=O.clientWidth;var Y=U>W;if(!M&&Y){var Z=J.tableCtrlScrWidth+J.tableRowHdrScrWidth+J.tableCtrlFixedWidth-X;var _={width:"auto"};_[this._bRtlMode?"right":"left"]=Z;this.$("sapUiTableRowActionScr").css(_);this.$("rowacthdr").css(_);$.toggleClass("sapUiTableRActFlexible",true);}else if(M&&!Y){this.$("sapUiTableRowActionScr").removeAttr("style");this.$("rowacthdr").removeAttr("style");$.toggleClass("sapUiTableRActFlexible",false);}}}$.find(".sapUiTableNoOpacity").addBack().removeClass("sapUiTableNoOpacity");this._getRowMode().updateTableSizes(l);};
t.prototype.setShowOverlay=function(i){i=!!i;this.setProperty("showOverlay",i,true);if(this.getDomRef()){var l=document.activeElement;this.$().toggleClass("sapUiTableOverlay",i);this._getAccExtension().updateAriaStateForOverlayAndNoData();this._getKeyboardExtension().updateNoDataAndOverlayFocus(l);}return this;};
t.prototype._updateFixedBottomRows=function(){var i=this.getDomRef();if(!i||this._getRowCounts().fixedBottom===0){return;}var l=T.getFirstFixedBottomRowIndex(this);var x=this.getRows();var $;q(i).find(".sapUiTableRowLastScrollable").removeClass("sapUiTableRowLastScrollable");q(i).find(".sapUiTableRowFirstFixedBottom").removeClass("sapUiTableRowFirstFixedBottom");if(l>=0&&l<x.length){$=x[l].getDomRefs(true);$.row.addClass("sapUiTableRowFirstFixedBottom",true);}if(l>=1&&l<x.length){$=x[l-1].getDomRefs(true);$.row.addClass("sapUiTableRowLastScrollable",true);}};
t.prototype.getFocusInfo=function(){var i=this.$().find(":focus").attr("id");if(i){return{customId:i};}else{return E.prototype.getFocusInfo.apply(this,arguments);}};
t.prototype.applyFocusInfo=function(i){if(i&&i.customId){q(document.getElementById(i.customId)).focus();}else{E.prototype.applyFocusInfo.apply(this,arguments);}return this;};
t.prototype.setTitle=function(i){var l=i;if(typeof(i)==="string"||i instanceof String){l=c.TableHelper.createTextView({text:i,width:"100%"});l.addStyleClass("sapUiTableHdrTitle");}this.setAggregation("title",l);return this;};
t.prototype.setFooter=function(i){var l=i;if(typeof(i)==="string"||i instanceof String){l=c.TableHelper.createTextView({text:i,width:"100%"});}this.setAggregation("footer",l);return this;};
t.prototype.setSelectionMode=function(i){if(i===p.Multi){i=p.MultiToggle;L.warning("The selection mode 'Multi' is deprecated and must not be used anymore."+" Your setting was defaulted to selection mode 'MultiToggle'",this);}if(this._hasSelectionPlugin()){L.error("If a selection plugin is applied to the table, the selection mode is controlled by the plugin.",this);}else{this.setProperty("selectionMode",i);this._oLegacySelectionPlugin.setSelectionMode(i);}return this;};
t.prototype.setFirstVisibleRow=function(i,O,l){if(parseInt(i)<0){L.error("The index of the first visible row must be greater than or equal to 0. The value has been set to 0.",this);i=0;}if(this._getTotalRowCount()>0){var M=this._getMaxFirstVisibleRowIndex();if(M<i){L.warning("The index of the first visible row must be lesser or equal than the scrollable row count minus the visible row count."+" The value has been set to "+M+".",this);i=M;}}var x=this.getFirstVisibleRow()!=i;var y=this._getScrollExtension();if(x){var z=this._getFirstRenderedRowIndex();this.setProperty("firstVisibleRow",i,true);var H=this._getFirstRenderedRowIndex()!==z;if(this.getBinding("rows")){if(H){var J=O===true?T.RowsUpdateReason.VerticalScroll:T.RowsUpdateReason.FirstVisibleRowChange;this.updateRows(J);}if(!O){y.updateVerticalScrollPosition();}}if(!l){this.fireFirstVisibleRowChanged({firstVisibleRow:i});}}else if(!O){y.updateVerticalScrollPosition();}return this;};
t.getMetadata().getAggregation("rows")._doesNotRequireFactory=true;
t.prototype.bindAggregation=function(i){if(i==="rows"){return this.bindRows.apply(this,[].slice.call(arguments,1));}return C.prototype.bindAggregation.apply(this,arguments);};
t.prototype._bindAggregation=function(i,l){if(i==="rows"){this._bBindingReady=false;this._bContextsAvailable=false;t._addBindingListener(l,"change",this._onBindingChange.bind(this));t._addBindingListener(l,"dataRequested",this._onBindingDataRequested.bind(this));t._addBindingListener(l,"dataReceived",this._onBindingDataReceived.bind(this));}C.prototype._bindAggregation.call(this,i,l);if(i==="rows"){var x=this.getBinding("rows");var M=x?x.getModel():null;this._getSelectionPlugin()._setBinding(x);if(M&&M.getDefaultBindingMode()===B.OneTime){L.error("The binding mode of the model is set to \"OneTime\"."+" This binding mode is not supported for the \"rows\" aggregation!"+" Scrolling can not be performed.",this);}}};
t.prototype.unbindAggregation=function(i,l){var x=this.getBinding("rows");if(i==="rows"&&this.isBound("rows")){l=true;}var y=C.prototype.unbindAggregation.call(this,i,l);if(i==="rows"&&x){this._invalidateColumnMenus();}return y;};
t.prototype.destroyAggregation=function(i,l){C.prototype.destroyAggregation.apply(this,arguments);if(i==="rows"){this._aRowClones.forEach(function(x){x.destroy();});this._aRowClones=[];}return this;};
t.prototype.bindRows=function(i){this._bBindingReady=false;this._bContextsAvailable=false;this._iPendingRequests=0;this._bPendingRequest=false;this._iBindingLength=null;if(this.getEnableBusyIndicator()){this.setBusy(false);}return C.prototype.bindAggregation.call(this,"rows",t._getSanitizedBindingInfo(arguments));};
t.prototype.unbindRows=function(){C.prototype.unbindAggregation.call(this,"rows",true);this._getSelectionPlugin()._setBinding(null);this._adjustToTotalRowCount();this._getRowMode().unbindRows();return this;};
t._getSanitizedBindingInfo=function(i){var l;if(i==null||i[0]==null){l=null;}else if(typeof i[0]==="string"){var x=i[0];var y=i[1];var z=i[2];var H=i[3];if(y instanceof S||Array.isArray(z)&&z[0]instanceof F){H=z;z=y;y=undefined;}l={path:x,sorter:z,filters:H,template:y};}else{l=i[0];}return l;};
t._addBindingListener=function(i,l,H){if(!i.events){i.events={};}if(!i.events[l]){i.events[l]=H;}else{var O=i.events[l];i.events[l]=function(){H.apply(this,arguments);O.apply(this,arguments);};}};
t.prototype._onBindingChange=function(i){var l=i.getParameter("reason");if(l===a.Sort||l===a.Filter){this.setFirstVisibleRow(0);}};
t.prototype.setRowMode=function(i){this._destroyLegacyRowMode();this.setAggregation("rowMode",i);this._initLegacyRowMode();};
t.prototype.getRowMode=function(){return this.getAggregation("rowMode");};
t.prototype._getRowMode=function(){var i=this.getRowMode()||this._oLegacyRowMode;if(!i){this._initLegacyRowMode();i=this._oLegacyRowMode;}return i;};
t.prototype._initLegacyRowMode=function(){if(this._oLegacyRowMode||this.getRowMode()){return;}this._oLegacyRowMode=u(this);};
t.prototype._destroyLegacyRowMode=function(){if(this._oLegacyRowMode){this._oLegacyRowMode.destroy();delete this._oLegacyRowMode;}};
function u(i){var l;switch(i.getVisibleRowCountMode()){case V.Fixed:l=new m(true,i);break;case V.Interactive:l=new n(true,i);break;case V.Auto:l=new A(true,i);break;default:}return l;}
t.prototype._getRowCounts=function(){return this._getRowMode().getComputedRowCounts();};
t.prototype.setVisibleRowCountMode=function(i){if(this.getRowMode()){L.warning("If the \"rowMode\" aggregation is set, setting the \"visibleRowCountMode\" has no effect");return this.setProperty("visibleRowCountMode",i,true);}var O=this.getVisibleRowCountMode();this.setProperty("visibleRowCountMode",i);var l=this.getVisibleRowCountMode();if(l!==O){this._destroyLegacyRowMode();this._initLegacyRowMode();}return this;};
t.prototype.setVisibleRowCount=function(i){var l=this.getVisibleRowCountMode();if(l==V.Auto){L.error("VisibleRowCount will be ignored since VisibleRowCountMode is set to Auto",this);return this;}if(i!=null&&!isFinite(i)){return this;}var x=this.getFixedRowCount()+this.getFixedBottomRowCount();if(i<=x&&x>0){L.error("Table: "+this.getId()+" visibleRowCount('"+i+"') must be bigger than number of"+" fixed rows('"+(this.getFixedRowCount()+this.getFixedBottomRowCount())+"')",this);return this;}if(this.getRowMode()){L.warning("If the \"rowMode\" aggregation is set, setting the \"visibleRowCount\" has no effect");return this.setProperty("visibleRowCount",i,true);}i=this.validateProperty("visibleRowCount",i);if(this.getBinding("rows")&&this._getTotalRowCount()<=i){this.setProperty("firstVisibleRow",0);}this.setProperty("visibleRowCount",i);T.dynamicCall(this._getSyncExtension,function(y){y.syncRowCount(i);});return this;};
t.prototype.setMinAutoRowCount=function(M){if(parseInt(M)<1){L.error("The minAutoRowCount property must be greater than 0. The value has been set to 1.",this);M=1;}if(this.getRowMode()){L.warning("If the \"rowMode\" aggregation is set, setting the \"minAutoRowCount\" has no effect");return this.setProperty("minAutoRowCount",M,true);}return this.setProperty("minAutoRowCount",M);};
t.prototype.setTooltip=function(i){L.warning("The aggregation tooltip is not supported for sap.ui.table.Table",this);return this.setAggregation("tooltip",i,true);};
t.prototype.setNavigationMode=function(){this.setProperty("navigationMode",N.Scrollbar,true);L.error("The navigationMode property is deprecated and must not be used anymore. Your setting was defaulted to 'Scrollbar'",this);return this;};
t.prototype._getFixedBottomRowContexts=function(){var i=this._getRowCounts();var l=this._getTotalRowCount();if(i.fixedBottom>0&&i.count-i.fixedBottom<l){return this._getContexts(l-i.fixedBottom,i.fixedBottom);}else{return[];}};
t.prototype._getFixedRowContexts=function(){var i=this._getRowCounts();if(i.fixedTop>0){return this._getContexts(0,i.fixedTop);}else{return[];}};
t.prototype._getContexts=function(i,l,x){var y=this.getBinding("rows");if(y){return y.getContexts(i,l,x);}else{return[];}};
t.prototype._getRowContexts=function(l,x,y){var z=this.getBinding("rows");var H=this.getRows().length;l=l==null?H:l;l=Math.max(l,this._getRowMode().getMinRequestLength());if(!z||l<=0){return[];}x=x===true;y=y===true;var J=this._getFirstRenderedRowIndex();var K=this._getRowCounts();var M=[];var O;var Q=l-K.fixedBottom;var U=0;var W=Q;var X=this.getThreshold();X=X?Math.max(H,X):0;var Y=J;var Z=function(a1,b1,Y){for(var i=0;i<b1.length;i++){a1[Y+i]=b1[i];}};if(K.fixedTop>0&&J>0){Y=J+K.fixedTop;Q-=K.fixedTop;U=K.fixedTop;O=this._getFixedRowContexts();M=M.concat(O);}O=this._getContexts(Y,Q,X);if(!x){this._adjustToTotalRowCount();}var $=this._getTotalRowCount();Z(M,O,U);W=Math.min(W,Math.max($-K.fixedBottom,0));if(K.fixedBottom>0){O=this._getFixedBottomRowContexts();Z(M,O,W);}var _=this._getMaxFirstRenderedRowIndex();if(_<J&&this._bContextsAvailable&&!y){this.setProperty("firstVisibleRow",_,true);M=this._getRowContexts(l,x,true);}return M;};
t.prototype._adjustToTotalRowCount=function(){var i=this.getBinding("rows");var l=this._getTotalRowCount();var x=this._getScrollExtension();if(this._iBindingLength!==l){this._iBindingLength=l;this._updateFixedBottomRows();x.updateVerticalScrollbarVisibility();x.updateVerticalScrollHeight();x.updateVerticalScrollPosition();if(!i||!T.hasPendingRequests(this)){this._updateNoData();}}};
t.prototype.refreshRows=function(i){var l=this.getBinding("rows");if(!l){L.error("RefreshRows must not be called without a binding",this);return;}this._bBindingReady=true;this._bContextsAvailable=false;if(i===a.Sort||i===a.Filter){this.setFirstVisibleRow(0);}this._getRowMode().refreshRows(i);};
t.prototype.updateRows=function(i){if(this.bIsDestroyed||this._bIsBeingDestroyed){return;}var l=this.getBinding("rows");if(!this._bBindingReady&&(typeof l.isLengthFinal!=="function"||l.isLengthFinal())){this._bBindingReady=true;}this._bContextsAvailable=this._bBindingReady;this._getRowMode().updateRows(i);};
t.prototype.insertRow=function(){L.error("The control manages the rows aggregation. The method \"insertRow\" cannot be used programmatically!",this);return this;};
t.prototype.addRow=function(){L.error("The control manages the rows aggregation. The method \"addRow\" cannot be used programmatically!",this);return this;};
t.prototype.removeRow=function(){L.error("The control manages the rows aggregation. The method \"removeRow\" cannot be used programmatically!",this);return null;};
t.prototype.removeAllRows=function(){L.error("The control manages the rows aggregation. The method \"removeAllRows\" cannot be used programmatically!",this);return[];};
t.prototype.destroyRows=function(){L.error("The control manages the rows aggregation. The method \"destroyRows\" cannot be used programmatically!",this);return this;};
t.prototype.setCreationRow=function(i){if(!T.isA(i,"sap.ui.table.CreationRow")){i=null;}return this.setAggregation("creationRow",i);};
t.prototype.getCreationRow=function(){return this.getAggregation("creationRow");};
t.prototype.destroyCreationRow=function(){return this.destroyAggregation("creationRow");};
t.prototype.autoResizeColumn=function(i){this._getPointerExtension().doAutoResizeColumn(i);};
t.prototype._attachEvents=function(){var $=this.$();if(sap.ui.getCore().getConfiguration().getAnimation()){q(document.body).on("webkitTransitionEnd transitionend",function(i){if(q(i.target).has($).length>0){this._updateTableSizes(T.RowsUpdateReason.Animation);}}.bind(this));}D.resize.attachHandler(this._onWindowResize,this);d.attachEvents(this);};
t.prototype._detachEvents=function(){q(document.body).off('webkitTransitionEnd transitionend');T.deregisterResizeHandler(this,"Table");D.resize.detachHandler(this._onWindowResize,this);d.detachEvents(this);};
t.prototype._cleanUpTimers=function(){var K;for(K in this._mTimeouts){if(this._mTimeouts[K]){window.clearTimeout(this._mTimeouts[K]);delete this._mTimeouts[K];}}for(K in this._mAnimationFrames){if(this._mAnimationFrames[K]){window.cancelAnimationFrame(this._mAnimationFrames[K]);delete this._mAnimationFrames[K];}}};
t.prototype._updateNoData=function(){if(!this.getDomRef()){return;}var i=document.activeElement;this.$().toggleClass("sapUiTableEmpty",T.isNoDataVisible(this));this._getAccExtension().updateAriaStateForOverlayAndNoData();this._getKeyboardExtension().updateNoDataAndOverlayFocus(i);};
t.prototype.removeColumn=function(i,l){var x=this.removeAggregation('columns',i,l);if(typeof i==="number"&&i>-1){i=this.getColumns()[i];}var y=this._aSortedColumns.indexOf(i);if(!this._bReorderInProcess&&y>=0){this._aSortedColumns.splice(y,1);}this.invalidateRowsAggregation();var z=this.getCreationRow();if(z){z._update();}return x;};
t.prototype.removeAllColumns=function(){var i=this.removeAllAggregation('columns');this._aSortedColumns=[];this.invalidateRowsAggregation();var l=this.getCreationRow();if(l){l._update();}return i;};
t.prototype.destroyColumns=function(){var i=this.destroyAggregation('columns');this._aSortedColumns=[];this.invalidateRowsAggregation();var l=this.getCreationRow();if(l){l._update();}return i;};
t.prototype.addColumn=function(i,l){this.addAggregation('columns',i,l);this.invalidateRowsAggregation();var x=this.getCreationRow();if(x){x._update();}return this;};
t.prototype.insertColumn=function(i,l,x){this.insertAggregation('columns',i,l,x);this.invalidateRowsAggregation();var y=this.getCreationRow();if(y){y._update();}return this;};
t.prototype._getTotalRowCount=function(){var i=this.getBinding("rows");var l=this.getBindingInfo("rows");if(!i){return 0;}if(l.length!=null){return l.length;}return i.getLength();};
t.prototype._getMaxFirstVisibleRowIndex=function(){var M;if(T.isVariableRowHeightEnabled(this)){M=this._getTotalRowCount()-1;}else{M=this._getTotalRowCount()-this._getRowCounts().count;}return Math.max(0,M);};
t.prototype._getMaxFirstRenderedRowIndex=function(){var M;if(T.isVariableRowHeightEnabled(this)){M=this._getTotalRowCount()-this._getRowCounts().count-1;}else{M=this._getTotalRowCount()-this._getRowCounts().count;}return Math.max(0,M);};
t.prototype._getFirstRenderedRowIndex=function(){var i=this.getFirstVisibleRow();if(T.isVariableRowHeightEnabled(this)&&i>this._getMaxFirstRenderedRowIndex()){return this._getMaxFirstRenderedRowIndex();}else{return i;}};
t.prototype._getVisibleColumns=function(){var x=[];var y=this.getColumns();for(var i=0,l=y.length;i<l;i++){if(y[i].shouldRender()){x.push(y[i]);}}return x;};
t.prototype._getColumnsWidth=function(x,y){var z=this.getColumns();var H=0;if(x!==0&&!x){x=0;}if(y!==0&&!y){y=z.length;}for(var i=x,l=y;i<l;i++){if(z[i]&&z[i].shouldRender()){var J=T.convertCSSSizeToPixel(z[i].getWidth());if(J==null){J=T.Column.getMinColumnWidth();}H+=J;}}return H;};
t.prototype._onTableResize=function(i){var O=i.oldSize.width;var l=i.size.width;if(this._bInvalid||!this.getDomRef()||O===l){return;}this._updateTableSizes(T.RowsUpdateReason.Resize);};
t.prototype._onWindowResize=function(){if(this._bInvalid||!this.getDomRef()){return;}if(D.browser.chrome&&window.devicePixelRatio!==this._nDevicePixelRatio){this._nDevicePixelRatio=window.devicePixelRatio;this._updateTableSizes(T.RowsUpdateReason.Zoom);this._adjustOutlineOffset();}};
t.prototype._adjustOutlineOffset=function(){if(window.devicePixelRatio<1){this.addStyleClass("sapUiTableZoomout");}else{this.removeStyleClass("sapUiTableZoomout");}};
t.prototype._disableTextSelection=function(i){q(i||document.body).attr("unselectable","on").css({"-moz-user-select":"none","-webkit-user-select":"none","user-select":"none"}).bind("selectstart",function(l){l.preventDefault();return false;});};
t.prototype._enableTextSelection=function(i){q(i||document.body).attr("unselectable","off").css({"-moz-user-select":"","-webkit-user-select":"","user-select":""}).unbind("selectstart");};
t.prototype._clearTextSelection=function(){if(window.getSelection){if(window.getSelection().empty){window.getSelection().empty();}else if(window.getSelection().removeAllRanges){window.getSelection().removeAllRanges();}}else if(document.selection&&document.selection.empty){try{document.selection.empty();}catch(i){}}};
t.prototype._findAndfireCellEvent=function(i,l,x){var $=q(l.target);var y=$.closest(".sapUiTableDataCell");var z=y.attr("id");var M=/.*-row(\d*)-col(\d*)/i.exec(z);var H=false;if(M){var J=M[1];var K=M[2];var O=this.getRows()[J];var Q=O&&O.getCells()[K];var U=O&&O.getIndex();var W=b.ofCell(Q).getId();var X;if(this.getBindingInfo("rows")){X=O.getBindingContext(this.getBindingInfo("rows").model);}var Y={rowIndex:U,columnIndex:K,columnId:W,cellControl:Q,rowBindingContext:X,cellDomRef:y.get(0)};H=!i.call(this,Y);if(!H&&typeof x==="function"){Y.cellDomRef=y[0];H=x.call(this,Y);}}return H;};
t.prototype.getFocusDomRef=function(){this._getKeyboardExtension().initItemNavigation();var i=T.getFocusedItemInfo(this);if(i){return i.domRef||C.prototype.getFocusDomRef.apply(this,arguments);}return null;};
t.prototype.pushSortedColumn=function(i,l){if(!l){this._aSortedColumns=[];}this._aSortedColumns.push(i);};
t.prototype.getSortedColumns=function(){return this._aSortedColumns.slice();};
t.prototype.sort=function(l,x,y){if(!l){for(var i=0;i<this._aSortedColumns.length;i++){this._aSortedColumns[i].setSorted(false);}var z=this.getBinding("rows");if(z){z.sort();}this._aSortedColumns=[];}if(this.getColumns().indexOf(l)>=0){l.sort(x===s.Descending,y);}};
t.prototype.filter=function(i,l){if(this.getColumns().indexOf(i)>=0){i.filter(l);}};
t.prototype._updateSelection=function(){var l=this.getSelectionMode();if(l===p.None){return;}var x=this._getSelectionPlugin().getRenderConfig();var y;var z;var $=this.$("selall");var H=this._getAccExtension().getAriaTextsForSelectionMode(true);var J=this.getRows();for(var i=0;i<J.length;i++){var K=J[i];K._updateSelection(this,H);}if(x.headerSelector.visible){var M=T.areAllRowsSelected(this);$.toggleClass("sapUiTableSelAll",!M);this._getAccExtension().setSelectAllState(M);if(x.headerSelector.type==="toggle"){y=M?"TBL_DESELECT_ALL":"TBL_SELECT_ALL";}}if(x.headerSelector.type==="clear"&&x.headerSelector.visible){$.attr("disabled",!x.headerSelector.enabled);y="TBL_DESELECT_ALL";if(x.headerSelector.enabled){$.removeAttr("aria-disabled");}else{$.attr("aria-disabled","true");}}if(y){z=T.getResourceText(y);if(this._getShowStandardTooltips()&&x.headerSelector.visible){$.attr('title',z);}else if(x.headerSelector.type==="toggle"){this.getDomRef("ariaselectall").innerText=z;}}};
t.prototype._getShowStandardTooltips=function(){return!this._bHideStandardTooltips;};
t.prototype._onSelectionChanged=function(i){var l=this._getSelectionPlugin();var x=i.getParameter("rowIndices");var y=i.getParameter("selectAll");var z=this._iSourceRowIndex!==undefined?this._iSourceRowIndex:l.getSelectedIndex();this._updateSelection();if(!this._hasSelectionPlugin()){this.setProperty("selectedIndex",z,true);this.fireRowSelectionChange({rowIndex:z,rowContext:this.getContextByIndex(z),rowIndices:x,selectAll:y,userInteraction:this._iSourceRowIndex!==undefined});}};
t.prototype.getContextByIndex=function(i){var l=this.getBinding("rows");return i>=0&&l?l.getContexts(i,1)[0]:null;};
t.prototype.getSelectedIndex=function(){if(this._hasSelectionPlugin()){throw new Error("Unsupported operation: sap.ui.table.Table#getSelectedIndex must not be called if a selection plugin is applied.");}return this._getSelectionPlugin().getSelectedIndex();};
t.prototype.setSelectedIndex=function(i){if(this._hasSelectionPlugin()){throw new Error("Unsupported operation: sap.ui.table.Table#setSelectedIndex must not be called if a selection plugin is applied.");}this._getSelectionPlugin().setSelectedIndex(i);return this;};
t.prototype.clearSelection=function(){if(this._hasSelectionPlugin()){throw new Error("Unsupported operation: sap.ui.table.Table#clearSelection must not be called if a selection plugin is applied.");}this._getSelectionPlugin().clearSelection();return this;};
t.prototype.selectAll=function(){if(this._hasSelectionPlugin()){throw new Error("Unsupported operation: sap.ui.table.Table#selectAll must not be called if a selection plugin is applied.");}if(T.hasSelectAll(this)){this._getSelectionPlugin().selectAll();}return this;};
t.prototype.getSelectedIndices=function(){if(this._hasSelectionPlugin()){throw new Error("Unsupported operation: sap.ui.table.Table#getSelectedIndices must not be called if a selection plugin is applied.");}return this._getSelectionPlugin().getSelectedIndices();};
t.prototype.addSelectionInterval=function(i,l){if(this._hasSelectionPlugin()){throw new Error("Unsupported operation: sap.ui.table.Table#addSelectionInterval must not be called if a selection plugin is applied.");}this._getSelectionPlugin().addSelectionInterval(i,l);return this;};
t.prototype.setSelectionInterval=function(i,l){if(this._hasSelectionPlugin()){throw new Error("Unsupported operation: sap.ui.table.Table#setSelectionInterval must not be called if a selection plugin is applied.");}this._getSelectionPlugin().setSelectionInterval(i,l);return this;};
t.prototype.removeSelectionInterval=function(i,l){if(this._hasSelectionPlugin()){throw new Error("Unsupported operation: sap.ui.table.Table#removeSelectionInterval must not be called if a selection plugin is applied.");}this._getSelectionPlugin().removeSelectionInterval(i,l);return this;};
t.prototype.isIndexSelected=function(i){if(this._hasSelectionPlugin()){throw new Error("Unsupported operation: sap.ui.table.Table#isIndexSelected must not be called if a selection plugin is applied.");}return this._getSelectionPlugin().isIndexSelected(i);};
t.prototype.setGroupBy=function(i){var l=i;var O=sap.ui.getCore().byId(this.getGroupBy());if(typeof l==="string"){l=sap.ui.getCore().byId(l);}var x=false;if(l instanceof b&&l!==O){if(this.getColumns().indexOf(l)===-1){throw new Error("Column has to be part of the columns aggregation!");}var y=this.fireGroup({column:l,groupedColumns:[l.getId()],type:G.group});if(O){O.setGrouped(false);x=true;}if(y&&this.getEnableGrouping()){l.setGrouped(true);}}if(!l||x){if(O){O.setGrouped(false);}T.Grouping.resetExperimentalGrouping(this);}return this.setAssociation("groupBy",l);};
t.prototype.getBinding=function(i){T.Grouping.setupExperimentalGrouping(this);return E.prototype.getBinding.call(this,[i||"rows"]);};
t.prototype.setEnableGrouping=function(i){var l=sap.ui.getCore().byId(this.getGroupBy());this.setProperty("enableGrouping",i);if(l){l.setGrouped(i);}T.Grouping.resetExperimentalGrouping(this);this._invalidateColumnMenus();return this;};
t.prototype.setEnableCustomFilter=function(i){this.setProperty("enableCustomFilter",i);this._invalidateColumnMenus();return this;};
t.prototype.setEnableColumnFreeze=function(i){this.setProperty("enableColumnFreeze",i);this._invalidateColumnMenus();return this;};
t.prototype.setShowColumnVisibilityMenu=function(i){this.setProperty("showColumnVisibilityMenu",i);this._invalidateColumnMenus();return this;};
t.prototype.getComputedFixedColumnCount=function(){if(this._bIgnoreFixedColumnCount){return 0;}return this.getFixedColumnCount();};
t.prototype.setFixedColumnCount=function(l,x){var y=this.getColumns();var z,i;for(i=l-1;i>=0;i--){z=y[i];if(z&&z.getVisible()){l=Math.max(l,z.getIndex()+T.Column.getHeaderSpan(z));break;}}var $=this.$().find(".sapUiTableCtrlFirstCol > th");for(i=l-1;i>=0;i--){z=y[i];if(z&&T.isVariableWidth(z.getWidth())){z._iFixWidth=$.filter("[data-sap-ui-headcolindex='"+z.getIndex()+"']").width();}}this.setProperty("fixedColumnCount",l,x);this._collectTableSizes();if(this.getEnableColumnFreeze()){this._invalidateColumnMenus();}return this;};
t.prototype.setFixedRowCount=function(i){if(!(parseInt(i)>=0)){L.error("Number of fixed rows must be greater or equal 0",this);return this;}if((i+this.getFixedBottomRowCount())>=this.getVisibleRowCount()){L.error("Table '"+this.getId()+"' fixed rows('"+(i+this.getFixedBottomRowCount())+"') must be smaller than"+" numberOfVisibleRows('"+this.getVisibleRowCount()+"')",this);return this;}if(this.getRowMode()){L.warning("If the \"rowMode\" aggregation is set, setting the \"fixedRowCount\" has no effect");return this.setProperty("fixedRowCount",i,true);}return this.setProperty("fixedRowCount",i);};
t.prototype.setFixedBottomRowCount=function(i){if(!(parseInt(i)>=0)){L.error("Number of fixed bottom rows must be greater or equal 0",this);return this;}if((i+this.getFixedRowCount())>=this.getVisibleRowCount()){L.error("Table '"+this.getId()+"' fixed rows('"+(i+this.getFixedRowCount())+"') must be smaller than"+" numberOfVisibleRows('"+this.getVisibleRowCount()+"')",this);return this;}if(this.getRowMode()){L.warning("If the \"rowMode\" aggregation is set, setting the \"iFixedBottomRowCount\" has no effect");return this.setProperty("fixedBottomRowCount",i,true);}return this.setProperty("fixedBottomRowCount",i);};
t.prototype.setThreshold=function(i){this.setProperty("threshold",i,true);return this;};
t.prototype._invalidateColumnMenus=function(){var x=this.getColumns();for(var i=0,l=x.length;i<l;i++){x[i].invalidateMenu();}};
t.prototype._isTouchEvent=function(i){return!!(i&&i.originalEvent&&i.originalEvent.touches);};
t.prototype._getRowClone=function(x){var y=this._aRowClones[x];if(y&&!y.bIsDestroyed){return y;}y=new R(this.getId()+"-rows"+"-row"+x);this._aRowClones[x]=y;var z=this.getColumns();for(var i=0,l=z.length;i<l;i++){if(z[i].getVisible()){var H=z[i].getTemplateClone(i);if(H){y.addCell(H);}}}if(T.hasRowActions(this)){var J=this.getRowActionTemplate().clone();J._setFixedLayout(true);J._setCount(this.getRowActionCount());J._setIconLabel(this.getId()+"-rowacthdr");y.setAggregation("_rowAction",J,true);}var K=this.getRowSettingsTemplate();if(K){var M=K.clone();y.setAggregation("_settings",M,true);}return y;};
t.prototype.invalidateRowsAggregation=function(){this._bRowAggregationInvalid=true;};
t.prototype._getBaseRowHeight=function(){var i=this._getRowMode().getBaseRowContentHeight();if(i>0){return i+T.RowHorizontalFrameSize;}else{return this._getDefaultRowHeight();}};
t.prototype._getDefaultRowHeight=function(){var i=T.getContentDensity(this);return T.DefaultRowHeight[i];};
t.prototype._getDefaultRowContentHeight=function(){var i=T.getContentDensity(this);return T.BaseSize[i];};
t.prototype.setShowNoData=function(i){this.setProperty('showNoData',i,true);this._updateNoData();return this;};
t.prototype.setNoData=function(i){var O=T.getNoDataText(this);this.setAggregation("noData",i,true);var l=T.getNoDataText(this);if(O!=null&&l!=null){if(O!==l){this.$("noDataMsg").text(l);}}else{this.invalidate();}return this;};
t.prototype.exportData=function(x){var y=sap.ui.requireSync("sap/ui/core/util/Export");x=x||{};if(!x.rows){var z=this.getBinding("rows"),H=this.getBindingInfo("rows");var J=z.aFilters.concat(z.aApplicationFilters);x.rows={path:H.path,model:H.model,sorter:z.aSorters,filters:J,parameters:H.parameters};}if(!x.exportType){var K=sap.ui.requireSync("sap/ui/core/util/ExportTypeCSV");x.exportType=new K();}var M=x.rows.model;if(!M){var O=x.rows.path;var Q=O.indexOf(">");if(Q>0){M=O.substr(0,Q);}}if(!x.columns){x.columns=[];var U=this.getColumns();for(var i=0,l=U.length;i<l;i++){var W=U[i];if(W.getSortProperty()){x.columns.push({name:W.getLabel().getText(),template:{content:{path:W.getSortProperty(),model:M}}});}}}var X=new y(x);this.addDependent(X);return X;};
t.prototype._onPersoApplied=function(){var x=this.getColumns();var y=[];for(var i=0,l=x.length;i<l;i++){var z=x[i];if(z.getSorted()){y.push(new S(z.getSortProperty(),z.getSortOrder()===s.Descending));}}var H=this.getBinding("rows");if(H){if(y.length>0){H.sort(y);}this.refreshRows();}};
t.prototype._toggleSelectAll=function(){if(!T.hasData(this)||this.getSelectionMode()!==p.MultiToggle){return;}var i=this._getSelectionPlugin();if(T.areAllRowsSelected(this)){this._iSourceRowIndex=-1;i.clearSelection();}else{this._iSourceRowIndex=0;i.selectAll();}this._iSourceRowIndex=undefined;};
t.prototype.setBusy=function(i,l){var x=this.getBusy()!=i;l="sapUiTableGridCnt";var y=C.prototype.setBusy.call(this,i,l);if(x){this.fireBusyStateChanged({busy:i});}return y;};
t.prototype.setEnableBusyIndicator=function(i){this.setProperty("enableBusyIndicator",i,true);if(!i){this.setBusy(false);}return this;};
t.prototype._onBindingDataRequested=function(i){if(i.getSource()!=this.getBinding("rows")||i.getParameter("__simulateAsyncAnalyticalBinding")){return;}this._iPendingRequests++;this._bPendingRequest=true;var l=T.canUsePendingRequestsCounter(this);if(this.getEnableBusyIndicator()&&(l&&this._iPendingRequests===1||!l)){this.setBusy(true);}if(this._dataReceivedHandlerId!=null){clearTimeout(this._dataReceivedHandlerId);delete this._dataReceivedHandlerId;}};
t.prototype._onBindingDataReceived=function(i){if(i.getSource()!=this.getBinding("rows")||i.getParameter("__simulateAsyncAnalyticalBinding")){return;}this._iPendingRequests--;this._bPendingRequest=false;this._adjustToTotalRowCount();if(!T.hasPendingRequests(this)){this._dataReceivedHandlerId=setTimeout(function(){if(this.getEnableBusyIndicator()){this.setBusy(false);}this._updateNoData();delete this._dataReceivedHandlerId;}.bind(this),0);}};
t.prototype._setLargeDataScrolling=function(l){this._bLargeDataScrolling=!!l;};
t.prototype._updateTableContent=function(){T.Grouping.updateGroups(this);};
t.prototype.setRowActionTemplate=function(i){this.setAggregation("rowActionTemplate",i);i=this.getRowActionTemplate();if(i){i._setCount(this.getRowActionCount());}this.invalidateRowsAggregation();return this;};
t.prototype.setRowActionCount=function(l){this.setProperty("rowActionCount",l);l=this.getRowActionCount();var x=this.getRowActionTemplate();if(x){x._setCount(l);}for(var i=0;i<this._aRowClones.length;i++){x=this._aRowClones[i].getRowAction();if(x){x._setCount(l);}}return this;};
t.prototype.setRowSettingsTemplate=function(i){this.setAggregation("rowSettingsTemplate",i);this.invalidateRowsAggregation();return this;};
t.prototype.addPlugin=function(i){this.addAggregation("plugins",i);if(T.isA(i,"sap.ui.table.plugins.SelectionPlugin")){this._initSelectionPlugin();}return this;};
t.prototype.insertPlugin=function(i,l){this.insertAggregation("plugins",i,l);if(T.isA(i,"sap.ui.table.plugins.SelectionPlugin")){this._initSelectionPlugin();}return this;};
t.prototype.removePlugin=function(i){var l=this.removeAggregation("plugins",i);if(T.isA(l,"sap.ui.table.plugins.SelectionPlugin")){this._initSelectionPlugin();}return l;};
t.prototype.removeAllPlugins=function(){var i=this.removeAllAggregation("plugins");this._initSelectionPlugin();return i;};
t.prototype.destroyPlugins=function(){this.destroyAggregation('plugins');this._initSelectionPlugin();return this;};
t.prototype.getPlugin=function(l){if(typeof l!=="string"){return null;}var x=this.getPlugins();for(var i=0;i<x.length;i++){if(x[i].isA(l)){return x[i];}}return null;};
t.prototype._getSelectionPlugin=function(){var i=this._oSelectionPlugin||this._oLegacySelectionPlugin;if(!i){this._initLegacySelectionPlugin();i=this._oLegacySelectionPlugin;}if(typeof this._getSelectedIndicesCount==="function"&&i.getSelectedCount!==this._getSelectedIndicesCount){i.getSelectedCount=this._getSelectedIndicesCount;["isIndexSelected","setSelectedIndex","getSelectedIndex","getSelectedIndices","setSelectionInterval","addSelectionInterval","removeSelectionInterval","selectAll","clearSelection"].forEach(function(M){i[M]=this[M];}.bind(this));}return i;};
t.prototype._hasSelectionPlugin=function(){return this._oSelectionPlugin!=null;};
t.prototype._initSelectionPlugin=function(){var i=this.getPlugin("sap.ui.table.plugins.SelectionPlugin");if(i){this._destroyLegacySelectionPlugin();if(i!==this._oSelectionPlugin){w(this,this._oSelectionPlugin);v(this,i);this._oSelectionPlugin=i;}}else{this._initLegacySelectionPlugin();w(this,this._oSelectionPlugin);delete this._oSelectionPlugin;}};
t.prototype._initLegacySelectionPlugin=function(){if(this._oLegacySelectionPlugin||this.getPlugin("sap.ui.table.plugins.SelectionPlugin")){return;}this._oLegacySelectionPlugin=this._createLegacySelectionPlugin();v(this,this._oLegacySelectionPlugin);};
t.prototype._destroyLegacySelectionPlugin=function(){if(this._oLegacySelectionPlugin){this._oLegacySelectionPlugin.destroy();delete this._oLegacySelectionPlugin;}};
t.prototype._createLegacySelectionPlugin=function(){return new o(this);};
function v(i,l){if(l){l.attachSelectionChange(i._onSelectionChanged,i);l._setBinding(i.getBinding("rows"));}}
function w(i,l){if(l){l.detachSelectionChange(i._onSelectionChanged,i);l._setBinding();}}
t.prototype.getCellControl=function(i,l,x){var y=T.getRowColCell(this,i,l,!x);return y.cell;};
t.prototype._fireRowsUpdated=function(i){if(i==null){i=T.RowsUpdateReason.Unknown;}var l={reason:i};this.onRowsUpdated(l);clearTimeout(this._mTimeouts.fireRowsUpdated);this._mTimeouts.fireRowsUpdated=setTimeout(function(){this.fireEvent("_rowsUpdated",l);}.bind(this),0);};
t.prototype.onRowsUpdated=function(i){if(this.getRows().length>0){this._updateTableContent();this._getAccExtension().updateAccForCurrentCell(i.reason);this._resetRowHeights();this._aRowHeights=this._collectRowHeights(false);this._updateRowHeights(this._aRowHeights,false);}this._updateSelection();this._iRenderedFirstVisibleRow=this._getFirstRenderedRowIndex();this._getScrollExtension().updateVerticalScrollbarVisibility();};
t.prototype._enableSynchronization=function(){var i=this;return new Promise(function(l,x){sap.ui.require(["sap/ui/table/TableSyncExtension"],function(y){l(d.enrich(i,y).getInterface());},function(y){x(y);});});};
t.prototype._enableLegacyMultiSelection=function(){if(this._hasSelectionPlugin()){throw new Error("Unsupported operation: sap.ui.table.Table#_enableLegacyMultiSelection must not be called"+" if a selection plugin is applied.");}this._legacyMultiSelection=function(i,l){if(this._hasSelectionPlugin()){throw new Error("Unsupported operation: The legacy multi selection is not supported if a selection plugin is applied");}var x=!!(l.metaKey||l.ctrlKey);if(!this.isIndexSelected(i)){if(x){this.addSelectionInterval(i,i);}else{this.setSelectedIndex(i);}}else if(x||this._getSelectionPlugin().getSelectedCount()===1){this.removeSelectionInterval(i,i);}else{this.setSelectedIndex(i);}}.bind(this);};
return t;});
sap.ui.predefine('sap/ui/table/TableAccExtension',["sap/ui/core/Control","./library","./TableExtension","./TableAccRenderExtension","./TableUtils","sap/ui/Device","sap/ui/thirdparty/jquery"],function(C,l,T,a,b,D,q){"use strict";var S=l.SelectionMode;var c=b.CELLTYPE;var A={getAccInfoOfControl:function(o){if(o&&typeof o.getAccessibilityInfo==="function"){if(typeof o.getVisible==="function"&&!o.getVisible()){return A._normalize({});}var s=o.getAccessibilityInfo();if(s){var t={};A._flatten(s,t);return t;}}return null;},_normalize:function(i){if(!i){return null;}if(i._normalized){return i;}i.role=i.role||"";i.type=i.type||"";i.description=i.description||"";i.enabled=(i.enabled===true||i.enabled===false)?i.enabled:null;i.editable=(i.editable===true||i.editable===false)?i.editable:null;i.children=i.children||[];i._normalized=true;return i;},_flatten:function(s,t,L){L=L?L:0;A._normalize(s);if(L==0){A._normalize(t);t._descriptions=[];}t._descriptions.push(A._getFullDescription(s));s.children.forEach(function(o){if(!o.getAccessibilityInfo||(o.getVisible&&!o.getVisible())){return;}var e=o.getAccessibilityInfo();if(e){A._flatten(e,t,L+1);}});if(L==0){t.description=t._descriptions.join(" ").trim();t._descriptions=undefined;}},_getFullDescription:function(i){var s=i.type+" "+i.description;if(i.enabled===false){s=s+" "+b.getResourceText("TBL_CTRL_STATE_DISABLED");}else if(i.editable===false){s=s+" "+b.getResourceText("TBL_CTRL_STATE_READONLY");}return s.trim();}};var E={getColumnIndexOfFocusedCell:function(e){var t=e.getTable();var i=b.getFocusedItemInfo(t);return i.cellInRow-(b.hasRowHeader(t)?1:0);},getInfoOfFocusedCell:function(e){var t=e.getTable();var i=t._getItemNavigation();var o=t.getDomRef();if(!e.getAccMode()||!o||!i){return null;}var f=i.getFocusedDomRef();if(!f||f!==document.activeElement){return null;}return b.getCellInfo(f);},getRelevantColumnHeaders:function(t,o){if(!t||!o){return[];}var h=b.getHeaderRowCount(t),s=o.getId(),L=[s];if(h>1){for(var i=1;i<h;i++){L.push(s+"_"+i);}var e=b.Column.getParentSpannedColumns(t,s);if(e&&e.length){for(var i=0;i<e.length;i++){var f=e[i].level;var p=e[i].column.getId();L[f]=f===0?p:(p+"_"+f);}}}return L;},isHiddenCell:function($,o){var g=b.Grouping.isInGroupingRow($);var s=b.Grouping.isInSumRow($);var e=!!o&&!!o.hasStyleClass;var i=$.parent().hasClass("sapUiTableRowHidden");var I=$.hasClass("sapUiTableCellHidden");var n=g&&$.hasClass("sapUiTableCellFirst")&&!$.hasClass("sapUiTableMeasureCell");var G=g&&e&&o.hasStyleClass("sapUiAnalyticalTableGroupCellHidden");var f=s&&e&&o.hasStyleClass("sapUiAnalyticalTableSumCellHidden");return i||I||n||G||f;},isTreeColumnCell:function(e,$){return b.Grouping.isTreeMode(e.getTable())&&$.hasClass("sapUiTableCellFirst");},getColumnTooltip:function(o){if(!o){return null;}var t=o.getTooltip_AsString();if(t){return t;}var L=o.getLabel();if(L instanceof C){t=L.getTooltip_AsString();}if(t){return t;}return null;},updateRowColCount:function(e){var t=e.getTable(),i=t._getItemNavigation(),I=false,f=false,g=false;if(i){var h=E.getColumnIndexOfFocusedCell(e)+1;var r=b.getRowIndexOfFocusedCell(t)+t._getFirstRenderedRowIndex()+1;var j=b.getVisibleColumnCount(t)+(b.hasRowActions(t)?1:0);var R=b.isNoDataVisible(t)?0:b.getTotalRowCount(t,true);I=e._iLastRowNumber!=r||(e._iLastRowNumber==r&&e._iLastColumnNumber==h);f=e._iLastColumnNumber!=h;g=!e._iLastRowNumber&&!e._iLastColumnNumber;t.$("rownumberofrows").text(I?b.getResourceText("TBL_ROW_ROWCOUNT",[r,R]):" ");t.$("colnumberofcols").text(f?b.getResourceText("TBL_COL_COLCOUNT",[h,j]):" ");t.$("ariacount").text(g?b.getResourceText("TBL_DATA_ROWS_COLS",[R,j]):" ");e._iLastRowNumber=r;e._iLastColumnNumber=h;}return{rowChange:I,colChange:f,initial:g};},cleanupCellModifications:function(e){if(e._cleanupInfo){e._cleanupInfo.cell.attr(e._cleanupInfo.attr);e._cleanupInfo=null;}},storeDefaultsBeforeCellModifications:function(e,$,f,g){e._cleanupInfo={cell:$,attr:{"aria-labelledby":f&&f.length?f.join(" "):null,"aria-describedby":g&&g.length?g.join(" "):null}};},performCellModifications:function(e,$,f,g,L,h,t,i){E.storeDefaultsBeforeCellModifications(e,$,f,g);var o=E.updateRowColCount(e);var j=e.getTable();j.$("cellacc").text(t||" ");if(i){i(L,h,o.rowChange,o.colChange,o.initial);}var s="";if(o.initial){s=j.getAriaLabelledBy().join(" ")+" "+j.getId()+"-ariadesc "+j.getId()+"-ariacount";if(j.getSelectionMode()!==S.None){s=s+" "+j.getId()+"-ariaselection";}}if(o.initial||o.rowChange){if(b.hasRowNavigatedIndicators(j)){var k=b.getCellInfo($);if(k.type!==b.CELLTYPE.COLUMNHEADER&&k.type!==b.CELLTYPE.COLUMNROWHEADER){var r=j.getRows()[k.rowIndex].getAggregation("_settings");if(r.getNavigated()){s=s+" "+j.getId()+"-rownavigatedtext";}}}}if(L&&L.length){s=s+" "+L.join(" ");}$.attr({"aria-labelledby":s?s:null,"aria-describedby":h&&h.length?h.join(" "):null});},modifyAccOfDATACELL:function(o){var t=this.getTable();var s=t.getId();var i=t._getItemNavigation();var $=o.cell;if(!i){return;}var r=b.getRowIndexOfFocusedCell(t),e=E.getColumnIndexOfFocusedCell(this),f=b.getRowColCell(t,r,e,false),I=null,h=E.isHiddenCell($,f.cell),g=E.isTreeColumnCell(this,$),j=b.Grouping.isInGroupingRow($),k=b.Grouping.isInSumRow($),m=E.getAriaAttributesFor(this,d.ELEMENTTYPES.DATACELL,{index:e,column:f.column,fixed:b.isFixedColumn(t,e)})["aria-labelledby"]||[],n=[],L=[s+"-rownumberofrows",s+"-colnumberofcols"];if(j){L.push(s+"-ariarowgrouplabel");L.push(s+"-rows-row"+r+"-groupHeader");}if(k){var p=$.parent().data("sap-ui-level");if(p==0){L.push(s+"-ariagrandtotallabel");}else if(p>0){L.push(s+"-ariagrouptotallabel");L.push(s+"-rows-row"+r+"-groupHeader");}}if(b.hasRowHighlights(t)&&!j&&!k){L.push(f.row.getId()+"-highlighttext");}L=L.concat(m);if(!h){I=A.getAccInfoOfControl(f.cell);L.push(I?(s+"-cellacc"):f.cell.getId());if(b.getInteractiveElements($)!==null){n.push(s+"-toggleedit");}if(b.Grouping.isTreeMode(t)&&$.parent().attr("aria-selected")==="true"){L.push(s+"-ariarowselected");}}var u=I?I.description:" ";if(g&&!h){var v=E.getAriaAttributesFor(this,d.ELEMENTTYPES.TREEICON,{row:f.row});if(v&&v["aria-label"]){u=v["aria-label"]+" "+u;}}E.performCellModifications(this,$,m,null,L,n,u,function(L,n,R,w,x){var y=$.find(".sapUiTableTreeIcon").not(".sapUiTableTreeIconLeaf").length==1;if((y||b.Grouping.isInGroupingRow($))&&(R||w)){n.push(t.getId()+(!f.row._bIsExpanded?"-rowexpandtext":"-rowcollapsetext"));}else if(!h&&b.isRowSelectionAllowed(t)&&R){n.push(f.row.getId()+"-rowselecttext");}});},modifyAccOfROWHEADER:function(o){var t=this.getTable();var s=t.getId();var $=o.cell;var i=b.Grouping.isInGroupingRow($);var I=b.Grouping.isInSumRow($);var r=t.getRows()[o.rowIndex];var e=E.getAriaAttributesFor(this,d.ELEMENTTYPES.ROWHEADER)["aria-labelledby"]||[];var L=e.concat([s+"-rownumberofrows"]);if(!I&&!i){if(!$.hasClass("sapUiTableRowHidden")){L.push(r.getId()+"-rowselecttext");if(b.hasRowHighlights(t)){L.push(r.getId()+"-highlighttext");}}}if(i){L.push(s+"-ariarowgrouplabel");L.push(s+(r._bIsExpanded?"-rowcollapsetext":"-rowexpandtext"));}if(I){var f=$.parent().data("sap-ui-level");if(f==0){L.push(s+"-ariagrandtotallabel");}else if(f>0){L.push(s+"-ariagrouptotallabel");}}E.performCellModifications(this,$,e,null,L,null,null);},modifyAccOfCOLUMNHEADER:function(o){var t=this.getTable();var $=o.cell;var e=sap.ui.getCore().byId($.attr("data-sap-ui-colid"));var m=E.getAriaAttributesFor(this,d.ELEMENTTYPES.COLUMNHEADER,{headerId:$.attr("id"),column:e,index:$.attr("data-sap-ui-colindex")});var s=E.getColumnTooltip(e);var L=[t.getId()+"-colnumberofcols"].concat(m["aria-labelledby"]);var i=o.columnSpan;if(i>1){L.push(t.getId()+"-ariacolspan");t.$("ariacolspan").text(b.getResourceText("TBL_COL_DESC_SPAN",[""+i]));}if(s){L.push(t.getId()+"-cellacc");}if(D.browser.msie){if(i<=1&&e&&e.getSorted()){L.push(t.getId()+(e.getSortOrder()==="Ascending"?"-ariacolsortedasc":"-ariacolsorteddes"));}}if(i<=1&&e&&e.getFiltered()){L.push(t.getId()+"-ariacolfiltered");}if(D.browser.msie){if(i<=1&&$.attr("aria-haspopup")==="true"){L.push(t.getId()+"-ariacolmenu");}}E.performCellModifications(this,$,m["aria-labelledby"],m["aria-describedby"],L,m["aria-describedby"],s);},modifyAccOfCOLUMNROWHEADER:function(o){var t=this.getTable();var $=o.cell;var e=$.hasClass("sapUiTableSelAllEnabled");t.$("sapUiTableGridCnt").removeAttr("role");var m=E.getAriaAttributesFor(this,d.ELEMENTTYPES.COLUMNROWHEADER,{enabled:e,checked:e&&!t.$().hasClass("sapUiTableSelAll")});E.performCellModifications(this,$,m["aria-labelledby"],m["aria-describedby"],m["aria-labelledby"],m["aria-describedby"],null);},modifyAccOfROWACTION:function(o){var t=this.getTable();var s=t.getId();var $=o.cell;var i=b.Grouping.isInGroupingRow($);var I=b.Grouping.isInSumRow($);var r=o.rowIndex;var R=t.getRows()[o.rowIndex];var h=E.isHiddenCell($);var e=E.getAriaAttributesFor(this,d.ELEMENTTYPES.ROWACTION)["aria-labelledby"]||[];var L=[s+"-rownumberofrows",s+"-colnumberofcols"].concat(e);var f=[];if(i){L.push(s+"-ariarowgrouplabel");L.push(s+"-rows-row"+r+"-groupHeader");L.push(s+(R._bIsExpanded?"-rowcollapsetext":"-rowexpandtext"));}if(I){var g=$.parent().data("sap-ui-level");if(g==0){L.push(s+"-ariagrandtotallabel");}else if(g>0){L.push(s+"-ariagrouptotallabel");L.push(s+"-rows-row"+r+"-groupHeader");}}if(!I&&!i&&$.attr("aria-selected")==="true"){L.push(s+"-ariarowselected");}if(b.hasRowHighlights(t)&&!i&&!I){L.push(R.getId()+"-highlighttext");}var j="";if(!h){var k=R.getRowAction();if(k){var m=k.getAccessibilityInfo();if(m){L.push(s+"-cellacc");j=m.description;if(b.getInteractiveElements($)!==null){f.push(s+"-toggleedit");}}}}E.performCellModifications(this,$,e,[],L,f,j);},getAriaAttributesFor:function(e,t,p){var m={},o=e.getTable(),s=o.getId();function f(o,z,O,B){var M="";if(O&&B){M="overlay,nodata";}else if(O&&!B){M="overlay";}else if(!O&&B){M="nodata";}var F=false;if(O&&o.getShowOverlay()||B&&b.isNoDataVisible(o)){F=true;}if(F){m["aria-hidden"]="true";}if(M){m["data-sap-ui-table-acc-covered"]=M;}}switch(t){case d.ELEMENTTYPES.COLUMNROWHEADER:m["aria-labelledby"]=[s+"-ariacolrowheaderlabel"];var r=o._getSelectionPlugin().getRenderConfig();if(r.headerSelector.visible){m["role"]=["button"];}if(p&&p.enabled){m["aria-pressed"]=p.checked?"true":"false";}else{m["aria-disabled"]="true";m["aria-pressed"]="false";}if(!o._getShowStandardTooltips()&&r.headerSelector.type==="toggle"){m["aria-labelledby"].push(s+"-ariaselectall");}break;case d.ELEMENTTYPES.ROWHEADER:m["role"]="rowheader";if(D.browser.msie){m["aria-labelledby"]=[s+"-ariarowheaderlabel"];}if(o.getSelectionMode()!==S.None&&p&&p.rowSelected){m["aria-selected"]="true";}if(b.isRowSelectorSelectionAllowed(o)&&(!p||!p.rowHidden)){var g=!!(p&&p.rowSelected);var h=e.getAriaTextsForSelectionMode(true);m["title"]=h.mouse[g?"rowDeselect":"rowSelect"];}break;case d.ELEMENTTYPES.ROWACTION:m["role"]="gridcell";m["aria-labelledby"]=[s+"-rowacthdr"];if(o.getSelectionMode()!==S.None&&p&&p.rowSelected){m["aria-selected"]="true";}break;case d.ELEMENTTYPES.COLUMNHEADER:var j=p&&p.column;var H=p&&p.colspan;m["role"]="columnheader";var L=[];if(p&&p.headerId){var k=E.getRelevantColumnHeaders(o,j);var I=k.indexOf(p.headerId);L=I>0?k.slice(0,I+1):[p.headerId];}for(var i=0;i<L.length;i++){L[i]=L[i]+"-inner";}m["aria-labelledby"]=L;if(p&&(p.index<o.getComputedFixedColumnCount())){m["aria-labelledby"].push(s+"-ariafixedcolumn");}if(!H&&j&&j.getSorted()){m["aria-sort"]=j.getSortOrder()==="Ascending"?"ascending":"descending";}if(!H&&j&&j._menuHasItems()){m["aria-haspopup"]="true";}break;case d.ELEMENTTYPES.DATACELL:m["role"]="gridcell";var L=[],j=p&&p.column?p.column:null;if(j){L=E.getRelevantColumnHeaders(o,j);m["headers"]=L.join(" ");for(var i=0;i<L.length;i++){L[i]=L[i]+"-inner";}if(p&&p.fixed){L.push(s+"-ariafixedcolumn");}}m["aria-labelledby"]=L;if(o.getSelectionMode()!==S.None&&p&&p.rowSelected){m["aria-selected"]="true";}else{m["aria-selected"]="false";}break;case d.ELEMENTTYPES.ROOT:break;case d.ELEMENTTYPES.TABLE:m["role"]="presentation";f(o,m,true,true);break;case d.ELEMENTTYPES.CONTENT:m["role"]=b.Grouping.isGroupMode(o)||b.Grouping.isTreeMode(o)?"treegrid":"grid";if(o.getSelectionMode()===S.MultiToggle){m["aria-multiselectable"]="true";}var R=o._getRowCounts();var n=b.hasFixedColumns(o);var u=R.fixedTop>0;var v=R.fixedBottom>0;var w=b.hasRowHeader(o);var x=b.hasRowActions(o);m["aria-owns"]=[s+"-table"];if(n){m["aria-owns"].push(s+"-table-fixed");}if(u){m["aria-owns"].push(s+"-table-fixrow");if(n){m["aria-owns"].push(s+"-table-fixed-fixrow");}}if(v){m["aria-owns"].push(s+"-table-fixrow-bottom");if(n){m["aria-owns"].push(s+"-table-fixed-fixrow-bottom");}}if(w){m["aria-owns"].push(s+"-sapUiTableRowHdrScr");}if(x){m["aria-owns"].push(s+"-sapUiTableRowActionScr");}break;case d.ELEMENTTYPES.TABLEHEADER:m["role"]="heading";f(o,m,true,false);break;case d.ELEMENTTYPES.COLUMNHEADER_TBL:m["role"]="presentation";break;case d.ELEMENTTYPES.COLUMNHEADER_ROW:m["role"]="row";f(o,m,true,false);break;case d.ELEMENTTYPES.CREATIONROW_TBL:m["role"]="presentation";break;case d.ELEMENTTYPES.CREATIONROW:m["role"]="form";m["aria-labelledby"]=p.creationRow.getId()+"-label";f(o,m,true,false);break;case d.ELEMENTTYPES.ROWHEADER_COL:f(o,m,true,true);break;case d.ELEMENTTYPES.TH:var n=o.getComputedFixedColumnCount()>0;if(!n){m["role"]="presentation";}m["scope"]="col";if(n){if(p&&p.column){m["aria-owns"]=p.column.getId();m["aria-labelledby"]=[p.column.getId()];}}else{m["aria-hidden"]="true";}break;case d.ELEMENTTYPES.TR:m["role"]="row";var g=false;if(p&&typeof p.index==="number"&&o.getSelectionMode()!==S.None&&o._getSelectionPlugin().isIndexSelected(p.index)){m["aria-selected"]="true";g=true;}else{m["aria-selected"]="false";}if(b.isRowSelectionAllowed(o)&&(!p||!p.rowHidden)){var h=e.getAriaTextsForSelectionMode(true);m["title"]=h.mouse[g?"rowDeselect":"rowSelect"];}break;case d.ELEMENTTYPES.TREEICON:if(b.Grouping.isTreeMode(o)){m={"aria-label":"","title":"","role":""};if(o.getBinding("rows")){if(p&&p.row){if(p.row._bHasChildren){var y=b.getResourceText(p.row._bIsExpanded?"TBL_COLLAPSE":"TBL_EXPAND");if(o._getShowStandardTooltips()){m["title"]=y;}else{m["aria-label"]=y;}m["aria-expanded"]=""+(!!p.row._bIsExpanded);m["aria-hidden"]="false";m["role"]="button";}else{m["aria-label"]=b.getResourceText("TBL_LEAF");m["aria-hidden"]="true";}}}}break;case d.ELEMENTTYPES.NODATA:m["role"]="gridcell";var N=o.getNoData();m["aria-labelledby"]=[N instanceof C?N.getId():(s+"-noDataMsg")];f(o,m,true,false);break;case d.ELEMENTTYPES.OVERLAY:m["role"]="region";m["aria-labelledby"]=[].concat(o.getAriaLabelledBy());if(o.getTitle()){m["aria-labelledby"].push(o.getTitle().getId());}m["aria-labelledby"].push(s+"-ariainvalid");break;case d.ELEMENTTYPES.TABLEFOOTER:case d.ELEMENTTYPES.TABLESUBHEADER:f(o,m,true,false);break;case d.ELEMENTTYPES.ROWACTIONHEADER:m["aria-hidden"]="true";break;case"PRESENTATION":m["role"]="presentation";break;}return m;}};
var d=T.extend("sap.ui.table.TableAccExtension",{
_init:function(t,s,m){this._accMode=sap.ui.getCore().getConfiguration().getAccessibility();this._busyCells=[];b.addDelegate(t,this);T.enrich(t,a);return"AccExtension";},
_debug:function(){this._ExtensionHelper=E;this._ACCInfoHelper=A;},
destroy:function(){this.getTable().removeEventDelegate(this);this._busyCells=[];T.prototype.destroy.apply(this,arguments);},
getAriaAttributesFor:function(t,p){return E.getAriaAttributesFor(this,t,p);},
onfocusin:function(e){var t=this.getTable();if(!t||b.getCellInfo(e.target).cell==null){return;}if(t._mTimeouts._cleanupACCExtension){clearTimeout(t._mTimeouts._cleanupACCExtension);t._mTimeouts._cleanupACCExtension=null;}this.updateAccForCurrentCell("Focus");},
onfocusout:function(e){var t=this.getTable();if(!t){return;}t.$("sapUiTableGridCnt").attr("role",E.getAriaAttributesFor(this,"CONTENT",{}).role);t._mTimeouts._cleanupACCExtension=setTimeout(function(){var t=this.getTable();if(!t){return;}this._iLastRowNumber=null;this._iLastColumnNumber=null;E.cleanupCellModifications(this);t._mTimeouts._cleanupACCExtension=null;}.bind(this),100);}
});
d.ELEMENTTYPES={DATACELL:"DATACELL",COLUMNHEADER:"COLUMNHEADER",ROWHEADER:"ROWHEADER",ROWACTION:"ROWACTION",COLUMNROWHEADER:"COLUMNROWHEADER",ROOT:"ROOT",CONTENT:"CONTENT",TABLE:"TABLE",TABLEHEADER:"TABLEHEADER",TABLEFOOTER:"TABLEFOOTER",TABLESUBHEADER:"TABLESUBHEADER",COLUMNHEADER_TBL:"COLUMNHEADER_TABLE",COLUMNHEADER_ROW:"COLUMNHEADER_ROW",CREATIONROW_TBL:"CREATIONROW_TABLE",CREATIONROW:"CREATIONROW",ROWHEADER_COL:"ROWHEADER_COL",TH:"TH",TR:"TR",TREEICON:"TREEICON",ROWACTIONHEADER:"ROWACTIONHEADER",NODATA:"NODATA",OVERLAY:"OVERLAY"};
d.prototype.getAccMode=function(){return this._accMode;};
d.prototype.updateAccForCurrentCell=function(r){if(!this._accMode||!this.getTable()._getItemNavigation()){return;}if(r==="Focus"||r===b.RowsUpdateReason.Expand||r===b.RowsUpdateReason.Collapse){E.cleanupCellModifications(this);}var t=this.getTable();var I=E.getInfoOfFocusedCell(this);var s;if(!I||!I.isOfType(c.ANY)){return;}if(I.isOfType(c.DATACELL)){s=d.ELEMENTTYPES.DATACELL;}else if(I.isOfType(c.COLUMNHEADER)){s=d.ELEMENTTYPES.COLUMNHEADER;}else if(I.isOfType(c.ROWHEADER)){s=d.ELEMENTTYPES.ROWHEADER;}else if(I.isOfType(c.ROWACTION)){s=d.ELEMENTTYPES.ROWACTION;}else if(I.isOfType(c.COLUMNROWHEADER)){s=d.ELEMENTTYPES.COLUMNROWHEADER;}if(!E["modifyAccOf"+s]){return;}if(r!=="Focus"&&r!==b.RowsUpdateReason.Expand&&r!==b.RowsUpdateReason.Collapse){if(I.isOfType(c.DATACELL|c.ROWHEADER)){if(D.browser.msie){if(t._mTimeouts._cleanupACCCellBusy){clearTimeout(t._mTimeouts._cleanupACCCellBusy);t._mTimeouts._cleanupACCCellBusy=null;}t._mTimeouts._cleanupACCCellBusy=setTimeout(function(){for(var i=0;i<this._busyCells.length;i++){this._busyCells[i].removeAttr("aria-hidden");this._busyCells[i].removeAttr("aria-busy");}t._mTimeouts._cleanupACCCellBusy=null;this._busyCells=[];}.bind(this),100);I.cell.attr("aria-busy","true");this._busyCells.push(I.cell);}else{I.cell.attr("role","status");I.cell.attr("role","gridcell");}}else{return;}}E["modifyAccOf"+s].apply(this,[I]);};
d.prototype.updateAriaStateOfColumn=function(o){if(!this._accMode){return;}var m=E.getAriaAttributesFor(this,d.ELEMENTTYPES.COLUMNHEADER,{headerId:o.getId(),column:o,index:this.getTable().indexOfColumn(o)});var h=E.getRelevantColumnHeaders(this.getTable(),o);for(var i=0;i<h.length;i++){var H=q(document.getElementById(h[i]));if(!H.attr("colspan")){H.attr({"aria-sort":m["aria-sort"]||null});}}};
d.prototype.updateAriaStateOfRow=function(r,R,i){if(!this._accMode){return;}if(!R){R=r.getDomRefs(true);}if(R.row){R.row.add(R.row.children(".sapUiTableCell")).attr("aria-selected",i?"true":"false");if(i&&R.rowSelectorText){var t=R.rowSelectorText.text();if(t){t=b.getResourceText("TBL_ROW_DESC_SELECTED")+" "+t;}R.rowSelectorText.text(t);}}};
d.prototype.updateAriaExpandAndLevelState=function(r,s,R,f,$,g,e,L,t){if(!this._accMode){return;}var h=null,o=this.getTable(),j=[R,f,s,$],k=!!t,B=o.getBinding("rows");if(!g&&R&&!k){var I=R.attr("data-sap-ui-rowindex");var m=E.getAriaAttributesFor(this,d.ELEMENTTYPES.ROWHEADER,{rowSelected:!r._bHidden&&o._getSelectionPlugin().isIndexSelected(I)});h=m["title"]||null;}if(R&&!k){R.attr({"aria-haspopup":g?"true":null,"title":h});}if(B&&B.hasTotaledMeasures&&L>0&&(!B.bProvideGrandTotals||!B.hasTotaledMeasures())){L=L-1;}for(var i=0;i<j.length;i++){if(j[i]){j[i].attr({"aria-expanded":g?e+"":null,"aria-level":L<0?null:(L+1)});}}if(k){t.attr(E.getAriaAttributesFor(this,d.ELEMENTTYPES.TREEICON,{row:r}));}};
d.prototype.updateAriaStateOfRowHighlight=function(r){if(!this._accMode||!r){return;}var R=r._getRow();var h=R?R.getDomRef("highlighttext"):null;if(h){h.innerText=r._getHighlightText();}};
d.prototype.updateAriaStateForOverlayAndNoData=function(){var t=this.getTable();if(!t||!t.getDomRef()||!this._accMode){return;}if(t.getShowOverlay()){t.$().find("[data-sap-ui-table-acc-covered*='overlay']").attr("aria-hidden","true");}else{t.$().find("[data-sap-ui-table-acc-covered*='overlay']").removeAttr("aria-hidden");if(b.isNoDataVisible(t)){t.$().find("[data-sap-ui-table-acc-covered*='nodata']").attr("aria-hidden","true");}else{t.$().find("[data-sap-ui-table-acc-covered*='nodata']").removeAttr("aria-hidden");}}};
d.prototype.getAriaTextsForSelectionMode=function(e,s){var t=this.getTable();if(!s){s=t.getSelectionMode();}var f=t._getShowStandardTooltips();var m={mouse:{rowSelect:"",rowDeselect:""},keyboard:{rowSelect:"",rowDeselect:""}};var i=t._getSelectionPlugin().getSelectedCount();if(s===S.Single){m.mouse.rowSelect=f?b.getResourceText("TBL_ROW_SELECT"):"";m.mouse.rowDeselect=f?b.getResourceText("TBL_ROW_DESELECT"):"";m.keyboard.rowSelect=b.getResourceText("TBL_ROW_SELECT_KEY");m.keyboard.rowDeselect=b.getResourceText("TBL_ROW_DESELECT_KEY");}else if(s===S.MultiToggle){m.mouse.rowSelect=f?b.getResourceText("TBL_ROW_SELECT_MULTI_TOGGLE"):"";m.mouse.rowDeselect=f?b.getResourceText("TBL_ROW_DESELECT"):"";m.keyboard.rowSelect=b.getResourceText("TBL_ROW_SELECT_KEY");m.keyboard.rowDeselect=b.getResourceText("TBL_ROW_DESELECT_KEY");if(e===true&&i===0){m.mouse.rowSelect=f?b.getResourceText("TBL_ROW_SELECT"):"";}}return m;};
d.prototype.setSelectAllState=function(s){var t=this.getTable();if(this._accMode&&t){t.$("selall").attr("aria-pressed",s?"true":"false");}};
d.prototype.addColumnHeaderLabel=function(o,e){var t=this.getTable();if(!this._accMode||!e.getAriaLabelledBy||!t){return;}var L=t.getColumnHeaderVisible()?o.getId():null;if(!L){var f=o.getAggregation("label");if(f){L=f.getId();}}var g=e.getAriaLabelledBy();if(L&&g.indexOf(L)<0){e.addAriaLabelledBy(L);}};
return d;});
sap.ui.predefine('sap/ui/table/TableAccRenderExtension',["./TableExtension","./TableUtils","./library"],function(T,a,l){"use strict";var S=l.SelectionMode;var _=function(r,p,i,t,c){c=c||[];c.push("sapUiInvisibleText");r.openStart("span",p+"-"+i);c.forEach(function(C){r.class(C);});r.attr("aria-hidden","true");r.openEnd();if(t){r.text(t);}r.close("span");};
var A=T.extend("sap.ui.table.TableAccRenderExtension",{
_init:function(t,s,m){return"AccRenderExtension";},
writeHiddenAccTexts:function(r,t){if(!t._getAccExtension().getAccMode()){return;}var s=t.getId();r.openStart("div");r.class("sapUiTableHiddenTexts");r.style("display","none");r.attr("aria-hidden","true");r.openEnd();var d=t.getTitle()&&t.getTitle().getText&&t.getTitle().getText()!=""?t.getTitle().getText():"";_(r,s,"ariadesc",d);_(r,s,"ariacount");_(r,s,"toggleedit",a.getResourceText("TBL_TOGGLE_EDIT_KEY"));var b=a.areAllRowsSelected(t);var R=t._getSelectionPlugin().getRenderConfig();var c;if(R.headerSelector.type==="toggle"){c=b?"TBL_DESELECT_ALL":"TBL_SELECT_ALL";}else if(R.headerSelector.type==="clear"){c="TBL_DESELECT_ALL";}_(r,s,"ariaselectall",a.getResourceText(c));_(r,s,"ariarowheaderlabel",a.getResourceText("TBL_ROW_HEADER_LABEL"));_(r,s,"ariarowgrouplabel",a.getResourceText("TBL_ROW_GROUP_LABEL"));_(r,s,"ariagrandtotallabel",a.getResourceText("TBL_GRAND_TOTAL_ROW"));_(r,s,"ariagrouptotallabel",a.getResourceText("TBL_GROUP_TOTAL_ROW"));_(r,s,"ariacolrowheaderlabel",a.getResourceText("TBL_ROW_COL_HEADER_LABEL"));_(r,s,"rownumberofrows");_(r,s,"colnumberofcols");_(r,s,"cellacc");_(r,s,"ariarowselected",a.getResourceText("TBL_ROW_DESC_SELECTED"));_(r,s,"ariacolmenu",a.getResourceText("TBL_COL_DESC_MENU"));_(r,s,"ariacolspan");_(r,s,"ariacolfiltered",a.getResourceText("TBL_COL_DESC_FILTERED"));_(r,s,"ariacolsortedasc",a.getResourceText("TBL_COL_DESC_SORTED_ASC"));_(r,s,"ariacolsorteddes",a.getResourceText("TBL_COL_DESC_SORTED_DES"));_(r,s,"ariainvalid",a.getResourceText("TBL_TABLE_INVALID"));_(r,s,"ariashowcolmenu",a.getResourceText("TBL_COL_VISBILITY_MENUITEM_SHOW"));_(r,s,"ariahidecolmenu",a.getResourceText("TBL_COL_VISBILITY_MENUITEM_HIDE"));_(r,s,"rowexpandtext",a.getResourceText("TBL_ROW_EXPAND_KEY"));_(r,s,"rowcollapsetext",a.getResourceText("TBL_ROW_COLLAPSE_KEY"));var o=t.getSelectionMode();if(o!==S.None){_(r,s,"ariaselection",a.getResourceText(o==S.MultiToggle?"TBL_TABLE_SELECTION_MULTI":"TBL_TABLE_SELECTION_SINGLE"));}if(t.getComputedFixedColumnCount()>0){_(r,s,"ariafixedcolumn",a.getResourceText("TBL_FIXED_COLUMN"));}if(a.hasRowNavigatedIndicators(t)){_(r,s,"rownavigatedtext",a.getResourceText("TBL_ROW_STATE_NAVIGATED"));}r.close("div");},
writeAriaAttributesFor:function(r,t,s,p){var e=t._getAccExtension();if(!e.getAccMode()){return;}var m=e.getAriaAttributesFor(s,p);var v,k;for(k in m){v=m[k];if(Array.isArray(v)){v=v.join(" ");}if(v){r.attr(k.toLowerCase(),v);}}},
writeAccRowSelectorText:function(r,t,R,i){if(!t._getAccExtension().getAccMode()){return;}var I=t._getSelectionPlugin().isIndexSelected(i);var m=t._getAccExtension().getAriaTextsForSelectionMode(true);var s=m.keyboard[I?"rowDeselect":"rowSelect"];_(r,R.getId(),"rowselecttext",R._bHidden?"":s,["sapUiTableAriaRowSel"]);},
writeAccRowHighlightText:function(r,t,R,i){if(!t._getAccExtension().getAccMode()){return;}var o=R.getAggregation("_settings");var h=o._getHighlightText();_(r,R.getId(),"highlighttext",h);},
writeAccCreationRowText:function(r,t,c){if(!t._getAccExtension().getAccMode()){return;}_(r,c.getId(),"label",a.getResourceText("TBL_CREATEROW_LABEL"));}
});
return A;});
sap.ui.predefine('sap/ui/table/TableBindingUtils',[],function(){"use strict";return{TableUtils:null,metadataLoaded:function(t){var b=t.getBinding("rows");var m=b?b.getModel():null;var r=null;var R=null;var p=new Promise(function(a,c){r=a;R=c;});if(!m){R();return p;}if(m.metadataLoaded){m.metadataLoaded().then(function(){r();});}else if(m.attachMetadataLoaded){if(m.oMetadata&&m.oMetadata.isLoaded()){r();}else{m.attachMetadataLoaded(function(){r();});}}return p;}};},true);
sap.ui.predefine('sap/ui/table/TableColumnUtils',["sap/ui/Device","./library","sap/base/Log"],function(D,l,L){"use strict";var T={TableUtils:null,initColumnUtils:function(t){if(!t._oColumnInfo){T.updateColumnInfo(t,T.collectColumnInfo(t));}},invalidateColumnUtils:function(t){t._oColumnInfo=null;},updateColumnInfo:function(t,c){t._oColumnInfo=c;},collectColumnInfo:function(t){return{columnCount:t.getColumns().length,visibleColumnCount:T.TableUtils.getVisibleColumnCount(t),columnMap:T.getColumnMap(t)};},getColumnMap:function(t){var i;var c;var C={};var o={};var a=t.getColumns();var m=T.TableUtils.getHeaderRowCount(t);var p={};for(var b=0;b<a.length;b++){c=a[b];C={};C.id=c.getId();C.column=c;C.levelInfo=[];C.parents=[];for(var d=0;d<m;d++){C.levelInfo[d]={};C.levelInfo[d].spannedColumns=[];var h=T.getHeaderSpan(c,d);for(i=1;i<h;i++){var s=a[b+i];if(s){var P=s.getId();C.levelInfo[d].spannedColumns.push(a[b+i]);if(!p[P]){p[P]=[];}p[P].push({column:c,level:d});}}}o[C.id]=C;}var e=Object.keys(p);for(i=0;i<e.length;i++){var f=e[i];o[f].parents=p[f];}return o;},getColumnMapItem:function(t,c){T.initColumnUtils(t);var s=t._oColumnInfo.columnMap[c];if(!s){L.error("Column with ID '"+c+"' not found",t);}else{return s;}},getParentSpannedColumns:function(t,c,a){var C=T.getColumnMapItem(t,c);if(!C){return undefined;}var p=[];for(var i=0;i<C.parents.length;i++){var P=C.parents[i];if(a===undefined||P.level===a){p.push(P);}}return p;},getChildrenSpannedColumns:function(t,c,a){var C=T.getColumnMapItem(t,c);if(!C){return undefined;}var b=[];var e;if(a===undefined){e=C.levelInfo.length;}else{e=a+1;}for(var i=a||0;i<e;i++){var o=C.levelInfo[i];for(var j=0;j<o.spannedColumns.length;j++){b.push({column:o.spannedColumns[j],level:i});}}return b;},getHeaderSpan:function(c,i){var h=c.getHeaderSpan();var H;if(!h){return 1;}if(!Array.isArray(h)){h=(h+"").split(",");}function g(s){var r=parseInt(s);return isNaN(r)?1:r;}if(isNaN(i)){H=Math.max.apply(null,h.map(g));}else{H=g(h[i]);}return Math.max(H,1);},getMaxHeaderSpan:function(c){return T.getHeaderSpan(c);},hasHeaderSpan:function(c){return T.getHeaderSpan(c)>1;},getColumnBoundaries:function(t,c){var C=T.getColumnMapItem(t,c);if(!C){return undefined;}var m={};if(c){m[c]=C.column;}var f=function(m,n){var o;var i;var g=[];n=n||[];for(i=0;i<n.length;i++){o=m[n[i]];g=g.concat(T.getParentSpannedColumns(t,o.getId()));g=g.concat(T.getChildrenSpannedColumns(t,o.getId()));}n=[];for(i=0;i<g.length;i++){o=g[i].column;var c=o.getId();if(!m[c]){n.push(c);m[c]=o;}}if(n.length>0){return f(m,n);}else{return m;}};m=f(m,[c]);var a=t.indexOfColumn(C.column);var b={startColumn:C.column,startIndex:a,endColumn:C.column,endIndex:-1};var d=t.getColumns();var k=Object.getOwnPropertyNames(m);for(var i=0;i<k.length;i++){var o=m[k[i]];a=t.indexOfColumn(o);var h=T.getMaxHeaderSpan(o);if(a<b.startIndex){b.startIndex=a;b.startColumn=o;}var e=a+h-1;if(e>b.endIndex){b.endIndex=e;b.endColumn=d[e];}}return b;},isColumnMovable:function(c){var t=c.getParent();if(!t||!t.getEnableColumnReordering()){return false;}var C=t.indexOfColumn(c);if(C<t.getComputedFixedColumnCount()||C<t._iFirstReorderableIndex){return false;}if(T.hasHeaderSpan(c)||T.getParentSpannedColumns(t,c.getId()).length!=0){return false;}return true;},normalizeColumnMoveTargetIndex:function(c,n){var t=c.getParent(),C=t.indexOfColumn(c),a=t.getColumns();if(n>C){n--;}if(n<0){n=0;}else if(n>a.length){n=a.length;}return n;},isColumnMovableTo:function(c,n){var t=c.getParent();if(!t||n===undefined||!T.isColumnMovable(c)){return false;}n=T.normalizeColumnMoveTargetIndex(c,n);if(n<t.getComputedFixedColumnCount()||n<t._iFirstReorderableIndex){return false;}var C=t.indexOfColumn(c),a=t.getColumns();if(n>C){var b=a[n>=a.length?a.length-1:n];var o=T.getColumnBoundaries(t,b.getId());if(T.hasHeaderSpan(b)||o.endIndex>n){return false;}}else{var A=a[n];if(T.getParentSpannedColumns(t,A.getId()).length!=0){return false;}}return true;},moveColumnTo:function(c,n){if(!T.isColumnMovableTo(c,n)){return false;}var t=c.getParent(),C=t.indexOfColumn(c);if(n===C){return false;}n=T.normalizeColumnMoveTargetIndex(c,n);var e=t.fireColumnMove({column:c,newPos:n});if(!e){return false;}t._bReorderInProcess=true;t.removeColumn(c,true);t.insertColumn(c,n);t._bReorderInProcess=false;return true;},getMinColumnWidth:function(){if(this._iColMinWidth){return this._iColMinWidth;}this._iColMinWidth=48;if(!D.system.desktop){this._iColMinWidth=88;}return this._iColMinWidth;},resizeColumn:function(t,c,w,f,C){if(!t||c==null||c<0||w==null||w<=0){return false;}if(C==null||C<=0){C=1;}if(f==null){f=true;}var a=t.getColumns();if(c>=a.length||!a[c].getVisible()){return false;}var v=[];for(var i=c;i<a.length;i++){var o=a[i];if(o.getVisible()){v.push(o);if(v.length===C){break;}}}var r=[];for(var i=0;i<v.length;i++){var V=v[i];if(V.getResizable()){r.push(V);}}if(r.length===0){return false;}var s=0;for(var i=0;i<v.length;i++){var V=v[i];s+=T.getColumnWidth(t,V.getIndex());}var p=w-s;var S=Math.round(p/r.length);var R=false;var b=t.getDomRef();if(!T.TableUtils.isFixedColumn(t,c)){t._getVisibleColumns().forEach(function(k){var m=k.getWidth(),q;if(b&&r.indexOf(k)<0&&T.TableUtils.isVariableWidth(m)){q=b.querySelector("th[data-sap-ui-colid=\""+k.getId()+"\"]");if(q){k._minWidth=Math.max(q.offsetWidth,T.getMinColumnWidth());}}});}for(var i=0;i<r.length;i++){var d=r[i];var e=T.getColumnWidth(t,d.getIndex());var n=e+S;var g=T.getMinColumnWidth();if(n<g){n=g;}var W=n-e;if(Math.abs(W)<Math.abs(S)){var h=r.length-(i+1);p-=W;S=Math.round(p/h);}if(W!==0){var E=true;var j=n+"px";if(f){E=t.fireColumnResize({column:d,width:j});}if(E){d.setWidth(j);R=true;}}}return R;},getColumnWidth:function(t,c){if(!t||c==null||c<0){return null;}var C=t.getColumns();if(c>=C.length){return null;}var o=C[c];var s=o.getWidth();if(s===""||s==="auto"||s.match(/%$/)){if(o.getVisible()){var a=o.getDomRef();return a?a.offsetWidth:0;}else{return 0;}}else{return T.TableUtils.convertCSSSizeToPixel(s);}},getFixedColumnCount:function(t,c){var f=t.getComputedFixedColumnCount();if(!c){return f;}if(f<=0||t._bIgnoreFixedColumnCount){return 0;}var C=t.getColumns();var v=0;f=Math.min(f,C.length);for(var i=0;i<f;i++){if(C[i].shouldRender()){v++;}}return v;}};return T;},true);
sap.ui.predefine('sap/ui/table/TableDragAndDropExtension',["./TableExtension","sap/ui/table/TableUtils","sap/ui/core/library"],function(T,a,C){"use strict";var S="sap.ui.table";var D=C.dnd.DropPosition;var E={getSessionData:function(d,k){return d.getComplexData(S+(k==null?"":"-"+k));},setSessionData:function(d,s,k){d.setComplexData(S+(k==null?"":"-"+k),s);},getInstanceSessionData:function(d,t){return this.getSessionData(d,t.getId());},setInstanceSessionData:function(d,t,s){this.setSessionData(d,s,t.getId());}};var b={ondragstart:function(e){var d=e.dragSession;if(!d||!d.getDragControl()){return;}var o=d.getDragControl();var s={};if(o.isA("sap.ui.table.Row")){var f=this.getContextByIndex(o.getIndex());var g=o.getDomRef();if(!f||g.classList.contains("sapUiTableGroupHeader")||g.classList.contains("sapUiAnalyticalTableSum")){e.preventDefault();return;}else{s.draggedRowContext=f;}}E.setInstanceSessionData(d,this,s);},ondragenter:function(e){var d=e.dragSession;if(!d||!d.getDropControl()){return;}var s=E.getInstanceSessionData(d,this);var o=d.getDragControl();var f=d.getDropControl();if(!s){s={};}if(f.isA("sap.ui.table.Row")){var g=s.draggedRowContext;var h=this.getContextByIndex(f.getIndex());var i=f.getDomRef();var j=d.getDropInfo().getDropPosition();if((!h&&j===D.On&&a.hasData(this))||(g&&g===h)||i.classList.contains("sapUiTableGroupHeader")||i.classList.contains("sapUiAnalyticalTableSum")){e.setMarked("NonDroppable");}else{if(!h){var l=this.getRows()[a.getNonEmptyVisibleRowCount(this)-1];d.setDropControl(l||this);}if(d.getDropControl()!==this){var v=this.getDomRef().classList.contains("sapUiTableVScr");var t=this.getDomRef("sapUiTableCnt").getBoundingClientRect();d.setIndicatorConfig({width:t.width-(v?16:0),left:t.left+(this._bRtlMode&&v?16:0)});}}}else if(f.isA("sap.ui.table.Column")){var t=this.getDomRef("sapUiTableCnt").getBoundingClientRect();d.setIndicatorConfig({height:t.height-(this._getScrollExtension().isHorizontalScrollbarVisible()?16:0)});}else if(o===f){e.setMarked("NonDroppable");}if(!s.verticalScrollEdge){var p=window.pageYOffset;var V=this.getDomRef("table").getBoundingClientRect();s.verticalScrollEdge={bottom:V.bottom+p,top:V.top+p};}var P=window.pageXOffset;var H=this.getDomRef("sapUiTableCtrlScr").getBoundingClientRect();s.horizontalScrollEdge={left:H.left+P,right:H.right+P};E.setInstanceSessionData(d,this,s);},ondragover:function(e){var d=e.dragSession;if(!d){return;}var s=E.getInstanceSessionData(d,this);if(!s){return;}var i=32;var t=50;var o=d.getDropControl();var f=this._getScrollExtension();var v=f.getVerticalScrollbar();var h=f.getHorizontalScrollbar();var V=s.verticalScrollEdge;var H=s.horizontalScrollEdge;if(V&&v&&o!==this){var p=e.pageY;if(p>=V.top-t&&p<=V.top+t){v.scrollTop-=i;}else if(p<=V.bottom+t&&p>=V.bottom-t){v.scrollTop+=i;}}if(H&&h&&o!==this){var P=e.pageX;if(P>=H.left-t&&P<=H.left+t){h.scrollLeft-=i;}else if(P<=H.right+t&&P>=H.right-t){h.scrollLeft+=i;}}},onlongdragover:function(e){var d=e.dragSession;if(!d){return;}var $=a.getCell(this,e.target);var r=a.getCellInfo($).rowIndex;var R=r==null?null:this.getRows()[r];var o=d.getDropControl();if(R&&(o==R||!o)){a.Grouping.toggleGroupHeader(this,R.getIndex(),true);}}};
var c=T.extend("sap.ui.table.TableDragAndDropExtension",{
_init:function(t,s,m){this._oDelegate=b;a.addDelegate(t,this._oDelegate,t);return"DragAndDropExtension";},
_debug:function(){this._ExtensionDelegate=b;},
destroy:function(){var t=this.getTable();if(t){t.removeEventDelegate(this._oDelegate);}this._oDelegate=null;T.prototype.destroy.apply(this,arguments);}
});
return c;});
sap.ui.predefine('sap/ui/table/TableExtension',["sap/ui/base/Object","./TableUtils"],function(B,T){"use strict";
var a=B.extend("sap.ui.table.TableExtension",{
_table:null,
_type:null,
_settings:null,
constructor:function(t,s){B.call(this);this._table=t;this._settings=s||{};this._type=a.TABLETYPES.STANDARD;if(t.isA("sap.ui.table.TreeTable")){this._type=a.TABLETYPES.TREE;}else if(t.isA("sap.ui.table.AnalyticalTable")){this._type=a.TABLETYPES.ANALYTICAL;}var e=this._init(this._table,this._type,this._settings);if(e){var b=this;t["_get"+e]=function(){return b;};}},
destroy:function(){this._table=null;this._type=null;this.bIsDestroyed=true;B.prototype.destroy.apply(this,arguments);},
getInterface:function(){return this;}
});
a.TABLETYPES={TREE:"TREE",ANALYTICAL:"ANALYTICAL",STANDARD:"STANDARD"};
a.prototype.getTable=function(){return this._table;};
a.prototype._init=function(t,s,S){return null;};
a.prototype._attachEvents=function(){};
a.prototype._detachEvents=function(){};
a.attachEvents=function(t){if(!t._aExtensions){return;}for(var i=0;i<t._aExtensions.length;i++){t._aExtensions[i]._attachEvents();}};
a.detachEvents=function(t){if(!t._aExtensions){return;}for(var i=0;i<t._aExtensions.length;i++){t._aExtensions[i]._detachEvents();}};
a.enrich=function(t,E,s){if(!E||!(E.prototype instanceof a)){return null;}var e=new E(t,s);if(!t._aExtensions){t._aExtensions=[];}t._aExtensions.push(e);return e;};
a.cleanup=function(t){if(!t._bExtensionsInitialized||!t._aExtensions){return;}for(var i=0;i<t._aExtensions.length;i++){t._aExtensions[i].destroy();}delete t._aExtensions;delete t._bExtensionsInitialized;};
a.isEnrichedWith=function(t,e){if(!t||!t._aExtensions){return false;}for(var i=0;i<t._aExtensions.length;i++){if(t._aExtensions[i].getMetadata().getName()===e){return true;}}return false;};
return a;});
sap.ui.predefine('sap/ui/table/TableGrouping',["sap/ui/core/Element","sap/ui/model/Sorter","sap/ui/Device","./library","sap/ui/thirdparty/jquery"],function(E,S,D,l,q){"use strict";var T={TableUtils:null,clearMode:function(t){t._mode=null;},setGroupMode:function(t){t._mode="Group";},isGroupMode:function(t){return t._mode==="Group";},setTreeMode:function(t){t._mode="Tree";},isTreeMode:function(t){return t._mode=="Tree";},getModeCssClass:function(t){switch(t._mode){case"Group":return"sapUiTableGroupMode";case"Tree":return"sapUiTableTreeMode";default:return null;}},showGroupMenuButton:function(t){return!D.system.desktop&&T.TableUtils.isA(t,"sap.ui.table.AnalyticalTable");},toggleGroupHeader:function(t,r,e){var I=[];var b=t?t.getBinding("rows"):null;if(!t||!b||!b.expand||r==null){return null;}if(typeof r==="number"){I=[r];}else if(Array.isArray(r)){if(e==null&&r.length>1){return null;}I=r;}var a=t._getTotalRowCount();var v=I.filter(function(c){var d=b.isExpanded(c);var f=true;if(b.nodeHasChildren){if(b.getNodeByIndex){f=!b.nodeHasChildren(b.getNodeByIndex(c));}else{f=false;}}return c>=0&&c<a&&!f&&e!==d;}).sort();if(v.length===0){return null;}for(var i=v.length-1;i>0;i--){if(e){b.expand(v[i],true);}else{b.collapse(v[i],true);}}if(e===true){b.expand(v[0],false);}else if(e===false){b.collapse(v[0],false);}else{b.toggleIndex(v[0]);}return b.isExpanded(v[0]);},toggleGroupHeaderByRef:function(t,r,e){var R=q(r);var g;if(R.hasClass("sapUiTableTreeIcon")||(T.isTreeMode(t)&&R.hasClass("sapUiTableCellFirst"))){g=R.closest("tr",t.getDomRef());}else{g=R.closest(".sapUiTableGroupHeader",t.getDomRef());}var b=t.getBinding("rows");if(g.length>0&&b){var G=+g.attr("data-sap-ui-rowindex");var o=t.getRows()[G];if(o){var a=o.getIndex();var i=T.toggleGroupHeader(t,a,e);var c=i===true||i===false;if(c&&t._onGroupHeaderChanged){t._onGroupHeaderChanged(a,i);}return c;}}return false;},isInGroupingRow:function(c){var i=T.TableUtils.getCellInfo(c);if(i.isOfType(T.TableUtils.CELLTYPE.ANYCONTENTCELL)){return i.cell.parent().hasClass("sapUiTableGroupHeader");}return false;},isGroupingRow:function(r){if(!r){return false;}return q(r).hasClass("sapUiTableGroupHeader");},isInSumRow:function(c){var i=T.TableUtils.getCellInfo(c);if(i.isOfType(T.TableUtils.CELLTYPE.ANYCONTENTCELL)){return i.cell.parent().hasClass("sapUiAnalyticalTableSum");}return false;},calcGroupIndent:function(t,L,c,s){var I=0;var i;if(t.isA("sap.ui.table.TreeTable")){for(i=0;i<L;i++){I=I+(i<2?12:8);}}else if(t.isA("sap.ui.table.AnalyticalTable")){L=L-1;L=!c&&!s?L-1:L;L=Math.max(L,0);for(i=0;i<L;i++){if(I==0){I=12;}I=I+(i<2?12:8);}}else{L=!c?L-1:L;L=Math.max(L,0);for(i=0;i<L;i++){I=I+(i<2?12:8);}}return I;},setIndent:function(t,r,R,i){var b=t._bRtlMode,f=r.find("td.sapUiTableCellFirst > .sapUiTableCellInner"),s=R.find(".sapUiTableGroupShield");if(i<=0){R.css(b?"right":"left","");s.css("width","").css(b?"margin-right":"margin-left","");f.css(b?"padding-right":"padding-left","");}else{R.css(b?"right":"left",i+"px");s.css("width",i+"px").css(b?"margin-right":"margin-left",((-1)*i)+"px");f.css(b?"padding-right":"padding-left",(i+8)+"px");}},updateTableRowForGrouping:function(t,r,c,e,h,s,L,g){var d=r.getDomRefs(true),R=d.row,$=d.rowScrollPart,f=d.rowFixedPart,a=d.rowHeaderPart,b=d.rowActionPart;R.attr({"data-sap-ui-level":L});R.data("sap-ui-level",L);if(T.isGroupMode(t)){R.toggleClass("sapUiAnalyticalTableSum",!c&&s).toggleClass("sapUiTableGroupHeader",c).toggleClass("sapUiTableRowHidden",c&&h||r._bHidden);q(document.getElementById(r.getId()+"-groupHeader")).toggleClass("sapUiTableGroupIconOpen",c&&e).toggleClass("sapUiTableGroupIconClosed",c&&!e).attr("title",t._getShowStandardTooltips()&&g?g:null).text(g||"");var i=T.calcGroupIndent(t,L,c,s);T.setIndent(t,R,a,i);R.toggleClass("sapUiTableRowIndented",i>0);}var j=null;if(T.isTreeMode(t)){j=R.find(".sapUiTableTreeIcon");j.css(t._bRtlMode?"margin-right":"margin-left",(L*17)+"px").toggleClass("sapUiTableTreeIconLeaf",!c).toggleClass("sapUiTableTreeIconNodeOpen",c&&e).toggleClass("sapUiTableTreeIconNodeClosed",c&&!e);}if(T.showGroupMenuButton(t)){var k=0;var m=t.$();if(m.hasClass("sapUiTableVScr")){k+=m.find(".sapUiTableVSb").width();}var G=a.find(".sapUiTableGroupMenuButton");if(t._bRtlMode){G.css("right",(m.width()-G.width()+a.position().left-k-5)+"px");}else{G.css("left",(m.width()-G.width()-a.position().left-k-5)+"px");}}t._getAccExtension().updateAriaExpandAndLevelState(r,$,a,f,b,c,e,L,j);},cleanupTableRowForGrouping:function(t,r){var d=r.getDomRefs(true);d.row.removeAttr("data-sap-ui-level");d.row.removeData("sap-ui-level");if(T.isGroupMode(t)){d.row.removeClass("sapUiTableGroupHeader sapUiAnalyticalTableSum");T.setIndent(t,d.row,d.rowSelector,0);}var $=null;if(T.isTreeMode(t)){$=d.row.find(".sapUiTableTreeIcon");$.removeClass("sapUiTableTreeIconLeaf").removeClass("sapUiTableTreeIconNodeOpen").removeClass("sapUiTableTreeIconNodeClosed").css(this._bRtlMode?"margin-right":"margin-left","");}t._getAccExtension().updateAriaExpandAndLevelState(r,d.rowScrollPart,d.rowSelector,d.rowFixedPart,d.rowAction,false,false,-1,$);},updateGroups:function(t){if(T.isGroupMode(t)||T.isTreeMode(t)){var b=t.getBinding("rows");var r=t.getBindingInfo("rows");var R=t.getRows();var c=R.length;var i;if(b){for(i=0;i<c;i++){var o=T.getRowGroupInfo(t,R[i],b,r);T.updateTableRowForGrouping(t,R[i],o.isHeader,o.expanded,o.hidden,false,o.level,o.title);}}else{for(i=0;i<c;i++){T.cleanupTableRowForGrouping(t,R[i]);}}}},getRowGroupInfo:function(t,r,R,o){var a={isHeader:false,expanded:false,hidden:false,title:"",level:0};if(t.getGroupHeaderProperty){a.isHeader=r._bHasChildren;a.expanded=r._bIsExpanded;a.hidden=a.isHeader;a.level=r._iLevel;var h=t.getGroupHeaderProperty();if(T.isGroupMode(t)&&h){var m=o&&o.model;a.title=t.getModel(m).getProperty(h,r.getBindingContext(m));}}else{var i=r.getIndex();a.isHeader=!!R.isGroupHeader(i);a.level=a.isHeader?0:1;if(a.isHeader){a.expanded=!!R.isExpanded(i);a.hidden=true;a.title=R.getTitle(i);}}return a;},setupExperimentalGrouping:function(t){if(!t.getEnableGrouping()){return;}var b=E.prototype.getBinding.call(t,"rows");var g=sap.ui.getCore().byId(t.getGroupBy());var I=g&&g.getGrouped()&&T.TableUtils.isA(b,"sap.ui.model.ClientListBinding");if(!I||b._modified){return;}b._modified=true;T.setGroupMode(t);var p=g.getSortProperty();b.sort(new S(p));var L=t._getTotalRowCount(),c=b.getContexts(0,L);var k;var C=0;for(var i=L-1;i>=0;i--){var n=c[i].getProperty(p);if(!k){k=n;}if(k!==n){var G=c[i+1].getModel().getContext("/sap.ui.table.GroupInfo"+i);G.__groupInfo={oContext:c[i+1],name:k,count:C,groupHeader:true,expanded:true};c.splice(i+1,0,G);k=n;C=0;}C++;}var G=c[0].getModel().getContext("/sap.ui.table.GroupInfo");G.__groupInfo={oContext:c[0],name:k,count:C,groupHeader:true,expanded:true};c.splice(0,0,G);q.extend(b,{getLength:function(){return c.length;},getContexts:function(s,L){return c.slice(s,s+L);},isGroupHeader:function(a){var o=c[a];return(o&&o.__groupInfo&&o.__groupInfo.groupHeader)===true;},getTitle:function(a){var o=c[a];return o&&o.__groupInfo&&o.__groupInfo.name+" - "+o.__groupInfo.count;},isExpanded:function(a){var o=c[a];return this.isGroupHeader(a)&&o.__groupInfo&&o.__groupInfo.expanded;},expand:function(a){if(this.isGroupHeader(a)&&!c[a].__groupInfo.expanded){for(var i=0;i<c[a].__childs.length;i++){c.splice(a+1+i,0,c[a].__childs[i]);}delete c[a].__childs;c[a].__groupInfo.expanded=true;this._fireChange();}},collapse:function(a){if(this.isGroupHeader(a)&&c[a].__groupInfo.expanded){c[a].__childs=c.splice(a+1,c[a].__groupInfo.count);c[a].__groupInfo.expanded=false;this._fireChange();}},toggleIndex:function(a){if(this.isExpanded(a)){this.collapse(a);}else{this.expand(a);}},nodeHasChildren:function(o){if(!o||!o.__groupInfo){return false;}else{return o.__groupInfo.groupHeader===true;}},getNodeByIndex:function(a){return c[a];}});t._mTimeouts.groupingFireBindingChange=t._mTimeouts.groupingFireBindingChange||window.setTimeout(function(){b._fireChange();},0);},resetExperimentalGrouping:function(t){var b=t.getBinding("rows");if(b&&b._modified){T.clearMode(t);var B=t.getBindingInfo("rows");t.unbindRows();t.bindRows(B);}}};return T;},true);
sap.ui.predefine('sap/ui/table/TableKeyboardDelegate2',["sap/ui/base/Object","sap/ui/Device","./library","./TableUtils","sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery"],function(B,D,l,T,K,q){"use strict";var C=T.CELLTYPE;var S=l.SelectionMode;var M={CTRL:1,SHIFT:2,ALT:4};var N={LEFT:"Left",RIGHT:"Right",UP:"Up",DOWN:"Down"};var H=5;var a="1rem";
function p(E,P){E.setMarked("sapUiTableSkipItemNavigation",P!==false);}
var b=B.extend("sap.ui.table.TableKeyboardDelegate2",{
constructor:function(t){B.call(this);},
destroy:function(){B.prototype.destroy.apply(this,arguments);},
getInterface:function(){return this;}
});
b._restoreFocusOnLastFocusedDataCell=function(t,E){var o=T.getFocusedItemInfo(t);var L=t._getKeyboardExtension()._getLastFocusedCellInfo();T.focusItem(t,o.cellInRow+(o.columnCount*L.row),E);};
b._setFocusOnColumnHeaderOfLastFocusedDataCell=function(t,E){var o=T.getFocusedItemInfo(t);T.focusItem(t,o.cellInRow,E);};
b._forwardFocusToTabDummy=function(t,g){t._getKeyboardExtension()._setSilentFocus(t.$().find("."+g));};
b._isKeyCombination=function(E,k,m){if(m==null){m=0;}var g=typeof k==="string"?String.fromCharCode(E.charCode):E.keyCode;var h=0;h|=(D.os.macintosh?E.metaKey:E.ctrlKey)&&k!==K.CONTROL?M.CTRL:0;h|=E.shiftKey&&k!==K.SHIFT?M.SHIFT:0;h|=E.altKey&&k!==K.ALT?M.ALT:0;var v=k==null||g===k;var V=m===h;return v&&V;};
b._handleSpaceAndEnter=function(t,E){var o=T.getCellInfo(E.target);if(o.isOfType(C.COLUMNROWHEADER)){t._getSelectionPlugin().onHeaderSelectorPress();}else if(b._isElementGroupToggler(t,E.target)){T.Grouping.toggleGroupHeaderByRef(t,E.target);}else if(o.isOfType(C.ROWHEADER)){h();}else if(o.isOfType(C.DATACELL|C.ROWACTION)){var g=!t.hasListeners("cellClick");if(!t._findAndfireCellEvent(t.fireCellClick,E)){if(T.isRowSelectionAllowed(t)){h();g=false;}}if(g){var i=T.getInteractiveElements(E.target);if(i){t._getKeyboardExtension().setActionMode(true);}}}function h(){var _=null;if(t._legacyMultiSelection){_=function(r){t._legacyMultiSelection(r,E);return true;};}T.toggleRowSelection(t,E.target,null,_);}};
b._moveColumn=function(o,n){var t=o.getParent();var v=t._getVisibleColumns();var i=v.indexOf(o);var g;if(n&&i<v.length-1){g=t.indexOfColumn(v[i+1])+1;}else if(!n&&i>0){g=t.indexOfColumn(v[i-1]);}if(g!=null){T.Column.moveColumnTo(o,g);}};
b._getVisibleAndGroupedColumns=function(t){return t.getColumns().filter(function(o){return o.getVisible()||o.getGrouped();});};
b._getColumnIndexInVisibleAndGroupedColumns=function(t,o){var v=b._getVisibleAndGroupedColumns(t);for(var i=0;i<v.length;i++){var V=v[i];if(V===o){return i;}}return-1;};
b._focusElement=function(t,E,g){if(!t||!E){return;}if(g==null){g=false;}T.deselectElementText(document.activeElement);if(g){t._getKeyboardExtension()._setSilentFocus(E);}else{E.focus();}T.selectElementText(E);};
b._focusCell=function(t,i,r,g,F,A){if(!t||i==null||r==null||r<0||r>=t.getRows().length){return;}var R=t.getRows()[r];var o;if(i===C.ROWHEADER){t._getKeyboardExtension()._setFocus(t.getDomRef("rowsel"+r));return;}else if(i===C.ROWACTION){o=t.getDomRef("rowact"+r);}else if(i===C.DATACELL&&(g!=null&&g>=0)){var h=t.getColumns()[g];var j=b._getColumnIndexInVisibleAndGroupedColumns(t,h);if(j>=0){o=R.getDomRef("col"+j);}}if(!o){return;}if(F){var I=T.getInteractiveElements(o);if(I){b._focusElement(t,I[0]);return;}}if(A){t._getKeyboardExtension()._bStayInActionMode=true;}o.focus();};
b._navigate=function(t,E,g){if(E.isMarked()){return;}var k=t._getKeyboardExtension();var A=k.isInActionMode();var o=T.getCellInfo(T.getCell(t,E.target));var h=false;if((g===N.UP||g===N.DOWN)&&o.isOfType(C.ANYCONTENTCELL)){var i=b._isKeyCombination(E,null,M.CTRL);var j=i||A;var P=T.getParentCell(t,E.target);var m=A&&o.isOfType(C.DATACELL);if(!i&&(E.target instanceof window.HTMLInputElement||E.target instanceof window.HTMLTextAreaElement)){return;}if(!j&&P){P.focus();return;}p(E);if(g===N.UP){if(T.isFirstScrollableRow(t,o.cell)){h=t._getScrollExtension().scrollVertically(false,false,true,m,function(){if(m){document.activeElement.blur();}});}}else if(T.isLastScrollableRow(t,o.cell)){h=t._getScrollExtension().scrollVertically(true,false,true,m,function(){if(m){document.activeElement.blur();}});}if(h){E.preventDefault();if(j){t.attachEventOnce("_rowsUpdated",function(){b._focusCell(t,o.type,o.rowIndex,o.columnIndex,true);});}}else if(g===N.UP&&o.rowIndex===0){p(E,o.isOfType(C.ROWACTION)||j);if(!A&&P){P.focus();}else{k.setActionMode(false);}}else if(g===N.DOWN&&o.rowIndex===t._getRowCounts().count-1){if(!A&&P){P.focus();}else{var n=t.getCreationRow();if(!n||!n._takeOverKeyboardHandling(E)){k.setActionMode(false);}}}else{var r=g===N.DOWN?1:-1;b._focusCell(t,o.type,o.rowIndex+r,o.columnIndex,j);E.preventDefault();}}else if(g===N.DOWN&&o.isOfType(C.ANYCOLUMNHEADER)){var u=T.getHeaderRowCount(t);if(T.isNoDataVisible(t)){var F=T.getFocusedItemInfo(t);if(F.row-u<=1){p(E);}}else if(o.isOfType(C.COLUMNROWHEADER)&&u>1){p(E);T.focusItem(t,u*(T.getVisibleColumnCount(t)+1),E);}}else if(g===N.LEFT&&!A){var I=sap.ui.getCore().getConfiguration().getRTL();if(o.isOfType(C.COLUMNHEADER)&&I){var v=T.getFocusedItemInfo(t);var w=v.cellInRow-(T.hasRowHeader(t)?1:0);var x=T.getVisibleColumnCount(t);if(T.hasRowActions(t)&&w===x-1){p(E);}}}};
b._isElementGroupToggler=function(t,E){return T.Grouping.isInGroupingRow(E)||(T.Grouping.isTreeMode(t)&&E.classList.contains("sapUiTableCellFirst")&&(E.querySelector(".sapUiTableTreeIconNodeOpen")||E.querySelector(".sapUiTableTreeIconNodeClosed")))||E.classList.contains("sapUiTableTreeIconNodeOpen")||E.classList.contains("sapUiTableTreeIconNodeClosed");};
b._isElementInteractive=function(E){if(!E){return false;}return q(E).is(T.INTERACTIVE_ELEMENT_SELECTORS);};
b._getFirstInteractiveElement=function(r){if(!r){return null;}var t=r.getParent();var g=r.getCells();var $;var I;if(T.hasRowActions(t)){g.push(r.getRowAction());}for(var i=0;i<g.length;i++){$=T.getParentCell(t,g[i].getDomRef());I=T.getInteractiveElements($);if(I){return I.first();}}return null;};
b._getLastInteractiveElement=function(r){if(!r){return null;}var t=r.getParent();var g=r.getCells();var $;var I;if(T.hasRowActions(t)){g.push(r.getRowAction());}for(var i=g.length-1;i>=0;i--){$=T.getParentCell(t,g[i].getDomRef());I=T.getInteractiveElements($);if(I){return I.last();}}return null;};
b._getPreviousInteractiveElement=function(t,E){if(!t||!E){return null;}var $=q(E);if(!this._isElementInteractive($)){return null;}var g=T.getParentCell(t,E);var I;var o;var h;var j;var k;var m;var n;I=T.getInteractiveElements(g);if(I[0]!==$[0]){return I.eq(I.index(E)-1);}o=T.getCellInfo(g);j=t.getRows()[o.rowIndex].getCells();if(o.isOfType(C.ROWACTION)){n=j.length-1;}else{k=t.getColumns()[o.columnIndex];m=b._getColumnIndexInVisibleAndGroupedColumns(t,k);n=m-1;}for(var i=n;i>=0;i--){h=j[i].getDomRef();g=T.getParentCell(t,h);I=T.getInteractiveElements(g);if(I){return I.last();}}return null;};
b._getNextInteractiveElement=function(t,E){if(!t||!E){return null;}var $=q(E);if(!this._isElementInteractive($)){return null;}var g=T.getParentCell(t,E);var I;var o;var h;var j;var k;var r;var m;I=T.getInteractiveElements(g);if(I.get(-1)!==$[0]){return I.eq(I.index(E)+1);}o=T.getCellInfo(g);if(o.isOfType(C.ROWACTION)){return null;}r=t.getRows()[o.rowIndex];j=r.getCells();k=t.getColumns()[o.columnIndex];m=b._getColumnIndexInVisibleAndGroupedColumns(t,k);for(var i=m+1;i<j.length;i++){h=j[i].getDomRef();g=T.getParentCell(t,h);I=T.getInteractiveElements(g);if(I){return I.first();}}if(T.hasRowActions(t)){g=T.getParentCell(t,r.getRowAction().getDomRef());I=T.getInteractiveElements(g);if(I.get(-1)!==$[0]){return I.eq(I.index(E)+1);}}return null;};
function s(t){var F=T.getRowIndexOfFocusedCell(t);var i=t.getRows()[F].getIndex();var o=t._getSelectionPlugin();t._oRangeSelection={startIndex:i,selected:o.isIndexSelected(i)};}
b.prototype.enterActionMode=function(){var k=this._getKeyboardExtension();var A=document.activeElement;var i=T.getInteractiveElements(A);var $=T.getParentCell(this,A);var o=T.getCellInfo($);if(o.isOfType(C.ANYCOLUMNHEADER)){return false;}if(i){k._suspendItemNavigation();A.tabIndex=-1;b._focusElement(this,i[0],true);return true;}else if($){this._getKeyboardExtension()._suspendItemNavigation();return true;}return false;};
b.prototype.leaveActionMode=function(A){A=A==null?true:A;var k=this._getKeyboardExtension();var o=document.activeElement;var $=T.getParentCell(this,o);k._resumeItemNavigation();if(A){if($){b._focusElement(this,$[0],true);}else{var i=this._getItemNavigation();if(i){var I=i.aItemDomRefs;var F=I.indexOf(o);if(F>-1){i.setFocusedIndex(F);}}k._setSilentFocus(o);}}};
b.prototype.onfocusin=function(E){if(E.isMarked("sapUiTableIgnoreFocusIn")){return;}var t=q(E.target);if(t.hasClass("sapUiTableOuterBefore")||t.hasClass("sapUiTableOuterAfter")||(E.target!=this.getDomRef("overlay")&&this.getShowOverlay())){this.$("overlay").focus();}else if(t.hasClass("sapUiTableCtrlBefore")){var n=T.isNoDataVisible(this);if(!n||n&&this.getColumnHeaderVisible()){b._setFocusOnColumnHeaderOfLastFocusedDataCell(this,E);}else{this._getKeyboardExtension()._setSilentFocus(this.$("noDataCnt"));}}else if(t.hasClass("sapUiTableCtrlAfter")){if(!T.isNoDataVisible(this)){b._restoreFocusOnLastFocusedDataCell(this,E);}}var o=T.getCellInfo(E.target);var i=o.isOfType(C.ROWHEADER)&&T.Grouping.isInGroupingRow(E.target);var I=o.isOfType(C.ROWHEADER)&&!i&&T.isRowSelectorSelectionAllowed(this);var g=o.isOfType(C.DATACELL)&&this._getKeyboardExtension()._bStayInActionMode;var P=T.getCellInfo(T.getParentCell(this,E.target)).isOfType(C.ANYCONTENTCELL);var h=b._isElementInteractive(E.target);var j=this._getKeyboardExtension().isInActionMode();var k=(j&&(i||I||g)||(h&&P));if(g){this._getKeyboardExtension()._bStayInActionMode=false;}this._getKeyboardExtension().setActionMode(k,false);};
b.prototype.onkeydown=function(E){var k=this._getKeyboardExtension();var o=T.getCellInfo(E.target);var g=this.getSelectionMode();var h=this._getSelectionPlugin();if(D.browser.msie&&b._isKeyCombination(E,K.V,M.CTRL)){this.onpaste(E);return;}if(b._isKeyCombination(E,K.F2)){var i=k.isInActionMode();var $=T.getCell(this,E.target);var I=T.getParentCell(this,E.target)!=null;o=T.getCellInfo($);if(!i&&I){$.focus();}else if(o.isOfType(C.ANYCOLUMNHEADER)){var j=T.getInteractiveElements($);if(j){j[0].focus();}}else{k.setActionMode(!i);}return;}else if(b._isKeyCombination(E,K.F4)&&b._isElementGroupToggler(this,E.target)){T.Grouping.toggleGroupHeaderByRef(this,E.target);return;}if(this._getKeyboardExtension().isInActionMode()||!o.isOfType(C.ANY)){return;}if(b._isKeyCombination(E,K.SPACE)){E.preventDefault();}if(b._isKeyCombination(E,K.SHIFT)&&g===S.MultiToggle&&(o.isOfType(C.ROWHEADER)&&T.isRowSelectorSelectionAllowed(this)||(o.isOfType(C.DATACELL|C.ROWACTION)))){s(this);}else if(b._isKeyCombination(E,K.A,M.CTRL)){E.preventDefault();if(o.isOfType(C.ANYCONTENTCELL|C.COLUMNROWHEADER)&&g===S.MultiToggle){h.onKeyboardShortcut("toggle");}}else if(b._isKeyCombination(E,K.A,M.CTRL+M.SHIFT)){if(o.isOfType(C.ANYCONTENTCELL|C.COLUMNROWHEADER)){h.onKeyboardShortcut("clear");}}else if(b._isKeyCombination(E,K.F4)){if(o.isOfType(C.DATACELL)){k.setActionMode(true);}}};
b.prototype.onkeypress=function(E){var k=this._getKeyboardExtension();var o=T.getCellInfo(E.target);if(b._isKeyCombination(E,"+")){if(b._isElementGroupToggler(this,E.target)){T.Grouping.toggleGroupHeaderByRef(this,E.target,true);}else if(o.isOfType(C.DATACELL|C.ROWACTION)){k.setActionMode(true);}}else if(b._isKeyCombination(E,"-")){if(b._isElementGroupToggler(this,E.target)){T.Grouping.toggleGroupHeaderByRef(this,E.target,false);}else if(o.isOfType(C.DATACELL|C.ROWACTION)){k.setActionMode(true);}}};
b.prototype.oncontextmenu=function(E){if(E.isMarked("handledByPointerExtension")){return;}var o=T.getCellInfo(document.activeElement);if(o.isOfType(C.ANY)){E.preventDefault();T.Menu.openContextMenu(this,E.target,true,null,E);}};
b.prototype.onkeyup=function(E){var o=T.getCellInfo(E.target);if(b._isKeyCombination(E,K.SHIFT)){delete this._oRangeSelection;}if(o.isOfType(C.COLUMNHEADER)){if(b._isKeyCombination(E,K.SPACE)||b._isKeyCombination(E,K.ENTER)){T.Menu.openContextMenu(this,E.target,true);}}else if(b._isKeyCombination(E,K.SPACE)){b._handleSpaceAndEnter(this,E);}else if(b._isKeyCombination(E,K.SPACE,M.SHIFT)){T.toggleRowSelection(this,this.getRows()[o.rowIndex].getIndex());s(this);}else if(this._legacyMultiSelection&&!o.isOfType(C.COLUMNROWHEADER)&&(b._isKeyCombination(E,K.SPACE,M.CTRL)||b._isKeyCombination(E,K.ENTER,M.CTRL))){b._handleSpaceAndEnter(this,E);}};
b.prototype.onsaptabnext=function(E){var k=this._getKeyboardExtension();var o=T.getCellInfo(E.target);var $;if(k.isInActionMode()){var I;$=T.getCell(this,E.target);o=T.getCellInfo($);if(!o.isOfType(C.ANYCONTENTCELL)){return;}var r=this.getRows()[o.rowIndex];var L=b._getLastInteractiveElement(r);var g=L===null||L[0]===E.target;if(g){var A=r.getIndex();var h=T.isLastScrollableRow(this,$);var j=this._getTotalRowCount()-1===A;var t=T.isRowSelectorSelectionAllowed(this);E.preventDefault();if(j){k.setActionMode(false);}else if(h){c(this,o,t,o.rowIndex,r);}else{var R=o.rowIndex;if(t){b._focusCell(this,C.ROWHEADER,R+1);}else{var v=this._getRowCounts().count;var m=false;for(var i=o.rowIndex+1;i<v;i++){R=i;r=this.getRows()[R];I=b._getFirstInteractiveElement(r);m=T.Grouping.isGroupingRow(r.getDomRef());if(I||m){break;}}if(I){b._focusElement(this,I[0]);}else if(m){b._focusCell(this,C.ROWHEADER,R);}else{c(this,o,t,R,r);}}}}else if(o.isOfType(C.ROWHEADER)){E.preventDefault();I=b._getFirstInteractiveElement(r);b._focusElement(this,I[0]);}else{E.preventDefault();I=b._getNextInteractiveElement(this,E.target);b._focusElement(this,I[0]);}}else if(o.isOfType(C.ANYCOLUMNHEADER)){if(T.isNoDataVisible(this)){this.$("noDataCnt").focus();}else{b._restoreFocusOnLastFocusedDataCell(this,E);}E.preventDefault();}else if(o.isOfType(C.ANYCONTENTCELL)){b._forwardFocusToTabDummy(this,"sapUiTableCtrlAfter");}else if(E.target===this.getDomRef("overlay")){k._setSilentFocus(this.$().find(".sapUiTableOuterAfter"));}else if(!o.isOfType(C.ANY)){$=T.getParentCell(this,E.target);if($){E.preventDefault();$.focus();}}};
function c(t,o,g,r,R){var A=o.isOfType(C.DATACELL);var k=t._getKeyboardExtension();var h=t._getScrollExtension().scrollVertically(true,false,true,A,function(){if(A){document.activeElement.blur();}});if(h){t.attachEventOnce("_rowsUpdated",function(){var I=T.Grouping.isGroupingRow(R.getDomRef());d(t,R,r,g,I);});}else if(R.getIndex()!==t._getTotalRowCount()-1){var n=o.rowIndex+1;var i=t.getRows()[n];var j=T.Grouping.isGroupingRow(i.getDomRef());d(t,i,n,g,j);}else{k.setActionMode(false);}}
function d(t,r,R,g,i){var k=t._getKeyboardExtension();if(g||i){b._focusCell(t,C.ROWHEADER,R);}else{var I=b._getFirstInteractiveElement(r);if(I){b._focusElement(t,I[0]);}else{b._focusCell(t,C.DATACELL,R,0,false,true);if(r.getIndex()===t._getTotalRowCount()-1){k.setActionMode(false);}}}}
b.prototype.onsaptabprevious=function(E){var k=this._getKeyboardExtension();var o=T.getCellInfo(E.target);var $;if(k.isInActionMode()){var I;$=T.getCell(this,E.target);o=T.getCellInfo($);if(!o.isOfType(C.ANYCONTENTCELL)){return;}var r=this.getRows()[o.rowIndex];var A=r.getIndex();var F=b._getFirstInteractiveElement(r);var g=F!==null&&F[0]===E.target;var t=T.isRowSelectorSelectionAllowed(this);var R=T.Grouping.isGroupingRow(r);var h=t||R;if(g&&h){E.preventDefault();b._focusCell(this,C.ROWHEADER,o.rowIndex);}else if((g&&!h)||o.isOfType(C.ROWHEADER)||F===null){var j=T.isFirstScrollableRow(this,$);var m=A===0;E.preventDefault();if(m){k.setActionMode(false);}else if(j){e(this,o,h,o.rowIndex,r);}else{var n=o.rowIndex;var R=false;for(var i=o.rowIndex-1;i>=0;i--){n=i;r=this.getRows()[n];I=b._getLastInteractiveElement(r);R=T.Grouping.isGroupingRow(r.getDomRef());if(I||h||R){break;}}if(I){b._focusElement(this,I[0]);}else if(R||h){b._focusCell(this,C.ROWHEADER,n);}else{e(this,o,h,n,r);}}}else{E.preventDefault();I=b._getPreviousInteractiveElement(this,E.target);b._focusElement(this,I[0]);}}else if(o.isOfType(C.ANYCONTENTCELL)||E.target===this.getDomRef("noDataCnt")){if(this.getColumnHeaderVisible()&&!o.isOfType(C.ROWACTION)){b._setFocusOnColumnHeaderOfLastFocusedDataCell(this,E);E.preventDefault();}else{b._forwardFocusToTabDummy(this,"sapUiTableCtrlBefore");}}else if(E.target===this.getDomRef("overlay")){this._getKeyboardExtension()._setSilentFocus(this.$().find(".sapUiTableOuterBefore"));}else if(!o.isOfType(C.ANY)){$=T.getParentCell(this,E.target);if($){E.preventDefault();$.focus();}}};
function e(t,o,r,R,g){var A=o.isOfType(C.DATACELL);var k=t._getKeyboardExtension();var h=t._getScrollExtension().scrollVertically(false,false,true,A,function(){if(A){document.activeElement.blur();}});if(h){t.attachEventOnce("_rowsUpdated",function(){var I=T.Grouping.isGroupingRow(g.getDomRef());f(t,g,R,r,I);});}else if(g.getIndex()!==0){var P=o.rowIndex-1;var i=t.getRows()[P];var j=T.Grouping.isGroupingRow(i.getDomRef());f(t,i,P,r,j);}else{k.setActionMode(false);}}
function f(t,r,R,g,i){var k=t._getKeyboardExtension();var I=b._getLastInteractiveElement(r);if(I){b._focusElement(t,I[0]);}else if(g||i){b._focusCell(t,C.ROWHEADER,R);}else{b._focusCell(t,C.DATACELL,R,0,false,true);if(r.getIndex()===0){k.setActionMode(false);}}}
b.prototype.onsapdown=function(E){b._navigate(this,E,N.DOWN);};
b.prototype.onsapdownmodifiers=function(E){if(b._isKeyCombination(E,null,M.CTRL)){b._navigate(this,E,N.DOWN);return;}var k=this._getKeyboardExtension();if(b._isKeyCombination(E,null,M.ALT)&&b._isElementGroupToggler(this,E.target)){p(E);T.Grouping.toggleGroupHeaderByRef(this,E.target,true);return;}if(k.isInActionMode()){return;}var o=T.getCellInfo(E.target);if(b._isKeyCombination(E,null,M.SHIFT)){E.preventDefault();if(o.isOfType(C.ANYCONTENTCELL)){if(!this._oRangeSelection){p(E);return;}var F=T.getRowIndexOfFocusedCell(this);var i=this.getRows()[F].getIndex();if(i===this._getTotalRowCount()-1){return;}if(T.isLastScrollableRow(this,E.target)){var g=this._getScrollExtension().scrollVertically(true,false,true);if(g){p(E);}}if(this._oRangeSelection.startIndex<=i){i++;if(this._oRangeSelection.selected){T.toggleRowSelection(this,i,true);}else{T.toggleRowSelection(this,i,false);}}else{T.toggleRowSelection(this,i,false);}}else{p(E);}}if(b._isKeyCombination(E,null,M.ALT)){if(o.isOfType(C.DATACELL)){k.setActionMode(true);}p(E);}};
b.prototype.onsapup=function(E){b._navigate(this,E,N.UP);};
b.prototype.onsapupmodifiers=function(E){var k=this._getKeyboardExtension();if(b._isKeyCombination(E,null,M.CTRL)){b._navigate(this,E,N.UP);return;}if(b._isKeyCombination(E,null,M.ALT)&&b._isElementGroupToggler(this,E.target)){p(E);T.Grouping.toggleGroupHeaderByRef(this,E.target,false);return;}if(k.isInActionMode()){return;}var o=T.getCellInfo(E.target);if(b._isKeyCombination(E,null,M.SHIFT)){E.preventDefault();if(o.isOfType(C.ANYCONTENTCELL)){if(!this._oRangeSelection){p(E);return;}var F=T.getRowIndexOfFocusedCell(this);var i=this.getRows()[F].getIndex();if(i===0){p(E);return;}if(T.isFirstScrollableRow(this,E.target)){var g=this._getScrollExtension().scrollVertically(false,false,true);if(g){p(E);}}if(this._oRangeSelection.startIndex>=i){i--;if(this._oRangeSelection.selected){T.toggleRowSelection(this,i,true);}else{T.toggleRowSelection(this,i,false);}}else{T.toggleRowSelection(this,i,false);}}else{p(E);}}if(b._isKeyCombination(E,null,M.ALT)){if(o.isOfType(C.DATACELL)){k.setActionMode(true);}p(E);}};
b.prototype.onsapleft=function(E){b._navigate(this,E,N.LEFT);};
b.prototype.onsapleftmodifiers=function(E){if(this._getKeyboardExtension().isInActionMode()){return;}var o=T.getCellInfo(E.target);var I=sap.ui.getCore().getConfiguration().getRTL();if(b._isKeyCombination(E,null,M.SHIFT)){E.preventDefault();if(o.isOfType(C.DATACELL)){if(!this._oRangeSelection){p(E);return;}var F=T.getFocusedItemInfo(this);var g=T.hasRowHeader(this)&&F.cellInRow===1;if(g&&!T.isRowSelectorSelectionAllowed(this)){p(E);}}else if(o.isOfType(C.ROWACTION)){if(!this._oRangeSelection){p(E);}}else if(o.isOfType(C.ROWHEADER)&&I){if(!T.isRowSelectionAllowed(this)){p(E);}}else if(o.isOfType(C.COLUMNROWHEADER)&&I){p(E);}else if(o.isOfType(C.COLUMNHEADER)){var r=-T.convertCSSSizeToPixel(a);var h=0;if(I){r=r*-1;}for(var i=o.columnIndex;i<o.columnIndex+o.columnSpan;i++){h+=T.Column.getColumnWidth(this,i);}T.Column.resizeColumn(this,o.columnIndex,h+r,true,o.columnSpan);p(E);}}else if(b._isKeyCombination(E,null,M.CTRL)){if(o.isOfType(C.COLUMNHEADER)){E.preventDefault();E.stopImmediatePropagation();var j=this.getColumns()[o.columnIndex];b._moveColumn(j,I);}}};
b.prototype.onsaprightmodifiers=function(E){if(this._getKeyboardExtension().isInActionMode()){return;}var o=T.getCellInfo(E.target);var I=sap.ui.getCore().getConfiguration().getRTL();if(b._isKeyCombination(E,null,M.SHIFT)){E.preventDefault();if(o.isOfType(C.DATACELL)){if(!this._oRangeSelection){p(E);}}else if(o.isOfType(C.ROWHEADER)){if(!T.isRowSelectionAllowed(this)){p(E);}}else if(o.isOfType(C.ROWACTION)&&I){if(!this._oRangeSelection){p(E);}}else if(o.isOfType(C.COLUMNHEADER)){var r=T.convertCSSSizeToPixel(a);var g=0;if(I){r=r*-1;}for(var i=o.columnIndex;i<o.columnIndex+o.columnSpan;i++){g+=T.Column.getColumnWidth(this,i);}T.Column.resizeColumn(this,o.columnIndex,g+r,true,o.columnSpan);p(E);}else if(o.isOfType(C.COLUMNROWHEADER)){p(E);}}else if(b._isKeyCombination(E,null,M.CTRL)){if(o.isOfType(C.COLUMNHEADER)){E.preventDefault();E.stopImmediatePropagation();var h=this.getColumns()[o.columnIndex];b._moveColumn(h,!I);}}};
b.prototype.onsaphome=function(E){if(this._getKeyboardExtension().isInActionMode()){return;}if(T.Grouping.isInGroupingRow(E.target)){p(E);E.preventDefault();return;}var o=T.getCellInfo(E.target);if(o.isOfType(C.ANY)){E.preventDefault();}if(o.isOfType(C.DATACELL|C.ROWACTION|C.COLUMNHEADER)){var F=T.getFocusedItemInfo(this);var i=F.cell;var g=F.cellInRow;var h=this.getComputedFixedColumnCount();var j=T.hasRowHeader(this);var r=j?1:0;if(T.hasFixedColumns(this)&&g>h+r){p(E);T.focusItem(this,i-g+h+r,null);}else if(j&&g>1){p(E);T.focusItem(this,i-g+r,null);}}};
b.prototype.onsapend=function(E){if(this._getKeyboardExtension().isInActionMode()){return;}if(T.Grouping.isInGroupingRow(E.target)){E.preventDefault();p(E);return;}var o=T.getCellInfo(E.target);if(o.isOfType(C.ANY)){E.preventDefault();var F=T.getFocusedItemInfo(this);var i=F.cell;var g=F.columnCount;var h=this.getComputedFixedColumnCount();var j=F.cellInRow;var k=T.hasRowHeader(this);var r=k?1:0;var I=false;if(o.isOfType(C.COLUMNHEADER)&&T.hasFixedColumns(this)){var m=parseInt(o.cell.attr("colspan")||1);if(m>1&&j+m-r===h){I=true;}}if(k&&j===0){p(E);T.focusItem(this,i+1,null);}else if(T.hasFixedColumns(this)&&j<h-1+r&&!I){p(E);T.focusItem(this,i+h-j,null);}else if(T.hasRowActions(this)&&o.isOfType(C.DATACELL)&&j<g-2){p(E);T.focusItem(this,i-j+g-2,null);}}};
b.prototype.onsaphomemodifiers=function(E){if(this._getKeyboardExtension().isInActionMode()){return;}if(b._isKeyCombination(E,null,M.CTRL)){E.preventDefault();var o=T.getCellInfo(E.target);if(o.isOfType(C.ANYCONTENTCELL|C.COLUMNHEADER)){p(E);var F=T.getFocusedItemInfo(this);var i=F.row;if(i>0){var g=F.cell;var h=F.columnCount;var j=T.getHeaderRowCount(this);var r=this._getRowCounts();if(i<j+r.fixedTop){if(o.isOfType(C.ROWACTION)){T.focusItem(this,g-h*(i-j),E);}else{T.focusItem(this,g-h*i,E);}}else if(i>=j+r.fixedTop&&i<j+T.getNonEmptyVisibleRowCount(this)-r.fixedBottom){this._getScrollExtension().scrollVerticallyMax(false,true);if(r.fixedTop>0||o.isOfType(C.ROWACTION)){T.focusItem(this,g-h*(i-j),E);}else{T.focusItem(this,g-h*i,E);}}else{this._getScrollExtension().scrollVerticallyMax(false,true);T.focusItem(this,g-h*(i-j-r.fixedTop),E);}}}}};
b.prototype.onsapendmodifiers=function(E){if(this._getKeyboardExtension().isInActionMode()){return;}if(b._isKeyCombination(E,null,M.CTRL)){E.preventDefault();var o=T.getCellInfo(E.target);if(o.isOfType(C.ANY)){var F=T.getFocusedItemInfo(this);var i=F.row;var h=T.getHeaderRowCount(this);var n=T.getNonEmptyVisibleRowCount(this);var r=this._getRowCounts();p(E);if(r.fixedBottom===0||i<h+n-1||(T.isNoDataVisible(this)&&i<h-1)){var g=F.cell;var j=F.columnCount;if(T.isNoDataVisible(this)){T.focusItem(this,g+j*(h-i-1),E);}else if(i<h){if(r.fixedTop>0){T.focusItem(this,g+j*(h+r.fixedTop-i-1),E);}else{this._getScrollExtension().scrollVerticallyMax(true,true);T.focusItem(this,g+j*(h+n-r.fixedBottom-i-1),E);}}else if(i>=h&&i<h+r.fixedTop){this._getScrollExtension().scrollVerticallyMax(true,true);T.focusItem(this,g+j*(h+n-r.fixedBottom-i-1),E);}else if(i>=h+r.fixedTop&&i<h+n-r.fixedBottom){this._getScrollExtension().scrollVerticallyMax(true,true);T.focusItem(this,g+j*(h+n-i-1),E);}else{T.focusItem(this,g+j*(h+n-i-1),E);}}}}};
b.prototype.onsappageup=function(E){if(this._getKeyboardExtension().isInActionMode()){return;}E.preventDefault();var o=T.getCellInfo(E.target);if(o.isOfType(C.ANYCONTENTCELL|C.COLUMNHEADER)){var F=T.getFocusedItemInfo(this);var i=F.row;var h=T.getHeaderRowCount(this);var r=this._getRowCounts();if(r.fixedTop===0&&i>=h||r.fixedTop>0&&i>h){p(E);var g=F.cell;var j=F.columnCount;if(i<h+r.fixedTop){T.focusItem(this,g-j*(i-h),E);}else if(i===h+r.fixedTop){var P=T.getNonEmptyVisibleRowCount(this)-r.fixedTop-r.fixedBottom;var R=this.getFirstVisibleRow();this._getScrollExtension().scrollVertically(false,true,true);if(R<P){if(r.fixedTop>0||o.isOfType(C.ROWACTION)){T.focusItem(this,g-j*(i-h),E);}else{T.focusItem(this,g-j*h,E);}}}else if(i>h+r.fixedTop&&i<h+T.getNonEmptyVisibleRowCount(this)){T.focusItem(this,g-j*(i-h-r.fixedTop),E);}else{T.focusItem(this,g-j*(i-h-T.getNonEmptyVisibleRowCount(this)+1),E);}}if(o.isOfType(C.ROWACTION)&&i===h&&r.fixedTop>0){p(E);}}};
b.prototype.onsappagedown=function(E){if(this._getKeyboardExtension().isInActionMode()){return;}E.preventDefault();var o=T.getCellInfo(E.target);if(o.isOfType(C.ANY)){var F=T.getFocusedItemInfo(this);var i=F.row;var h=T.getHeaderRowCount(this);var n=T.getNonEmptyVisibleRowCount(this);var r=this._getRowCounts();p(E);if((T.isNoDataVisible(this)&&i<h-1)||r.fixedBottom===0||i<h+n-1){var g=F.cell;var j=F.columnCount;if(i<h-1&&!o.isOfType(C.COLUMNROWHEADER)){T.focusItem(this,g+j*(h-i-1),E);}else if(i<h){if(!T.isNoDataVisible(this)){T.focusItem(this,g+j*(h-i),E);}}else if(i>=h&&i<h+n-r.fixedBottom-1){T.focusItem(this,g+j*(h+n-r.fixedBottom-i-1),E);}else if(i===h+n-r.fixedBottom-1){var P=T.getNonEmptyVisibleRowCount(this)-r.fixedTop-r.fixedBottom;var R=this._getTotalRowCount()-r.fixedBottom-this.getFirstVisibleRow()-P*2;this._getScrollExtension().scrollVertically(true,true,true);if(R<P&&r.fixedBottom>0){T.focusItem(this,g+j*(h+n-i-1),E);}}else{T.focusItem(this,g+j*(h+n-i-1),E);}}}};
b.prototype.onsappageupmodifiers=function(E){if(this._getKeyboardExtension().isInActionMode()){return;}if(b._isKeyCombination(E,null,M.ALT)){var o=T.getCellInfo(E.target);var F=T.getFocusedItemInfo(this);if(o.isOfType(C.DATACELL|C.COLUMNHEADER)){var i=F.cell;var g=F.cellInRow;var h=T.hasRowHeader(this);var r=h?1:0;var P=H;p(E);if(h&&(T.Grouping.isInGroupingRow(E.target)||g===1)){T.focusItem(this,i-g,null);}else if(g-r<P){T.focusItem(this,i-g+r,null);}else{T.focusItem(this,i-P,null);}}else if(o.isOfType(C.ROWACTION)){T.focusItem(this,F.cell-1,null);}}};
b.prototype.onsappagedownmodifiers=function(E){if(this._getKeyboardExtension().isInActionMode()){return;}if(b._isKeyCombination(E,null,M.ALT)){var o=T.getCellInfo(E.target);if(o.isOfType(C.DATACELL|C.ROWHEADER|C.ANYCOLUMNHEADER)){var F=T.getFocusedItemInfo(this);var i=F.cellInRow;var h=T.hasRowHeader(this);var r=h?1:0;var v=T.getVisibleColumnCount(this);var g=parseInt(o.cell.attr("colspan")||1);p(E);if(i+g-r<v){var j=F.cell;var P=H;if(h&&i===0){T.focusItem(this,j+1,null);}else if(g>P){T.focusItem(this,j+g,null);}else if(i+g-r+P>v){T.focusItem(this,j+v-i-1+r,null);}else if(!T.Grouping.isInGroupingRow(E.target)){T.focusItem(this,j+P,null);}}else if(o.isOfType(C.DATACELL)&&T.hasRowActions(this)&&i===F.columnCount-2){T.focusItem(this,F.cell+1,null);}}}};
b.prototype.onsapenter=function(E){b._handleSpaceAndEnter(this,E);};
return b;});
sap.ui.predefine('sap/ui/table/TableKeyboardExtension',["./TableExtension","sap/ui/core/delegate/ItemNavigation","./TableUtils","./TableKeyboardDelegate2","sap/ui/Device","sap/ui/dom/containsOrEquals","sap/ui/thirdparty/jquery"],function(T,I,a,b,D,c,q){"use strict";var d=false;
function e(o){if(D.browser.msie){if(!d){q("head").append("<style type=\"text/css\">"+"/* Avoid focus outline problems in tables */\n"+".sapUiTableStatic[data-sap-ui-table-focus]{}"+"</style>");d=true;}var C=a.getCellInfo(o)||{};if(C.isOfType(a.CELLTYPE.ANY)){C.cell.attr("data-sap-ui-table-focus",Date.now());}}}
var f={_forward:function(t,o){var i=t._getItemNavigation();if(i!=null&&!t._getKeyboardExtension()._isItemNavigationSuspended()&&!o.isMarked("sapUiTableSkipItemNavigation")){i["on"+o.type](o);}},onfocusin:function(o){f._forward(this,o);e(o.target);},onsapfocusleave:function(o){f._forward(this,o);},onmousedown:function(o){f._forward(this,o);},onsapnext:function(o){f._forward(this,o);},onsapnextmodifiers:function(o){f._forward(this,o);},onsapprevious:function(o){f._forward(this,o);},onsappreviousmodifiers:function(o){f._forward(this,o);},onsappageup:function(o){f._forward(this,o);},onsappagedown:function(o){f._forward(this,o);},onsaphome:function(o){f._forward(this,o);},onsaphomemodifiers:function(o){f._forward(this,o);},onsapend:function(o){f._forward(this,o);},onsapendmodifiers:function(o){f._forward(this,o);},onsapkeyup:function(o){f._forward(this,o);}};var E={onBeforeRendering:function(o){this._oStoredFocusInfo=this.getFocusInfo();},onAfterRendering:function(o){var r=o&&o.isMarked("renderRows");this._getKeyboardExtension().invalidateItemNavigation();if(this._oStoredFocusInfo&&this._oStoredFocusInfo.customId){if(r){this.applyFocusInfo(this._oStoredFocusInfo);}else{this._getKeyboardExtension().initItemNavigation();}}delete this._oStoredFocusInfo;},onfocusin:function(o){var i=this._getKeyboardExtension();if(!i._bIgnoreFocusIn){i.initItemNavigation();}else{o.setMarked("sapUiTableIgnoreFocusIn");}if(o.target&&o.target.id===this.getId()+"-rsz"){o.preventDefault();o.setMarked("sapUiTableSkipItemNavigation");}}};var g={_initItemNavigation:function(o){var t=o.getTable();var $=t.$();var r=t.getRows().length;var C=a.getVisibleColumnCount(t);var H=a.hasRowHeader(t);var j=a.hasRowActions(t);var k=a.hasFixedColumns(t);var i;var l=[],R,m,n,p,s;if(k){n=$.find(".sapUiTableCtrlFixed.sapUiTableCtrlRowFixed:not(.sapUiTableCHT)");p=$.find(".sapUiTableCtrlFixed.sapUiTableCtrlRowScroll:not(.sapUiTableCHT)");s=$.find(".sapUiTableCtrlFixed.sapUiTableCtrlRowFixedBottom:not(.sapUiTableCHT)");}var u=$.find(".sapUiTableCtrlScroll.sapUiTableCtrlRowFixed:not(.sapUiTableCHT)");var v=$.find(".sapUiTableCtrlScroll.sapUiTableCtrlRowScroll:not(.sapUiTableCHT)");var w=$.find(".sapUiTableCtrlScroll.sapUiTableCtrlRowFixedBottom:not(.sapUiTableCHT)");if(H){R=$.find(".sapUiTableRowSelectionCell").get();C++;}if(j){m=$.find(".sapUiTableRowActionCell").get();C++;}for(i=0;i<r;i++){if(H){l.push(R[i]);}if(k){l=l.concat(n.find("tr[data-sap-ui-rowindex=\""+i+"\"]").find("td[tabindex]").get());}l=l.concat(u.find("tr[data-sap-ui-rowindex=\""+i+"\"]").find("td[tabindex]").get());if(k){l=l.concat(p.find("tr[data-sap-ui-rowindex=\""+i+"\"]").find("td[tabindex]").get());}l=l.concat(v.find("tr[data-sap-ui-rowindex=\""+i+"\"]").find("td[tabindex]").get());if(k){l=l.concat(s.find("tr[data-sap-ui-rowindex=\""+i+"\"]").find("td[tabindex]").get());}l=l.concat(w.find("tr[data-sap-ui-rowindex=\""+i+"\"]").find("td[tabindex]").get());if(j){l.push(m[i]);}}if(t.getColumnHeaderVisible()){var x=[];var F=$.find(".sapUiTableCHT.sapUiTableCtrlFixed>tbody>tr");var S=$.find(".sapUiTableCHT.sapUiTableCtrlScroll>tbody>tr");var y=a.getHeaderRowCount(t);for(i=0;i<y;i++){if(H){x.push(t.getDomRef("selall"));}if(F.length){x=x.concat(q(F.get(i)).find(".sapUiTableHeaderCell").get());}if(S.length){x=x.concat(q(S.get(i)).find(".sapUiTableHeaderCell").get());}if(j){x.push($.find(".sapUiTableRowActionHeaderCell").children().get(0));}}l=x.concat(l);}if(!o._itemNavigation){o._itemNavigation=new I();o._itemNavigation.setTableMode(true);o._itemNavigation.attachEvent(I.Events.AfterFocus,function(z){var A=a.getFocusedItemInfo(t);A.header=a.getHeaderRowCount(t);A.domRef=null;if(A.row>=A.header){o._oLastFocusedCellInfo=A;}},t);}o._itemNavigation.setColumns(C);o._itemNavigation.setRootDomRef($.find(".sapUiTableCnt").get(0));o._itemNavigation.setItemDomRefs(l);o._itemNavigation.setFocusedIndex(g.getInitialItemNavigationIndex(o));o._itemNavigationInvalidated=false;},getInitialItemNavigationIndex:function(o){return a.hasRowHeader(o.getTable())?1:0;},isItemNavigationInvalid:function(o){return!o._itemNavigation||o._itemNavigationInvalidated;}};
var h=T.extend("sap.ui.table.TableKeyboardExtension",{
_init:function(t,s,S){this._itemNavigation=null;this._itemNavigationInvalidated=false;this._itemNavigationSuspended=false;this._delegate=new b(s);this._actionMode=false;a.addDelegate(t,E,t);a.addDelegate(t,this._delegate,t);a.addDelegate(t,f,t);t._getItemNavigation=function(){return this._itemNavigation;}.bind(this);return"KeyboardExtension";},
_debug:function(){this._ExtensionHelper=g;this._ItemNavigationDelegate=f;this._ExtensionDelegate=E;},
destroy:function(){var t=this.getTable();if(t){t.removeEventDelegate(E);t.removeEventDelegate(this._delegate);t.removeEventDelegate(f);}if(this._itemNavigation){this._itemNavigation.destroy();this._itemNavigation=null;}if(this._delegate){this._delegate.destroy();this._delegate=null;}T.prototype.destroy.apply(this,arguments);}
});
h.prototype.initItemNavigation=function(){if(g.isItemNavigationInvalid(this)){g._initItemNavigation(this);}};
h.prototype.invalidateItemNavigation=function(){this._itemNavigationInvalidated=true;};
h.prototype.setActionMode=function(i){if(!this._delegate){return;}if(i===true&&!this._actionMode&&this._delegate.enterActionMode){this._actionMode=this._delegate.enterActionMode.apply(this.getTable(),Array.prototype.slice.call(arguments,1))===true;}else if(i===false&&this._actionMode&&this._delegate.leaveActionMode){this._actionMode=false;this._delegate.leaveActionMode.apply(this.getTable(),Array.prototype.slice.call(arguments,1));}};
h.prototype.isInActionMode=function(){return this._actionMode;};
h.prototype.updateNoDataAndOverlayFocus=function(p){var t=this.getTable();if(!t||!t.getDomRef()){return;}if(t.getShowOverlay()){if(c(t.getDomRef(),p)){t.$("overlay").focus();}}else if(a.isNoDataVisible(t)){if(c(t.getDomRef("sapUiTableCnt"),p)){t.$("noDataCnt").focus();}}else if(c(t.getDomRef("noDataCnt"),p)||c(t.getDomRef("overlay"),p)){a.focusItem(t,g.getInitialItemNavigationIndex(this));}};
h.prototype._suspendItemNavigation=function(){this._itemNavigationSuspended=true;};
h.prototype._resumeItemNavigation=function(){this._itemNavigationSuspended=false;};
h.prototype._isItemNavigationSuspended=function(){return this._itemNavigationSuspended;};
h.prototype._getLastFocusedCellInfo=function(){var H=a.getHeaderRowCount(this.getTable());if(!this._oLastFocusedCellInfo||this._oLastFocusedCellInfo.header!=H){var i=a.getFocusedItemInfo(this.getTable());var j=g.getInitialItemNavigationIndex(this);return{cellInRow:j,row:H,header:H,cellCount:i.cellCount,columnCount:i.columnCount,cell:i.columnCount*H+j};}return this._oLastFocusedCellInfo;};
h.prototype._setSilentFocus=function(o){this._bIgnoreFocusIn=true;this._setFocus(o);this._bIgnoreFocusIn=false;};
h.prototype._setFocus=function(o){if(!o){return;}var t=this.getTable();var C=a.getCellInfo(o);if(C.isOfType(a.CELLTYPE.ANY)&&t){var $=q(o);if($.attr("tabindex")!="0"){var j=t._getItemNavigation();if(j&&j.aItemDomRefs){for(var i=0;i<j.aItemDomRefs.length;i++){if(j.aItemDomRefs[i]){j.aItemDomRefs[i].setAttribute("tabindex","-1");}}}$.attr("tabindex","0");}}o.focus();};
h.prototype._getTableType=function(){return this._type;};
return h;});
sap.ui.predefine('sap/ui/table/TableMenuUtils',["sap/ui/Device","sap/ui/unified/Menu","sap/ui/unified/MenuItem","sap/ui/core/Popup","sap/ui/thirdparty/jquery"],function(D,M,a,P,q){"use strict";P.setInitialZIndex(10);var b={TableUtils:null,openContextMenu:function(t,e,h,f,E){if(!t||!e){return;}f=f!==false;var T=b.TableUtils.getCell(t,e);var c=b.TableUtils.getCellInfo(T);var C=c.columnIndex;var r=c.rowIndex;var d;if(c.isOfType(b.TableUtils.CELLTYPE.COLUMNHEADER)){var g=T.find(".sapUiTableColDropDown").length>0;if(D.system.desktop||g){b.removeColumnHeaderCellMenu(t,C);d=true;if(f){d=t.fireColumnSelect({column:t.getColumns()[C]});}if(d){b.openColumnContextMenu(t,C,h,T);}}else{b.applyColumnHeaderCellMenu(t,C,T);}}else if(c.isOfType(b.TableUtils.CELLTYPE.ANYCONTENTCELL)){d=true;if(f){var R=b.TableUtils.getRowColCell(t,r,C,C>=0);var o=R.row;var i;var j=t.getBindingInfo("rows");if(j){i=o.getBindingContext(j.model);}var k=t.getContextMenu();if(k){k.setBindingContext(i);}if(C>=0){d=t.fireCellContextmenu({rowIndex:o.getIndex(),columnIndex:C,columnId:R.column.getId(),cellControl:R.cell,rowBindingContext:i,cellDomRef:T[0]});}if(d){d=t.fireBeforeOpenContextMenu({rowIndex:o.getIndex(),columnIndex:R.column?C:null,contextMenu:k});}}if(d){b.openDataCellContextMenu(t,c,h,E);}}},openColumnContextMenu:function(t,c,h,C){if(!t||c==null||c<0){return;}if(h==null){h=false;}var o=t.getColumns();if(c>=o.length){return;}var d=o[c];if(!d.getVisible()){return;}for(var i=0;i<o.length;i++){if(o[i]!==d){b.closeColumnContextMenu(t,i);}}b.closeDataCellContextMenu(t);var e=C&&C.attr("colspan");if(e&&e!=="1"){return;}d._openMenu(C&&C[0]||d.getDomRef(),h);},closeColumnContextMenu:function(t,c){if(!t||c==null||c<0){return;}var C=t.getColumns();if(c>=C.length){return;}var o=C[c];o._closeMenu();},openDataCellContextMenu:function(t,c,h,e){if(!t||!c||!c.isOfType(b.TableUtils.CELLTYPE.ANYCONTENTCELL)||c.rowIndex>=b.TableUtils.getNonEmptyVisibleRowCount(t)){return;}h=h===true;if(b.hasContextMenu(t)){if(!b.TableUtils.Grouping.isInSumRow(c.cell)&&!b.TableUtils.Grouping.isInGroupingRow(c.cell)){t.getContextMenu().openAsContextMenu(e,c.cell);}return;}var r=c.rowIndex;var R=t.getRows()[r];var C=c.columnIndex;var d=t.getColumns();var o=d[C];if(!o||!o.getVisible()){return;}if(t.getEnableCellFilter()&&o&&o.isFilterableByMenu()){if(!t._oCellContextMenu){t._oCellContextMenu=new M(t.getId()+"-cellcontextmenu");var f=new a({text:b.TableUtils.getResourceText("TBL_FILTER")});f._onSelect=function(o,r){var k=this.getContextByIndex(r);var F=o.getFilterProperty();var s=k.getProperty(F);if(this.getEnableCustomFilter()){this.fireCustomFilter({column:o,value:s});}else{this.filter(o,s);}};f.attachSelect(f._onSelect.bind(t,o,R.getIndex()));t._oCellContextMenu.addItem(f);t.addDependent(t._oCellContextMenu);}else{var m=t._oCellContextMenu.getItems()[0];m.mEventRegistry.select[0].fFunction=m._onSelect.bind(t,o,R.getIndex());}if(!b.TableUtils.Grouping.isInGroupingRow(c.cell)){var g=c.cell[0];var j=t._oCellContextMenu.bOpen&&t._oCellContextMenu.oOpenerRef!==g;if(j){b.closeDataCellContextMenu(t);}for(var i=0;i<d.length;i++){b.closeColumnContextMenu(t,i);}t._oCellContextMenu.open(h,g,P.Dock.BeginTop,P.Dock.BeginBottom,g);}}},closeDataCellContextMenu:function(t){if(!t){return;}var m=t._oCellContextMenu;var c=m!=null&&m.bOpen;if(c){m.close();}},cleanupDataCellContextMenu:function(t){if(!t||!t._oCellContextMenu){return;}t._oCellContextMenu.destroy();t._oCellContextMenu=null;},applyColumnHeaderCellMenu:function(t,c,T){if(!t||c==null||c<0){return;}var C=t.getColumns();if(c>=C.length){return;}var d=T&&T.attr("colspan");if(d&&d!=="1"){return;}var o=C[c];if(o.getVisible()&&(o.getResizable()||o._menuHasItems())){var $=T||o.$();var e=$.find(".sapUiTableCellInner");var f=$.find(".sapUiTableCellTouchMenu").length>0;if(!f){b.removeColumnHeaderCellMenu(t);e.hide();var s="";if(o._menuHasItems()){s="<div class='sapUiTableColDropDown'></div>";}var g="";if(o.getResizable()){g="<div class='sapUiTableColResizer'></div>";}var h=q("<div class='sapUiTableCellTouchMenu'>"+s+g+"</div>");$.append(h);$.on("focusout",function(t){b.removeColumnHeaderCellMenu(t);this.off("focusout");}.bind($,t));}}},removeColumnHeaderCellMenu:function(t){var c=t&&t.$().find(".sapUiTableCHT .sapUiTableCellTouchMenu");if(c.length){c.parent().find(".sapUiTableCellInner").show();c.remove();}},hasContextMenu:function(t){return t!=null&&t.getContextMenu()!=null;}};return b;},true);
sap.ui.predefine('sap/ui/table/TablePersoController',['sap/ui/base/ManagedObject',"sap/ui/core/syncStyleClass","sap/base/Log","sap/ui/thirdparty/jquery"],function(M,s,L,q){"use strict";
var T=M.extend("sap.ui.table.TablePersoController",{
constructor:function(i,S){M.apply(this,arguments);},
metadata:{properties:{"autoSave":{type:"boolean",defaultValue:true},"persoService":{type:"any"},"customDataKey":{type:"string",defaultValue:"persoKey"}},associations:{"table":{type:"sap.ui.table.Table",multiple:false}},library:"sap.ui.table"}
});
T.prototype.init=function(){this._schemaProperty="_persoSchemaVersion";this._schemaVersion="1.0";this._oInitialPersoData=null;this._aTableEvents=["columnResize","columnMove","columnVisibility","sort","filter","group"];this._aColumnProperties=["visible","width","sorted","sortOrder","grouped","summed"];this._bSaveFilters=false;if(this._bSaveFilters){this._aTableEvents.push("filter");this._aColumnProperties.push("filtered");this._aColumnProperties.push("filterValue");}};
T.prototype.exit=function(){var t=this._getTable();if(t){this._manageTableEventHandlers(t,false);}delete this._schemaProperty;delete this._schemaVersion;delete this._oInitialPersoData;if(this._oDialog){this._oDialog.destroy();delete this._oDialog;}};
T.prototype.setPersoService=function(S){S=this.validateProperty("persoService",S);if(S&&(!q.isFunction(S.getPersData)||!q.isFunction(S.setPersData)||!q.isFunction(S.delPersData))){throw new Error("Value of property \"persoService\" needs to be null/undefined or an object that has the methods "+"\"getPersData\", \"setPersData\" and \"delPersData\".");}var o=this.getPersoService();this.setProperty("persoService",S,true);var n=this.getPersoService();if(n&&n!==o&&this._getTable()&&(this.getAutoSave()||!o)){this.refresh();}return this;};
T.prototype.setAutoSave=function(a){var o=this.getAutoSave();this.setProperty("autoSave",a,true);var n=this.getAutoSave();if(n&&!o){this.savePersonalizations();}return this;};
T.prototype.setTable=function(t){var o=this._getTable();if(o){o._oPersoController=undefined;}this.setAssociation("table",t,true);var n=this._getTable();if(n){n._oPersoController=this;}if(o){this._manageTableEventHandlers(o,false);}if(n&&n!==o){this._oInitialPersoData=this._getCurrentTablePersoData(true);this._manageTableEventHandlers(n,true);if(this.getPersoService()&&(this.getAutoSave()||!o)){this.refresh();}}else if(!n){this._oInitialPersoData=null;}return this;};
T.prototype.setCustomDataKey=function(c){var o=this.getCustomDataKey();this.setProperty("customDataKey",c,true);var n=this.getCustomDataKey();if(o!==n&&this.getAutoSave()){this.savePersonalizations();}return this;};
T.prototype._manageTableEventHandlers=function(t,a){for(var i=0,l=this._aTableEvents.length;i<l;i++){var f=t[(a?"attachEvent":"detachEvent")];f.apply(t,[this._aTableEvents[i],this._tableEventHandler,this]);}};
T.prototype.refresh=function(){var t=this;var S=this.getPersoService();if(S){return S.getPersData().done(function(o){var D=(o&&Array.isArray(o.aColumns))?o:t._oInitialPersoData;t._adjustTable(D);}).fail(function(){L.error("Problem reading persisted personalization data.");});}else{L.error("The Personalization Service is not available!");var d=q.Deferred();d.reject();return d.promise();}};
T.prototype.savePersonalizations=function(){var S=this.getPersoService();if(S){var d=this._getCurrentTablePersoData();d[this._schemaProperty]=this._schemaVersion;return S.setPersData(d).fail(function(){L.error("Problem persisting personalization data.");});}else{L.error("The Personalization Service is not available!");var D=q.Deferred();D.reject();return D.promise();}};
T.prototype._adjustTable=function(d){var t=this._getTable();if(!t||!d||!Array.isArray(d.aColumns)){return;}var c={},C=t.getColumns();for(var i=0,l=C.length;i<l;i++){c[this._getColumnPersoKey(C[i])]=C[i];}var a=d.aColumns;for(var i=0,l=a.length;i<l;i++){var o=a[i];var b=c[o.id];if(b){if(t.indexOfColumn(b)!==o.order){t.removeColumn(b);t.insertColumn(b,o.order);}var m=b.getMetadata();for(var j=0,e=this._aColumnProperties.length;j<e;j++){var p=this._aColumnProperties[j];if(o[p]!==undefined){try{if(m.hasProperty(p)&&b.getProperty(p)!=o[p]){b.setProperty(p,o[p]);}}catch(f){L.error("sap.ui.table.TablePersoController: failed to apply the value \""+b[p]+"\" for the property + \""+p+"\".");}}}}}if(typeof t._onPersoApplied==="function"){t._onPersoApplied();}};
T.prototype._tableEventHandler=function(e){if(this.getAutoSave()&&!this._iTriggerSaveTimeout){var t=this;this._iTriggerSaveTimeout=setTimeout(function(){t.savePersonalizations();t._iTriggerSaveTimeout=null;},0);}};
T.prototype._getCurrentTablePersoData=function(f){var t=this._getTable(),c=t.getColumns();var d={aColumns:[]};for(var i=0,l=c.length;i<l;i++){var C=c[i];var p=this._getColumnPersoKey(C);var o={id:p,order:i};var m=C.getMetadata();for(var j=0,a=this._aColumnProperties.length;j<a;j++){var P=this._aColumnProperties[j];if(m.hasProperty(P)){o[P]=C.getProperty(P);}}if(f){o.text=C.getLabel()&&C.getLabel().getText()||p;}d.aColumns.push(o);}return d;};
T.prototype._getTable=function(){return sap.ui.getCore().byId(this.getTable());};
T.prototype._getColumnPersoKey=function(c){return this._getPersoKey(this._getTable())+"-"+this._getPersoKey(c);};
T.prototype._getPersoKey=function(c){var p=c.data(this.getCustomDataKey());if(!p){p=c.getId();if(p.indexOf(sap.ui.getCore().getConfiguration().getUIDPrefix())===0){L.warning("Generated IDs should not be used as personalization keys! The stability cannot be ensured! (Control: \""+c.getId()+"\")");}}return p;};
T.prototype.openDialog=function(S){var t=this;function _(){if(t._oDialog){s("sapUiSizeCompact",t._getTable(),t._oDialog._oDialog);t._oDialog.open();}}if(!this._oDialog){sap.ui.getCore().loadLibrary("sap.m",{async:true}).then(function(){sap.ui.require(["sap/m/TablePersoDialog"],function(a){t._oDialog=new a(t._getTable().getId()+"-PersoDialog",{persoService:t.getPersoService(),showSelectAll:true,showResetAll:true,hasGrouping:false,contentWidth:S&&S.contentWidth,contentHeight:S&&S.contentHeight||"20rem",initialColumnState:t._oInitialPersoData.aColumns,columnInfoCallback:function(o,p,P){return t._getCurrentTablePersoData(true).aColumns;},confirm:function(){t._adjustTable(this.retrievePersonalizations());if(t.getAutoSave()){t.savePersonalizations();}}});t._oDialog._oDialog.removeStyleClass("sapUiPopupWithPadding");_();});});}else{_();}};
return T;});
sap.ui.predefine('sap/ui/table/TablePointerExtension',["./library","./TableExtension","./TableUtils","sap/ui/Device","sap/ui/core/Popup","sap/base/Log","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/scrollLeftRTL","sap/ui/dom/jquery/control"],function(l,T,a,D,P,L,q){"use strict";var S=l.SelectionMode;var K=["sapMBtnBase","sapMInputBase","sapMLnk","sapMSlt","sapMCb","sapMRI","sapMSegBBtn","sapUiIconPointer","sapMBtnIcon"];var E={_getEventPosition:function(e,t){var p;function g(o){if(!t._isTouchEvent(o)){return null;}var f=["touches","targetTouches","changedTouches"];for(var i=0;i<f.length;i++){var s=f[i];if(e[s]&&e[s][0]){return e[s][0];}if(e.originalEvent[s]&&e.originalEvent[s][0]){return e.originalEvent[s][0];}}return null;}p=g(e)||e;return{x:p.pageX,y:p.pageY};},_skipClick:function(e,t,o){if(!o.isOfType(a.CELLTYPE.DATACELL|a.CELLTYPE.ROWACTION)){return false;}if(e.isMarked()){return true;}var f=t.control(0);if(f){var $=f.$();if($.length){for(var i=0;i<K.length;i++){if($.hasClass(K[i])){return typeof f.getEnabled==="function"?f.getEnabled():true;}}}}var h=false;if(window.getSelection){var s=window.getSelection();h=s.rangeCount?!s.getRangeAt(0).collapsed:false;}if(h){L.debug("DOM Selection detected -> Click event on table skipped, Target: "+e.target);return true;}return false;},_handleClickSelection:function(e,$,t){a.toggleRowSelection(t,$,null,function(r){var s=t._getSelectionPlugin();if((D.browser.msie||D.browser.edge)&&e.shiftKey){t._clearTextSelection();}var o=t.getSelectionMode();if(o===S.Single){if(!s.isIndexSelected(r)){s.setSelectedIndex(r);}else{s.clearSelection();}}else if(e.shiftKey){var i=s.getSelectedIndex();if(i>=0){s.addSelectionInterval(i,r);}else if(s.getSelectedCount()===0){s.setSelectedIndex(r);}}else if(!t._legacyMultiSelection){if(!s.isIndexSelected(r)){s.addSelectionInterval(r,r);}else{s.removeSelectionInterval(r,r);}}else{t._legacyMultiSelection(r,e);}return true;});}};var C={initColumnResizing:function(t,e){if(t._bIsColumnResizerMoving){return;}t._bIsColumnResizerMoving=true;t.$().toggleClass("sapUiTableResizing",true);var $=q(document),f=t._isTouchEvent(e);t._$colResize=t.$("rsz");t._iColumnResizeStart=E._getEventPosition(e,t).x;$.bind((f?"touchend":"mouseup")+".sapUiTableColumnResize",C.exitColumnResizing.bind(t));$.bind((f?"touchmove":"mousemove")+".sapUiTableColumnResize",C.onMouseMoveWhileColumnResizing.bind(t));t._disableTextSelection();},exitColumnResizing:function(e){C._resizeColumn(this,this._iLastHoveredColumnIndex);},onMouseMoveWhileColumnResizing:function(e){var i=E._getEventPosition(e,this).x;if(this._iColumnResizeStart&&i<this._iColumnResizeStart+3&&i>this._iColumnResizeStart-3){return;}if(this._isTouchEvent(e)){e.stopPropagation();e.preventDefault();}this._$colResize.toggleClass("sapUiTableColRszActive",true);var o=this._getVisibleColumns()[this._iLastHoveredColumnIndex];var f=i-this._iColumnResizeStart;var g=this.$().find("th[data-sap-ui-colid=\""+o.getId()+"\"]").width();var w=Math.max(g+f*(this._bRtlMode?-1:1),a.Column.getMinColumnWidth());var r=this.$().find(".sapUiTableCnt").offset().left;var h=Math.floor((i-r)-(this._$colResize.width()/2));this._$colResize.css("left",h+"px");o._iNewWidth=w;},_cleanupColumResizing:function(t){if(t._$colResize){t._$colResize.toggleClass("sapUiTableColRszActive",false);t._$colResize=null;}t._iColumnResizeStart=null;t._bIsColumnResizerMoving=false;t.$().toggleClass("sapUiTableResizing",false);t._enableTextSelection();var $=q(document);$.unbind("touchmove.sapUiTableColumnResize");$.unbind("touchend.sapUiTableColumnResize");$.unbind("mousemove.sapUiTableColumnResize");$.unbind("mouseup.sapUiTableColumnResize");},_resizeColumn:function(t,i){var v=t._getVisibleColumns();var o;if(i>=0&&i<v.length){o=v[i];if(o._iNewWidth){a.Column.resizeColumn(t,t.indexOfColumn(o),o._iNewWidth);delete o._iNewWidth;}}C._cleanupColumResizing(t);o.focus();},doAutoResizeColumn:function(t,i){var v=t._getVisibleColumns(),o;if(i>=0&&i<v.length){o=v[i];if(!o.getAutoResizable()||!o.getResizable()){return;}var n=C._calculateAutomaticColumnWidth.apply(t,[o,i]);if(n){o._iNewWidth=n;C._resizeColumn(t,i);}}},_calculateAutomaticColumnWidth:function(o,i){o=o||this.getColumns()[i];var $=this.$();var e=q("<div>").addClass("sapUiTableHiddenSizeDetector sapUiTableHeaderDataCell sapUiTableDataCell");$.append(e);var f=$.find("td[data-sap-ui-colid = \""+o.getId()+"\"]:not([colspan])").filter(function(g,h){return h.style.display!="none";}).children().clone();f.removeAttr("id");var w=e.append(f).width()+4;w=Math.min(w,$.find(".sapUiTableCnt").width());w=Math.max(w+4,a.Column.getMinColumnWidth());e.remove();return w;},initColumnTracking:function(t){t.$().find(".sapUiTableCtrlScr, .sapUiTableCtrlScrFixed").mousemove(function(e){var o=this.getDomRef();if(!o||this._bIsColumnResizerMoving){return;}var p=e.clientX,f=o.getBoundingClientRect(),g=0,r=this._bRtlMode?10000:-10000;for(var i=0;i<this._aTableHeaders.length;i++){var h=this._aTableHeaders[i].getBoundingClientRect();if(this._bRtlMode){if((p<h.right-5)&&(p>=h.left)){g=i;r=h.left-f.left;break;}}else{if((p>h.left+5)&&(p<=h.right)){g=i;r=h.right-f.left;break;}}}var j=this._getVisibleColumns()[g];if(j&&j.getResizable()){this.$("rsz").css("left",r+"px");this._iLastHoveredColumnIndex=g;}}.bind(t));}};var R={initReordering:function(t,i,e){var o=t.getColumns()[i],$=o.$(),f=t.$();t._disableTextSelection();f.addClass("sapUiTableDragDrop");var g=$.clone();g.find("*").addBack(g).removeAttr("id").removeAttr("data-sap-ui").removeAttr("tabindex");g.attr("id",t.getId()+"-roghost").addClass("sapUiTableColReorderGhost").css({"left":-10000,"top":-10000,"z-index":P.getNextZIndex()});g.toggleClass(a.getContentDensity(t),true);g.appendTo(document.body);t._$ReorderGhost=t.getDomRef("roghost");f.find("td[data-sap-ui-colid='"+o.getId()+"']").toggleClass("sapUiTableColReorderFade",true);var I=q("<div id='"+t.getId()+"-roind' class='sapUiTableColReorderIndicator'><div class='sapUiTableColReorderIndicatorArrow'></div><div class='sapUiTableColReorderIndicatorInner'></div></div>");I.appendTo(t.getDomRef("sapUiTableCnt"));t._$ReorderIndicator=t.getDomRef("roind");t._iDnDColIndex=i;var h=q(document),j=t._isTouchEvent(e);h.bind((j?"touchend":"mouseup")+".sapUiColumnMove",R.exitReordering.bind(t));h.bind((j?"touchmove":"mousemove")+".sapUiColumnMove",R.onMouseMoveWhileReordering.bind(t));},onMouseMoveWhileReordering:function(e){var o=E._getEventPosition(e,this),i=o.x,f=o.y,O=this._iNewColPos;this._iNewColPos=this._iDnDColIndex;e.preventDefault();var p=R.findColumnForPosition(this,i);if(!p||!p.id){this._iNewColPos=O;return;}var s=40,g=this.getDomRef("sapUiTableColHdrScr"),$=q(g),h=g.getBoundingClientRect(),j=$.outerWidth(),k=this._bRtlMode?$.scrollLeftRTL():$.scrollLeft();this._bReorderScroll=false;if(i>h.left+j-s&&k+j<g.scrollWidth){this._bReorderScroll=true;R.doScroll(this,!this._bRtlMode);R.adaptReorderMarkerPosition(this,p,false);}else if(i<h.left+s&&k>0){this._bReorderScroll=true;R.doScroll(this,this._bRtlMode);R.adaptReorderMarkerPosition(this,p,false);}q(this._$ReorderGhost).css({"left":i+5,"top":f+5});if(this._bReorderScroll||!p){return;}if(p.before||(p.after&&p.index==this._iDnDColIndex)){this._iNewColPos=p.index;}else if(p.after&&p.index!=this._iDnDColIndex){this._iNewColPos=p.index+1;}if(!a.Column.isColumnMovableTo(this.getColumns()[this._iDnDColIndex],this._iNewColPos)){this._iNewColPos=O;}else{R.adaptReorderMarkerPosition(this,p,true);}},exitReordering:function(e){var o=this._iDnDColIndex;var n=this._iNewColPos;var $=q(document);$.unbind("touchmove.sapUiColumnMove");$.unbind("touchend.sapUiColumnMove");$.unbind("mousemove.sapUiColumnMove");$.unbind("mouseup.sapUiColumnMove");this._bReorderScroll=false;this.$().removeClass("sapUiTableDragDrop");delete this._iDnDColIndex;delete this._iNewColPos;q(this._$ReorderGhost).remove();delete this._$ReorderGhost;q(this._$ReorderIndicator).remove();delete this._$ReorderIndicator;this.$().find(".sapUiTableColReorderFade").removeClass("sapUiTableColReorderFade");this._enableTextSelection();a.Column.moveColumnTo(this.getColumns()[o],n);if(this._mTimeouts.reApplyFocusTimerId){window.clearTimeout(this._mTimeouts.reApplyFocusTimerId);}var t=this;this._mTimeouts.reApplyFocusTimerId=window.setTimeout(function(){var O=a.getFocusedItemInfo(t).cell;a.focusItem(t,0,e);a.focusItem(t,O,e);},0);},findColumnForPosition:function(t,e){var h,H,r,w,p,B,A;for(var i=0;i<t._aTableHeaders.length;i++){h=t._aTableHeaders[i];H=q(h);r=h.getBoundingClientRect();w=H.outerWidth();p={left:r.left,center:r.left+w/2,right:r.left+w,width:w,index:parseInt(H.attr("data-sap-ui-headcolindex")),id:H.attr("data-sap-ui-colid")};B=e>=p.left&&e<=p.center;A=e>=p.center&&e<=p.right;if(B||A){p.before=t._bRtlMode?A:B;p.after=t._bRtlMode?B:A;return p;}}return null;},doScroll:function(t,f){if(t._mTimeouts.horizontalReorderScrollTimerId){window.clearTimeout(t._mTimeouts.horizontalReorderScrollTimerId);t._mTimeouts.horizontalReorderScrollTimerId=null;}if(t._bReorderScroll){var s=f?30:-30;if(t._bRtlMode){s=(-1)*s;}t._mTimeouts.horizontalReorderScrollTimerId=setTimeout(R.doScroll.bind(t,t,f),60);var $=t.$("sapUiTableColHdrScr");var e=t._bRtlMode?"scrollLeftRTL":"scrollLeft";$[e]($[e]()+s);}},adaptReorderMarkerPosition:function(t,p,s){if(!p||!t._$ReorderIndicator){return;}var i=p.left-t.getDomRef().getBoundingClientRect().left;if(t._bRtlMode&&p.before||!t._bRtlMode&&p.after){i=i+p.width;}q(t._$ReorderIndicator).css({"left":i+"px"}).toggleClass("sapUiTableColReorderIndicatorActive",s);}};var b={ROWAREAS:[".sapUiTableRowSelectionCell",".sapUiTableRowActionCell",".sapUiTableCtrlFixed > tbody > .sapUiTableTr",".sapUiTableCtrlScroll > tbody > .sapUiTableTr"],initRowHovering:function(t){var $=t.$();for(var i=0;i<b.ROWAREAS.length;i++){b._initRowHoveringForArea(t,$,b.ROWAREAS[i]);}},_initRowHoveringForArea:function(t,$,A){$.find(A).hover(function(){b._onHover(t,$,A,this);},function(){b._onUnhover(t,$,A,this);});},_onHover:function(t,$,A,e){var i=$.find(A).index(e);var r=t.getRows()[i];if(r){r._setHovered(true);}},_onUnhover:function(t,$,A,e){var i=$.find(A).index(e);var r=t.getRows()[i];if(r){r._setHovered(false);}}};var c={onmousedown:function(e){var p=this._getPointerExtension();var $=a.getCell(this,e.target);var o=a.getCellInfo($);var t=q(e.target);var f;var m;var M;this._getKeyboardExtension().initItemNavigation();if(e.button===0){if(e.target===this.getDomRef("rsz")){e.preventDefault();e.stopPropagation();C.initColumnResizing(this,e);}else if(t.hasClass("sapUiTableColResizer")){var i=t.closest(".sapUiTableHeaderCell").attr("data-sap-ui-colindex");this._iLastHoveredColumnIndex=parseInt(i);C.initColumnResizing(this,e);}else if(o.isOfType(a.CELLTYPE.COLUMNHEADER)){f=this.getColumns()[o.columnIndex];m=f.getAggregation("menu");M=m&&m.bOpen;if(!M){p._bShowMenu=true;this._mTimeouts.delayedMenuTimerId=setTimeout(function(){delete p._bShowMenu;},200);}if(this.getEnableColumnReordering()&&!(this._isTouchEvent(e)&&t.hasClass("sapUiTableColDropDown"))){this._getPointerExtension().doReorderColumn(o.columnIndex,e);}}if((D.browser.firefox&&!!(e.metaKey||e.ctrlKey))||t.closest(".sapUiTableHSb",this.getDomRef()).length===1||t.closest(".sapUiTableVSb",this.getDomRef()).length===1){e.preventDefault();}}if(e.button===2){if(E._skipClick(e,t,o)){p._bShowDefaultMenu=true;return;}if(o.isOfType(a.CELLTYPE.COLUMNHEADER)){f=this.getColumns()[o.columnIndex];m=f.getAggregation("menu");M=m&&m.bOpen;if(!M){p._bShowMenu=true;}else{p._bHideMenu=true;}}else if(o.isOfType(a.CELLTYPE.ANYCONTENTCELL)){if(a.Menu.hasContextMenu(this)){p._bShowMenu=true;}else{M=this._oCellContextMenu&&this._oCellContextMenu.bOpen;var g=M&&this._oCellContextMenu.oOpenerRef!==$[0];if(!M||g){p._bShowMenu=true;}else{p._bHideMenu=true;}}}else{p._bShowDefaultMenu=true;}}},onmouseup:function(e){clearTimeout(this._mTimeouts.delayedColumnReorderTimerId);},ondblclick:function(e){if(D.system.desktop&&e.target===this.getDomRef("rsz")){e.preventDefault();C.doAutoResizeColumn(this,this._iLastHoveredColumnIndex);}},onclick:function(e){clearTimeout(this._mTimeouts.delayedColumnReorderTimerId);if(e.isMarked()){return;}var t=q(e.target);if(t.hasClass("sapUiAnalyticalTableSum")){e.preventDefault();return;}else if(t.hasClass("sapUiTableGroupMenuButton")){this.oncontextmenu(e);return;}else if(t.hasClass("sapUiTableGroupIcon")||t.hasClass("sapUiTableTreeIcon")){if(a.Grouping.toggleGroupHeaderByRef(this,e.target)){return;}}var $=a.getCell(this,e.target);var o=a.getCellInfo($);if(o.isOfType(a.CELLTYPE.COLUMNHEADER)){var p=this._getPointerExtension();if(p._bShowMenu){a.Menu.openContextMenu(this,e.target,false);delete p._bShowMenu;}}else{if(E._skipClick(e,t,o)){return;}if(!this._findAndfireCellEvent(this.fireCellClick,e)){if(o.isOfType(a.CELLTYPE.COLUMNROWHEADER)){this._getSelectionPlugin().onHeaderSelectorPress();}else{E._handleClickSelection(e,$,this);}}else{e.preventDefault();}}},oncontextmenu:function(e){var p=this._getPointerExtension();if(p._bShowDefaultMenu){e.setMarked("handledByPointerExtension");delete p._bShowDefaultMenu;}else if(p._bShowMenu){e.setMarked("handledByPointerExtension");e.preventDefault();a.Menu.openContextMenu(this,e.target,false,null,e);delete p._bShowMenu;}else if(p._bHideMenu){e.setMarked("handledByPointerExtension");e.preventDefault();delete p._bHideMenu;}}};
var d=T.extend("sap.ui.table.TablePointerExtension",{
_init:function(t,s,m){this._delegate=c;a.addDelegate(t,this._delegate,t);t._iLastHoveredColumnIndex=0;t._bIsColumnResizerMoving=false;t._iFirstReorderableIndex=s==T.TABLETYPES.TREE?1:0;return"PointerExtension";},
_attachEvents:function(){var t=this.getTable();if(t){C.initColumnTracking(t);b.initRowHovering(t);}},
_detachEvents:function(){var t=this.getTable();if(t){var $=t.$();$.find(".sapUiTableCtrlScr, .sapUiTableCtrlScrFixed").unbind();$.find(".sapUiTableCtrl > tbody > tr").unbind();$.find(".sapUiTableRowSelectionCell").unbind();}},
_debug:function(){this._ExtensionHelper=E;this._ColumnResizeHelper=C;this._ReorderHelper=R;this._ExtensionDelegate=c;this._RowHoverHandler=b;this._KNOWNCLICKABLECONTROLS=K;},
doAutoResizeColumn:function(i){var t=this.getTable();if(t){C.doAutoResizeColumn(t,i);}},
doReorderColumn:function(i,e){var t=this.getTable();if(t&&a.Column.isColumnMovable(t.getColumns()[i])){t._mTimeouts.delayedColumnReorderTimerId=setTimeout(function(){R.initReordering(this,i,e);}.bind(t),200);}},
destroy:function(){var t=this.getTable();if(t){t.removeEventDelegate(this._delegate);}this._delegate=null;T.prototype.destroy.apply(this,arguments);}
});
return d;});
sap.ui.predefine('sap/ui/table/TableRenderer',['sap/ui/core/Control','sap/ui/core/theming/Parameters','sap/ui/Device','./library',"./Column",'./TableUtils',"./TableExtension",'sap/ui/core/Renderer','sap/ui/core/IconPool',"sap/base/Log"],function(C,P,D,a,b,T,c,R,I,L){"use strict";var V=a.VisibleRowCountMode;var S=a.SortOrder;var f={Begin:"flex-start",End:"flex-end",Left:undefined,Right:undefined,Center:"center"};var d={apiVersion:2};
d.render=function(r,t){delete t._iHeaderRowCount;f.Left=t._bRtlMode?"flex-end":"flex-start";f.Right=t._bRtlMode?"flex-start":"flex-end";T.getResourceBundle();r.openStart("div",t);t._getAccRenderExtension().writeAriaAttributesFor(r,t,"ROOT");r.class("sapUiTable");if(D.browser.chrome&&window.devicePixelRatio<1){r.class("sapUiTableZoomout");}if('ontouchstart'in document){r.class("sapUiTableTouch");}r.class("sapUiTableSelMode"+t.getSelectionMode());if(t.getColumnHeaderVisible()){r.class("sapUiTableCHdr");}if(T.hasRowHeader(t)){r.class("sapUiTableRowSelectors");}if(T.hasRowHighlights(t)){r.class("sapUiTableRowHighlights");}var s=a.TableHelper.addTableClass();if(s){r.class(s);}var o=t._getScrollExtension();if(o.isVerticalScrollbarRequired()&&!o.isVerticalScrollbarExternal()){r.class("sapUiTableVScr");}if(t.getEditable()){r.class("sapUiTableEdt");}if(T.hasRowActions(t)){var i=T.getRowActionCount(t);r.class(i==1?"sapUiTableRActS":"sapUiTableRAct");}if(T.isNoDataVisible(t)&&!T.hasPendingRequests(t)){r.class("sapUiTableEmpty");}if(t.getShowOverlay()){r.class("sapUiTableOverlay");}var m=T.Grouping.getModeCssClass(t);if(m){r.class(m);}r.style("width",t.getWidth());t._getRowMode().applyTableStyles(r);if(t._bFirstRendering){r.class("sapUiTableNoOpacity");}r.openEnd();this.renderTabElement(r,"sapUiTableOuterBefore");if(t.getTitle()){this.renderHeader(r,t,t.getTitle());}if(t.getToolbar()){this.renderToolbar(r,t,t.getToolbar());}if(t.getExtension()&&t.getExtension().length>0){this.renderExtensions(r,t,t.getExtension());}r.openStart("div",t.getId()+"-sapUiTableCnt");r.class("sapUiTableCnt");r.attr("data-sap-ui-fastnavgroup","true");r.openEnd();r.openStart("div",t.getId()+"-sapUiTableGridCnt");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"CONTENT");r.openEnd();this.renderColRsz(r,t);this.renderColHdr(r,t);this.renderTable(r,t);r.close("div");var e=t.getCreationRow();if(e){r.renderControl(e);this.renderHSbBackground(r,t);this.renderHSb(r,t);}t._getAccRenderExtension().writeHiddenAccTexts(r,t);r.openStart("div",t.getId()+"-overlay");r.class("sapUiTableOverlayArea");r.attr("tabindex","0");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"OVERLAY");r.openEnd();r.close("div");r.close("div");if(t.getFooter()){this.renderFooter(r,t,t.getFooter());}if(t.getVisibleRowCountMode()==V.Interactive){this.renderVariableHeight(r,t);}this.renderBottomPlaceholder(r,t);this.renderTabElement(r,"sapUiTableOuterAfter");r.close("div");};
d.renderHeader=function(r,t,o){r.openStart("div");r.class("sapUiTableHdr");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"TABLEHEADER");r.openEnd();r.renderControl(o);r.close("div");};
d.renderToolbar=function(r,t,o){if(!T.isA(o,"sap.ui.core.Toolbar")){return;}r.openStart("div");r.class("sapUiTableTbr");if(typeof o.getStandalone==="function"&&o.getStandalone()){o.setStandalone(false);}if(o.isA("sap.m.Toolbar")){o.setDesign("Transparent",true);o.addStyleClass("sapMTBHeader-CTX");r.class("sapUiTableMTbr");}t._getAccRenderExtension().writeAriaAttributesFor(r,t,"TABLESUBHEADER");r.openEnd();r.renderControl(o);r.close("div");};
d.renderExtensions=function(r,t,e){for(var i=0,l=e.length;i<l;i++){this.renderExtension(r,t,e[i]);}};
d.renderExtension=function(r,t,e){r.openStart("div");r.class("sapUiTableExt");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"TABLESUBHEADER");r.openEnd();r.renderControl(e);r.close("div");};
d.renderTable=function(r,t){this.renderTabElement(r,"sapUiTableCtrlBefore");r.openStart("div",t.getId()+"-tableCCnt");t._getRowMode().applyRowContainerStyles(r);r.class("sapUiTableCCnt");r.openEnd();this.renderTableCCnt(r,t);r.close("div");this.renderTabElement(r,"sapUiTableCtrlAfter");if(!t._getScrollExtension().isVerticalScrollbarExternal()){this.renderVSbBackground(r,t);this.renderVSb(r,t);}var o=t.getCreationRow();if(!o){this.renderHSbBackground(r,t);this.renderHSb(r,t);}};
d.renderTableCCnt=function(r,t){this.renderTableCtrl(r,t);this.renderRowHdr(r,t);this.renderRowActions(r,t);r.openStart("div",t.getId()+"-noDataCnt");r.class("sapUiTableCtrlEmpty");r.attr("tabindex","0");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"NODATA");r.openEnd();if(t.getNoData()instanceof C){r.renderControl(t.getNoData());}else{r.openStart("span",t.getId()+"-noDataMsg");r.class("sapUiTableCtrlEmptyMsg");r.openEnd();r.text(T.getNoDataText(t));r.close("span");}r.close("div");};
d.renderFooter=function(r,t,F){r.openStart("div");r.class("sapUiTableFtr");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"TABLEFOOTER");r.openEnd();r.renderControl(F);r.close("div");};
d.renderVariableHeight=function(r,t){r.openStart("div",t.getId()+"-sb");r.attr("tabindex","-1");r.class("sapUiTableHeightResizer");r.style("height","5px");r.openEnd();r.close("div");};
d.renderBottomPlaceholder=function(r,t){var p=t._getRowMode().getTableBottomPlaceholderStyles();if(p===undefined){return;}r.openStart("div",t.getId()+"-placeholder-bottom");r.class("sapUiTablePlaceholder");t._getRowMode().applyTableBottomPlaceholderStyles(r);r.openEnd();r.close("div");};
d.renderColHdr=function(r,t){var n=T.getHeaderRowCount(t);var e=t.getColumns();var F=t.getComputedFixedColumnCount();r.openStart("div");r.class("sapUiTableColHdrCnt");r.openEnd();this.renderColRowHdr(r,t);if(F>0){r.openStart("div");r.class("sapUiTableCHA");r.class("sapUiTableCtrlScrFixed");r.class("sapUiTableNoOpacity");r.openEnd();this.renderTableControlCnt(r,t,true,0,F,true,false,0,n,true);r.close("div");}r.openStart("div",t.getId()+"-sapUiTableColHdrScr");r.class("sapUiTableCHA");r.class("sapUiTableCtrlScr");if(e.length==0){r.class("sapUiTableHasNoColumns");}if(F>0){if(t._bRtlMode){r.style("margin-right","0");}else{r.style("margin-left","0");}}r.openEnd();this.renderTableControlCnt(r,t,false,F,e.length,false,false,0,n,true);r.close("div");if(T.hasRowActions(t)){r.openStart("div");r.attr("id",t.getId()+"-rowacthdr");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"ROWACTIONHEADER");r.class("sapUiTableCell");r.class("sapUiTableHeaderCell");r.class("sapUiTableRowActionHeaderCell");r.openEnd();r.openStart("span");r.openEnd();r.text(T.getResourceText("TBL_ROW_ACTION_COLUMN_LABEL"));r.close("span");r.close("div");}r.close("div");};
d.renderColRowHdr=function(r,t){var e=false;var s=false;var m=t._getSelectionPlugin().getRenderConfig();r.openStart("div",t.getId()+"-selall");r.class("sapUiTableCell");r.class("sapUiTableHeaderCell");r.class("sapUiTableRowSelectionHeaderCell");var g;if(m.headerSelector.visible){var A=T.areAllRowsSelected(t);if(m.headerSelector.type==="toggle"){g=A?"TBL_DESELECT_ALL":"TBL_SELECT_ALL";}else if(m.headerSelector.type==="clear"){g="TBL_DESELECT_ALL";if(!m.headerSelector.enabled){r.attr("disabled","true");r.attr("aria-disabled","true");}}if(t._getShowStandardTooltips()&&g){r.attr("title",T.getResourceText(g));}if(!A){r.class("sapUiTableSelAll");}else{s=true;}r.class("sapUiTableSelAllEnabled");e=true;}else{r.class("sapUiTableSelAllDisabled");}r.attr("tabindex","-1");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"COLUMNROWHEADER",{enabled:e,checked:s});r.openEnd();if(m.headerSelector.visible){if(m.headerSelector.type==="clear"&&m.headerSelector.icon){r.renderControl(m.headerSelector.icon);}else{r.openStart("div");r.class("sapUiTableSelectAllCheckBox");r.openEnd();r.close("div");}}r.close("div");};
d.renderCol=function(r,t,o,h,n,i,e,g,j){var l,k=!n,m=o.getIndex(),p=o.getMultiLabels();if(p.length>0){l=p[h];}else if(h==0){l=o.getLabel();}var H=o.getId();if(h===0){r.openStart("td",o);}else{H=H+"_"+h;r.openStart("td",H);}r.attr('data-sap-ui-colid',o.getId());r.attr("data-sap-ui-colindex",m);r.attr("tabindex","-1");var A={column:o,headerId:H,index:m};if(n>1){r.attr("colspan",n);A.colspan=true;}if(j){var F=o.getFiltered();var s=o.getSorted();if(F){r.class("sapUiTableColFiltered");}if(s){r.class("sapUiTableColSorted");if(o.getSortOrder()===S.Descending){r.class("sapUiTableColSortedD");}}}t._getAccRenderExtension().writeAriaAttributesFor(r,t,"COLUMNHEADER",A);r.class("sapUiTableCell");r.class("sapUiTableHeaderCell");r.class("sapUiTableHeaderDataCell");if(t.getEnableColumnReordering()||t.hasListeners("columnSelect")||o._menuHasItems()){r.class("sapUiTableHeaderCellActive");}if(i){r.class("sapUiTableCellFirst");}if(e){r.class("sapUiTableCellLastFixed");}if(g){r.class("sapUiTableCellLast");}if(k){r.class("sapUiTableHidden");}if(t.getColumnHeaderHeight()>0){r.style("height",t.getColumnHeaderHeight()+"px");}var q=o.getTooltip_AsString();if(q){r.attr("title",q);}r.openEnd();r.openStart("div");r.class("sapUiTableCellInner");r.attr("id",H+"-inner");var u=o.getHAlign();var v=R.getTextAlign(u);if(v){r.style("text-align",v);}r.openEnd();r.openStart("div");r.style("justify-content",f[u]);r.openEnd();if(l){r.renderControl(l);}r.close("div");r.close("div");r.close("td");};
d.renderColRsz=function(r,t){r.openStart("div",t.getId()+"-rsz");r.class("sapUiTableColRsz");r.openEnd();r.close("div");};
d.renderRowHdr=function(r,t){r.openStart("div",t.getId()+"-sapUiTableRowHdrScr");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"PRESENTATION");r.class("sapUiTableRowHdrScr");r.class("sapUiTableNoOpacity");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"ROWHEADER_COL");r.openEnd();for(var e=0,g=t.getRows().length;e<g;e++){this.renderRowAddon(r,t,t.getRows()[e],e,true);}r.close("div");};
d.renderRowActions=function(r,t){if(!T.hasRowActions(t)){return;}r.openStart("div",t.getId()+"-sapUiTableRowActionScr");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"PRESENTATION");r.class("sapUiTableRowActionScr");r.class("sapUiTableNoOpacity");r.openEnd();for(var e=0,g=t.getRows().length;e<g;e++){this.renderRowAddon(r,t,t.getRows()[e],e,false);}r.close("div");};
d.addRowCSSClasses=function(r,t,i){var m=t._getRowCounts();var F=T.getFirstFixedBottomRowIndex(t);if(i===0){r.class("sapUiTableFirstRow");}else if(i===t.getRows().length-1){r.class("sapUiTableLastRow");}if(m.fixedTop>0){if(i==m.fixedTop-1){r.class("sapUiTableRowLastFixedTop");}if(i==m.fixedTop){r.class("sapUiTableRowFirstScrollable");}}if(F>=0&&F===i){r.class("sapUiTableRowFirstFixedBottom");}else if(F>=1&&F-1===i){r.class("sapUiTableRowLastScrollable");}};
d.renderRowAddon=function(r,t,o,i,h){var e=t._getSelectionPlugin().isIndexSelected(o.getIndex());r.openStart("div");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"TR",{index:i,rowHidden:o._bHidden});r.attr("data-sap-ui-related",o.getId());r.attr("data-sap-ui-rowindex",i);r.class("sapUiTableRow");r.class("sapUiTableContentRow");if(o._bHidden){r.class("sapUiTableRowHidden");}else if(e){r.class("sapUiTableRowSel");}if(i%2!=0&&t.getAlternateRowColors()&&!T.Grouping.isTreeMode(t)){r.class("sapUiTableRowAlternate");}this.addRowCSSClasses(r,t,i);r.openEnd();r.openStart("div",t.getId()+(h?"-rowsel":"-rowact")+i);r.class("sapUiTableCell");r.class("sapUiTableContentCell");r.class(h?"sapUiTableRowSelectionCell":"sapUiTableRowActionCell");t._getRowMode().renderRowStyles(r);r.attr("tabindex","-1");t._getAccRenderExtension().writeAriaAttributesFor(r,t,h?"ROWHEADER":"ROWACTION",{rowSelected:e,rowHidden:o._bHidden});r.openEnd();if(h){this.writeRowHighlightContent(r,t,o,i);this.writeRowSelectorContent(r,t,o,i);}else{var A=o.getRowAction();if(A){r.renderControl(A);this.writeRowNavigatedContent(r,t,o,i);}}r.close("div");r.close("div");};
d.renderTableCtrl=function(r,t){if(t.getComputedFixedColumnCount()>0){r.openStart("div");r.attr("id",t.getId()+"-sapUiTableCtrlScrFixed");r.class("sapUiTableCtrlScrFixed");r.openEnd();this.renderTableControl(r,t,true);r.close("div");}r.openStart("div",t.getId()+"-sapUiTableCtrlScr");r.class("sapUiTableCtrlScr");if(t.getComputedFixedColumnCount()>0){if(t._bRtlMode){r.style("margin-right","0");}else{r.style("margin-left","0");}}r.openEnd();r.openStart("div",t.getId()+"-tableCtrlCnt");r.class("sapUiTableCtrlCnt");r.openEnd();this.renderTableControl(r,t,false);r.close("div");r.close("div");};
d.renderTableControl=function(r,t,F){var s,e;if(F){s=0;e=t.getComputedFixedColumnCount();}else{s=t.getComputedFixedColumnCount();e=t.getColumns().length;}var m=t._getRowCounts();var g=t.getRows();if(m.fixedTop>0){this.renderTableControlCnt(r,t,F,s,e,true,false,0,m.fixedTop);}this.renderTableControlCnt(r,t,F,s,e,false,false,m.fixedTop,g.length-m.fixedBottom);if(m.fixedBottom>0&&g.length>0){this.renderTableControlCnt(r,t,F,s,e,false,true,g.length-m.fixedBottom,g.length);}};
d.renderTableControlCnt=function(r,t,F,s,e,g,h,i,E,H){var j=H?"-header":"-table";var k=t.getId()+j;var l=[];if(F){k+="-fixed";l.push("sapUiTableCtrlFixed");}else{l.push("sapUiTableCtrlScroll");}if(g){k+="-fixrow";l.push("sapUiTableCtrlRowFixed");}else if(h){k+="-fixrow-bottom";l.push("sapUiTableCtrlRowFixedBottom");}else{l.push("sapUiTableCtrlRowScroll");}r.openStart("table",k);l.forEach(function(J){r.class(J);});t._getAccRenderExtension().writeAriaAttributesFor(r,t,H?"COLUMNHEADER_TABLE":"TABLE");r.class("sapUiTableCtrl");if(H){r.class("sapUiTableCHT");}r.style(F?"width":"min-width",t._getColumnsWidth(s,e)+"px");r.openEnd();r.openStart("thead").openEnd();r.openStart("tr");r.class("sapUiTableCtrlCol");if(i==0){r.class("sapUiTableCtrlFirstCol");}if(H){r.class("sapUiTableCHTHR");}r.openEnd();var m=t.getColumns();var n=new Array(e);var o;var p;var q=!F&&e>s;for(o=s;o<e;o++){p=m[o];var u={shouldRender:!!(p&&p.shouldRender())};if(u.shouldRender){var w=p.getWidth();if(T.isVariableWidth(w)){q=false;if(F){p._iFixWidth=p._iFixWidth||160;w=p._iFixWidth+"px";}}else if(F){delete p._iFixWidth;}u.width=w;}n[o]=u;}if(m.length===0){r.openStart("th").openEnd().close("th");}for(o=s;o<e;o++){j=H?"_hdr":"_col";p=m[o];u=n[o];if(u.shouldRender){if(i==0){r.openStart("th",t.getId()+j+o);t._getAccRenderExtension().writeAriaAttributesFor(r,t,"TH",{column:p});}else{r.openStart("th");}r.style("width",u.width);r.attr("data-sap-ui-headcolindex",o);r.attr("data-sap-ui-colid",p.getId());r.openEnd();if(i==0&&T.getHeaderRowCount(t)==0&&!H){if(p.getMultiLabels().length>0){r.renderControl(p.getMultiLabels()[0]);}else{r.renderControl(p.getLabel());}}r.close("th");}}if(q){r.openStart("th",H&&t.getId()+"-dummycolhdr");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"PRESENTATION");r.openEnd().close("th");}r.close("tr");r.close("thead");r.openStart("tbody").openEnd();var v=t._getVisibleColumns();var x=t.getRows();var y;var z;if(H){for(y=i,z=E;y<z;y++){this.renderColumnHeaderRow(r,t,y,F,s,e,q,y===z-1);}}else{var A=t._getAccExtension().getAriaTextsForSelectionMode(true);var B=T.isRowSelectionAllowed(t);var G=t.getDragDropConfig().some(function(J){return J.getMetadata().isInstanceOf("sap.ui.core.dnd.IDragInfo")&&J.getSourceAggregation()==="rows";});for(y=i,z=E;y<z;y++){this.renderTableRow(r,t,x[y],y,F,s,e,false,v,q,A,B,G);}}r.close("tbody");r.close("table");};
d.writeRowSelectorContent=function(r,t,o,i){t._getAccRenderExtension().writeAccRowSelectorText(r,t,o,i);if(T.Grouping.isGroupMode(t)){r.openStart("div");r.class("sapUiTableGroupShield");r.openEnd();r.close("div");r.openStart("div",o.getId()+"-groupHeader");r.class("sapUiTableGroupIcon");r.openEnd();r.close("div");if(T.Grouping.showGroupMenuButton(t)){var e=I.getIconInfo("sap-icon://drop-down-list");r.openStart("div").class("sapUiTableGroupMenuButton").openEnd();r.text(e.content);r.close("div");}}};
d.writeRowHighlightContent=function(r,t,o,i){if(!T.hasRowHighlights(t)){return;}var e=o.getAggregation("_settings");var h=e._getHighlightCSSClassName();r.openStart("div",o.getId()+"-highlight");r.class("sapUiTableRowHighlight");r.class(h);r.openEnd();t._getAccRenderExtension().writeAccRowHighlightText(r,t,o,i);r.close("div");};
d.writeRowNavigatedContent=function(r,t,o,i){if(!T.hasRowNavigatedIndicators(t)){return;}var e=o.getAggregation("_settings");r.openStart("div",o.getId()+"-navIndicator");if(e.getNavigated()){r.class("sapUiTableRowNavigated");}r.openEnd();r.close("div");};
d.renderColumnHeaderRow=function(r,t,i,F,s,e,h,l){r.openStart("tr");r.class("sapUiTableRow");r.class("sapUiTableHeaderRow");r.class("sapUiTableColHdrTr");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"COLUMNHEADER_ROW");r.openEnd();var g,n=0,j=-1;g=t.getColumns().slice(s,e).filter(function(o){return o&&o.shouldRender();});function k(o,p,q){var u=T.Column.getHeaderSpan(o,i),v;if(n<1){if(u>1){v=o.getIndex();u=q.slice(p+1,p+u).reduce(function(w,x){return x.getIndex()-v<u?w+1:w;},1);}o._nSpan=n=u;j=p;}else{o._nSpan=0;}n--;}g.forEach(k);function m(o,p){this.renderCol(r,t,o,i,o._nSpan,p===0,F&&(p==j),!F&&(p==j),o._nSpan===1&&!o._bIconsRendered);o._bIconsRendered=o._bIconsRendered||o._nSpan===1;delete o._nSpan;if(l){delete o._bIconsRendered;}}g.forEach(m.bind(this));if(!F&&h&&g.length>0){r.openStart("td").class("sapUiTableCellDummy");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"PRESENTATION");r.openEnd().close("td");}r.close("tr");};
d.renderTableRow=function(r,t,o,i,F,s,e,g,v,h,m,j,k){if(!o){return;}var l=t._getSelectionPlugin();if(F){r.openStart("tr",o.getId()+"-fixed");r.attr("data-sap-ui-related",o.getId());}else{r.openStart("tr",o);}if(o._bDummyRow){r.style("opacity","0");}r.class("sapUiTableRow");r.class("sapUiTableContentRow");r.class("sapUiTableTr");if(o._bHidden){r.class("sapUiTableRowHidden");}else{if(k&&F){r.attr("draggable",true);}if(l.isIndexSelected(o.getIndex())){r.class("sapUiTableRowSel");}}if(i%2!=0&&t.getAlternateRowColors()&&!T.Grouping.isTreeMode(t)){r.class("sapUiTableRowAlternate");}this.addRowCSSClasses(r,t,i);r.attr("data-sap-ui-rowindex",i);t._getRowMode().renderRowStyles(r);t._getAccRenderExtension().writeAriaAttributesFor(r,t,"TR",{index:i,rowHidden:o._bHidden});r.openEnd();var n=!o._bHidden&&l.isIndexSelected(o.getIndex());var p=o.getCells();for(var q=0,u=p.length;q<u;q++){this.renderTableCell(r,t,o,p[q],q,F,s,e,v,n);}if(!F&&h&&p.length>0){r.openStart("td").class("sapUiTableCellDummy");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"PRESENTATION");r.openEnd();r.close("td");}r.close("tr");};
d.renderTableCell=function(r,t,o,e,i,F,s,E,v,g){var h=b.ofCell(e);var j=h.getIndex();var l=t.getColumns()[t.getFixedColumnCount()-1];if(h.shouldRender()&&s<=j&&E>j){var k=o.getId()+"-col"+i;r.openStart("td",k);r.attr("tabindex","-1");r.attr("data-sap-ui-colid",h.getId());var n=v.length;var m=n>0&&v[0]===h;var p=n>0&&v[n-1]===h;var q=F&l===h;t._getAccRenderExtension().writeAriaAttributesFor(r,t,"DATACELL",{index:j,column:h,row:o,fixed:F,rowSelected:g});var u=R.getTextAlign(h.getHAlign());if(u){r.style("text-align",u);}r.class("sapUiTableCell");r.class("sapUiTableContentCell");r.class("sapUiTableDataCell");if(m){r.class("sapUiTableCellFirst");}if(q){r.class("sapUiTableCellLastFixed");}if(p){r.class("sapUiTableCellLast");}var B=t.getBinding("rows");if(B&&h.getLeadingProperty&&B.isMeasure(h.getLeadingProperty())){r.class("sapUiTableMeasureCell");}r.openEnd();r.openStart("div");r.class("sapUiTableCellInner");if(m&&T.Grouping.isTreeMode(t)){r.class("sapUiTableCellFlex");}t._getRowMode().renderCellContentStyles(r);r.openEnd();this.renderTableCellControl(r,t,e,m);r.close("div");r.close("td");}};
d.renderTableCellControl=function(r,t,o,i){if(i&&T.Grouping.isTreeMode(t)&&!t._bFlatMode){var e=o.getParent();r.openStart("span",e.getId()+"-treeicon");r.class("sapUiTableTreeIcon");r.attr("tabindex","-1");t._getAccRenderExtension().writeAriaAttributesFor(r,t,"TREEICON",{row:e});r.openEnd();r.close("span");}r.renderControl(o);};
d.renderVSb=function(r,t,m){m=Object.assign({cssClass:"sapUiTableVSb",tabIndex:true,hidden:true},m);m.id=t.getId()+"-vsb";var s=t._getScrollExtension();r.openStart("div",m.id);r.class(m.cssClass);if(m.hidden){r.class("sapUiTableHidden");}if(m.tabIndex){r.attr("tabindex","-1");}r.style("max-height",s.getVerticalScrollbarHeight()+"px");var e=t._getRowCounts();if(e.fixedTop>0){t._iVsbTop=e.fixedTop*t._getBaseRowHeight()-1;r.style("top",t._iVsbTop+'px');}r.openEnd();r.openStart("div",m.id+"-content");r.class("sapUiTableVSbContent");r.style("height",s.getVerticalScrollHeight()+"px");r.openEnd();r.close("div");r.close("div");};
d.renderVSbExternal=function(r,t){if(c.isEnrichedWith(t,"sap.ui.table.TableSyncExtension")){this.renderVSb(r,t,{cssClass:"sapUiTableVSbExternal",tabIndex:false});}else{L.error("This method can only be used with synchronization enabled.",t,"TableRenderer.renderVSbExternal");}};
d.renderVSbBackground=function(r,t){r.openStart("div",t.getId()+"-vsb-bg");r.class("sapUiTableVSbBg");r.openEnd().close("div");};
d.renderHSb=function(r,t,m){m=Object.assign({id:t.getId()+"-hsb",cssClass:"sapUiTableHSb",tabIndex:true,hidden:true,scrollWidth:0},m);r.openStart("div",m.id);r.class(m.cssClass);if(m.hidden){r.class("sapUiTableHidden");}if(m.tabIndex){r.attr("tabindex","-1");}r.openEnd();r.openStart("div",m.id+"-content");r.class("sapUiTableHSbContent");if(m.scrollWidth>0){r.style("width",m.scrollWidth+"px");}r.openEnd();r.close("div");r.close("div");};
d.renderHSbExternal=function(r,t,i,s){if(c.isEnrichedWith(t,"sap.ui.table.TableSyncExtension")){this.renderHSb(r,t,{id:i,cssClass:"sapUiTableHSbExternal",tabIndex:false,hidden:false,scrollWidth:s});}else{L.error("This method can only be used with synchronization enabled.",t,"TableRenderer.renderVSbExternal");}};
d.renderHSbBackground=function(r,t){r.openStart("div",t.getId()+"-hsb-bg");r.class("sapUiTableHSbBg");r.openEnd().close("div");};
d.renderTabElement=function(r,s){r.openStart("div");if(s){r.class(s);}r.attr("tabindex","0");r.openEnd().close("div");};
return d;},true);
sap.ui.predefine('sap/ui/table/TableScrollExtension',["./TableExtension","./TableUtils","sap/ui/Device","./library","sap/ui/performance/trace/Interaction","sap/base/Log","sap/ui/thirdparty/jquery"],function(T,c,D,l,I,L,q){"use strict";var S=l.SharedDomRef;var M=1000000;var V=2;var d={HORIZONAL:"HORIZONTAL",VERTICAL:"VERTICAL",BOTH:"BOTH"};var e={SCROLLBAR:"Scrollbar",KEYBOARD:"Keyboard",MOUSEWHEEL:"MouseWheel",TOUCH:"Touch",FOCUS:"Focus",EXTENSION:"Extension",TABLE:"Table"};
function f(s,t){L.debug("sap.ui.table.TableScrollExtension",s,t);}
function g(o){return typeof o.isConnected==="boolean"&&o.isConnected||document.body.contains(o);}
var h=new window.WeakMap();var j=function(t){if(!t){return{};}if(!h.has(t)){h.set(t,{oHorizontalScrollbar:null,iHorizontalScrollPosition:null,bVerticalScrollingSuspended:false,oVerticalScrollbar:null,oExternalVerticalScrollbar:null,nVerticalScrollPosition:null,iVerticalScrollHeight:null,iVerticalScrollbarHeight:null,iFirstVisibleRowInBuffer:null,bIsScrolledVerticallyByWheel:false,bIsScrolledVerticallyByKeyboard:false,mTouchSessionData:null,bIsVerticalScrollbarExternal:false,fnOnRowsUpdatedPreprocessor:null});}return h.get(t);};
j.destroy=function(t){delete h.delete(t);};
var H={onScroll:function(o){var N=o.target.scrollLeft;var O=o.target._scrollLeft;I.notifyScrollEvent&&I.notifyScrollEvent(o);if(N!==O){var s=H.getScrollAreas(this);o.target._scrollLeft=N;for(var i=0;i<s.length;i++){var a=s[i];if(a!==o.target&&a.scrollLeft!==N){a.scrollLeft=N;a._scrollLeft=N;}}j(this).iHorizontalScrollPosition=N;}},restoreScrollPosition:function(t){var s=t._getScrollExtension();var o=s.getHorizontalScrollbar();if(o&&j(t).iHorizontalScrollPosition!==null){var a=H.getScrollAreas(t);for(var i=0;i<a.length;i++){var b=a[i];delete b._scrollLeft;}if(o.scrollLeft!==j(t).iHorizontalScrollPosition){o.scrollLeft=j(t).iHorizontalScrollPosition;}else{var p=q.Event("scroll");p.target=o;H.onScroll.call(t,p);}}},onScrollbarMouseDown:function(o){this._getKeyboardExtension().setActionMode(false);},addEventListeners:function(t){var s=t._getScrollExtension();var o=s.getHorizontalScrollbar();var a=H.getScrollAreas(t);if(!s._onHorizontalScrollEventHandler){s._onHorizontalScrollEventHandler=H.onScroll.bind(t);}for(var i=0;i<a.length;i++){a[i].addEventListener("scroll",s._onHorizontalScrollEventHandler);}if(o){if(!s._onHorizontalScrollbarMouseDownEventHandler){s._onHorizontalScrollbarMouseDownEventHandler=H.onScrollbarMouseDown.bind(t);}o.addEventListener("mousedown",s._onHorizontalScrollbarMouseDownEventHandler);}},removeEventListeners:function(t){var s=t._getScrollExtension();var o=s.getHorizontalScrollbar();var a=H.getScrollAreas(t);if(s._onHorizontalScrollEventHandler){for(var i=0;i<a.length;i++){a[i].removeEventListener("scroll",s._onHorizontalScrollEventHandler);delete a[i]._scrollLeft;}delete s._onHorizontalScrollEventHandler;}if(o&&s._onHorizontalScrollbarMouseDownEventHandler){o.removeEventListener("mousedown",s._onHorizontalScrollbarMouseDownEventHandler);delete s._onHorizontalScrollbarMouseDownEventHandler;}},getScrollAreas:function(t){var o=t.getDomRef();var s;if(o){s=Array.prototype.slice.call(t.getDomRef().querySelectorAll(".sapUiTableCtrlScr"));}var a=[t._getScrollExtension().getHorizontalScrollbar()].concat(s);return a.filter(function(b){return b!=null;});}};var k={updateScrollPosition:function(t,a,s,p){s=s==null?e.EXTENSION:s;var o=t?t._getScrollExtension():null;var v=o?o.getVerticalScrollbar(true):null;if(!t||!v||!o.isVerticalScrollbarRequired()||j(t).bVerticalScrollingSuspended){f("VerticalScrollingHelper#updateScrollPosition: Not executed - Guard clause not passed",t);return;}var b=j(t).nVerticalScrollPosition;var i=k.getScrollRange(t);if(a==null){var F=t.getFirstVisibleRow();var r=t._getMaxFirstRenderedRowIndex();if(F>r){a=i;j(t).iFirstVisibleRowInBuffer=F-r;}else{a=F*k.getScrollRangeRowFraction(t);j(t).iFirstVisibleRowInBuffer=null;}}else{j(t).iFirstVisibleRowInBuffer=null;}j(t).nVerticalScrollPosition=Math.min(Math.max(0,a),i);f("VerticalScrollingHelper#updateScrollPosition: From "+b+" to "+j(t).nVerticalScrollPosition+" (diff: "+(j(t).nVerticalScrollPosition-b)+", trigger: "+s+")",t);if(p===true){f("VerticalScrollingHelper#updateScrollPosition: Scrolling prevented",t);return;}if(!g(v)){f("VerticalScrollingHelper#updateScrollPosition: Scrollbar is not connected with the DOM",t);return;}window.cancelAnimationFrame(t._mAnimationFrames.verticalScrollUpdate);delete t._mAnimationFrames.verticalScrollUpdate;switch(s){case e.SCROLLBAR:clearTimeout(t._mTimeouts.largeDataScrolling);delete t._mTimeouts.largeDataScrolling;if(t._bLargeDataScrolling&&!j(t).bIsScrolledVerticallyByWheel){t._mTimeouts.largeDataScrolling=setTimeout(function(){delete t._mTimeouts.largeDataScrolling;k.updateFirstVisibleRow(t);},300);}else{k.updateFirstVisibleRow(t);}break;case e.KEYBOARD:case e.MOUSEWHEEL:case e.TOUCH:case e.EXTENSION:case e.TABLE:var N=0;var u=k.getScrollRange(t);if(j(t).nVerticalScrollPosition>0&&j(t).nVerticalScrollPosition<0.5){N=1;}else if(j(t).nVerticalScrollPosition>=u-0.5&&j(t).nVerticalScrollPosition<u){N=u-1;}else{N=Math.round(j(t).nVerticalScrollPosition);}if(v.scrollTop!==N){f("VerticalScrollingHelper#updateScrollPosition: scrollTop will be set asynchronously",t);t._mAnimationFrames.verticalScrollUpdate=window.requestAnimationFrame(function(){var w=v.scrollTop;delete t._mAnimationFrames.verticalScrollUpdate;f("VerticalScrollingHelper#updateScrollPosition: (async) Set scrollTop from "+w+" to "+N,t);v.scrollTop=N;v._scrollTop=v.scrollTop;k.updateFirstVisibleRow(t);});}else if(j(t).nVerticalScrollPosition!==b){f("VerticalScrollingHelper#updateScrollPosition: firstVisibleRow will be set asynchronously",t);t._mAnimationFrames.verticalScrollUpdate=window.requestAnimationFrame(function(){delete t._mAnimationFrames.verticalScrollUpdate;k.updateFirstVisibleRow(t);});}else{f("VerticalScrollingHelper#updateScrollPosition: scrollTop and nVerticalScrollPosition not changed"+" -> update inner vertical scroll position",t);o.updateInnerVerticalScrollPosition();}break;default:}},onScroll:function(o){I.notifyScrollEvent&&I.notifyScrollEvent(o);if(j(this).bIsScrolledVerticallyByKeyboard){f("Vertical scroll event handler: Aborted - Scrolled by keyboard",this);return;}this._getKeyboardExtension().setActionMode(false);var a=o.target.scrollTop;var b=o.target._scrollTop;var s=a!==b;if(a===0&&!g(o.target)){f("Vertical scroll event handler: Scrollbar is not connected with the DOM",this);}else if(s){f("Vertical scroll event handler: Scroll position changed by scrolling with the scrollbar:"+" From "+j(this).nVerticalScrollPosition+" to "+a,this);delete o.target._scrollTop;k.updateScrollPosition(this,a,e.SCROLLBAR);}else{f("Vertical scroll event handler: Scroll position changed by scrolling with VerticalScrollingHelper#updateScrollPosition",this);}j(this).bIsScrolledVerticallyByWheel=false;},updateFirstVisibleRow:function(t){var s=t._getScrollExtension();var i=t._getMaxFirstRenderedRowIndex();var N=k.getRowIndexAtCurrentScrollPosition(t);var o=t.getFirstVisibleRow();var b=N<0;var O=o>=i;var F=N!==o;var r=F&&!(b&&O);if(r){var a=!O||N!==i;if(b){N=i;}f("updateFirstVisibleRow: From "+o+" to "+N,t);t.setFirstVisibleRow(N,true,b);if(a){k.setOnRowsUpdatedPreprocessor(t,function(p){f("updateFirstVisibleRow - onRowsUpdatedPreprocessor: Reason "+p.getParameters().reason,this);s.updateInnerVerticalScrollPosition();if(b){var C=this.getFirstVisibleRow();var u=N===C;if(u){this.setProperty("firstVisibleRow",-1,true);this.setFirstVisibleRow(C,true);}}return false;});}else{f("updateFirstVisibleRow: Update inner vertical scroll position",t);s.updateInnerVerticalScrollPosition();}}else if(c.isVariableRowHeightEnabled(t)){f("updateFirstVisibleRow: Update inner vertical scroll position",t);s.updateInnerVerticalScrollPosition();}},getRowIndexAtCurrentScrollPosition:function(t){var s=t._getScrollExtension();var i=t._getMaxFirstVisibleRowIndex();if(i===0){return 0;}else{var a=k.getScrollPosition(t);var b=k.getScrollRange(t);var o=k.getScrollRangeRowFraction(t);if(c.isVariableRowHeightEnabled(t)){if(k.isScrollPositionInBuffer(t)){return-1;}else{return Math.min(i,Math.floor(a/o));}}else{var r=Math.floor(a/o);var p=b-a;var u=s.getVerticalScrollbar(true)._scrollTop==null||j(t).bIsScrolledVerticallyByWheel;var v=p<1&&u||p<0.01;if(v){k.updateScrollPosition(t,b,null,true);}return v?i:Math.min(i,r);}}},getScrollRange:function(t){var s=t._getScrollExtension();var v=s.getVerticalScrollHeight()-s.getVerticalScrollbarHeight();return Math.max(0,v);},getScrollRangeBuffer:function(t){if(!c.isVariableRowHeightEnabled(t)){return 0;}return V*t._getBaseRowHeight();},getScrollPosition:function(t){var s=t._getScrollExtension();if(j(t).nVerticalScrollPosition!=null){return j(t).nVerticalScrollPosition;}else if(s.isVerticalScrollbarVisible()){return s.getVerticalScrollbar().scrollTop;}else{return 0;}},getScrollRangeRowFraction:function(t){var s=t._getScrollExtension();var v=t._getTotalRowCount()-t._getRowCounts().count;var i;if(c.isVariableRowHeightEnabled(t)){i=k.getScrollRange(t)-k.getScrollRangeBuffer(t);var b=s.getVerticalScrollHeight()===M;if(!b){i+=t._getBaseRowHeight();}}else{i=k.getScrollRange(t);}return i/Math.max(1,v);},isScrollPositionInBuffer:function(t){if(!c.isVariableRowHeightEnabled(t)){return false;}var s=k.getScrollRange(t);var a=k.getScrollPosition(t);var i=k.getScrollRangeBuffer(t);return s-a<=i;},getInnerScrollRange:function(t){if(!t||!t._aRowHeights){return 0;}var r=t._aRowHeights;var i=t._getBaseRowHeight()*t._getRowCounts().count;if(t._getRowCounts().count>=t._getTotalRowCount()){r=r.slice(0,t._getTotalRowCount());}var o=r.reduce(function(a,b){return a+b;},0)-i;if(o>0){o=Math.ceil(o);}return Math.max(0,o);},onScrollbarMouseDown:function(o){j(this).bIsScrolledVerticallyByWheel=false;j(this).bIsScrolledVerticallyByKeyboard=false;},setOnRowsUpdatedPreprocessor:function(t,p){j(t).fnOnRowsUpdatedPreprocessor=p;},runOnRowsUpdatedPreprocessor:function(t,o){var b=true;if(j(t).fnOnRowsUpdatedPreprocessor!=null){b=j(t).fnOnRowsUpdatedPreprocessor.call(t,o)!==false;}j(t).fnOnRowsUpdatedPreprocessor=null;return b;},onRowsUpdated:function(o){var s=this._getScrollExtension();var b=k.runOnRowsUpdatedPreprocessor(this,o);if(!c.isVariableRowHeightEnabled(this)||!b){return;}var r=o.getParameters().reason;var R=r===c.RowsUpdateReason.Expand||r===c.RowsUpdateReason.Collapse;var F=this.getFirstVisibleRow()-this._getMaxFirstRenderedRowIndex();f("onRowsUpdated: Reason "+r,this);if(F>=0&&R){j(this).iFirstVisibleRowInBuffer=F;s.updateInnerVerticalScrollPosition();}},restoreScrollPosition:function(t){k.updateScrollPosition(t,j(t).nVerticalScrollPosition);},addEventListeners:function(t){var s=t._getScrollExtension();var a=k.getScrollAreas(t);var v=s.getVerticalScrollbar();if(!s._onVerticalScrollEventHandler){s._onVerticalScrollEventHandler=k.onScroll.bind(t);}for(var i=0;i<a.length;i++){a[i].addEventListener("scroll",s._onVerticalScrollEventHandler);}if(v){if(!s._onVerticalScrollbarMouseDownEventHandler){s._onVerticalScrollbarMouseDownEventHandler=k.onScrollbarMouseDown.bind(t);}v.addEventListener("mousedown",s._onVerticalScrollbarMouseDownEventHandler);}t.attachEvent("_rowsUpdated",k.onRowsUpdated);},removeEventListeners:function(t){var s=t._getScrollExtension();var a=k.getScrollAreas(t);var v=s.getVerticalScrollbar();if(s._onVerticalScrollEventHandler){for(var i=0;i<a.length;i++){a[i].removeEventListener("scroll",s._onVerticalScrollEventHandler);}delete s._onVerticalScrollEventHandler;}if(v&&s._onVerticalScrollbarMouseDownEventHandler){v.removeEventListener("mousedown",s._onVerticalScrollbarMouseDownEventHandler);delete s._onVerticalScrollbarMouseDownEventHandler;}t.detachEvent("_rowsUpdated",k.onRowsUpdated);},isUpdatePending:function(t){return!!(t&&t._mAnimationFrames.verticalScrollUpdate);},getScrollAreas:function(t){var s=[t._getScrollExtension().getVerticalScrollbar()];return s.filter(function(o){return o!=null;});}};var m={onMouseWheelScrolling:function(o,a){var s=this._getScrollExtension();var v=Math.abs(a.deltaY)>Math.abs(a.deltaX);var i=v?a.deltaY:a.deltaX;var b=v&&a.shiftKey||!v;var p=i>0;var r=false;if(i===0){return;}if(b&&(o.scrollDirection===d.HORIZONAL||o.scrollDirection===d.BOTH)){var t=s.getHorizontalScrollbar();if(a.deltaMode>0){var u=c.Column.getMinColumnWidth();i=p?u:-u;}if(p){r=t.scrollLeft===t.scrollWidth-t.offsetWidth;}else{r=t.scrollLeft===0;}if(s.isHorizontalScrollbarVisible()&&!r){a.preventDefault();a.stopPropagation();this._getKeyboardExtension().setActionMode(false);t.scrollLeft=t.scrollLeft+i;}}else if(!b&&(o.scrollDirection===d.VERTICAL||o.scrollDirection===d.BOTH)){var w=s.getVerticalScrollbar();var x=this._getMaxFirstRenderedRowIndex();var y=c.isVariableRowHeightEnabled(this)&&this._getFirstRenderedRowIndex()===x;var z=k.getScrollRangeRowFraction(this);var A=y?this._getBaseRowHeight():z;if(a.deltaMode===1){i*=A;}else if(a.deltaMode===2){i*=A*this._getRowCounts().count;}if(p){r=w.scrollTop===w.scrollHeight-w.offsetHeight;}else{r=w.scrollTop===0;}if(s.isVerticalScrollbarVisible()&&!r){a.preventDefault();a.stopPropagation();var B=k.getScrollPosition(this);var C=B-(x*z);var F=i;if(!y||(y&&C===0&&!p)){var G=i/(a.deltaMode===0?this._getBaseRowHeight():z);if(G>1){G=Math.floor(G);}else if(G<-1){G=Math.ceil(G);}F=G*z;}else if(!p){if(C+F<0){F=-C;}}j(this).bIsScrolledVerticallyByWheel=true;j(this).bIsScrolledVerticallyByKeyboard=false;this._getKeyboardExtension().setActionMode(false);k.updateScrollPosition(this,B+F,e.MOUSEWHEEL);}}},onTouchStart:function(o,a){if(a.type==="touchstart"||a.pointerType==="touch"){var s=this._getScrollExtension();var b=s.getHorizontalScrollbar();var v=s.getVerticalScrollbar();var t=a.touches?a.touches[0]:a;j(this).mTouchSessionData={initialPageX:t.pageX,initialPageY:t.pageY,initialScrollTop:v?v.scrollTop:0,initialScrollLeft:b?b.scrollLeft:0,initialScrolledToEnd:null,touchMoveDirection:null};}},onTouchMoveScrolling:function(o,a){if(a.type!=="touchmove"&&a.pointerType!=="touch"){return;}var s=this._getScrollExtension();var t=j(this).mTouchSessionData;if(!t){return;}var b=a.touches?a.touches[0]:a;var i=(b.pageX-t.initialPageX);var p=(b.pageY-t.initialPageY);var r=false;if(!t.touchMoveDirection){if(i===0&&p===0){return;}t.touchMoveDirection=Math.abs(i)>Math.abs(p)?"horizontal":"vertical";}switch(t.touchMoveDirection){case"horizontal":var u=s.getHorizontalScrollbar();if(u&&(o.scrollDirection===d.HORIZONAL||o.scrollDirection===d.BOTH)){this._getKeyboardExtension().setActionMode(false);if(t.initialScrolledToEnd==null){if(i<0){t.initialScrolledToEnd=u.scrollLeft===u.scrollWidth-u.offsetWidth;}else{t.initialScrolledToEnd=u.scrollLeft===0;}}if(!t.initialScrolledToEnd){u.scrollLeft=t.initialScrollLeft-i;r=true;}}break;case"vertical":var v=s.getVerticalScrollbar();if(v&&(o.scrollDirection===d.VERTICAL||o.scrollDirection===d.BOTH)){this._getKeyboardExtension().setActionMode(false);if(t.initialScrolledToEnd==null){if(p<0){t.initialScrolledToEnd=v.scrollTop===v.scrollHeight-v.offsetHeight;}else{t.initialScrolledToEnd=v.scrollTop===0;}}if(!t.initialScrolledToEnd){k.updateScrollPosition(this,t.initialScrollTop-p,e.TOUCH);r=true;}}break;default:}if(r){a.preventDefault();}},addEventListeners:function(t){var s=t._getScrollExtension();var a=m.getEventListenerTargets(t);s._mMouseWheelEventListener=this.addMouseWheelEventListener(a,t,{scrollDirection:d.BOTH});s._mTouchEventListener=this.addTouchEventListener(a,t,{scrollDirection:d.BOTH});},addMouseWheelEventListener:function(a,t,o){var O=m.onMouseWheelScrolling.bind(t,o);for(var i=0;i<a.length;i++){a[i].addEventListener("wheel",O);}return{wheel:O};},addTouchEventListener:function(a,t,o){var O=m.onTouchStart.bind(t,o);var b=m.onTouchMoveScrolling.bind(t,o);var p={};for(var i=0;i<a.length;i++){if(D.support.pointer&&D.system.desktop){a[i].addEventListener("pointerdown",O);a[i].addEventListener("pointermove",b,D.browser.chrome?{passive:true}:false);}else if(D.support.touch){a[i].addEventListener("touchstart",O);a[i].addEventListener("touchmove",b);}}if(D.support.pointer&&D.system.desktop){p={pointerdown:O,pointermove:b};}else if(D.support.touch){p={touchstart:O,touchmove:b};}return p;},removeEventListeners:function(t){var s=t._getScrollExtension();var a=m.getEventListenerTargets(t);function r(o,b){for(var p in b){var u=b[p];if(u){o.removeEventListener(p,u);}}}for(var i=0;i<a.length;i++){r(a[i],s._mMouseWheelEventListener);r(a[i],s._mTouchEventListener);}delete s._mMouseWheelEventListener;delete s._mTouchEventListener;},getEventListenerTargets:function(t){var a=[t.getDomRef("tableCCnt")];return a.filter(function(o){return o!=null;});}};var E={onBeforeRendering:function(o){var s=this._getScrollExtension();var r=o!=null&&o.isMarked("renderRows");s._clearCache();if(!r){j(this).bVerticalScrollingSuspended=true;this.attachEventOnce("_rowsUpdated",function(){j(this).bVerticalScrollingSuspended=false;k.restoreScrollPosition(this);});}},onAfterRendering:function(o){var s=this._getScrollExtension();var r=o!=null&&o.isMarked("renderRows");if(r){s.updateVerticalScrollbarHeight();s.updateVerticalScrollHeight();}H.restoreScrollPosition(this);},onfocusin:function(o){var r;var C=c.getCellInfo(o.target);var a=this._getScrollExtension().getHorizontalScrollbar();if(C.isOfType(c.CELLTYPE.DATACELL)){r=this.getDomRef("sapUiTableCtrlScr");}else if(C.isOfType(c.CELLTYPE.COLUMNHEADER)){r=this.getDomRef("sapUiTableColHdrScr");}if(r&&a&&C.columnIndex>=this.getComputedFixedColumnCount()){var $=q(a);var b=C.cell[0];var i=this._bRtlMode?$.scrollLeftRTL():a.scrollLeft;var R=r.clientWidth;var p=b.offsetLeft;var s=p+b.offsetWidth;var O=p-i;var t=s-R-i;var N;if(O<0&&t<0){N=i+O;}else if(t>0&&O>0){N=i+t;}if(N!=null){if(this._bRtlMode){$.scrollLeftRTL(N);}else{a.scrollLeft=N;}}}var P=c.getParentCell(this,o.target);if(P){var u=this;var v=function(){var w=P.find(".sapUiTableCellInner");if(w.length>0){if(u._bRtlMode){w.scrollLeftRTL(w[0].scrollWidth-w[0].clientWidth);}else{w[0].scrollLeft=0;}w[0].scrollTop=0;}};Promise.resolve().then(function(){if(D.browser.safari){window.setTimeout(v,0);}else{v();}});}}};
var n=T.extend("sap.ui.table.TableScrollExtension",{
_init:function(t,s,a){this._delegate=E;c.addDelegate(t,this._delegate,t);return"ScrollExtension";},
_attachEvents:function(){var t=this.getTable();H.addEventListeners(t);k.addEventListeners(t);m.addEventListeners(t);},
_detachEvents:function(){var t=this.getTable();H.removeEventListeners(t);k.removeEventListeners(t);m.removeEventListeners(t);},
_debug:function(){this._ScrollingHelper=m;this._ExtensionDelegate=E;this._HorizontalScrollingHelper=H;this._VerticalScrollingHelper=k;},
destroy:function(){var t=this.getTable();if(t){t.removeEventDelegate(this._delegate);}this._delegate=null;this._clearCache();j.destroy(t);T.prototype.destroy.apply(this,arguments);}
});
n.prototype.scrollVertically=function(b,p,i,a,B){var t=this.getTable();if(!t){return false;}b=b===true;p=p===true;i=i===true;a=a===true;var s=false;var o=t._getTotalRowCount();var r=t._getRowCounts();var F=t.getFirstVisibleRow();var u=p?r.scrollable:1;if(b){if(F+r.count<o){if(B){B();}if(a){setTimeout(function(){t.setFirstVisibleRow(Math.min(F+u,o-r.count));},0);}else{t.setFirstVisibleRow(Math.min(F+u,o-r.count));}s=true;}}else if(F>0){if(B){B();}if(a){setTimeout(function(){t.setFirstVisibleRow(Math.max(F-u,0));},0);}else{t.setFirstVisibleRow(Math.max(F-u,0));}s=true;}if(s&&i){j(t).bIsScrolledVerticallyByKeyboard=true;}return s;};
n.prototype.scrollVerticallyMax=function(b,i){var t=this.getTable();if(!t){return false;}if(b==null){b=false;}if(i==null){i=false;}var s=false;var F=t.getFirstVisibleRow();if(b){var a=t._getTotalRowCount()-c.getNonEmptyVisibleRowCount(t);if(F<a){t.setFirstVisibleRow(a);s=true;}}else if(F>0){t.setFirstVisibleRow(0);s=true;}if(s&&i){j(t).bIsScrolledVerticallyByKeyboard=true;}return s;};
n.prototype.getHorizontalScrollbar=function(){var t=this.getTable();if(t&&!t._bInvalid&&!j(t).oHorizontalScrollbar){j(t).oHorizontalScrollbar=t.getDomRef(S.HorizontalScrollBar);}return j(t).oHorizontalScrollbar||null;};
n.prototype.getVerticalScrollbar=function(i){var t=this.getTable();var b=this.isVerticalScrollbarExternal();if(t&&!t._bInvalid&&!j(t).oVerticalScrollbar){j(t).oVerticalScrollbar=t.getDomRef(S.VerticalScrollBar);if(!j(t).oVerticalScrollbar&&b){j(t).oVerticalScrollbar=j(t).oExternalVerticalScrollbar;}}var s=j(t).oVerticalScrollbar;if(s&&!b&&!i&&!g(s)){return null;}return s||null;};
n.prototype.isHorizontalScrollbarVisible=function(){var o=this.getHorizontalScrollbar();return o!=null&&!o.classList.contains("sapUiTableHidden");};
n.prototype.isVerticalScrollbarVisible=function(){var v=this.getVerticalScrollbar();return v!=null&&!v.classList.contains("sapUiTableHidden");};
n.prototype.isVerticalScrollbarExternal=function(){return j(this.getTable()).bIsVerticalScrollbarExternal;};
n.prototype.markVerticalScrollbarAsExternal=function(s){if(s){j(this.getTable()).bIsVerticalScrollbarExternal=true;j(this.getTable()).oExternalVerticalScrollbar=s;}};
n.prototype.updateHorizontalScrollbar=function(t){var o=this.getTable();var a=this.getHorizontalScrollbar();if(!o||!a||!t){return;}var $=o.$();var C=t.tableCtrlScrollWidth;if(D.browser.safari){C=Math.max(C,o._getColumnsWidth(o.getComputedFixedColumnCount()));}var b=C>t.tableCtrlScrWidth;if(b){if(!this.isHorizontalScrollbarVisible()){$.addClass("sapUiTableHScr");a.classList.remove("sapUiTableHidden");if(D.browser.safari){var i=$.find(".sapUiTableCtrlScroll, .sapUiTableColHdrScr > .sapUiTableColHdr");i.outerWidth(C);}}var s=t.tableCtrlFixedWidth;if($.find(".sapUiTableRowHdrScr").length>0){s+=t.tableRowHdrScrWidth;}if(o._bRtlMode){a.style.marginRight=s+"px";a.style.marginLeft="";}else{a.style.marginLeft=s+"px";a.style.marginRight="";}var p=o.getDomRef("hsb-content");if(p){p.style.width=C+"px";}}if(!b&&this.isHorizontalScrollbarVisible()){$.removeClass("sapUiTableHScr");a.classList.add("sapUiTableHidden");if(D.browser.safari){$.find(".sapUiTableCtrlScroll, .sapUiTableColHdr").css("width","");}}};
n.prototype.updateVerticalScrollbarHeight=function(){var t=this.getTable();var v=this.getVerticalScrollbar();if(!t||!v){return;}var N=this.getVerticalScrollbarHeight();v.style.maxHeight=N+"px";if(j(t).iVerticalScrollbarHeight!==N){j(t).iVerticalScrollbarHeight=N;k.updateScrollPosition(t);}};
n.prototype.getVerticalScrollbarHeight=function(){var t=this.getTable();if(!t){return 0;}return t._getRowCounts().scrollable*t._getBaseRowHeight();};
n.prototype.updateVerticalScrollbarPosition=function(){var t=this.getTable();var v=this.getVerticalScrollbar();if(!t||!v){return;}var o=t.getDomRef("tableCCnt");if(o){var i=o.offsetTop;var a=t.getDomRef("vsb-bg");if(a){a.style.top=i+"px";}if(t._getRowCounts().fixedTop>0){i+=t._iVsbTop;}v.style.top=i+"px";}};
n.prototype.updateVerticalScrollPosition=function(){k.updateScrollPosition(this.getTable(),undefined,e.TABLE);};
n.prototype.restoreVerticalScrollPosition=function(){k.restoreScrollPosition(this.getTable());};
n.prototype.updateVerticalScrollHeight=function(){var v=this.getVerticalScrollbar();var o=v?v.firstChild:null;if(!o){return;}var N=this.getVerticalScrollHeight(true);o.style.height=this.getVerticalScrollHeight()+"px";if(j(this.getTable()).iVerticalScrollHeight!==N){j(this.getTable()).iVerticalScrollHeight=N;k.updateScrollPosition(this.getTable());}};
n.prototype.getVerticalScrollHeight=function(b){var t=this.getTable();if(!t){return 0;}var i=t._getTotalRowCount();var v=t._getRowCounts().count;var B=t._getBaseRowHeight();var r;var s;if(c.isVariableRowHeightEnabled(t)){r=Math.max(i,v+1);s=B*(r-1)+k.getScrollRangeBuffer(t);}else{r=Math.max(i,v);s=B*r;}if(b===true){return s;}else{return Math.min(M,s);}};
n.prototype.updateVerticalScrollbarVisibility=function(){var t=this.getTable();var o=t?t.getDomRef():null;var v=this.getVerticalScrollbar();if(!o||!v){return;}var b=this.isVerticalScrollbarRequired();if(b&&!this.isVerticalScrollbarVisible()){if(!this.isVerticalScrollbarExternal()){o.classList.add("sapUiTableVScr");}v.classList.remove("sapUiTableHidden");}if(!b&&this.isVerticalScrollbarVisible()){o.classList.remove("sapUiTableVScr");v.classList.add("sapUiTableHidden");}};
n.prototype.isVerticalScrollbarRequired=function(){var t=this.getTable();if(!t){return false;}return c.isVariableRowHeightEnabled(t)&&k.getInnerScrollRange(t)>0||(t._getTotalRowCount()>t._getRowCounts().count);};
n.prototype.updateInnerVerticalScrollPosition=function(){var t=this.getTable();var C=t?t.getDomRef("tableCCnt"):null;if(!c.isVariableRowHeightEnabled(t)||!C||k.isUpdatePending(t)){return;}if(t._getFirstRenderedRowIndex()!==t._iRenderedFirstVisibleRow){f("updateInnerVerticalScrollPosition: Skipped, because rows will be updated",t);return;}var a=k.getInnerScrollRange(t);if(a===0){f("updateInnerVerticalScrollPosition: 0",t);t.setFirstVisibleRow(0,true);this._nVerticalScrollPosition=0;C.scrollTop=0;return;}var F=t.getFirstVisibleRow();var b=k.getScrollPosition(t);var s=k.isScrollPositionInBuffer(t);var o=0;var p;var r;var u=null;var R=t._aRowHeights;if(!s){var v=k.getScrollRangeRowFraction(t);o=b-(F*v);p=R[0];r=Math.max(0,Math.min(o/v,1));u=Math.round(p*r);}else{var w=0;var x=0;var i;for(i=0;i<R.length&&x<a;i++){w++;x+=R[i];}var y=k.getScrollRange(t);var B=k.getScrollRangeBuffer(t);var z=B/w;if(j(t).iFirstVisibleRowInBuffer==null){o=b-y+B;var A=o/z;var G;if(Math.ceil(A)-A<0.00001){G=Math.ceil(o/z);}else{G=Math.floor(o/z);}G=Math.min(G,w);p=R[G]||0;r=Math.max(0,Math.min((o-(z*G))/z,1));for(i=0;i<G;i++){u+=R[i];}u+=p*r;u=Math.min(u,a);var N=t._getMaxFirstRenderedRowIndex()+G;if(N!==F){f("updateInnerVerticalScrollPosition: Set firstVisibleRow from "+F+" to "+N,t);t.setFirstVisibleRow(N,true);}}else{var J=y-B;o=j(t).iFirstVisibleRowInBuffer*z;var K=J+o;r=0;f("updateInnerVerticalScrollPosition: Set scroll position to "+K,t);k.updateScrollPosition(t,K);return;}}f("updateInnerVerticalScrollPosition: "+u+" of "+p+" ("+(r*100)+"%)"+" (in buffer: "+s+")",t);C.scrollTop=u;};
n.prototype.registerForMouseWheel=function(a,o){var t=this.getTable();if(T.isEnrichedWith(t,"sap.ui.table.TableSyncExtension")){return m.addMouseWheelEventListener(a,t,o);}else{L.error("This method can only be used with synchronization enabled.",t,"TableScrollExtension#registerForMouseWheel");return null;}};
n.prototype.registerForTouch=function(a,o){var t=this.getTable();if(T.isEnrichedWith(t,"sap.ui.table.TableSyncExtension")){return m.addTouchEventListener(a,t,o);}else{L.error("This method can only be used with synchronization enabled.",t,"TableScrollExtension#registerForTouch");return null;}};
n.prototype._clearCache=function(){j(this.getTable()).oVerticalScrollbar=null;j(this.getTable()).oHorizontalScrollbar=null;};
n.ScrollDirection=d;return n;});
sap.ui.predefine('sap/ui/table/TableSyncExtension',["./Table","./TableExtension","./TableUtils","./library","sap/base/Log"],function(T,a,b,l,L){"use strict";var E={setRowSelection:function(i,s){var t=this.getTable();var r=t.getRows()[i];if(r&&s!=null){b.toggleRowSelection(t,r.getIndex(),s);}},setRowHover:function(i,h){var t=this.getTable();var r=t.getRows()[i];if(r&&h!=null){r._setHovered(h);}},addVerticalScrollingListener:function(C){var t=this.getTable();var s=t._getScrollExtension();var S=s.constructor.ScrollDirection;if(C){s.registerForMouseWheel(C.wheelAreas,{scrollDirection:S.VERTICAL});s.registerForTouch(C.touchAreas,{scrollDirection:S.VERTICAL});}},placeVerticalScrollbarAt:function(h){var t=this.getTable();var s=t._getScrollExtension();if(!h){throw new Error("The HTMLElement in which the vertical scrollbar should be placed must be specified.");}if(!s.isVerticalScrollbarExternal()){var r=sap.ui.getCore().createRenderManager();t.getRenderer().renderVSbExternal(r,t);r.flush(h);var e=h.querySelector("#"+t.getId()+"-"+l.SharedDomRef.VerticalScrollBar);s.markVerticalScrollbarAsExternal(e);t.invalidate();}else{h.appendChild(s.getVerticalScrollbar());s.restoreVerticalScrollPosition();}},renderHorizontalScrollbar:function(r,i,s){var t=this.getTable();if(i==null){throw new Error("The id must be specified.");}t.getRenderer().renderHSbExternal(r,t,i,s);}};var c={onAfterRendering:function(e){var s=this._getScrollExtension();var r=e&&e.isMarked("renderRows");var C=this.getDomRef("tableCCnt");if(s.isVerticalScrollbarExternal()&&!r){s.updateVerticalScrollbarHeight();s.updateVerticalScrollHeight();}if(!r){C.addEventListener("scroll",function(e){this._getSyncExtension().syncInnerVerticalScrollPosition(e.target.scrollTop);}.bind(this));}}};
var d=a.extend("sap.ui.table.TableSyncExtension",{
_init:function(t,s,S){this._delegate=c;this._oPublicInterface={syncRowSelection:E.setRowSelection.bind(this),syncRowHover:E.setRowHover.bind(this),registerVerticalScrolling:E.addVerticalScrollingListener.bind(this),placeVerticalScrollbarAt:E.placeVerticalScrollbarAt.bind(this),renderHorizontalScrollbar:E.renderHorizontalScrollbar.bind(this)};b.addDelegate(t,this._delegate,t);return"SyncExtension";},
destroy:function(){var t=this.getTable();if(t){t.removeEventDelegate(this._delegate);}this._delegate=null;this._oPublicInterface=null;a.prototype.destroy.apply(this,arguments);}
});
d.prototype.syncRowCount=function(C){this.callInterfaceHook("rowCount",arguments);};
d.prototype.syncRowSelection=function(i,s){this.callInterfaceHook("rowSelection",arguments);};
d.prototype.syncRowHover=function(i,h){this.callInterfaceHook("rowHover",arguments);};
d.prototype.syncRowHeights=function(h){return this.callInterfaceHook("rowHeights",arguments);};
d.prototype.syncInnerVerticalScrollPosition=function(s){this.callInterfaceHook("innerVerticalScrollPosition",arguments);};
d.prototype.syncLayout=function(m){this.callInterfaceHook("layout",arguments);};
d.prototype.callInterfaceHook=function(h,A){var C={};C[h]=Array.prototype.slice.call(A);L.debug("sap.ui.table.TableSyncExtension","Sync "+h+"("+C[h]+")",this.getTable());return b.dynamicCall(this._oPublicInterface,C);};
d.prototype.getInterface=function(){return this._oPublicInterface;};
return d;});
sap.ui.predefine('sap/ui/table/TableUtils',["sap/ui/base/Object","sap/ui/core/Control","sap/ui/core/ResizeHandler","sap/ui/core/library","sap/ui/core/theming/Parameters","sap/ui/model/ChangeReason","./TableGrouping","./TableColumnUtils","./TableMenuUtils","./TableBindingUtils","./library","sap/base/Log","sap/ui/thirdparty/jquery"],function(B,C,R,c,T,a,b,d,e,f,l,L,q){"use strict";var S=l.SelectionBehavior;var g=l.SelectionMode;var M=c.MessageType;var r;var h=null;var j={DATACELL:1<<1,COLUMNHEADER:1<<2,ROWHEADER:1<<3,ROWACTION:1<<4,COLUMNROWHEADER:1<<5,PSEUDO:1<<6};j.ANYCONTENTCELL=j.ROWHEADER|j.DATACELL|j.ROWACTION;j.ANYCOLUMNHEADER=j.COLUMNHEADER|j.COLUMNROWHEADER;j.ANYROWHEADER=j.ROWHEADER|j.COLUMNROWHEADER;j.ANY=j.ANYCONTENTCELL|j.ANYCOLUMNHEADER;var m={sapUiSizeCozy:48,sapUiSizeCompact:32,sapUiSizeCondensed:24,undefined:32};var k=1;var n=1;var D={sapUiSizeCozy:m.sapUiSizeCozy+n,sapUiSizeCompact:m.sapUiSizeCompact+n,sapUiSizeCondensed:m.sapUiSizeCondensed+n,undefined:m.undefined+n};var t={navigationIcon:"navigation-right-arrow",deleteIcon:"sys-cancel",resetIcon:"undo"};var o={Render:"Render",VerticalScroll:"VerticalScroll",FirstVisibleRowChange:"FirstVisibleRowChange",Unbind:"Unbind",Animation:"Animation",Resize:"Resize",Zoom:"Zoom",Unknown:"Unknown"};for(var p in a){o[p]=a[p];}var I=":sapTabbable, .sapUiTableTreeIcon:not(.sapUiTableTreeIconLeaf)";
function s(E){return E!=null&&E instanceof window.HTMLInputElement&&/^(text|password|search|tel|url)$/.test(E.type);}
var u={Grouping:b,Column:d,Menu:e,Binding:f,CELLTYPE:j,BaseSize:m,BaseBorderWidth:k,RowHorizontalFrameSize:n,DefaultRowHeight:D,RowsUpdateReason:o,INTERACTIVE_ELEMENT_SELECTORS:I,ThemeParameters:t,hasRowHeader:function(i){return(i.getSelectionMode()!==g.None&&i.getSelectionBehavior()!==S.RowOnly)||b.isGroupMode(i);},hasSelectAll:function(i){var v=i?i.getSelectionMode():g.None;return v===g.MultiToggle&&i.getEnableSelectAll();},hasRowHighlights:function(i){if(!i){return false;}var v=i.getRowSettingsTemplate();if(!v){return false;}var H=v.getHighlight();return v.isBound("highlight")||(H!=null&&H!==M.None);},hasRowNavigatedIndicators:function(i){if(!i){return false;}var v=i.getRowSettingsTemplate();if(!v){return false;}var N=v.getNavigated();return v.isBound("navigated")||N;},getRowActionCount:function(i){var v=i?i.getRowActionTemplate():null;return v?v._getCount():0;},hasRowActions:function(i){var v=i?i.getRowActionTemplate():null;return v!=null&&(v.isBound("visible")||v.getVisible())&&u.getRowActionCount(i)>0;},isRowSelectionAllowed:function(i){return i.getSelectionMode()!==g.None&&(i.getSelectionBehavior()===S.Row||i.getSelectionBehavior()===S.RowOnly);},isRowSelectorSelectionAllowed:function(i){return i.getSelectionMode()!==g.None&&u.hasRowHeader(i);},areAllRowsSelected:function(i){if(!i){return false;}var v=i._getSelectionPlugin();var w=v.getSelectableCount();var x=v.getSelectedCount();return w>0&&w===x;},isNoDataVisible:function(i){if(!i.getShowNoData()){return false;}return!u.hasData(i);},hasData:function(i){var v=i.getBinding("rows");var w=i._getTotalRowCount();var H=w>0;if(v&&v.providesGrandTotal){var x=v.providesGrandTotal()&&v.hasTotaledMeasures();H=(x&&w>1)||(!x&&w>0);}return H;},isBusyIndicatorVisible:function(i){if(!i||!i.getDomRef()){return false;}return i.getDomRef().querySelector("#"+i.getId()+"-sapUiTableGridCnt > .sapUiLocalBusyIndicator")!=null;},hasPendingRequests:function(i){if(!i){return false;}if(u.canUsePendingRequestsCounter(i)){return i._iPendingRequests>0;}else{return i._bPendingRequest;}},canUsePendingRequestsCounter:function(i){var v=i?i.getBinding("rows"):null;if(u.isA(v,"sap.ui.model.analytics.AnalyticalBinding")){return v.bUseBatchRequests;}else if(u.isA(v,"sap.ui.model.TreeBinding")){return false;}return true;},isA:function(O,v){return B.isA(O,v);},toggleRowSelection:function(i,v,w,x){if(!i||!i.getBinding("rows")||i.getSelectionMode()===g.None||v==null){return false;}var y=i._getSelectionPlugin();function z(F){if(!y.isIndexSelectable(F)){return false;}i._iSourceRowIndex=F;var G=false;if(x){G=x(F,w);}else if(y.isIndexSelected(F)){if(w!==true){G=true;y.removeSelectionInterval(F,F);}}else if(w!==false){G=true;y.addSelectionInterval(F,F);}delete i._iSourceRowIndex;return G;}if(typeof v==="number"){if(v<0||v>=i._getTotalRowCount()){return false;}return z(v);}else{var $=q(v);var A=u.getCellInfo($[0]);var E=u.isRowSelectionAllowed(i);if(!u.Grouping.isInGroupingRow($[0])&&((A.isOfType(u.CELLTYPE.DATACELL|u.CELLTYPE.ROWACTION)&&E)||(A.isOfType(u.CELLTYPE.ROWHEADER)&&u.isRowSelectorSelectionAllowed(i)))){var F=i.getRows()[A.rowIndex].getIndex();return z(F);}return false;}},getNoDataText:function(i){var N=i.getNoData();if(N instanceof C){return null;}else if(typeof N==="string"||i.getNoData()instanceof String){return N;}else{return u.getResourceText("TBL_NO_DATA");}},getVisibleColumnCount:function(i){return i._getVisibleColumns().length;},getHeaderRowCount:function(v){if(v._iHeaderRowCount===undefined){if(!v.getColumnHeaderVisible()){v._iHeaderRowCount=0;}else{var H=1;var w=v.getColumns();for(var i=0;i<w.length;i++){if(w[i].shouldRender()){H=Math.max(H,w[i].getMultiLabels().length);}}v._iHeaderRowCount=H;}}return v._iHeaderRowCount;},isVariableRowHeightEnabled:function(i){var v=i._getRowCounts();return i&&i._bVariableRowHeightEnabled&&!v.fixedTop&&!v.fixedBottom;},getTotalRowCount:function(i,v){var w=i._getTotalRowCount();if(v){w=Math.max(w,i._getRowCounts().count);}return w;},getNonEmptyVisibleRowCount:function(i){return Math.min(i._getRowCounts().count,i._getTotalRowCount());},getFocusedItemInfo:function(i){var v=i._getItemNavigation();if(!v){return null;}return{cell:v.getFocusedIndex(),columnCount:v.iColumns,cellInRow:v.getFocusedIndex()%v.iColumns,row:Math.floor(v.getFocusedIndex()/v.iColumns),cellCount:v.getItemDomRefs().length,domRef:v.getFocusedDomRef()};},getRowIndexOfFocusedCell:function(i){var v=u.getFocusedItemInfo(i);return v.row-u.getHeaderRowCount(i);},isFixedColumn:function(i,v){return v<i.getComputedFixedColumnCount();},hasFixedColumns:function(i){return i.getComputedFixedColumnCount()>0;},focusItem:function(i,v,E){var w=i._getItemNavigation();if(w){w.focusItem(v,E);}},getCellInfo:function(i){var v;var $=q(i);var w;var x;var y;var z;var A;v={type:0,cell:null,rowIndex:null,columnIndex:null,columnSpan:null};if($.hasClass("sapUiTableDataCell")){w=$.attr("data-sap-ui-colid");x=sap.ui.getCore().byId(w);v.type=u.CELLTYPE.DATACELL;v.rowIndex=parseInt($.parent().attr("data-sap-ui-rowindex"));v.columnIndex=x.getIndex();v.columnSpan=1;}else if($.hasClass("sapUiTableHeaderDataCell")){y=/_([\d]+)/;w=$.attr("id");z=y.exec(w);A=z&&z[1]!=null?parseInt(z[1]):0;v.type=u.CELLTYPE.COLUMNHEADER;v.rowIndex=A;v.columnIndex=parseInt($.attr("data-sap-ui-colindex"));v.columnSpan=parseInt($.attr("colspan")||1);}else if($.hasClass("sapUiTableRowSelectionCell")){v.type=u.CELLTYPE.ROWHEADER;v.rowIndex=parseInt($.parent().attr("data-sap-ui-rowindex"));v.columnIndex=-1;v.columnSpan=1;}else if($.hasClass("sapUiTableRowActionCell")){v.type=u.CELLTYPE.ROWACTION;v.rowIndex=parseInt($.parent().attr("data-sap-ui-rowindex"));v.columnIndex=-2;v.columnSpan=1;}else if($.hasClass("sapUiTableRowSelectionHeaderCell")){v.type=u.CELLTYPE.COLUMNROWHEADER;v.columnIndex=-1;v.columnSpan=1;}else if($.hasClass("sapUiTablePseudoCell")){w=$.attr("data-sap-ui-colid");x=sap.ui.getCore().byId(w);v.type=u.CELLTYPE.PSEUDO;v.rowIndex=-1;v.columnIndex=x?x.getIndex():-1;v.columnSpan=1;}if(v.type!==0){v.cell=$;}v.isOfType=function(E){if(E==null){return false;}return(this.type&E)>0;};return v;},getRowColCell:function(v,w,x,y){var z=w>=0&&w<v.getRows().length?v.getRows()[w]:null;var A=y?v.getColumns():v._getVisibleColumns();var E=x>=0&&x<A.length?A[x]:null;var F=null;if(z&&E){if(y){if(E.shouldRender()){var V=v._getVisibleColumns();for(var i=0;i<V.length;i++){if(V[i]===E){F=z.getCells()[i];break;}}}}else{F=z.getCells()[x];}}return{row:z,column:E,cell:F};},getCell:function(i,E,v){v=v===true;if(!i||!E){return null;}var $=q(E);var w=i.getDomRef();var x=".sapUiTableCell";if(!v){x+=":not(.sapUiTablePseudoCell)";}var y=$.closest(x,w);if(y.length>0){return y;}return null;},getParentCell:function(i,E,v){v=v===true;var $=q(E);var w=u.getCell(i,E,v);if(!w||w[0]===$[0]){return null;}else{return w;}},registerResizeHandler:function(i,H,v,w,x){w=w==null?"":w;x=x===true;if(!i||typeof H!=="string"||typeof v!=="function"){return undefined;}var y=i.getDomRef(w);u.deregisterResizeHandler(i,H);if(!i._mResizeHandlerIds){i._mResizeHandlerIds={};}if(x&&y){y=y.parentNode;}if(y){i._mResizeHandlerIds[H]=R.register(y,v);}return i._mResizeHandlerIds[H];},deregisterResizeHandler:function(v,H){var w=[];if(!v._mResizeHandlerIds){return;}if(typeof H==="string"){w.push(H);}else if(H===undefined){for(var K in v._mResizeHandlerIds){if(typeof K=="string"&&v._mResizeHandlerIds.hasOwnProperty(K)){w.push(K);}}}else if(Array.isArray(H)){w=H;}for(var i=0;i<w.length;i++){var x=w[i];if(v._mResizeHandlerIds[x]){R.deregister(v._mResizeHandlerIds[x]);v._mResizeHandlerIds[x]=undefined;}}},isFirstScrollableRow:function(i,v){if(isNaN(v)){var $=q(v);v=parseInt($.add($.parent()).filter("[data-sap-ui-rowindex]").attr("data-sap-ui-rowindex"));}return v==i._getRowCounts().fixedTop;},isLastScrollableRow:function(i,v){if(isNaN(v)){var $=q(v);v=parseInt($.add($.parent()).filter("[data-sap-ui-rowindex]").attr("data-sap-ui-rowindex"));}var w=i._getRowCounts();return v==w.count-w.fixedBottom-1;},getContentDensity:function(v){var w;var x=["sapUiSizeCondensed","sapUiSizeCompact","sapUiSizeCozy"];var G=function(F,O){if(!O[F]){return;}for(var i=0;i<x.length;i++){if(O[F](x[i])){return x[i];}}};var $=v.$();if($.length>0){w=G("hasClass",$);}else{w=G("hasStyleClass",v);}if(w){return w;}var P=null;var y=v.getParent();if(y){do{w=G("hasStyleClass",y);if(w){return w;}if(y.getDomRef){P=y.getDomRef();}else if(y.getRootNode){P=y.getRootNode();}if(!P&&y.getParent){y=y.getParent();}else{y=null;}}while(y&&!P);}$=q(P||document.body);w=G("hasClass",$.closest("."+x.join(",.")));return w;},isVariableWidth:function(w){return!w||w=="auto"||w.toString().match(/%$/);},getFirstFixedBottomRowIndex:function(i){var v=i._getRowCounts();if(!i.getBinding("rows")||v.fixedBottom===0){return-1;}var F=-1;var w=i.getFirstVisibleRow();var x=i._getTotalRowCount();if(x>=v.count){F=v.count-v.fixedBottom;}else{var y=x-v.fixedBottom-w;if(y>=0&&(w+y)<x){F=y;}}return F;},getResourceBundle:function(O){O=q.extend({async:false,reload:false},O);if(r&&O.reload!==true){if(O.async===true){return Promise.resolve(r);}else{return r;}}var v=sap.ui.getCore().getLibraryResourceBundle("sap.ui.table",O.async===true);if(v instanceof Promise){v=v.then(function(i){r=i;return r;});}else{r=v;}return v;},getResourceText:function(K,v){return r?r.getText(K,v):"";},dynamicCall:function(O,v,i){var w=typeof O==="function"?O():O;if(!w||!v){return undefined;}i=i||w;if(typeof v==="function"){v.call(i,w);return undefined;}else{var P;var x=[];for(var F in v){if(typeof w[F]==="function"){P=v[F];x.push(w[F].apply(i,P));}else{x.push(undefined);}}if(x.length===1){return x[0];}else{return x;}}},throttle:function(i,O){O=Object.assign({wait:0,leading:true},O);O.maxWait=O.wait;O.trailing=true;O.requestAnimationFrame=false;return u.debounce(i,O);},debounce:function(i,O){O=Object.assign({wait:0,maxWait:null,leading:false,asyncLeading:false,trailing:true,requestAnimationFrame:false},O);var v=null;var w=null;var x=null;var y=O.maxWait!=null;O.wait=Math.max(0,O.wait);O.maxWait=y?Math.max(O.maxWait,O.wait):O.maxWait;function z(K,N,P,Q){v=Q===true?null:Date.now();if(N==null){return;}if(P===true){var U=Promise.resolve().then(function(){if(!U.canceled){i.apply(K,N);}x=null;});U.cancel=function(){U.canceled=true;};x=U;}else{i.apply(K,N);}}function A(K,N){E();function _(W){W=W!==false;if(W){G();}if(O.trailing){z(K,N,null,W);}}if(O.requestAnimationFrame){w=window.requestAnimationFrame(function(){_();});}else{var P=Date.now();var Q=v==null?0:P-v;var U=Math.max(0,y?Math.min(O.maxWait-Q,O.wait):O.wait);var V=U<O.wait;w=setTimeout(function(){if(V){var W=Math.max(0,(Date.now()-P)-U);var X=O.wait-U;if(W>X){_();}else{w=setTimeout(G,X-W);_(false);}}else{_();}},U);}}function E(){if(O.requestAnimationFrame){window.cancelAnimationFrame(w);}else{clearTimeout(w);}w=null;}function F(){if(x){x.cancel();x=null;}}function G(){E();F();v=null;}function H(){return w!=null;}var J=function(){if(!H()&&!O.leading){z();}if(H()||!O.leading){A(this,arguments);}else if(O.asyncLeading){z(this,arguments,true);A();}else{A();z(this,arguments);}};J.cancel=G;J.pending=H;return J;},getInteractiveElements:function(i){if(!i){return null;}var $=q(i);var v=u.getCellInfo($);if(v.isOfType(j.ANY|j.PSEUDO)){var w=$.find(I);if(w.length>0){return w;}}return null;},convertCSSSizeToPixel:function(i,w){var P;if(typeof i!=="string"){return null;}if(i.endsWith("px")){P=parseInt(i);}else if(i.endsWith("em")||i.endsWith("rem")){P=Math.ceil(parseFloat(i)*u.getBaseFontSize());}else{return null;}if(w){return P+"px";}else{return P;}},getBaseFontSize:function(){if(h==null){var i=document.documentElement;if(i){h=parseInt(window.getComputedStyle(i).fontSize);}}return h==null?16:h;},readThemeParameters:function(){function i(v){return u.convertCSSSizeToPixel(T.get(v));}m.undefined=i("_sap_ui_table_BaseSize");m.sapUiSizeCozy=i("_sap_ui_table_BaseSizeCozy");m.sapUiSizeCompact=i("_sap_ui_table_BaseSizeCompact");m.sapUiSizeCondensed=i("_sap_ui_table_BaseSizeCondensed");k=i("_sap_ui_table_BaseBorderWidth");n=k;D.undefined=m.undefined+n;D.sapUiSizeCozy=m.sapUiSizeCozy+n;D.sapUiSizeCompact=m.sapUiSizeCompact+n;D.sapUiSizeCondensed=m.sapUiSizeCondensed+n;t.navigationIcon=T.get("_sap_ui_table_NavigationIcon");t.deleteIcon=T.get("_sap_ui_table_DeleteIcon");t.resetIcon=T.get("_sap_ui_table_ResetIcon");},selectElementText:function(E){if(s(E)){E.select();}},deselectElementText:function(E){if(s(E)){E.setSelectionRange(0,0);}},addDelegate:function(E,i,v){if(E&&i){E.addDelegate(i,false,v?v:i,false);}},removeDelegate:function(E,i){if(E&&i){E.removeDelegate(i);}}};b.TableUtils=u;d.TableUtils=u;e.TableUtils=u;f.TableUtils=u;return u;},true);
sap.ui.predefine('sap/ui/table/TreeTable',['./Table',"./TableRenderer",'sap/ui/model/ClientTreeBindingAdapter','sap/ui/model/TreeBindingCompatibilityAdapter','./library','sap/ui/core/Element','./TableUtils',"./plugins/BindingSelectionPlugin","sap/base/Log","sap/base/assert"],function(T,a,C,b,l,E,c,B,L,d){"use strict";
var e=T.extend("sap.ui.table.TreeTable",{
metadata:{library:"sap.ui.table",properties:{expandFirstLevel:{type:"boolean",defaultValue:false,deprecated:true},useGroupMode:{type:"boolean",group:"Appearance",defaultValue:false},groupHeaderProperty:{type:"string",group:"Data",defaultValue:null},collapseRecursive:{type:"boolean",defaultValue:true},rootLevel:{type:"int",group:"Data",defaultValue:0}},events:{toggleOpenState:{parameters:{rowIndex:{type:"int"},rowContext:{type:"object"},expanded:{type:"boolean"}}}}},
renderer:"sap.ui.table.TableRenderer"
});
e.prototype.init=function(){T.prototype.init.apply(this,arguments);c.Grouping.setTreeMode(this);};
e.prototype.bindRows=function(o){o=T._getSanitizedBindingInfo(arguments);if(o){if(!o.parameters){o.parameters={};}o.parameters.rootLevel=this.getRootLevel();o.parameters.collapseRecursive=this.getCollapseRecursive();if(!("numberOfExpandedLevels"in o.parameters)){o.parameters.numberOfExpandedLevels=this.getExpandFirstLevel()?1:0;}}return T.prototype.bindRows.call(this,o);};
e.prototype.setFixedRowCount=function(r){L.warning("TreeTable: the property \"fixedRowCount\" is not supported and will be ignored!");return this;};
e.prototype.isTreeBinding=function(n){n=n||"rows";if(n==="rows"){return true;}return E.prototype.isTreeBinding.apply(this,arguments);};
e.prototype.getBinding=function(n){n=n||"rows";var o=E.prototype.getBinding.call(this,n);if(o&&n==="rows"&&!o.getLength){if(o.isA("sap.ui.model.odata.ODataTreeBinding")){b(o,this);}else if(o.isA("sap.ui.model.odata.v2.ODataTreeBinding")){o.applyAdapterInterface();}else if(o.isA("sap.ui.model.ClientTreeBinding")){C.apply(o);}else{L.error("Binding not supported by sap.ui.table.TreeTable");}}return o;};
e.prototype._getContexts=function(s,i,t){var o=this.getBinding("rows");if(o){return o.getNodes(s,i,t);}else{return[];}};
e.prototype._onGroupHeaderChanged=function(r,f){this.fireToggleOpenState({rowIndex:r,rowContext:this.getContextByIndex(r),expanded:f});};
e.prototype.expand=function(r){c.Grouping.toggleGroupHeader(this,r,true);return this;};
e.prototype.collapse=function(r){c.Grouping.toggleGroupHeader(this,r,false);return this;};
e.prototype.collapseAll=function(){var o=this.getBinding("rows");if(o){o.collapseToLevel(0);this.setFirstVisibleRow(0);}return this;};
e.prototype.expandToLevel=function(i){var o=this.getBinding("rows");d(o&&o.expandToLevel,"TreeTable.expandToLevel is not supported with your current Binding. Please check if you are running on an ODataModel V2.");if(o&&o.expandToLevel){o.expandToLevel(i);}return this;};
e.prototype.isExpanded=function(r){var o=this.getBinding("rows");if(o){return o.isExpanded(r);}return false;};
e.prototype.getContextByIndex=function(r){var o=this.getBinding("rows");if(o){return o.getContextByIndex(r);}};
e.prototype.setRootLevel=function(r){this.setFirstVisibleRow(0);var o=this.getBinding("rows");if(o){d(o.setRootLevel,"rootLevel is not supported by the used binding");if(o.setRootLevel){o.setRootLevel(r);}}this.setProperty("rootLevel",r,true);return this;};
e.prototype.setCollapseRecursive=function(f){var o=this.getBinding("rows");if(o){d(o.setCollapseRecursive,"Collapse Recursive is not supported by the used binding");if(o.setCollapseRecursive){o.setCollapseRecursive(f);}}this.setProperty("collapseRecursive",!!f,true);return this;};
e.prototype.setUseGroupMode=function(g){this.setProperty("useGroupMode",!!g);if(!!g){c.Grouping.setGroupMode(this);}else{c.Grouping.setTreeMode(this);}return this;};
e.prototype.setEnableGrouping=function(){L.warning("The property enableGrouping is not supported by the sap.ui.table.TreeTable control");return this;};
e.prototype.setGroupBy=function(){L.warning("The groupBy association is not supported by the sap.ui.table.TreeTable control");return this;};
e.prototype.setUseFlatMode=function(f){f=!!f;if(f!=this._bFlatMode){this._bFlatMode=f;if(this.getDomRef()&&c.Grouping.isTreeMode(this)){this.invalidate();}}return this;};
e.prototype._createLegacySelectionPlugin=function(){return new B(this);};
return e;});
sap.ui.predefine('sap/ui/table/TreeTableRenderer',['sap/ui/table/TreeTable'],function(T){"use strict";return T.getMetadata().getRenderer();},true);
sap.ui.predefine('sap/ui/table/library',['sap/ui/core/Core','sap/ui/model/TreeAutoExpandMode','sap/ui/core/library','sap/ui/unified/library'],function(C,T){"use strict";sap.ui.getCore().initLibrary({name:"sap.ui.table",version:"1.72.0",dependencies:["sap.ui.core","sap.ui.unified"],designtime:"sap/ui/table/designtime/library.designtime",types:["sap.ui.table.NavigationMode","sap.ui.table.RowActionType","sap.ui.table.SelectionBehavior","sap.ui.table.SelectionMode","sap.ui.table.SortOrder","sap.ui.table.VisibleRowCountMode","sap.ui.table.TreeAutoExpandMode"],interfaces:[],controls:["sap.ui.table.AnalyticalColumnMenu","sap.ui.table.AnalyticalTable","sap.ui.table.ColumnMenu","sap.ui.table.CreationRow","sap.ui.table.Table","sap.ui.table.TreeTable","sap.ui.table.RowAction"],elements:["sap.ui.table.AnalyticalColumn","sap.ui.table.Column","sap.ui.table.Row","sap.ui.table.RowActionItem","sap.ui.table.RowSettings","sap.ui.table.rowmodes.RowMode","sap.ui.table.rowmodes.FixedRowMode","sap.ui.table.rowmodes.InteractiveRowMode","sap.ui.table.rowmodes.AutoRowMode","sap.ui.table.plugins.MultiSelectionPlugin","sap.ui.table.plugins.SelectionPlugin"],extensions:{flChangeHandlers:{"sap.ui.table.Column":{"propertyChange":"default"},"sap.ui.table.Table":{"moveElements":"default"},"sap.ui.table.AnalyticalTable":{"moveElements":"default"}},"sap.ui.support":{publicRules:true}}});var t=sap.ui.table;t.NavigationMode={Scrollbar:"Scrollbar",Paginator:"Paginator"};t.RowActionType={Custom:"Custom",Navigation:"Navigation",Delete:"Delete"};t.SelectionBehavior={Row:"Row",RowSelector:"RowSelector",RowOnly:"RowOnly"};t.SelectionMode={MultiToggle:"MultiToggle",Multi:"Multi",Single:"Single",None:"None"};t.SortOrder={Ascending:"Ascending",Descending:"Descending"};t.VisibleRowCountMode={Fixed:"Fixed",Interactive:"Interactive",Auto:"Auto"};t.SharedDomRef={HorizontalScrollBar:"hsb",VerticalScrollBar:"vsb"};t.GroupEventType={group:"group",ungroup:"ungroup",ungroupAll:"ungroupAll",moveUp:"moveUp",moveDown:"moveDown",showGroupedColumn:"showGroupedColumn",hideGroupedColumn:"hideGroupedColumn"};t.ColumnHeader=t.Column;t.TreeAutoExpandMode=T;if(!t.TableHelper){t.TableHelper={addTableClass:function(){return"";},createLabel:function(c){throw new Error("no Label control available!");},createTextView:function(c){throw new Error("no TextView control available!");},bFinal:false};}return t;});
sap.ui.predefine('sap/ui/table/plugins/BindingSelectionPlugin',['./SelectionPlugin',"../TableUtils",'../library'],function(S,T,l){"use strict";var a=l.SelectionMode;
var B=S.extend("sap.ui.table.plugins.BindingSelectionPlugin",{
metadata:{library:"sap.ui.table",events:{selectionChange:{parameters:{indices:{type:"int[]"},selectAll:{type:"boolean"}}}}},
constructor:function(t){this._oTable=t;S.call(this);}
});
B.prototype.exit=function(){var b=this._getBinding();if(b){b.detachChange(this._onBindingChange,this);}S.prototype.exit.call(this);};
B.prototype.getRenderConfig=function(){return{headerSelector:{type:"toggle",visible:T.hasSelectAll(this._oTable)}};};
B.prototype.onHeaderSelectorPress=function(){if(this.getRenderConfig().headerSelector.visible){this._oTable._toggleSelectAll();}};
B.prototype.onKeyboardShortcut=function(t){if(t==="toggle"){this._oTable._toggleSelectAll();}else if(t==="clear"){this.clearSelection();}};
B.prototype.addSelectionInterval=function(i,I){if(this._getSelectionMode()===a.None){return;}var b=this._getBinding();if(b&&b.addSelectionInterval){if(this._getSelectionMode()===a.Single){i=I;b.setSelectionInterval(i,I);}b.addSelectionInterval(i,I);}};
B.prototype.clearSelection=function(){var b=this._getBinding();if(b&&b.clearSelection){b.clearSelection();}};
B.prototype.getSelectedIndex=function(){var b=this._getBinding();if(b&&b.findNode){return b.getSelectedIndex();}else{return-1;}};
B.prototype.getSelectedIndices=function(){var b=this._getBinding();if(b&&b.findNode&&b.getSelectedIndices){return b.getSelectedIndices();}else{return[];}};
B.prototype.getSelectableCount=function(){var b=this._getBinding();if(!b){return 0;}else if(b.getGrandTotalContextInfo){var r=b.getGrandTotalContextInfo();return r?r.totalNumberOfLeafs:0;}else{return b.getLength();}};
B.prototype.getSelectedCount=function(){var b=this._getBinding();if(b&&b.getSelectedNodesCount){return b.getSelectedNodesCount();}else{return 0;}};
B.prototype.isIndexSelectable=function(i){var b=this._getBinding();if(b){return b.isIndexSelectable(i);}else{return false;}};
B.prototype.isIndexSelected=function(i){var b=this._getBinding();if(b&&b.isIndexSelected){return b.isIndexSelected(i);}else{return false;}};
B.prototype.removeSelectionInterval=function(i,I){var b=this._getBinding();if(b&&b.findNode&&b.removeSelectionInterval){b.removeSelectionInterval(i,I);}};
B.prototype.selectAll=function(){if(this._getSelectionMode()===a.None){return;}var b=this._getBinding();if(b&&b.selectAll){b.selectAll();}};
B.prototype.setSelectedIndex=function(i){if(this._getSelectionMode()===a.None){return;}if(i===-1){this.clearSelection();}else{var b=this._getBinding();if(b&&b.setSelectedIndex){b.setSelectedIndex(i);}}};
B.prototype.setSelectionInterval=function(i,I){if(this._getSelectionMode()===a.None){return;}var b=this._getBinding();if(b&&b.setSelectionInterval){if(this._getSelectionMode()===a.Single){i=I;}b.setSelectionInterval(i,I);}};
B.prototype.setSelectionMode=function(s){var o=this._getSelectionMode();S.prototype._setSelectionMode.apply(this,arguments);if(this._getSelectionMode()!==o){this.clearSelection();}return this;};
B.prototype._setBinding=function(b){var c=this._getBinding();S.prototype._setBinding.call(this,b);if(c!==b){if(b){b.attachChange(this._onBindingChange,this);b.attachSelectionChanged(this._onSelectionChange,this);}if(c){c.detachChange(this._onBindingChange,this);c.detachSelectionChanged(this._onSelectionChange,this);}}};
B.prototype._onBindingChange=function(e){var r=typeof(e)==="object"?e.getParameter("reason"):e;if(r==="sort"||r==="filter"){this.clearSelection();}};
B.prototype._onSelectionChange=function(e){var r=e.getParameter("rowIndices");var s=e.getParameter("selectAll");this.fireSelectionChange({rowIndices:r,selectAll:s});};
return B;});
sap.ui.predefine('sap/ui/table/plugins/MultiSelectionPlugin',["./SelectionPlugin","./SelectionModelPlugin","./BindingSelectionPlugin","../library","../TableUtils","sap/ui/core/Icon","sap/ui/core/IconPool","sap/base/Log"],function(S,a,B,l,T,I,b,L){"use strict";var c=l.SelectionMode;
var M=S.extend("sap.ui.table.plugins.MultiSelectionPlugin",{metadata:{properties:{limit:{type:"int",group:"Behavior",defaultValue:200},enableNotification:{type:"boolean",group:"Behavior",defaultValue:false},showHeaderSelector:{type:"boolean",group:"Appearance",defaultValue:true},selectionMode:{type:"sap.ui.table.SelectionMode",group:"Behavior",defaultValue:c.MultiToggle}},events:{selectionChange:{parameters:{indices:{type:"int[]"},limitReached:{type:"boolean"}}}}}});
M.prototype.init=function(){S.prototype.init.call(this);var i=new I({src:b.getIconURI(T.ThemeParameters.resetIcon),useIconTooltip:false});i.addStyleClass("sapUiTableSelectClear");this._bLimitReached=false;this._bLimitDisabled=this.getLimit()===0;this.oInnerSelectionPlugin=null;this.oDeselectAllIcon=i;};
M.prototype.exit=function(){if(this.oInnerSelectionPlugin){this.oInnerSelectionPlugin.destroy();this.oInnerSelectionPlugin=null;}if(this.oDeselectAllIcon){this.oDeselectAllIcon.destroy();this.oDeselectAllIcon=null;}if(this._oNotificationPopover){this._oNotificationPopover.destroy();this._oNotificationPopover=null;}};
M.prototype.getRenderConfig=function(){return{headerSelector:{type:this._bLimitDisabled?"toggle":"clear",icon:this.oDeselectAllIcon,visible:this.getSelectionMode()===c.MultiToggle&&this.getShowHeaderSelector(),enabled:this._bLimitDisabled||this.getSelectedCount()>0}};};
M.prototype.onHeaderSelectorPress=function(){var r=this.getRenderConfig();if(!r.headerSelector.visible||!r.headerSelector.enabled){return;}if(r.headerSelector.type==="toggle"){t(this);}else if(r.headerSelector.type==="clear"){this.clearSelection();}};
M.prototype.onKeyboardShortcut=function(s){if(s==="toggle"){if(this._bLimitDisabled){t(this);}}else if(s==="clear"){this.clearSelection();}};
function t(P){if(P.getSelectableCount()>P.getSelectedCount()){P.selectAll();}else{P.clearSelection();}}
M.prototype.setSelectionMode=function(s){var o=this.getSelectionMode();var f=this.getParent();if(f){f.setProperty("selectionMode",s,true);}this.setProperty("selectionMode",s);if(this.getSelectionMode()!==o){this.clearSelection();}return this;};
M.prototype.setLimit=function(i){if(typeof i==="number"&&i<0){L.warning("The limit must be greater than or equal to 0",this);return this;}this.setProperty("limit",i,!!this.getLimit()===!!i);this._bLimitDisabled=i===0;return this;};
M.prototype.setEnableNotification=function(n){this.setProperty("enableNotification",n,true);return this;};
M.prototype.isLimitReached=function(){return this._bLimitReached;};
M.prototype.setLimitReached=function(f){this._bLimitReached=f;};
M.prototype.selectAll=function(){if(this._bLimitDisabled){var i=this._getBinding().getLength()-1;this.addSelectionInterval(0,i);}};
function p(m,i,f,A){var g=m.getLimit();var r=f<i;var o=m._getBinding();var G=r?f:i;if(m.isIndexSelected(i)&&A){if(!r){if(i!==f){i++;G++;}}else{i--;}}var h=Math.abs(f-i)+1;if(!m._bLimitDisabled){m.setLimitReached(h>g);if(m.isLimitReached()){if(!r){f=i+g-1;}else{f=i-g+1;}h=g+1;}}if(o&&G>=0&&h>0){return d(o,G,h).then(function(){return{indexFrom:i,indexTo:f};});}return Promise.resolve();}
M.prototype.setSelectionInterval=function(i,f){var s=this.getSelectionMode();if(s===c.None){return;}else if(s===c.Single){i=f;}p(this,i,f,false).then(function(m){if(m){this.oInnerSelectionPlugin.setSelectionInterval(m.indexFrom,m.indexTo);this._scrollTableToRow(m.indexFrom>m.indexTo,m.indexTo);}}.bind(this));};
M.prototype.setSelectedIndex=function(i){this.setSelectionInterval(i,i);};
M.prototype.addSelectionInterval=function(i,f){var s=this.getSelectionMode();if(s===c.None){return;}else if(s===c.Single){i=f;this.setSelectionInterval(i,f);return;}p(this,i,f,true).then(function(m){if(m){this.oInnerSelectionPlugin.addSelectionInterval(m.indexFrom,m.indexTo);this._scrollTableToRow(m.indexFrom>m.indexTo,m.indexTo);}}.bind(this));};
M.prototype._scrollTableToRow=function(r,i){var o=this.getParent();if(!o||!this.isLimitReached()){return;}var f=o.getFirstVisibleRow();var R=o._getRowCounts();var g=f+R.scrollable-1;if(i<f||i>g){if(!r){o.setFirstVisibleRow(Math.max(0,i-R.scrollable-R.fixedTop+2));}else{o.setFirstVisibleRow(Math.max(0,i-R.fixedTop-1));}}if(this.getEnableNotification()){this.showNotificationPopoverAtIndex(i);}};
M.prototype.showNotificationPopoverAtIndex=function(i){var f=this;var P=this._oNotificationPopover;var o=this.getParent();var r=o.getRows()[i-o._getFirstRenderedRowIndex()];var s=T.getResourceText('TBL_SELECT_LIMIT_TITLE');var m=T.getResourceText('TBL_SELECT_LIMIT',[this.getLimit()]);return new Promise(function(g,h){sap.ui.require(['sap/m/Popover','sap/m/Bar','sap/m/Title','sap/m/Text','sap/m/HBox','sap/ui/core/library','sap/m/library'],function(j,k,n,q,H,u,v){if(!P){P=new j(f.getId()+'-notificationPopover',{customHeader:[new k({contentMiddle:[new H({items:[new I({src:'sap-icon://message-warning',color:u.IconColor.Critical}).addStyleClass("sapUiTinyMarginEnd"),new n({text:s,level:u.TitleLevel.H2})],renderType:v.FlexRendertype.Bare,justifyContent:v.FlexJustifyContent.Center,alignItems:v.FlexAlignItems.Center})]})],content:new q({text:m})});P.addStyleClass("sapUiContentPadding");f._oNotificationPopover=P;}else{P.getContent()[0].setText(m);}o.detachFirstVisibleRowChanged(f.onFirstVisibleRowChange,f);o.attachFirstVisibleRowChanged(f.onFirstVisibleRowChange,f);var R=r.getDomRefs().rowSelector;if(R){P.openBy(R);}g();});});};
M.prototype.onFirstVisibleRowChange=function(){if(!this._oNotificationPopover){return;}var o=this.getParent();if(o){o.detachFirstVisibleRowChanged(this.onFirstVisibleRowChange,this);}this._oNotificationPopover.close();};
function d(o,s,i){return new Promise(function(r){e(o,s,i,r);});}
function e(o,s,f,r){var C=o.getContexts(s,f);var g=false;for(var i=0;i<C.length;i++){if(!C[i]){g=true;break;}}if(!g&&!C.dataRequested){r(C);return;}o.attachEventOnce("dataReceived",function(){C=o.getContexts(s,f);if(C.length==f){r(C);}else{e(o,s,f,r);}});}
M.prototype.clearSelection=function(){if(this.oInnerSelectionPlugin){this.setLimitReached(false);this.oInnerSelectionPlugin.clearSelection();}};
M.prototype.getSelectedIndex=function(){if(this.oInnerSelectionPlugin){return this.oInnerSelectionPlugin.getSelectedIndex();}return-1;};
M.prototype.getSelectedIndices=function(){if(this.oInnerSelectionPlugin){return this.oInnerSelectionPlugin.getSelectedIndices();}return[];};
M.prototype.getSelectableCount=function(){if(this.oInnerSelectionPlugin){return this.oInnerSelectionPlugin.getSelectableCount();}return 0;};
M.prototype.getSelectedCount=function(){if(this.oInnerSelectionPlugin){return this.oInnerSelectionPlugin.getSelectedCount();}return 0;};
M.prototype.isIndexSelectable=function(i){if(this.oInnerSelectionPlugin){return this.oInnerSelectionPlugin.isIndexSelectable(i);}return false;};
M.prototype.isIndexSelected=function(i){if(this.oInnerSelectionPlugin){return this.oInnerSelectionPlugin.isIndexSelected(i);}return false;};
M.prototype.removeSelectionInterval=function(i,f){if(this.oInnerSelectionPlugin){this.setLimitReached(false);this.oInnerSelectionPlugin.removeSelectionInterval(i,f);}};
M.prototype.setParent=function(P){var o=this.getParent();if(o){o.detachFirstVisibleRowChanged(this.onFirstVisibleRowChange,this);}if(this._oNotificationPopover){this._oNotificationPopover.close();}var r=S.prototype.setParent.apply(this,arguments);if(this.oInnerSelectionPlugin){this.oInnerSelectionPlugin.destroy();this.oInnerSelectionPlugin=null;}if(P){this.oInnerSelectionPlugin=P._createLegacySelectionPlugin();this.oInnerSelectionPlugin.attachSelectionChange(this._onSelectionChange,this);P.setProperty("selectionMode",this.getSelectionMode());}return r;};
M.prototype._onSelectionChange=function(E){var r=E.getParameter("rowIndices");this.fireSelectionChange({rowIndices:r,limitReached:this.isLimitReached()});};
M.prototype._getLastIndex=function(){if(this.oInnerSelectionPlugin){return this.oInnerSelectionPlugin._getLastIndex();}return 0;};
M.prototype._getBinding=function(){if(this.oInnerSelectionPlugin){return this.oInnerSelectionPlugin._getBinding();}return null;};
M.prototype._setBinding=function(o){if(this.oInnerSelectionPlugin){return this.oInnerSelectionPlugin._setBinding(o);}};
M.prototype._onBindingChange=function(E){if(this.oInnerSelectionPlugin){return this.oInnerSelectionPlugin._onBindingChange(E);}};
M.prototype.onThemeChanged=function(){this.oDeselectAllIcon.setSrc(b.getIconURI(T.ThemeParameters.resetIcon));};
return M;});
sap.ui.predefine('sap/ui/table/plugins/SelectionModelPlugin',['sap/ui/model/SelectionModel','./SelectionPlugin',"../TableUtils",'../library'],function(S,a,T,l){"use strict";var b=l.SelectionMode;
var c=a.extend("sap.ui.table.plugins.SelectionModelPlugin",{
metadata:{library:"sap.ui.table",events:{selectionChange:{parameters:{indices:{type:"int[]"},selectAll:{type:"boolean"}}}}},
constructor:function(t){this._oTable=t;a.call(this);}
});
c.prototype.init=function(){this.oSelectionModel=new S(this._getSelectionMode);this.oSelectionModel.attachSelectionChanged(this._onSelectionChange,this);a.prototype.init.call(this);};
c.prototype.exit=function(){var B=this._getBinding();if(B){B.detachChange(this._onBindingChange,this);}if(this.oSelectionModel){this.oSelectionModel.destroy();this.oSelectionModel=null;}a.prototype.exit.call(this);};
c.prototype.getRenderConfig=function(){return{headerSelector:{type:"toggle",visible:T.hasSelectAll(this._oTable)}};};
c.prototype.onHeaderSelectorPress=function(){if(this.getRenderConfig().headerSelector.visible){this._oTable._toggleSelectAll();}};
c.prototype.onKeyboardShortcut=function(t){if(t==="toggle"){this._oTable._toggleSelectAll();}else if(t==="clear"){this.clearSelection();}};
c.prototype.addSelectionInterval=function(i,I){if(!this.oSelectionModel||this._getSelectionMode()===b.None){return;}this.oSelectionModel.addSelectionInterval(i,I);};
c.prototype.clearSelection=function(){if(this.oSelectionModel){this.oSelectionModel.clearSelection();}};
c.prototype.getSelectedIndex=function(){if(this.oSelectionModel){return this.oSelectionModel.getLeadSelectedIndex();}return-1;};
c.prototype.getSelectedIndices=function(){if(this.oSelectionModel){return this.oSelectionModel.getSelectedIndices();}return[];};
c.prototype.getSelectableCount=function(){var B=this._getBinding();return B?B.getLength():0;};
c.prototype.getSelectedCount=function(){return this.getSelectedIndices().length;};
c.prototype.isIndexSelectable=function(i){var C=this._getLastIndex();return i>=0&&i<=C;};
c.prototype.isIndexSelected=function(i){return this.getSelectedIndices().indexOf(i)!==-1;};
c.prototype.removeSelectionInterval=function(i,I){if(this.oSelectionModel){this.oSelectionModel.removeSelectionInterval(i,I);}};
c.prototype.selectAll=function(){if(!this.oSelectionModel||this._getSelectionMode()===b.None){return;}this.oSelectionModel.selectAll(this._getLastIndex());};
c.prototype.setSelectedIndex=function(i){if(this._getSelectionMode()===b.None){return;}if(i===-1){this.clearSelection();}else{this.setSelectionInterval(i,i);}};
c.prototype.setSelectionInterval=function(i,I){if(!this.oSelectionModel||this._getSelectionMode()===b.None){return;}this.oSelectionModel.setSelectionInterval(i,I);};
c.prototype.setSelectionMode=function(s){var o=this._getSelectionMode();a.prototype._setSelectionMode.apply(this,arguments);if(this._getSelectionMode()!==o){this.clearSelection();}if(this.oSelectionModel){var i=(s===b.MultiToggle?S.MULTI_SELECTION:S.SINGLE_SELECTION);this.oSelectionModel.setSelectionMode(i);}return this;};
c.prototype._getLastIndex=function(){if(!this._getBinding()){return 0;}return this._getBinding().getLength()-1;};
c.prototype._onSelectionChange=function(e){var r=e.getParameter("rowIndices");var s=e.getParameter("selectAll");this.fireSelectionChange({rowIndices:r,selectAll:s});};
c.prototype._setBinding=function(B){var C=this._getBinding();a.prototype._setBinding.call(this,B);if(C!==B){this._suspend();this.clearSelection();this._resume();if(B){B.attachChange(this._onBindingChange,this);}if(C){C.detachChange(this._onBindingChange,this);}}};
c.prototype._onBindingChange=function(e){var r=typeof(e)==="object"?e.getParameter("reason"):e;if(r==="sort"||r==="filter"){this.clearSelection();}};
return c;});
sap.ui.predefine('sap/ui/table/plugins/SelectionPlugin',['sap/ui/core/Element','../library'],function(E,l){"use strict";var S=l.SelectionMode;
var a=E.extend("sap.ui.table.plugins.SelectionPlugin",{metadata:{"abstract":true,library:"sap.ui.table",properties:{selectionMode:{type:"sap.ui.table.SelectionMode",defaultValue:S.MultiToggle,visibility:"hidden"}},events:{selectionChange:{parameters:{}}}}});
a.prototype.init=function(){this._bSuspended=false;};
a.prototype.exit=function(){this._oBinding=null;};
a.prototype.getRenderConfig=function(){return{headerSelector:{type:"none"}};};
a.prototype.addSelectionInterval=function(i,I){};
a.prototype.clearSelection=function(){};
a.prototype.getSelectedIndex=function(){return-1;};
a.prototype.getSelectedIndices=function(){return[];};
a.prototype.getSelectableCount=function(){return 0;};
a.prototype.getSelectedCount=function(){return 0;};
a.prototype.isIndexSelectable=function(i){return false;};
a.prototype.isIndexSelected=function(i){return false;};
a.prototype.removeSelectionInterval=function(i,I){};
a.prototype.selectAll=function(){};
a.prototype.setSelectedIndex=function(i){};
a.prototype.setSelectionInterval=function(i,I){};
a.prototype.fireSelectionChange=function(A){if(!this._isSuspended()){this.fireEvent("selectionChange",A);}};
a.prototype._setSelectionMode=function(s){this.setProperty("selectionMode",s);};
a.prototype._getSelectionMode=function(){return this.getProperty("selectionMode");};
a.prototype._getBinding=function(){return this._oBinding;};
a.prototype._setBinding=function(b){this._oBinding=b;};
a.prototype._suspend=function(){this._bSuspended=true;};
a.prototype._resume=function(){this._bSuspended=false;};
a.prototype._isSuspended=function(){return this._bSuspended;};
return a;});
sap.ui.predefine('sap/ui/table/rowmodes/AutoRowMode',["../library","../TableUtils","./RowMode","sap/ui/Device","sap/base/Log"],function(l,T,R,D,L){"use strict";
var A=R.extend("sap.ui.table.rowmodes.AutoRowMode",{
metadata:{library:"sap.ui.table",properties:{rowContentHeight:{type:"int",defaultValue:0,group:"Appearance"},minRowCount:{type:"int",defaultValue:5,group:"Appearance"},maxRowCount:{type:"int",defaultValue:-1,group:"Appearance"},hideEmptyRows:{type:"boolean",defaultValue:false,group:"Appearance"}}},
constructor:function(i){Object.defineProperty(this,"bLegacy",{value:typeof i==="boolean"?i:false});if(this.bLegacy){var t=arguments[1];this.getParent=function(){return t;};R.call(this);this.attachEvents();}else{R.apply(this,arguments);}}
});
var a={};
A.prototype.init=function(){R.prototype.init.call(this,a);this.bRowCountAutoAdjustmentActive=false;this.iLastAvailableSpace=0;this.adjustRowCountToAvailableSpaceAsync=T.debounce(this.adjustRowCountToAvailableSpace,{requestAnimationFrame:true});};
A.prototype.attachEvents=function(){R.prototype.attachEvents.apply(this,arguments);T.addDelegate(this.getTable(),a,this);};
A.prototype.detachEvents=function(){R.prototype.detachEvents.apply(this,arguments);T.removeDelegate(this.getTable(),a);};
A.prototype.cancelAsyncOperations=function(){R.prototype.cancelAsyncOperations.apply(this,arguments);this.stopAutoRowMode();};
A.prototype.setRowCount=function(){L.error("The row count is set automatically and cannot be set manually.",this);return this;};
A.prototype.getRowCount=function(){return this.bLegacy?this.getTable().getVisibleRowCount():this.getProperty("rowCount");};
A.prototype.getFixedTopRowCount=function(){return this.bLegacy?this.getTable().getFixedRowCount():this.getProperty("fixedTopRowCount");};
A.prototype.getFixedBottomRowCount=function(){return this.bLegacy?this.getTable().getFixedBottomRowCount():this.getProperty("fixedBottomRowCount");};
A.prototype.getMinRowCount=function(){return this.bLegacy?this.getTable().getMinAutoRowCount():this.getProperty("minRowCount");};
A.prototype.getRowContentHeight=function(){return this.bLegacy?this.getTable().getRowHeight():this.getProperty("rowContentHeight");};
A.prototype._getMinRowCount=function(){var m=this.getMinRowCount();var M=this.getMaxRowCount();if(M>=0){return Math.min(m,M);}else{return m;}};
A.prototype.getMinRequestLength=function(){var t=this.getTable();var r=this.getConfiguredRowCount();if(this.isPropertyInitial("rowCount")||(t&&!t._bContextsAvailable)){var e=Math.ceil(D.resize.height/T.DefaultRowHeight.sapUiSizeCondensed);r=Math.max(r,e);}return r;};
A.prototype.getComputedRowCounts=function(){if(this.isPropertyInitial("rowCount")){return{count:0,scrollable:0,fixedTop:0,fixedBottom:0};}var r=this.getConfiguredRowCount();var f=this.getFixedTopRowCount();var F=this.getFixedBottomRowCount();if(this.getHideEmptyRows()){r=Math.min(r,this.getTotalRowCountOfTable());}return this.sanitizeRowCounts(r,f,F);};
A.prototype.getTableStyles=function(){var h="0px";if(this.isPropertyInitial("rowCount")){h="auto";}else{var r=this.getConfiguredRowCount();if(r===0||r===this._getMinRowCount()){h="auto";}}return{height:h};};
A.prototype.getTableBottomPlaceholderStyles=function(){if(!this.getHideEmptyRows()){return undefined;}var r=0;if(this.isPropertyInitial("rowCount")){r=this._getMinRowCount();}else{r=this.getConfiguredRowCount()-this.getComputedRowCounts().count;}return{height:r*this.getBaseRowHeightOfTable()+"px"};};
A.prototype.getRowContainerStyles=function(){return{height:this.getComputedRowCounts().count*this.getBaseRowHeightOfTable()+"px"};};
A.prototype.renderRowStyles=function(r){var i=this.getRowContentHeight();if(i>0){r.style("height",this.getBaseRowHeightOfTable()+"px");}};
A.prototype.renderCellContentStyles=function(r){var i=this.getRowContentHeight();if(!this.bLegacy&&i<=0){i=this.getDefaultRowContentHeightOfTable();}if(i>0){r.style("max-height",i+"px");}};
A.prototype.getBaseRowContentHeight=function(){return Math.max(0,this.getRowContentHeight());};
A.prototype.refreshRows=function(){var c=this.getConfiguredRowCount();var r=!this.isPropertyInitial("rowCount");if(c>0){if(r){this.initTableRowsAfterDataRequested(c);}this.getRowContexts(c,true);}};
A.prototype.getConfiguredRowCount=function(){var r=Math.max(0,this.getMinRowCount(),this.getRowCount());var m=this.getMaxRowCount();if(m>=0){r=Math.min(r,m);}return r;};
A.prototype.startAutoRowMode=function(){this.adjustRowCountToAvailableSpaceAsync(T.RowsUpdateReason.Render,true);};
A.prototype.stopAutoRowMode=function(){this.deregisterResizeHandler();this.adjustRowCountToAvailableSpaceAsync.cancel();this.bRowCountAutoAdjustmentActive=false;};
A.prototype.registerResizeHandler=function(o){var t=this.getTable();if(t){T.registerResizeHandler(t,"AutoRowMode",this.onResize.bind(this),null,o===true);}};
A.prototype.deregisterResizeHandler=function(){var t=this.getTable();if(t){T.deregisterResizeHandler(t,"AutoRowMode");}};
A.prototype.onResize=function(e){var o=e.oldSize.height;var n=e.size.height;if(o!==n){this.adjustRowCountToAvailableSpaceAsync(T.RowsUpdateReason.Resize);}};
A.prototype.updateTableSizes=function(r){if(r===T.RowsUpdateReason.Resize||r===T.RowsUpdateReason.Render){return;}if(this.bRowCountAutoAdjustmentActive){this.adjustRowCountToAvailableSpaceAsync(r);}};
A.prototype.adjustRowCountToAvailableSpace=function(r,s){s=s===true;var t=this.getTable();var o=t?t.getDomRef():null;if(!t||t._bInvalid||!o||!sap.ui.getCore().isThemeApplied()){return;}this.bTableIsFlexItem=window.getComputedStyle(o.parentNode).display==="flex";if(o.offsetWidth===0){if(s){this.registerResizeHandler(!this.bTableIsFlexItem);this.bRowCountAutoAdjustmentActive=true;}return;}var n=this.determineAvailableSpace();var O=this.getConfiguredRowCount();var N=Math.floor(n/this.getBaseRowHeightOfTable());var i=this.getComputedRowCounts().count;var b;if(this.bLegacy){t.setProperty("visibleRowCount",N,true);}this.setProperty("rowCount",N,true);b=this.getComputedRowCounts().count;if(i!==b){this.updateTable(r);}else{if(O!==N){this.applyTableStyles();this.applyRowContainerStyles();this.applyTableBottomPlaceholderStyles();}if(s&&t.getRows().length>0){t._fireRowsUpdated(r);}}if(s){this.registerResizeHandler(!this.bTableIsFlexItem);this.bRowCountAutoAdjustmentActive=true;}};
A.prototype.determineAvailableSpace=function(){var t=this.getTable();var o=t?t.getDomRef():null;var r=t?t.getDomRef("tableCCnt"):null;var p=t?t.getDomRef("placeholder-bottom"):null;if(!o||!r||!o.parentNode){return 0;}var u=0;var b=r.clientHeight;var P=p?p.clientHeight:0;if(this.bTableIsFlexItem){var c=o.childNodes;for(var i=0;i<c.length;i++){u+=c[i].offsetHeight;}u-=b-P;}else{u=o.scrollHeight-b-P;}var s=t._getScrollExtension();if(!s.isHorizontalScrollbarVisible()){var d={};d[D.browser.BROWSER.CHROME]=16;d[D.browser.BROWSER.FIREFOX]=16;d[D.browser.BROWSER.INTERNET_EXPLORER]=18;d[D.browser.BROWSER.EDGE]=16;d[D.browser.BROWSER.SAFARI]=16;d[D.browser.BROWSER.ANDROID]=8;u+=d[D.browser.name];}var e=this.bTableIsFlexItem?o:o.parentNode;var n=Math.max(0,Math.floor(jQuery(e).height()-u));var f=Math.abs(n-this.iLastAvailableSpace);if(f>=5){this.iLastAvailableSpace=n;}return this.iLastAvailableSpace;};
a.onBeforeRendering=function(e){var r=e&&e.isMarked("renderRows");if(!r){this.stopAutoRowMode();this.updateTable(T.RowsUpdateReason.Render);}};
a.onAfterRendering=function(e){var r=e&&e.isMarked("renderRows");if(!r){this.startAutoRowMode();}};
return A;});
sap.ui.predefine('sap/ui/table/rowmodes/FixedRowMode',["../library","./RowMode","../TableUtils"],function(l,R,T){"use strict";
var F=R.extend("sap.ui.table.rowmodes.FixedRowMode",{
metadata:{library:"sap.ui.table",properties:{rowContentHeight:{type:"int",defaultValue:0,group:"Appearance"},hideEmptyRows:{type:"boolean",defaultValue:false,group:"Appearance"}}},
constructor:function(i){Object.defineProperty(this,"bLegacy",{value:typeof i==="boolean"?i:false});if(this.bLegacy){var t=arguments[1];this.getParent=function(){return t;};R.call(this);this.attachEvents();}else{R.apply(this,arguments);}}
});
var a={};
F.prototype.attachEvents=function(){R.prototype.attachEvents.apply(this,arguments);T.addDelegate(this.getTable(),a,this);};
F.prototype.detachEvents=function(){R.prototype.detachEvents.apply(this,arguments);T.removeDelegate(this.getTable(),a);};
F.prototype.getRowCount=function(){return this.bLegacy?this.getTable().getVisibleRowCount():this.getProperty("rowCount");};
F.prototype.getFixedTopRowCount=function(){return this.bLegacy?this.getTable().getFixedRowCount():this.getProperty("fixedTopRowCount");};
F.prototype.getFixedBottomRowCount=function(){return this.bLegacy?this.getTable().getFixedBottomRowCount():this.getProperty("fixedBottomRowCount");};
F.prototype.getRowContentHeight=function(){return this.bLegacy?this.getTable().getRowHeight():this.getProperty("rowContentHeight");};
F.prototype.getMinRequestLength=function(){return Math.max(0,this.getRowCount());};
F.prototype.getComputedRowCounts=function(){var r=this.getRowCount();var f=this.getFixedTopRowCount();var i=this.getFixedBottomRowCount();if(this.getHideEmptyRows()){r=Math.min(r,this.getTotalRowCountOfTable());}return this.sanitizeRowCounts(r,f,i);};
F.prototype.getTableStyles=function(){return{height:"auto"};};
F.prototype.getTableBottomPlaceholderStyles=function(){if(!this.getHideEmptyRows()){return undefined;}var r=Math.max(0,this.getRowCount()-this.getComputedRowCounts().count);return{height:r*this.getBaseRowHeightOfTable()+"px"};};
F.prototype.getRowContainerStyles=function(){var h=this.getComputedRowCounts().count*this.getBaseRowHeightOfTable()+"px";if(this.bLegacy&&!T.isVariableRowHeightEnabled(this.getTable())){return{minHeight:h};}else{return{height:h};}};
F.prototype.renderRowStyles=function(r){var i=this.getRowContentHeight();if(i>0){r.style("height",this.getBaseRowHeightOfTable()+"px");}};
F.prototype.renderCellContentStyles=function(r){var i=this.getRowContentHeight();if(this.bLegacy){return;}if(i<=0){i=this.getDefaultRowContentHeightOfTable();}if(i>0){r.style("max-height",i+"px");}};
F.prototype.getBaseRowContentHeight=function(){return Math.max(0,this.getRowContentHeight());};
F.prototype.refreshRows=function(){var r=this.getRowCount();if(r>0){this.initTableRowsAfterDataRequested(r);this.getRowContexts(r,true);}};
a.onBeforeRendering=function(e){var r=e&&e.isMarked("renderRows");if(!r){this.updateTable(T.RowsUpdateReason.Render);}};
a.onAfterRendering=function(e){var t=this.getTable();var r=e&&e.isMarked("renderRows");if(!r&&t.getRows().length>0){t._fireRowsUpdated(T.RowsUpdateReason.Render);}};
return F;});
sap.ui.predefine('sap/ui/table/rowmodes/InteractiveRowMode',["../library","./RowMode","../TableUtils","sap/base/Log","sap/ui/thirdparty/jquery"],function(l,R,T,L,q){"use strict";
var I=R.extend("sap.ui.table.rowmodes.InteractiveRowMode",{
metadata:{library:"sap.ui.table","final":true,properties:{rowContentHeight:{type:"int",defaultValue:0,group:"Appearance"},minRowCount:{type:"int",defaultValue:5,group:"Appearance"}}},
constructor:function(i){Object.defineProperty(this,"bLegacy",{value:typeof i==="boolean"?i:false});if(this.bLegacy){var t=arguments[1];this.getParent=function(){return t;};R.call(this);this.attachEvents();}else{R.apply(this,arguments);}}
});
var a={};var b={};
I.prototype.attachEvents=function(){R.prototype.attachEvents.apply(this,arguments);T.addDelegate(this.getTable(),a,this);};
I.prototype.detachEvents=function(){R.prototype.detachEvents.apply(this,arguments);T.removeDelegate(this.getTable(),a);};
I.prototype.getRowCount=function(){return this.bLegacy?this.getTable().getVisibleRowCount():this.getProperty("rowCount");};
I.prototype.getFixedTopRowCount=function(){return this.bLegacy?this.getTable().getFixedRowCount():this.getProperty("fixedTopRowCount");};
I.prototype.getFixedBottomRowCount=function(){return this.bLegacy?this.getTable().getFixedBottomRowCount():this.getProperty("fixedBottomRowCount");};
I.prototype.getMinRowCount=function(){return this.bLegacy?this.getTable().getMinAutoRowCount():this.getProperty("minRowCount");};
I.prototype.getRowContentHeight=function(){return this.bLegacy?this.getTable().getRowHeight():this.getProperty("rowContentHeight");};
I.prototype.getMinRequestLength=function(){return this.getConfiguredRowCount();};
I.prototype.getComputedRowCounts=function(){return this.sanitizeRowCounts(this.getConfiguredRowCount(),this.getFixedTopRowCount(),this.getFixedBottomRowCount());};
I.prototype.getTableStyles=function(){return{height:"auto"};};
I.prototype.getTableBottomPlaceholderStyles=function(){return undefined;};
I.prototype.getRowContainerStyles=function(){var h=this.getComputedRowCounts().count*this.getBaseRowHeightOfTable()+"px";if(this.bLegacy&&!T.isVariableRowHeightEnabled(this.getTable())){return{minHeight:h};}else{return{height:h};}};
I.prototype.renderRowStyles=function(r){var i=this.getRowContentHeight();if(i>0){r.style("height",this.getBaseRowHeightOfTable()+"px");}};
I.prototype.renderCellContentStyles=function(r){var i=this.getRowContentHeight();if(this.bLegacy){return;}if(i<=0){i=this.getDefaultRowContentHeightOfTable();}if(i>0){r.style("max-height",i+"px");}};
I.prototype.getBaseRowContentHeight=function(){return Math.max(0,this.getRowContentHeight());};
I.prototype.refreshRows=function(){var r=this.getConfiguredRowCount();if(r>0){this.initTableRowsAfterDataRequested(r);this.getRowContexts(r,true);}};
I.prototype.getConfiguredRowCount=function(){return Math.max(0,this.getMinRowCount(),this.getRowCount());};
a.onBeforeRendering=function(e){var r=e&&e.isMarked("renderRows");if(this.bLegacy){this.getTable().setVisibleRowCount(this.getComputedRowCounts().count);}if(!r){this.updateTable(T.RowsUpdateReason.Render);}};
a.onAfterRendering=function(e){var t=this.getTable();var r=e&&e.isMarked("renderRows");if(!r&&t.getRows().length>0){t._fireRowsUpdated(T.RowsUpdateReason.Render);}};
a.onmousedown=function(e){var t=this.getTable();if(e.button===0&&e.target===t.getDomRef("sb")){b.initInteractiveResizing(t,this,e);}};
b.initInteractiveResizing=function(t,m,e){var B=q(document.body);var s=t.$("sb");var d=q(document);var o=s.offset();var h=s.height();var w=s.width();var c=t._isTouchEvent(e);B.bind("selectstart",b.onSelectStartWhileInteractiveResizing);B.append("<div id=\""+t.getId()+"-ghost\" class=\"sapUiTableInteractiveResizerGhost\" style =\" height:"+h+"px; width:"+w+"px; left:"+o.left+"px; top:"+o.top+"px\" ></div>");s.append("<div id=\""+t.getId()+"-rzoverlay\" style =\"left: 0px; right: 0px; bottom: 0px; top: 0px; position:absolute\" ></div>");d.bind((c?"touchend":"mouseup")+".sapUiTableInteractiveResize",b.exitInteractiveResizing.bind(t,m));d.bind((c?"touchmove":"mousemove")+".sapUiTableInteractiveResize",b.onMouseMoveWhileInteractiveResizing.bind(t));t._disableTextSelection();};
b.exitInteractiveResizing=function(m,e){var B=q(document.body);var d=q(document);var t=this.$();var g=this.$("ghost");var i=b.getEventPosition(this,e).y;var n=i-t.find(".sapUiTableCCnt").offset().top-g.height()-t.find(".sapUiTableFtr").height();var u=Math.floor(n/m.getBaseRowHeightOfTable());var N=Math.max(1,u,m.getMinRowCount());if(m.bLegacy){N=Math.max(N,m.getFixedTopRowCount()+m.getFixedBottomRowCount()+1);this.setVisibleRowCount(N);}m.setRowCount(N);g.remove();this.$("rzoverlay").remove();B.unbind("selectstart",b.onSelectStartWhileInteractiveResizing);d.unbind("touchend.sapUiTableInteractiveResize");d.unbind("touchmove.sapUiTableInteractiveResize");d.unbind("mouseup.sapUiTableInteractiveResize");d.unbind("mousemove.sapUiTableInteractiveResize");this._enableTextSelection();};
b.onSelectStartWhileInteractiveResizing=function(e){e.preventDefault();e.stopPropagation();return false;};
b.onMouseMoveWhileInteractiveResizing=function(e){var i=b.getEventPosition(this,e).y;var m=this.$().offset().top;if(i>m){this.$("ghost").css("top",i+"px");}};
b.getEventPosition=function(t,e){var p;function g(o){if(!t._isTouchEvent(o)){return null;}var c=["touches","targetTouches","changedTouches"];for(var i=0;i<c.length;i++){var s=c[i];if(e[s]&&e[s][0]){return e[s][0];}if(e.originalEvent[s]&&e.originalEvent[s][0]){return e.originalEvent[s][0];}}return null;}p=g(e)||e;return{x:p.pageX,y:p.pageY};};
return I;});
sap.ui.predefine('sap/ui/table/rowmodes/RowMode',["../library","../TableUtils","sap/ui/core/Element","sap/base/Log","sap/ui/thirdparty/jquery"],function(l,T,E,L,q){"use strict";
var R=E.extend("sap.ui.table.rowmodes.RowMode",{metadata:{library:"sap.ui.table","abstract":true,properties:{rowCount:{type:"int",defaultValue:10,group:"Appearance"},fixedTopRowCount:{type:"int",defaultValue:0,group:"Appearance"},fixedBottomRowCount:{type:"int",defaultValue:0,group:"Appearance"}}}});
var a={};
R.prototype.init=function(t){this._bTableIsRendering=false;this.updateTableAsync=T.throttle(this.updateTable,{wait:50,asyncLeading:true});};
R.prototype.exit=function(){this.detachEvents();this.cancelAsyncOperations();};
R.prototype.setParent=function(){this.detachEvents();this.cancelAsyncOperations();E.prototype.setParent.apply(this,arguments);this.attachEvents();};
R.prototype.attachEvents=function(){T.addDelegate(this.getTable(),a,this);};
R.prototype.detachEvents=function(){T.removeDelegate(this.getTable(),a);};
R.prototype.cancelAsyncOperations=function(){var t=this.getTable();if(t){clearTimeout(t._mTimeouts.refreshRowsCreateRows);}this.updateTableAsync.cancel();};
R.prototype.getMinRequestLength=function(){throw new Error(this.getMetadata().getName()+": sap.ui.table.rowmodes.RowMode subclass did not implement #getMinRequestLength");};
R.prototype.getComputedRowCounts=function(){throw new Error(this.getMetadata().getName()+": sap.ui.table.rowmodes.RowMode subclass did not implement #getComputedRowCounts");};
R.prototype.getTableStyles=function(){throw new Error(this.getMetadata().getName()+": sap.ui.table.rowmodes.RowMode subclass did not implement #getTableStyles");};
R.prototype.getTableBottomPlaceholderStyles=function(){throw new Error(this.getMetadata().getName()+": sap.ui.table.rowmodes.RowMode subclass did not implement #getTableBottomPlaceholderStyles");};
R.prototype.getRowContainerStyles=function(){throw new Error(this.getMetadata().getName()+": sap.ui.table.rowmodes.RowMode subclass did not implement #getRowContainerStyles");};
R.prototype.getTable=function(){var p=this.getParent();return T.isA(p,"sap.ui.table.Table")?p:null;};
R.prototype.updateTable=function(r){var t=this.getTable();if(!t){return;}this.updateTableAsync.cancel();var b=this.updateTableRows();if(t._bInvalid||this._bTableIsRendering){return;}this.applyTableStyles();this.applyRowContainerStyles();this.applyTableBottomPlaceholderStyles();if(b||t.getRows().some(function(o){return o.getDomRef()==null;})){this.renderTableRows();}if(b||t.getRows().length>0){t._fireRowsUpdated(r);}};
R.prototype.getBaseRowContentHeight=function(){return 0;};
R.prototype.getBaseRowHeightOfTable=function(){var t=this.getTable();return t?t._getBaseRowHeight():0;};
R.prototype.getDefaultRowContentHeightOfTable=function(){var t=this.getTable();return t?t._getDefaultRowContentHeight():0;};
R.prototype.getTotalRowCountOfTable=function(){var t=this.getTable();return t?t._getTotalRowCount():0;};
R.prototype.updateTableSizes=function(r){};
R.prototype.unbindRows=function(){clearTimeout(this.getTable()._mTimeouts.refreshRowsCreateRows);this.updateTable(T.RowsUpdateReason.Unbind);};
R.prototype.refreshRows=function(r){};
R.prototype.updateRows=function(r){var t=this.getTable();clearTimeout(t._mTimeouts.refreshRowsCreateRows);if(!t._bBindingReady){var C=this.getRowContexts(null,true);if(this.getTotalRowCountOfTable()===0&&C.length===1){var v=C[0];var V=c(t,1)[0];V.setBindingContext(v);t.addAggregation("rows",V,true);t.removeAggregation("rows",V,true);V.setBindingContext(null);}return;}this.updateTableAsync(r);};
R.prototype.applyTableStyles=function(r){var t=this.getTableStyles();if(r){r.style("height",t.height);r.style("min-height",t.minHeight);r.style("max-height",t.maxHeight);return;}var o=this.getTable();var b=o?o.getDomRef():null;if(b){b.style.height=t.height;b.style.minHeight=t.minHeight;b.style.maxHeight=t.maxHeight;}};
R.prototype.applyTableBottomPlaceholderStyles=function(r){var p=this.getTableBottomPlaceholderStyles();if(r){r.style("height",p.height);return;}var t=this.getTable();var P=t?t.getDomRef("placeholder-bottom"):null;if(P){P.style.height=p.height;}};
R.prototype.applyRowContainerStyles=function(r){var m=this.getRowContainerStyles();if(r){r.style("height",m.height);r.style("min-height",m.minHeight);r.style("max-height",m.maxHeight);return;}var t=this.getTable();var o=t?t.getDomRef("tableCCnt"):null;if(o){o.style.height=m.height;o.style.minHeight=m.minHeight;o.style.maxHeight=m.maxHeight;}};
R.prototype.sanitizeRowCounts=function(C,f,F){C=Math.max(0,C);f=Math.max(0,f);F=Math.max(0,F);if(f+F>=C){F=Math.max(0,F-Math.max(0,(f+F-(C-1))));f=Math.max(0,f-Math.max(0,(f+F-(C-1))));}return{count:C,scrollable:C-f-F,fixedTop:f,fixedBottom:F};};
R.prototype.renderRowStyles=function(r){};
R.prototype.renderCellContentStyles=function(r){};
R.prototype.initTableRowsAfterDataRequested=function(r){var t=this.getTable();var b=t.getBinding("rows");clearTimeout(t._mTimeouts.refreshRowsCreateRows);if(!b||r<=0||t.getRows().length>0){return;}b.attachEventOnce("dataRequested",function(){clearTimeout(t._mTimeouts.refreshRowsCreateRows);t._mTimeouts.refreshRowsCreateRows=setTimeout(function(){if(t.getRows().length>0){return;}var d=c(t,r),o;var B=t.getBindingInfo("rows");var m=B?B.model:undefined;for(var i=0;i<d.length;i++){o=d[i];o.setBindingContext(null,m);t.addAggregation("rows",o,true);}t._bRowAggregationInvalid=false;},0);});};
R.prototype.updateTableRows=function(){var t=this.getTable();var r=t.getRows();var n=this.getComputedRowCounts().count;var i;var b=false;if(T.isNoDataVisible(t)&&!t.getBinding("rows")){n=0;}else if(T.isVariableRowHeightEnabled(t)){n=n+1;}if(t._bRowAggregationInvalid){b=r.length>0;t.destroyAggregation("rows",t._bInvalid?"KeepDom":true);r=[];}if(n===r.length){u(this,r);return b;}T.dynamicCall(t._getSyncExtension,function(s){s.syncRowCount(n);});if(r.length<n){var N=c(t,n-r.length);r=r.concat(N);u(this,r);for(i=0;i<N.length;i++){t.addAggregation("rows",N[i],true);N[i]._updateTableCells(N[i].getBindingContext());}}else{for(i=r.length-1;i>=n;i--){t.removeAggregation("rows",i,true);}r.splice(n);u(this,r);}b=true;t._bRowAggregationInvalid=false;return b;};
R.prototype.renderTableRows=function(){var t=this.getTable();var o=t?t.getDomRef("tableCCnt"):null;if(!o){return;}var b=q.Event("BeforeRendering");b.setMarked("renderRows");b.srcControl=this;t._handleEvent(b);var r=sap.ui.getCore().createRenderManager();var d=t.getRenderer();d.renderTableCCnt(r,t);r.flush(o,false,false);r.destroy();var A=q.Event("AfterRendering");A.setMarked("renderRows");A.srcControl=this;t._handleEvent(A);};
R.prototype.getRowContexts=function(r,s){var t=this.getTable();if(!t){return[];}return t._getRowContexts(r,s===true);};
R.prototype.disableFixedRows=function(){if(this.bFixedRowsDisabled===true){return;}Object.defineProperty(this,"bFixedRowsDisabled",{value:true});function b(){L.error("This mode does not support fixed rows",this);}this.setProperty("fixedTopRowCount",0,true);this.setFixedTopRowCount=b;this.setProperty("fixedBottomRowCount",0,true);this.setFixedBottomRowCount=b;};
function c(t,r){var b=[];var s=t.getRows().length;for(var i=0;i<r;i++){b.push(t._getRowClone(s+i));}return b;}
function u(m,r){var t=m.getParent();var C=m.getRowContexts(r.length);if(!t||r.length===0){return;}var b=t.getBinding("rows");var B=t.getBindingInfo("rows");var M=B?B.model:undefined;for(var i=0;i<r.length;i++){r[i].setRowBindingContext(C[i],M,b);}}
a.onBeforeRendering=function(){this._bTableIsRendering=true;};
a.onAfterRendering=function(){this._bTableIsRendering=false;};
return R;});
sap.ui.predefine('sap/ui/table/rowmodes/VariableRowMode',["../library","./RowMode"],function(l,R){"use strict";
var V=R.extend("sap.ui.table.rowmodes.VariableRowMode",{
metadata:{library:"sap.ui.table",properties:{tableHeight:{type:"sap.ui.core.CSSSize",defaultValue:"100%",group:"Dimension"}}},
constructor:function(i){Object.defineProperty(this,"bLegacy",{value:typeof i==="boolean"?i:false});if(this.bLegacy){R.call(this);}else{R.apply(this,arguments);}}
});
V.prototype.getComputedRowCounts=function(){var t=this.getTotalRowCountOfTable();var r=this.getHideEmptyRows()?Math.min(this.getRowCount(),t):this.getRowCount();return{count:r,fixedTopCount:this.getFixedTopRowCount(),fixedBottomCount:this.getFixedBottomRowCount()};};
V.prototype.getComputedRowCounts=function(){var t=this.getTotalRowCountOfTable();var r=this.getHideEmptyRows()?Math.min(this.getRowCount(),t):this.getRowCount();return{count:r,fixedTopCount:this.getFixedTopRowCount(),fixedBottomCount:this.getFixedBottomRowCount()};};
V.prototype.getTableHeight=function(){return{height:this.getTableHeight()};};
V.prototype.getRowContainerHeight=function(){return{height:this.getComputedRowCounts().count*this.getBaseRowHeightOfTable()};};
return V;});
sap.ui.require.preload({
	"sap/ui/table/manifest.json":'{"_version":"1.9.0","sap.app":{"id":"sap.ui.table","type":"library","embeds":[],"applicationVersion":{"version":"1.72.0"},"title":"Table-like controls, mainly for desktop scenarios.","description":"Table-like controls, mainly for desktop scenarios.","ach":"CA-UI5-TBL","resources":"resources.json","offline":true},"sap.ui":{"technology":"UI5","supportedThemes":["base","sap_hcb"]},"sap.ui5":{"dependencies":{"minUI5Version":"1.72","libs":{"sap.ui.core":{"minVersion":"1.72.0"},"sap.ui.unified":{"minVersion":"1.72.0"}}},"library":{"i18n":"messagebundle.properties","content":{"controls":["sap.ui.table.AnalyticalColumnMenu","sap.ui.table.AnalyticalTable","sap.ui.table.ColumnMenu","sap.ui.table.CreationRow","sap.ui.table.Table","sap.ui.table.TreeTable","sap.ui.table.RowAction"],"elements":["sap.ui.table.AnalyticalColumn","sap.ui.table.Column","sap.ui.table.Row","sap.ui.table.RowActionItem","sap.ui.table.RowSettings","sap.ui.table.rowmodes.RowMode","sap.ui.table.rowmodes.FixedRowMode","sap.ui.table.rowmodes.InteractiveRowMode","sap.ui.table.rowmodes.AutoRowMode","sap.ui.table.plugins.MultiSelectionPlugin","sap.ui.table.plugins.SelectionPlugin"],"types":["sap.ui.table.NavigationMode","sap.ui.table.RowActionType","sap.ui.table.SelectionBehavior","sap.ui.table.SelectionMode","sap.ui.table.SortOrder","sap.ui.table.VisibleRowCountMode","sap.ui.table.TreeAutoExpandMode"],"interfaces":[]}}}}'
},"sap/ui/table/library-preload"
);
//# sourceMappingURL=library-preload.js.map